// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAttributeWrapper_H
#define SBK_QAttributeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qattribute.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAttributeWrapper : public Qt3DCore::QAttribute
{
public:
    QAttributeWrapper(const QAttributeWrapper &) = delete;
    QAttributeWrapper& operator=(const QAttributeWrapper &) = delete;
    QAttributeWrapper(QAttributeWrapper &&) = delete;
    QAttributeWrapper& operator=(QAttributeWrapper &&) = delete;

    QAttributeWrapper(::Qt3DCore::QBuffer * buf, ::Qt3DCore::QAttribute::VertexBaseType vertexBaseType, uint vertexSize, uint count, uint offset = 0, uint stride = 0, ::Qt3DCore::QNode * parent = nullptr);
    QAttributeWrapper(::Qt3DCore::QBuffer * buf, const ::QString & name, ::Qt3DCore::QAttribute::VertexBaseType vertexBaseType, uint vertexSize, uint count, uint offset = 0, uint stride = 0, ::Qt3DCore::QNode * parent = nullptr);
    QAttributeWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QAttributeWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QAttributeWrapper_H

