// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractPhysicalDeviceWrapper_H
#define SBK_QAbstractPhysicalDeviceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DInput/qabstractphysicaldevice.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractPhysicalDeviceWrapper : public Qt3DInput::QAbstractPhysicalDevice
{
public:
    QAbstractPhysicalDeviceWrapper(const QAbstractPhysicalDeviceWrapper &) = delete;
    QAbstractPhysicalDeviceWrapper& operator=(const QAbstractPhysicalDeviceWrapper &) = delete;
    QAbstractPhysicalDeviceWrapper(QAbstractPhysicalDeviceWrapper &&) = delete;
    QAbstractPhysicalDeviceWrapper& operator=(QAbstractPhysicalDeviceWrapper &&) = delete;

    QAbstractPhysicalDeviceWrapper(::Qt3DCore::QNode * parent = nullptr);
    int axisCount() const override;
    int axisIdentifier(const ::QString & name) const override;
    ::QStringList axisNames() const override;
    int buttonCount() const override;
    int buttonIdentifier(const ::QString & name) const override;
    ::QStringList buttonNames() const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QAbstractPhysicalDeviceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QAbstractPhysicalDeviceWrapper_H

