// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPickPointEventWrapper_H
#define SBK_QPickPointEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qpickpointevent.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPickPointEventWrapper : public Qt3DRender::QPickPointEvent
{
public:
    QPickPointEventWrapper(const QPickPointEventWrapper &) = delete;
    QPickPointEventWrapper& operator=(const QPickPointEventWrapper &) = delete;
    QPickPointEventWrapper(QPickPointEventWrapper &&) = delete;
    QPickPointEventWrapper& operator=(QPickPointEventWrapper &&) = delete;

    QPickPointEventWrapper();
    QPickPointEventWrapper(const ::QPointF & position, const ::QVector3D & worldIntersection, const ::QVector3D & localIntersection, float distance, uint pointIndex, ::Qt3DRender::QPickEvent::Buttons button, int buttons, int modifiers);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPickPointEventWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QPickPointEventWrapper_H

