// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRenderTargetOutputWrapper_H
#define SBK_QRenderTargetOutputWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qrendertargetoutput.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRenderTargetOutputWrapper : public Qt3DRender::QRenderTargetOutput
{
public:
    QRenderTargetOutputWrapper(const QRenderTargetOutputWrapper &) = delete;
    QRenderTargetOutputWrapper& operator=(const QRenderTargetOutputWrapper &) = delete;
    QRenderTargetOutputWrapper(QRenderTargetOutputWrapper &&) = delete;
    QRenderTargetOutputWrapper& operator=(QRenderTargetOutputWrapper &&) = delete;

    QRenderTargetOutputWrapper(::Qt3DCore::QNode * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QRenderTargetOutputWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QRenderTargetOutputWrapper_H

