// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtconcurrent_python.h"

// main header
#include "qtconcurrent_wrapper.h"

// Extra includes
#include <qtconcurrentreducekernel.h>
#include <qtconcurrentthreadengine.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QtConcurrent_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QtConcurrent_EnumFlagInfo[] = {
    "FutureResult:Enum",
    "ReduceOption:Flag:ReduceOptions",
    "ThreadFunctionResult:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtConcurrent_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtConcurrent_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtConcurrent_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtConcurrent_Type = nullptr;
static PyTypeObject *Sbk_QtConcurrent_TypeF(void)
{
    return _Sbk_QtConcurrent_Type;
}

static PyType_Slot Sbk_QtConcurrent_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtConcurrent_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtConcurrent_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtConcurrent_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtConcurrent_spec = {
    "2:PySide6.QtConcurrent.QtConcurrent",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtConcurrent_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QtConcurrent_FutureResult_PythonToCpp_QtConcurrent_FutureResult(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtConcurrent::FutureResult>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtConcurrent::FutureResult *>(cppOut) = value;

}
static PythonToCppFunc is_QtConcurrent_FutureResult_PythonToCpp_QtConcurrent_FutureResult_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_FutureResult_IDX])))
        return QtConcurrent_FutureResult_PythonToCpp_QtConcurrent_FutureResult;
    return {};
}
static PyObject *QtConcurrent_FutureResult_CppToPython_QtConcurrent_FutureResult(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtConcurrent::FutureResult *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_FutureResult_IDX]), castCppIn);

}

static void QtConcurrent_ThreadFunctionResult_PythonToCpp_QtConcurrent_ThreadFunctionResult(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtConcurrent::ThreadFunctionResult>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtConcurrent::ThreadFunctionResult *>(cppOut) = value;

}
static PythonToCppFunc is_QtConcurrent_ThreadFunctionResult_PythonToCpp_QtConcurrent_ThreadFunctionResult_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ThreadFunctionResult_IDX])))
        return QtConcurrent_ThreadFunctionResult_PythonToCpp_QtConcurrent_ThreadFunctionResult;
    return {};
}
static PyObject *QtConcurrent_ThreadFunctionResult_CppToPython_QtConcurrent_ThreadFunctionResult(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtConcurrent::ThreadFunctionResult *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ThreadFunctionResult_IDX]), castCppIn);

}

static void QtConcurrent_ReduceOption_PythonToCpp_QtConcurrent_ReduceOption(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtConcurrent::ReduceOption>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtConcurrent::ReduceOption *>(cppOut) = value;

}
static PythonToCppFunc is_QtConcurrent_ReduceOption_PythonToCpp_QtConcurrent_ReduceOption_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ReduceOption_IDX])))
        return QtConcurrent_ReduceOption_PythonToCpp_QtConcurrent_ReduceOption;
    return {};
}
static PyObject *QtConcurrent_ReduceOption_CppToPython_QtConcurrent_ReduceOption(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtConcurrent::ReduceOption *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ReduceOption_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtConcurrentQtConcurrent_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtConcurrentQtConcurrent(PyObject *module)
{
    if (SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrentQtConcurrent_IDX].type != nullptr)
        return SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrentQtConcurrent_IDX].type;

    Shiboken::AutoDecRef Sbk_QtConcurrent_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtConcurrent_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtConcurrent",
        "QtConcurrent",
        &Sbk_QtConcurrent_spec,
        nullptr,
        Sbk_QtConcurrent_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtConcurrent_TypeF(); // references _Sbk_QtConcurrent_Type
    InitSignatureStrings(pyType, QtConcurrentQtConcurrent_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtConcurrent_PropertyStrings);
    SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrentQtConcurrent_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QtConcurrent_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'FutureResult'.
    const char *FutureResult_Initializer[] = {
        "Ignore",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t FutureResult_InitializerValues[] = {
        int8_t(QtConcurrent::FutureResult::Ignore) //  0x00  0
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtConcurrent_TypeF(),
        "2:PySide6.QtConcurrent.QtConcurrent.FutureResult",
        FutureResult_Initializer, FutureResult_InitializerValues);
    SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_FutureResult_IDX].type = EType;
    // Register converter for enum 'QtConcurrent::FutureResult'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtConcurrent_FutureResult_CppToPython_QtConcurrent_FutureResult);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtConcurrent_FutureResult_PythonToCpp_QtConcurrent_FutureResult,
            is_QtConcurrent_FutureResult_PythonToCpp_QtConcurrent_FutureResult_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtConcurrent::FutureResult");
        Shiboken::Conversions::registerConverterName(converter, "FutureResult");
    }
    // End of 'FutureResult' enum.

    // Initialization of enum 'ThreadFunctionResult'.
    const char *ThreadFunctionResult_Initializer[] = {
        "ThrottleThread",
        "ThreadFinished",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ThreadFunctionResult_InitializerValues[] = {
        uint8_t(QtConcurrent::ThreadFunctionResult::ThrottleThread), //  0x00  0
        uint8_t(QtConcurrent::ThreadFunctionResult::ThreadFinished)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtConcurrent_TypeF(),
        "2:PySide6.QtConcurrent.QtConcurrent.ThreadFunctionResult",
        ThreadFunctionResult_Initializer, ThreadFunctionResult_InitializerValues);
    SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ThreadFunctionResult_IDX].type = EType;
    // Register converter for enum 'QtConcurrent::ThreadFunctionResult'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtConcurrent_ThreadFunctionResult_CppToPython_QtConcurrent_ThreadFunctionResult);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtConcurrent_ThreadFunctionResult_PythonToCpp_QtConcurrent_ThreadFunctionResult,
            is_QtConcurrent_ThreadFunctionResult_PythonToCpp_QtConcurrent_ThreadFunctionResult_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtConcurrent::ThreadFunctionResult");
        Shiboken::Conversions::registerConverterName(converter, "ThreadFunctionResult");
    }
    // End of 'ThreadFunctionResult' enum.

    // Initialization of enum 'ReduceOption'.
    const char *ReduceOption_Initializer[] = {
        "UnorderedReduce",
        "OrderedReduce",
        "SequentialReduce",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ReduceOption_InitializerValues[] = {
        uint8_t(QtConcurrent::ReduceOption::UnorderedReduce), //  0x01  1
        uint8_t(QtConcurrent::ReduceOption::OrderedReduce),   //  0x02  2
        uint8_t(QtConcurrent::ReduceOption::SequentialReduce) //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtConcurrent_TypeF(),
        "2:PySide6.QtConcurrent.QtConcurrent.ReduceOption",
        ReduceOption_Initializer, ReduceOption_InitializerValues);
    SbkPySide6_QtConcurrentTypeStructs[SBK_QtConcurrent_ReduceOption_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtConcurrentTypeStructs[SBK_QFlags_QtConcurrent_ReduceOption_IDX].type =
        EType;
    // Register converter for enum 'QtConcurrent::ReduceOption'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtConcurrent_ReduceOption_CppToPython_QtConcurrent_ReduceOption);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtConcurrent_ReduceOption_PythonToCpp_QtConcurrent_ReduceOption,
            is_QtConcurrent_ReduceOption_PythonToCpp_QtConcurrent_ReduceOption_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtConcurrent::ReduceOption");
        Shiboken::Conversions::registerConverterName(converter, "ReduceOption");
        // Register converter for flag 'QFlags<QtConcurrent::ReduceOption>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QtConcurrent::ReduceOption>");
        Shiboken::Conversions::registerConverterName(converter, "QtConcurrent::ReduceOptions");
    }
    // End of 'ReduceOption' enum/flags.

    qRegisterMetaType< ::QtConcurrent::FutureResult >("QtConcurrent::FutureResult");
    qRegisterMetaType< ::QtConcurrent::ThreadFunctionResult >("QtConcurrent::ThreadFunctionResult");
    qRegisterMetaType< ::QtConcurrent::ReduceOption >("QtConcurrent::ReduceOption");

    return pyType;
}
