// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qabstracteventdispatcher_timerinfo_wrapper.h"

// Argument includes
#include <qnamespace.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QAbstractEventDispatcher_TimerInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QAbstractEventDispatcher::TimerInfo >()))
        return -1;

    ::QAbstractEventDispatcher::TimerInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QAbstractEventDispatcher.TimerInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "TimerInfo", 1, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TimerInfo::TimerInfo(QAbstractEventDispatcher::TimerInfo)
    // 1: TimerInfo::TimerInfo(int,int,Qt::TimerType)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TimerType_IDX])))->converter, (pyArgs[2])))) {
        overloadId = 1; // TimerInfo(int,int,Qt::TimerType)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), (pyArgs[0])))) {
        overloadId = 0; // TimerInfo(QAbstractEventDispatcher::TimerInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TimerInfo(const QAbstractEventDispatcher::TimerInfo & TimerInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QAbstractEventDispatcher::TimerInfo cppArg0_local = ::QAbstractEventDispatcher::TimerInfo(int(0), int(0), Qt::PreciseTimer);
            ::QAbstractEventDispatcher::TimerInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TimerInfo(QAbstractEventDispatcher::TimerInfo)
                cptr = new ::QAbstractEventDispatcher::TimerInfo(*cppArg0);
            }
            break;
        }
        case 1: // TimerInfo(int id, int i, Qt::TimerType t)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::Qt::TimerType cppArg2{Qt::PreciseTimer};
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // TimerInfo(int,int,Qt::TimerType)
                cptr = new ::QAbstractEventDispatcher::TimerInfo(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QAbstractEventDispatcher::TimerInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QAbstractEventDispatcher_TimerInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QAbstractEventDispatcher_TimerInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QAbstractEventDispatcher_TimerInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QAbstractEventDispatcher_TimerInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QAbstractEventDispatcher_TimerInfo_get_timerId(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->timerId;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QAbstractEventDispatcher_TimerInfo_set_timerId(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("timerId");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("timerId", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->timerId;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->timerId = cppOut_local;

    return 0;
}

static PyObject *Sbk_QAbstractEventDispatcher_TimerInfo_get_interval(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->interval;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QAbstractEventDispatcher_TimerInfo_set_interval(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("interval");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("interval", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->interval;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->interval = cppOut_local;

    return 0;
}

static PyObject *Sbk_QAbstractEventDispatcher_TimerInfo_get_timerType(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::TimerType cppOut_local = cppSelf->timerType;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TimerType_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QAbstractEventDispatcher_TimerInfo_set_timerType(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("timerType");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TimerType_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("timerType", "TimerType");
        return -1;
    }

    auto cppOut_local = cppSelf->timerType;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->timerType = cppOut_local;

    return 0;
}

// Getters and Setters for TimerInfo
static PyGetSetDef Sbk_QAbstractEventDispatcher_TimerInfo_getsetlist[] = {
    {const_cast<char *>("timerId"), Sbk_QAbstractEventDispatcher_TimerInfo_get_timerId, Sbk_QAbstractEventDispatcher_TimerInfo_set_timerId, nullptr, nullptr},
    {const_cast<char *>("interval"), Sbk_QAbstractEventDispatcher_TimerInfo_get_interval, Sbk_QAbstractEventDispatcher_TimerInfo_set_interval, nullptr, nullptr},
    {const_cast<char *>("timerType"), Sbk_QAbstractEventDispatcher_TimerInfo_get_timerType, Sbk_QAbstractEventDispatcher_TimerInfo_set_timerType, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QAbstractEventDispatcher_TimerInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QAbstractEventDispatcher_TimerInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QAbstractEventDispatcher_TimerInfo_Type = nullptr;
static PyTypeObject *Sbk_QAbstractEventDispatcher_TimerInfo_TypeF(void)
{
    return _Sbk_QAbstractEventDispatcher_TimerInfo_Type;
}

static PyType_Slot Sbk_QAbstractEventDispatcher_TimerInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QAbstractEventDispatcher_TimerInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QAbstractEventDispatcher_TimerInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QAbstractEventDispatcher_TimerInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QAbstractEventDispatcher_TimerInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QAbstractEventDispatcher_TimerInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QAbstractEventDispatcher_TimerInfo_spec = {
    "2:PySide6.QtCore.QAbstractEventDispatcher.TimerInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QAbstractEventDispatcher_TimerInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TimerInfo_PythonToCpp_TimerInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QAbstractEventDispatcher_TimerInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TimerInfo_PythonToCpp_TimerInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QAbstractEventDispatcher_TimerInfo_TypeF()))
        return TimerInfo_PythonToCpp_TimerInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TimerInfo_PTR_CppToPython_TimerInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QAbstractEventDispatcher::TimerInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QAbstractEventDispatcher_TimerInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *TimerInfo_COPY_CppToPython_TimerInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QAbstractEventDispatcher::TimerInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QAbstractEventDispatcher_TimerInfo_TypeF(), new ::QAbstractEventDispatcher::TimerInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void TimerInfo_PythonToCpp_TimerInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QAbstractEventDispatcher::TimerInfo *>(cppOut) = *reinterpret_cast< ::QAbstractEventDispatcher::TimerInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TimerInfo_PythonToCpp_TimerInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QAbstractEventDispatcher_TimerInfo_TypeF()))
        return TimerInfo_PythonToCpp_TimerInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QAbstractEventDispatcher_TimerInfo_SignatureStrings[] = {
    "1:PySide6.QtCore.QAbstractEventDispatcher.TimerInfo(self,TimerInfo:PySide6.QtCore.QAbstractEventDispatcher.TimerInfo)",
    "0:PySide6.QtCore.QAbstractEventDispatcher.TimerInfo(self,id:int,i:int,t:PySide6.QtCore.Qt.TimerType)",
    "PySide6.QtCore.QAbstractEventDispatcher.TimerInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QAbstractEventDispatcher_TimerInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QAbstractEventDispatcher_TimerInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QAbstractEventDispatcher_TimerInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TimerInfo",
        "QAbstractEventDispatcher::TimerInfo",
        &Sbk_QAbstractEventDispatcher_TimerInfo_spec,
        &Shiboken::callCppDestructor< ::QAbstractEventDispatcher::TimerInfo >,
        Sbk_QAbstractEventDispatcher_TimerInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QAbstractEventDispatcher_TimerInfo_TypeF(); // references _Sbk_QAbstractEventDispatcher_TimerInfo_Type
    InitSignatureStrings(pyType, QAbstractEventDispatcher_TimerInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QAbstractEventDispatcher_TimerInfo_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QAbstractEventDispatcher_TimerInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TimerInfo_PythonToCpp_TimerInfo_PTR,
        is_TimerInfo_PythonToCpp_TimerInfo_PTR_Convertible,
        TimerInfo_PTR_CppToPython_TimerInfo,
        TimerInfo_COPY_CppToPython_TimerInfo);

    Shiboken::Conversions::registerConverterName(converter, "QAbstractEventDispatcher::TimerInfo");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractEventDispatcher::TimerInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QAbstractEventDispatcher::TimerInfo&");
    Shiboken::Conversions::registerConverterName(converter, "TimerInfo");
    Shiboken::Conversions::registerConverterName(converter, "TimerInfo*");
    Shiboken::Conversions::registerConverterName(converter, "TimerInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QAbstractEventDispatcher::TimerInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TimerInfo_PythonToCpp_TimerInfo_COPY,
        is_TimerInfo_PythonToCpp_TimerInfo_COPY_Convertible);


    return pyType;
}
