// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qbytearray_frombase64result_wrapper.h"

// Argument includes
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QByteArray_FromBase64Result_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QByteArray::FromBase64Result >()))
        return -1;

    ::QByteArray::FromBase64Result *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QByteArray.FromBase64Result.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "FromBase64Result", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: FromBase64Result::FromBase64Result()
    // 1: FromBase64Result::FromBase64Result(QByteArray::FromBase64Result)
    if (numArgs == 0) {
        overloadId = 0; // FromBase64Result()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), (pyArgs[0])))) {
        overloadId = 1; // FromBase64Result(QByteArray::FromBase64Result)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // FromBase64Result()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // FromBase64Result()
                cptr = new ::QByteArray::FromBase64Result();
            }
            break;
        }
        case 1: // FromBase64Result(const QByteArray::FromBase64Result & FromBase64Result)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QByteArray::FromBase64Result cppArg0_local;
            ::QByteArray::FromBase64Result *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // FromBase64Result(QByteArray::FromBase64Result)
                cptr = new ::QByteArray::FromBase64Result(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QByteArray::FromBase64Result >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QByteArray_FromBase64ResultFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QByteArray.FromBase64Result.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: FromBase64Result::swap(QByteArray::FromBase64Result&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QByteArray::FromBase64Result&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray::FromBase64Result cppArg0_local;
        ::QByteArray::FromBase64Result *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QByteArray::FromBase64Result&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QByteArray_FromBase64Result__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QByteArray_FromBase64Result_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QByteArray_FromBase64Result_methods[] = {
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QByteArray_FromBase64ResultFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QByteArray_FromBase64Result__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QByteArray_FromBase64Result_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), (pyArg)))) {
                // operator!=(const QByteArray::FromBase64Result & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QByteArray::FromBase64Result cppArg0_local;
                ::QByteArray::FromBase64Result *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), (pyArg)))) {
                // operator==(const QByteArray::FromBase64Result & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QByteArray::FromBase64Result cppArg0_local;
                ::QByteArray::FromBase64Result *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

static PyObject *Sbk_QByteArray_FromBase64Result_get_decoded(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->decoded)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->decoded))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->decoded)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &(cppSelf->decoded), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QByteArray_FromBase64Result_set_decoded(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("decoded");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("decoded", "QByteArray");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->decoded;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QByteArray_FromBase64Result_get_decodingStatus(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QByteArray::Base64DecodingStatus cppOut_local = cppSelf->decodingStatus;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_Base64DecodingStatus_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QByteArray_FromBase64Result_set_decodingStatus(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("decodingStatus");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_Base64DecodingStatus_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("decodingStatus", "Base64DecodingStatus");
        return -1;
    }

    auto cppOut_local = cppSelf->decodingStatus;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->decodingStatus = cppOut_local;

    return 0;
}

// Getters and Setters for FromBase64Result
static PyGetSetDef Sbk_QByteArray_FromBase64Result_getsetlist[] = {
    {const_cast<char *>("decoded"), Sbk_QByteArray_FromBase64Result_get_decoded, Sbk_QByteArray_FromBase64Result_set_decoded, nullptr, nullptr},
    {const_cast<char *>("decodingStatus"), Sbk_QByteArray_FromBase64Result_get_decodingStatus, Sbk_QByteArray_FromBase64Result_set_decodingStatus, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static Py_hash_t Sbk_QByteArray_FromBase64Result_HashFunc(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return Py_hash_t(qHash(*cppSelf));
}

static int Sbk_QByteArray_FromBase64Result_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QByteArray_FromBase64Result_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QByteArray_FromBase64Result_Type = nullptr;
static PyTypeObject *Sbk_QByteArray_FromBase64Result_TypeF(void)
{
    return _Sbk_QByteArray_FromBase64Result_Type;
}

static PyType_Slot Sbk_QByteArray_FromBase64Result_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_hash,        reinterpret_cast<void *>(&Sbk_QByteArray_FromBase64Result_HashFunc)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QByteArray_FromBase64Result_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QByteArray_FromBase64Result_spec = {
    "2:PySide6.QtCore.QByteArray.FromBase64Result",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QByteArray_FromBase64Result_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void FromBase64Result_PythonToCpp_FromBase64Result_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QByteArray_FromBase64Result_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_FromBase64Result_PythonToCpp_FromBase64Result_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QByteArray_FromBase64Result_TypeF()))
        return FromBase64Result_PythonToCpp_FromBase64Result_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *FromBase64Result_PTR_CppToPython_FromBase64Result(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QByteArray::FromBase64Result *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QByteArray_FromBase64Result_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *FromBase64Result_COPY_CppToPython_FromBase64Result(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QByteArray::FromBase64Result *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QByteArray_FromBase64Result_TypeF(), new ::QByteArray::FromBase64Result(*source), true, true);
}

// Python to C++ copy conversion.
static void FromBase64Result_PythonToCpp_FromBase64Result_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QByteArray::FromBase64Result *>(cppOut) = *reinterpret_cast< ::QByteArray::FromBase64Result *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_FromBase64Result_PythonToCpp_FromBase64Result_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QByteArray_FromBase64Result_TypeF()))
        return FromBase64Result_PythonToCpp_FromBase64Result_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QByteArray_FromBase64Result_SignatureStrings[] = {
    "1:PySide6.QtCore.QByteArray.FromBase64Result(self)",
    "0:PySide6.QtCore.QByteArray.FromBase64Result(self,FromBase64Result:PySide6.QtCore.QByteArray.FromBase64Result)",
    "PySide6.QtCore.QByteArray.FromBase64Result.swap(self,other:PySide6.QtCore.QByteArray.FromBase64Result)",
    "PySide6.QtCore.QByteArray.FromBase64Result.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QByteArray_FromBase64Result(PyObject *enclosingClass)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX].type;

    Shiboken::AutoDecRef Sbk_QByteArray_FromBase64Result_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QByteArray_FromBase64Result_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "FromBase64Result",
        "QByteArray::FromBase64Result",
        &Sbk_QByteArray_FromBase64Result_spec,
        &Shiboken::callCppDestructor< ::QByteArray::FromBase64Result >,
        Sbk_QByteArray_FromBase64Result_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QByteArray_FromBase64Result_TypeF(); // references _Sbk_QByteArray_FromBase64Result_Type
    InitSignatureStrings(pyType, QByteArray_FromBase64Result_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QByteArray_FromBase64Result_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_FromBase64Result_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        FromBase64Result_PythonToCpp_FromBase64Result_PTR,
        is_FromBase64Result_PythonToCpp_FromBase64Result_PTR_Convertible,
        FromBase64Result_PTR_CppToPython_FromBase64Result,
        FromBase64Result_COPY_CppToPython_FromBase64Result);

    Shiboken::Conversions::registerConverterName(converter, "QByteArray::FromBase64Result");
    Shiboken::Conversions::registerConverterName(converter, "QByteArray::FromBase64Result*");
    Shiboken::Conversions::registerConverterName(converter, "QByteArray::FromBase64Result&");
    Shiboken::Conversions::registerConverterName(converter, "FromBase64Result");
    Shiboken::Conversions::registerConverterName(converter, "FromBase64Result*");
    Shiboken::Conversions::registerConverterName(converter, "FromBase64Result&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QByteArray::FromBase64Result).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        FromBase64Result_PythonToCpp_FromBase64Result_COPY,
        is_FromBase64Result_PythonToCpp_FromBase64Result_COPY_Convertible);

    qRegisterMetaType< ::QByteArray::FromBase64Result >("FromBase64Result");
    qRegisterMetaType< ::QByteArray::FromBase64Result >("QByteArray::FromBase64Result");

    return pyType;
}
