// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QChildEventWrapper_H
#define SBK_QChildEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QChildEventWrapper : public QChildEvent
{
public:
    QChildEventWrapper(const QChildEventWrapper &) = delete;
    QChildEventWrapper& operator=(const QChildEventWrapper &) = delete;
    QChildEventWrapper(QChildEventWrapper &&) = delete;
    QChildEventWrapper& operator=(QChildEventWrapper &&) = delete;

    QChildEventWrapper(::QEvent::Type type, ::QObject * child);
    QChildEventWrapper(const QChildEvent& self) : QChildEvent(self)
    {
    }

    ::QChildEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QChildEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QChildEventWrapper_H

