// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qregularexpressionmatchiterator_wrapper.h"

// Argument includes
#include <qregularexpression.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRegularExpressionMatchIterator_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRegularExpressionMatchIterator >()))
        return -1;

    ::QRegularExpressionMatchIterator *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRegularExpressionMatchIterator", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRegularExpressionMatchIterator::QRegularExpressionMatchIterator()
    // 1: QRegularExpressionMatchIterator::QRegularExpressionMatchIterator(QRegularExpressionMatchIterator)
    if (numArgs == 0) {
        overloadId = 0; // QRegularExpressionMatchIterator()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRegularExpressionMatchIterator(QRegularExpressionMatchIterator)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRegularExpressionMatchIterator()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRegularExpressionMatchIterator()
                cptr = new ::QRegularExpressionMatchIterator();
            }
            break;
        }
        case 1: // QRegularExpressionMatchIterator(const QRegularExpressionMatchIterator & iterator)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRegularExpressionMatchIterator cppArg0_local;
            ::QRegularExpressionMatchIterator *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRegularExpressionMatchIterator(QRegularExpressionMatchIterator)
                cptr = new ::QRegularExpressionMatchIterator(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRegularExpressionMatchIterator >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_hasNext(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.hasNext";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasNext()const
            bool cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->hasNext();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_matchOptions(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.matchOptions";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // matchOptions()const
            QFlags<QRegularExpression::MatchOption> cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->matchOptions();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QFlags_QRegularExpression_MatchOption_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_matchType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.matchType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // matchType()const
            QRegularExpression::MatchType cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->matchType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpression_MatchType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_next(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.next";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // next()
            QRegularExpressionMatch cppResult = cppSelf->next();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_peekNext(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.peekNext";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // peekNext()const
            QRegularExpressionMatch cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->peekNext();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatch_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_regularExpression(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.regularExpression";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // regularExpression()const
            QRegularExpression cppResult = const_cast<const ::QRegularExpressionMatchIterator *>(cppSelf)->regularExpression();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpression_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QRegularExpressionMatchIteratorFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QRegularExpressionMatchIterator.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRegularExpressionMatchIterator::swap(QRegularExpressionMatchIterator&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QRegularExpressionMatchIterator&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRegularExpressionMatchIterator cppArg0_local;
        ::QRegularExpressionMatchIterator *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QRegularExpressionMatchIterator&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QRegularExpressionMatchIterator__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRegularExpressionMatchIterator_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRegularExpressionMatchIterator_methods[] = {
    {"hasNext", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_hasNext), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_isValid), METH_NOARGS, nullptr},
    {"matchOptions", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_matchOptions), METH_NOARGS, nullptr},
    {"matchType", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_matchType), METH_NOARGS, nullptr},
    {"next", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_next), METH_NOARGS, nullptr},
    {"peekNext", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_peekNext), METH_NOARGS, nullptr},
    {"regularExpression", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_regularExpression), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIteratorFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRegularExpressionMatchIterator__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRegularExpressionMatchIterator_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRegularExpressionMatchIterator_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRegularExpressionMatchIterator_Type = nullptr;
static PyTypeObject *Sbk_QRegularExpressionMatchIterator_TypeF(void)
{
    return _Sbk_QRegularExpressionMatchIterator_Type;
}

static PyType_Slot Sbk_QRegularExpressionMatchIterator_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRegularExpressionMatchIterator_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRegularExpressionMatchIterator_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRegularExpressionMatchIterator_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRegularExpressionMatchIterator_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRegularExpressionMatchIterator_spec = {
    "2:PySide6.QtCore.QRegularExpressionMatchIterator",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRegularExpressionMatchIterator_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRegularExpressionMatchIterator_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRegularExpressionMatchIterator_TypeF()))
        return QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRegularExpressionMatchIterator_PTR_CppToPython_QRegularExpressionMatchIterator(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QRegularExpressionMatchIterator *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QRegularExpressionMatchIterator_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRegularExpressionMatchIterator_COPY_CppToPython_QRegularExpressionMatchIterator(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRegularExpressionMatchIterator *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRegularExpressionMatchIterator_TypeF(), new ::QRegularExpressionMatchIterator(*source), true, true);
}

// Python to C++ copy conversion.
static void QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRegularExpressionMatchIterator *>(cppOut) = *reinterpret_cast< ::QRegularExpressionMatchIterator *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRegularExpressionMatchIterator_TypeF()))
        return QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRegularExpressionMatchIterator_SignatureStrings[] = {
    "1:PySide6.QtCore.QRegularExpressionMatchIterator(self)",
    "0:PySide6.QtCore.QRegularExpressionMatchIterator(self,iterator:PySide6.QtCore.QRegularExpressionMatchIterator)",
    "PySide6.QtCore.QRegularExpressionMatchIterator.hasNext(self)->bool",
    "PySide6.QtCore.QRegularExpressionMatchIterator.isValid(self)->bool",
    "PySide6.QtCore.QRegularExpressionMatchIterator.matchOptions(self)->PySide6.QtCore.QRegularExpression.MatchOption",
    "PySide6.QtCore.QRegularExpressionMatchIterator.matchType(self)->PySide6.QtCore.QRegularExpression.MatchType",
    "PySide6.QtCore.QRegularExpressionMatchIterator.next(self)->PySide6.QtCore.QRegularExpressionMatch",
    "PySide6.QtCore.QRegularExpressionMatchIterator.peekNext(self)->PySide6.QtCore.QRegularExpressionMatch",
    "PySide6.QtCore.QRegularExpressionMatchIterator.regularExpression(self)->PySide6.QtCore.QRegularExpression",
    "PySide6.QtCore.QRegularExpressionMatchIterator.swap(self,other:PySide6.QtCore.QRegularExpressionMatchIterator)",
    "PySide6.QtCore.QRegularExpressionMatchIterator.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRegularExpressionMatchIterator(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX].type;

    Shiboken::AutoDecRef Sbk_QRegularExpressionMatchIterator_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRegularExpressionMatchIterator_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRegularExpressionMatchIterator",
        "QRegularExpressionMatchIterator",
        &Sbk_QRegularExpressionMatchIterator_spec,
        &Shiboken::callCppDestructor< ::QRegularExpressionMatchIterator >,
        Sbk_QRegularExpressionMatchIterator_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRegularExpressionMatchIterator_TypeF(); // references _Sbk_QRegularExpressionMatchIterator_Type
    InitSignatureStrings(pyType, QRegularExpressionMatchIterator_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRegularExpressionMatchIterator_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QRegularExpressionMatchIterator_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_PTR,
        is_QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_PTR_Convertible,
        QRegularExpressionMatchIterator_PTR_CppToPython_QRegularExpressionMatchIterator,
        QRegularExpressionMatchIterator_COPY_CppToPython_QRegularExpressionMatchIterator);

    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatchIterator");
    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatchIterator*");
    Shiboken::Conversions::registerConverterName(converter, "QRegularExpressionMatchIterator&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRegularExpressionMatchIterator).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_COPY,
        is_QRegularExpressionMatchIterator_PythonToCpp_QRegularExpressionMatchIterator_COPY_Convertible);

    qRegisterMetaType< ::QRegularExpressionMatchIterator >("QRegularExpressionMatchIterator");

    return pyType;
}
