// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRunnableWrapper_H
#define SBK_QRunnableWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qrunnable.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRunnableWrapper : public QRunnable
{
public:
    QRunnableWrapper(const QRunnableWrapper &) = delete;
    QRunnableWrapper& operator=(const QRunnableWrapper &) = delete;
    QRunnableWrapper(QRunnableWrapper &&) = delete;
    QRunnableWrapper& operator=(QRunnableWrapper &&) = delete;

    QRunnableWrapper() noexcept;
    void run() override;
    ~QRunnableWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QRunnableWrapper_H

