// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qsystemsemaphore_wrapper.h"

// Argument includes
#include <QString>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qsystemsemaphore.h>
#include <qtipccommon.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSystemSemaphore_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSystemSemaphore >()))
        return -1;

    ::QSystemSemaphore *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:QSystemSemaphore", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSystemSemaphore::QSystemSemaphore(QNativeIpcKey,int=,QSystemSemaphore::AccessMode=)
    // 1: QSystemSemaphore::QSystemSemaphore(QString,int=,QSystemSemaphore::AccessMode=)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // QSystemSemaphore(QString,int,QSystemSemaphore::AccessMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 1; // QSystemSemaphore(QString,int,QSystemSemaphore::AccessMode)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2])))) {
                overloadId = 1; // QSystemSemaphore(QString,int,QSystemSemaphore::AccessMode)
            }
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // QSystemSemaphore(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // QSystemSemaphore(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2])))) {
                overloadId = 0; // QSystemSemaphore(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSystemSemaphore(const QNativeIpcKey & key, int initialValue, QSystemSemaphore::AccessMode arg__3)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_initialValue = Shiboken::String::createStaticString("initialValue");
                if (PyDict_Contains(kwds, key_initialValue) != 0) {
                    value = PyDict_GetItem(kwds, key_initialValue);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_initialValue);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_initialValue);
                }
                static PyObject *const key_arg__3 = Shiboken::String::createStaticString("arg__3");
                if (PyDict_Contains(kwds, key_arg__3) != 0) {
                    value = PyDict_GetItem(kwds, key_arg__3);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_arg__3);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_arg__3);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNativeIpcKey cppArg0_local;
            ::QNativeIpcKey *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            int cppArg1 = 0;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QSystemSemaphore::AccessMode cppArg2(QSystemSemaphore::AccessMode::Open);
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSystemSemaphore(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
                cptr = new ::QSystemSemaphore(*cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 1: // QSystemSemaphore(const QString & key, int initialValue, QSystemSemaphore::AccessMode mode)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_initialValue = Shiboken::String::createStaticString("initialValue");
                if (PyDict_Contains(kwds, key_initialValue) != 0) {
                    value = PyDict_GetItem(kwds, key_initialValue);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_initialValue);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_initialValue);
                }
                static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
                if (PyDict_Contains(kwds, key_mode) != 0) {
                    value = PyDict_GetItem(kwds, key_mode);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_mode);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_mode);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = 0;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QSystemSemaphore::AccessMode cppArg2(QSystemSemaphore::AccessMode::Open);
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSystemSemaphore(QString,int,QSystemSemaphore::AccessMode)
                cptr = new ::QSystemSemaphore(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSystemSemaphore >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSystemSemaphoreFunc_acquire(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.acquire";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // acquire()
            bool cppResult = cppSelf->acquire();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_error(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.error";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // error()const
            QSystemSemaphore::SystemSemaphoreError cppResult = const_cast<const ::QSystemSemaphore *>(cppSelf)->error();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_SystemSemaphoreError_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_errorString(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.errorString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // errorString()const
            QString cppResult = const_cast<const ::QSystemSemaphore *>(cppSelf)->errorString();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_isKeyTypeSupported(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.isKeyTypeSupported";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QSystemSemaphore::isKeyTypeSupported(QNativeIpcKey::Type)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // isKeyTypeSupported(QNativeIpcKey::Type)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QNativeIpcKey::Type cppArg0 = static_cast< ::QNativeIpcKey::Type>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isKeyTypeSupported(QNativeIpcKey::Type)
            bool cppResult = ::QSystemSemaphore::isKeyTypeSupported(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_key(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.key";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // key()const
            QString cppResult = const_cast<const ::QSystemSemaphore *>(cppSelf)->key();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_legacyNativeKey(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.legacyNativeKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:legacyNativeKey", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QSystemSemaphore::legacyNativeKey(QString,QNativeIpcKey::Type=)->QNativeIpcKey
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // legacyNativeKey(QString,QNativeIpcKey::Type)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[1])))) {
            overloadId = 0; // legacyNativeKey(QString,QNativeIpcKey::Type)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_type = Shiboken::String::createStaticString("type");
            if (PyDict_Contains(kwds, key_type) != 0) {
                value = PyDict_GetItem(kwds, key_type);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_type);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_type);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QNativeIpcKey::Type cppArg1 = QNativeIpcKey::legacyDefaultTypeForOs();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // legacyNativeKey(QString,QNativeIpcKey::Type)
            QNativeIpcKey cppResult = ::QSystemSemaphore::legacyNativeKey(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_nativeIpcKey(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.nativeIpcKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // nativeIpcKey()const
            QNativeIpcKey cppResult = const_cast<const ::QSystemSemaphore *>(cppSelf)->nativeIpcKey();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_platformSafeKey(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.platformSafeKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:platformSafeKey", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QSystemSemaphore::platformSafeKey(QString,QNativeIpcKey::Type=)->QNativeIpcKey
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // platformSafeKey(QString,QNativeIpcKey::Type)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[1])))) {
            overloadId = 0; // platformSafeKey(QString,QNativeIpcKey::Type)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_type = Shiboken::String::createStaticString("type");
            if (PyDict_Contains(kwds, key_type) != 0) {
                value = PyDict_GetItem(kwds, key_type);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_type);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_type);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QNativeIpcKey::Type cppArg1(QNativeIpcKey::DefaultTypeForOs);
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // platformSafeKey(QString,QNativeIpcKey::Type)
            QNativeIpcKey cppResult = ::QSystemSemaphore::platformSafeKey(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_release(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.release";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:release", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QSystemSemaphore::release(int=)->bool
    if (numArgs == 0) {
        overloadId = 0; // release(int)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 0; // release(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_n = Shiboken::String::createStaticString("n");
            if (PyDict_Contains(kwds, key_n) != 0) {
                value = PyDict_GetItem(kwds, key_n);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_n);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_n);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        int cppArg0 = 1;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // release(int)
            bool cppResult = cppSelf->release(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSystemSemaphoreFunc_setKey(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.setKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 3));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOO:setKey", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QSystemSemaphore::setKey(QString,int=,QSystemSemaphore::AccessMode=)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // setKey(QString,int,QSystemSemaphore::AccessMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // setKey(QString,int,QSystemSemaphore::AccessMode)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2])))) {
                overloadId = 0; // setKey(QString,int,QSystemSemaphore::AccessMode)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_initialValue = Shiboken::String::createStaticString("initialValue");
            if (PyDict_Contains(kwds, key_initialValue) != 0) {
                value = PyDict_GetItem(kwds, key_initialValue);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_initialValue);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_initialValue);
            }
            static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
            if (PyDict_Contains(kwds, key_mode) != 0) {
                value = PyDict_GetItem(kwds, key_mode);
                if (value != nullptr && pyArgs[2] != nullptr ) {
                    errInfo.reset(key_mode);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[2] = value;
                    if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_mode);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1 = 0;
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);
        ::QSystemSemaphore::AccessMode cppArg2(QSystemSemaphore::AccessMode::Open);
        if (pythonToCpp[2])
            pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setKey(QString,int,QSystemSemaphore::AccessMode)
            cppSelf->setKey(cppArg0, cppArg1, cppArg2);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSystemSemaphoreFunc_setNativeKey(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSystemSemaphore *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QSystemSemaphore.setNativeKey";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 4));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOOO:setNativeKey", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QSystemSemaphore::setNativeKey(QNativeIpcKey,int=,QSystemSemaphore::AccessMode=)
    // 1: QSystemSemaphore::setNativeKey(QString,int=,QSystemSemaphore::AccessMode=,QNativeIpcKey::Type=)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // setNativeKey(QString,int,QSystemSemaphore::AccessMode,QNativeIpcKey::Type)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 1; // setNativeKey(QString,int,QSystemSemaphore::AccessMode,QNativeIpcKey::Type)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2])))) {
                if (numArgs == 3) {
                    overloadId = 1; // setNativeKey(QString,int,QSystemSemaphore::AccessMode,QNativeIpcKey::Type)
                } else if (numArgs >= 4
                    && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[3])))) {
                    overloadId = 1; // setNativeKey(QString,int,QSystemSemaphore::AccessMode,QNativeIpcKey::Type)
                }
            }
        }
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_IDX]), (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // setNativeKey(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 0; // setNativeKey(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2])))) {
                overloadId = 0; // setNativeKey(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
            }
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // setNativeKey(const QNativeIpcKey & key, int initialValue, QSystemSemaphore::AccessMode arg__3)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_initialValue = Shiboken::String::createStaticString("initialValue");
                if (PyDict_Contains(kwds, key_initialValue) != 0) {
                    value = PyDict_GetItem(kwds, key_initialValue);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_initialValue);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_initialValue);
                }
                static PyObject *const key_arg__3 = Shiboken::String::createStaticString("arg__3");
                if (PyDict_Contains(kwds, key_arg__3) != 0) {
                    value = PyDict_GetItem(kwds, key_arg__3);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_arg__3);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2]))))
                            return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_arg__3);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QNativeIpcKey cppArg0_local;
            ::QNativeIpcKey *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            int cppArg1 = 0;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QSystemSemaphore::AccessMode cppArg2(QSystemSemaphore::AccessMode::Open);
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setNativeKey(QNativeIpcKey,int,QSystemSemaphore::AccessMode)
                cppSelf->setNativeKey(*cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 1: // setNativeKey(const QString & key, int initialValue, QSystemSemaphore::AccessMode mode, QNativeIpcKey::Type type)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_initialValue = Shiboken::String::createStaticString("initialValue");
                if (PyDict_Contains(kwds, key_initialValue) != 0) {
                    value = PyDict_GetItem(kwds, key_initialValue);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_initialValue);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1]))))
                            return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_initialValue);
                }
                static PyObject *const key_mode = Shiboken::String::createStaticString("mode");
                if (PyDict_Contains(kwds, key_mode) != 0) {
                    value = PyDict_GetItem(kwds, key_mode);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_mode);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))->converter, (pyArgs[2]))))
                            return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_mode);
                }
                static PyObject *const key_type = Shiboken::String::createStaticString("type");
                if (PyDict_Contains(kwds, key_type) != 0) {
                    value = PyDict_GetItem(kwds, key_type);
                    if (value != nullptr && pyArgs[3] != nullptr ) {
                        errInfo.reset(key_type);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[3] = value;
                        if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QNativeIpcKey_Type_IDX])))->converter, (pyArgs[3]))))
                            return Shiboken::returnWrongArguments(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_type);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
            }
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1 = 0;
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QSystemSemaphore::AccessMode cppArg2(QSystemSemaphore::AccessMode::Open);
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);
            ::QNativeIpcKey::Type cppArg3 = QNativeIpcKey::legacyDefaultTypeForOs();
            if (pythonToCpp[3])
                pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // setNativeKey(QString,int,QSystemSemaphore::AccessMode,QNativeIpcKey::Type)
                cppSelf->setNativeKey(cppArg0, cppArg1, cppArg2, cppArg3);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QSystemSemaphore_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QSystemSemaphore_EnumFlagInfo[] = {
    "AccessMode:Enum",
    "SystemSemaphoreError:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSystemSemaphore_methods[] = {
    {"acquire", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_acquire), METH_NOARGS, nullptr},
    {"error", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_error), METH_NOARGS, nullptr},
    {"errorString", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_errorString), METH_NOARGS, nullptr},
    {"isKeyTypeSupported", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_isKeyTypeSupported), METH_O|METH_STATIC, nullptr},
    {"key", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_key), METH_NOARGS, nullptr},
    {"legacyNativeKey", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_legacyNativeKey), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"nativeIpcKey", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_nativeIpcKey), METH_NOARGS, nullptr},
    {"platformSafeKey", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_platformSafeKey), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"release", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_release), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"setKey", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_setKey), METH_VARARGS|METH_KEYWORDS, nullptr},
    {"setNativeKey", reinterpret_cast<PyCFunction>(Sbk_QSystemSemaphoreFunc_setNativeKey), METH_VARARGS|METH_KEYWORDS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSystemSemaphore_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSystemSemaphore_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSystemSemaphore_Type = nullptr;
static PyTypeObject *Sbk_QSystemSemaphore_TypeF(void)
{
    return _Sbk_QSystemSemaphore_Type;
}

static PyType_Slot Sbk_QSystemSemaphore_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSystemSemaphore_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSystemSemaphore_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSystemSemaphore_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSystemSemaphore_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSystemSemaphore_spec = {
    "2:PySide6.QtCore.QSystemSemaphore",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSystemSemaphore_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QSystemSemaphore_AccessMode_PythonToCpp_QSystemSemaphore_AccessMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSystemSemaphore::AccessMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSystemSemaphore::AccessMode *>(cppOut) = value;

}
static PythonToCppFunc is_QSystemSemaphore_AccessMode_PythonToCpp_QSystemSemaphore_AccessMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX])))
        return QSystemSemaphore_AccessMode_PythonToCpp_QSystemSemaphore_AccessMode;
    return {};
}
static PyObject *QSystemSemaphore_AccessMode_CppToPython_QSystemSemaphore_AccessMode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSystemSemaphore::AccessMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX]), castCppIn);

}

static void QSystemSemaphore_SystemSemaphoreError_PythonToCpp_QSystemSemaphore_SystemSemaphoreError(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QSystemSemaphore::SystemSemaphoreError>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QSystemSemaphore::SystemSemaphoreError *>(cppOut) = value;

}
static PythonToCppFunc is_QSystemSemaphore_SystemSemaphoreError_PythonToCpp_QSystemSemaphore_SystemSemaphoreError_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_SystemSemaphoreError_IDX])))
        return QSystemSemaphore_SystemSemaphoreError_PythonToCpp_QSystemSemaphore_SystemSemaphoreError;
    return {};
}
static PyObject *QSystemSemaphore_SystemSemaphoreError_CppToPython_QSystemSemaphore_SystemSemaphoreError(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QSystemSemaphore::SystemSemaphoreError *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_SystemSemaphoreError_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSystemSemaphore_PythonToCpp_QSystemSemaphore_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSystemSemaphore_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSystemSemaphore_PythonToCpp_QSystemSemaphore_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSystemSemaphore_TypeF()))
        return QSystemSemaphore_PythonToCpp_QSystemSemaphore_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSystemSemaphore_PTR_CppToPython_QSystemSemaphore(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSystemSemaphore *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSystemSemaphore_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSystemSemaphore_SignatureStrings[] = {
    "1:PySide6.QtCore.QSystemSemaphore(self,key:typing.Union[PySide6.QtCore.QNativeIpcKey, QString],initialValue:int=0,arg__3:PySide6.QtCore.QSystemSemaphore.AccessMode=QSystemSemaphore.AccessMode.Open)",
    "0:PySide6.QtCore.QSystemSemaphore(self,key:QString,initialValue:int=0,mode:PySide6.QtCore.QSystemSemaphore.AccessMode=QSystemSemaphore.AccessMode.Open)",
    "PySide6.QtCore.QSystemSemaphore.acquire(self)->bool",
    "PySide6.QtCore.QSystemSemaphore.error(self)->PySide6.QtCore.QSystemSemaphore.SystemSemaphoreError",
    "PySide6.QtCore.QSystemSemaphore.errorString(self)->QString",
    "PySide6.QtCore.QSystemSemaphore.isKeyTypeSupported(type:PySide6.QtCore.QNativeIpcKey.Type)->bool",
    "PySide6.QtCore.QSystemSemaphore.key(self)->QString",
    "PySide6.QtCore.QSystemSemaphore.legacyNativeKey(key:QString,type:PySide6.QtCore.QNativeIpcKey.Type=QNativeIpcKey.legacyDefaultTypeForOs())->PySide6.QtCore.QNativeIpcKey",
    "PySide6.QtCore.QSystemSemaphore.nativeIpcKey(self)->PySide6.QtCore.QNativeIpcKey",
    "PySide6.QtCore.QSystemSemaphore.platformSafeKey(key:QString,type:PySide6.QtCore.QNativeIpcKey.Type=QNativeIpcKey.DefaultTypeForOs)->PySide6.QtCore.QNativeIpcKey",
    "PySide6.QtCore.QSystemSemaphore.release(self,n:int=1)->bool",
    "PySide6.QtCore.QSystemSemaphore.setKey(self,key:QString,initialValue:int=0,mode:PySide6.QtCore.QSystemSemaphore.AccessMode=QSystemSemaphore.AccessMode.Open)",
    "1:PySide6.QtCore.QSystemSemaphore.setNativeKey(self,key:typing.Union[PySide6.QtCore.QNativeIpcKey, QString],initialValue:int=0,arg__3:PySide6.QtCore.QSystemSemaphore.AccessMode=QSystemSemaphore.AccessMode.Open)",
    "0:PySide6.QtCore.QSystemSemaphore.setNativeKey(self,key:QString,initialValue:int=0,mode:PySide6.QtCore.QSystemSemaphore.AccessMode=QSystemSemaphore.AccessMode.Open,type:PySide6.QtCore.QNativeIpcKey.Type=QNativeIpcKey.legacyDefaultTypeForOs())",
    nullptr}; // Sentinel

PyTypeObject *init_QSystemSemaphore(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX].type;

    Shiboken::AutoDecRef Sbk_QSystemSemaphore_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSystemSemaphore_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSystemSemaphore",
        "QSystemSemaphore*",
        &Sbk_QSystemSemaphore_spec,
        &Shiboken::callCppDestructor< ::QSystemSemaphore >,
        Sbk_QSystemSemaphore_Type_bases.object(),
        0);
    auto *pyType = Sbk_QSystemSemaphore_TypeF(); // references _Sbk_QSystemSemaphore_Type
    InitSignatureStrings(pyType, QSystemSemaphore_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSystemSemaphore_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSystemSemaphore_PythonToCpp_QSystemSemaphore_PTR,
        is_QSystemSemaphore_PythonToCpp_QSystemSemaphore_PTR_Convertible,
        QSystemSemaphore_PTR_CppToPython_QSystemSemaphore);

    Shiboken::Conversions::registerConverterName(converter, "QSystemSemaphore");
    Shiboken::Conversions::registerConverterName(converter, "QSystemSemaphore*");
    Shiboken::Conversions::registerConverterName(converter, "QSystemSemaphore&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSystemSemaphore).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QSystemSemaphore_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'AccessMode'.
    const char *AccessMode_Initializer[] = {
        "Open",
        "Create",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AccessMode_InitializerValues[] = {
        uint8_t(QSystemSemaphore::AccessMode::Open),  //  0x00  0
        uint8_t(QSystemSemaphore::AccessMode::Create) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSystemSemaphore_TypeF(),
        "2:PySide6.QtCore.QSystemSemaphore.AccessMode",
        AccessMode_Initializer, AccessMode_InitializerValues);
    SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_AccessMode_IDX].type = EType;
    // Register converter for enum 'QSystemSemaphore::AccessMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSystemSemaphore_AccessMode_CppToPython_QSystemSemaphore_AccessMode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSystemSemaphore_AccessMode_PythonToCpp_QSystemSemaphore_AccessMode,
            is_QSystemSemaphore_AccessMode_PythonToCpp_QSystemSemaphore_AccessMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSystemSemaphore::AccessMode");
        Shiboken::Conversions::registerConverterName(converter, "AccessMode");
    }
    // End of 'AccessMode' enum.

    // Initialization of enum 'SystemSemaphoreError'.
    const char *SystemSemaphoreError_Initializer[] = {
        "NoError",
        "PermissionDenied",
        "KeyError",
        "AlreadyExists",
        "NotFound",
        "OutOfResources",
        "UnknownError",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SystemSemaphoreError_InitializerValues[] = {
        uint8_t(QSystemSemaphore::SystemSemaphoreError::NoError),          //  0x00  0
        uint8_t(QSystemSemaphore::SystemSemaphoreError::PermissionDenied), //  0x01  1
        uint8_t(QSystemSemaphore::SystemSemaphoreError::KeyError),         //  0x02  2
        uint8_t(QSystemSemaphore::SystemSemaphoreError::AlreadyExists),    //  0x03  3
        uint8_t(QSystemSemaphore::SystemSemaphoreError::NotFound),         //  0x04  4
        uint8_t(QSystemSemaphore::SystemSemaphoreError::OutOfResources),   //  0x05  5
        uint8_t(QSystemSemaphore::SystemSemaphoreError::UnknownError)      //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QSystemSemaphore_TypeF(),
        "2:PySide6.QtCore.QSystemSemaphore.SystemSemaphoreError",
        SystemSemaphoreError_Initializer, SystemSemaphoreError_InitializerValues);
    SbkPySide6_QtCoreTypeStructs[SBK_QSystemSemaphore_SystemSemaphoreError_IDX].type = EType;
    // Register converter for enum 'QSystemSemaphore::SystemSemaphoreError'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QSystemSemaphore_SystemSemaphoreError_CppToPython_QSystemSemaphore_SystemSemaphoreError);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QSystemSemaphore_SystemSemaphoreError_PythonToCpp_QSystemSemaphore_SystemSemaphoreError,
            is_QSystemSemaphore_SystemSemaphoreError_PythonToCpp_QSystemSemaphore_SystemSemaphoreError_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QSystemSemaphore::SystemSemaphoreError");
        Shiboken::Conversions::registerConverterName(converter, "SystemSemaphoreError");
    }
    // End of 'SystemSemaphoreError' enum.

    qRegisterMetaType< ::QSystemSemaphore *>();
    qRegisterMetaType< ::QSystemSemaphore::AccessMode >("QSystemSemaphore::AccessMode");
    qRegisterMetaType< ::QSystemSemaphore::SystemSemaphoreError >("QSystemSemaphore::SystemSemaphoreError");

    return pyType;
}
