// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtcore_python.h"

// main header
#include "qtcorehelper_qgenericargumentholder_wrapper.h"

// Argument includes
#include <qmetatype.h>
#include <qobjectdefs.h>
#include <qtcorehelper.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QtCoreHelper;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QtCoreHelper_QGenericArgumentHolder_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QtCoreHelper::QGenericArgumentHolder >()))
        return -1;

    ::QtCoreHelper::QGenericArgumentHolder *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtCore.QGenericArgumentHolder.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QGenericArgumentHolder", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QGenericArgumentHolder::QGenericArgumentHolder()
    // 1: QGenericArgumentHolder::QGenericArgumentHolder(QMetaType,const void*)
    // 2: QGenericArgumentHolder::QGenericArgumentHolder(QtCoreHelper::QGenericArgumentHolder)
    if (numArgs == 0) {
        overloadId = 0; // QGenericArgumentHolder()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QGenericArgumentHolder(QtCoreHelper::QGenericArgumentHolder)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), (pyArgs[1])))) {
        overloadId = 1; // QGenericArgumentHolder(QMetaType,const void*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QGenericArgumentHolder()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QGenericArgumentHolder()
                cptr = new ::QtCoreHelper::QGenericArgumentHolder();
            }
            break;
        }
        case 1: // QGenericArgumentHolder(const QMetaType & type, const void * aData)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaType cppArg0_local;
            ::QMetaType *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);

            void* cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QGenericArgumentHolder(QMetaType,const void*)
                cptr = new ::QtCoreHelper::QGenericArgumentHolder(*cppArg0, cppArg1);
            }
            break;
        }
        case 2: // QGenericArgumentHolder(const QtCoreHelper::QGenericArgumentHolder & arg__1)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QtCoreHelper::QGenericArgumentHolder cppArg0_local;
            ::QtCoreHelper::QGenericArgumentHolder *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QGenericArgumentHolder(QtCoreHelper::QGenericArgumentHolder)
                cptr = new ::QtCoreHelper::QGenericArgumentHolder(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QtCoreHelper::QGenericArgumentHolder >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QtCoreHelper_QGenericArgumentHolderFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericArgumentHolder.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            const void * cppResult = const_cast<const ::QtCoreHelper::QGenericArgumentHolder *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<void *>(), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericArgumentHolderFunc_metaType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericArgumentHolder.metaType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // metaType()const
            QMetaType cppResult = const_cast<const ::QtCoreHelper::QGenericArgumentHolder *>(cppSelf)->metaType();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QMetaType_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericArgumentHolderFunc_toGenericArgument(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QtCoreHelper::QGenericArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtCore.QGenericArgumentHolder.toGenericArgument";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // toGenericArgument()const
            QGenericArgument cppResult = const_cast<const ::QtCoreHelper::QGenericArgumentHolder *>(cppSelf)->toGenericArgument();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QGenericArgument_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QtCoreHelper_QGenericArgumentHolder__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QtCoreHelper::QGenericArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QtCoreHelper_QGenericArgumentHolder_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtCoreHelper_QGenericArgumentHolder_methods[] = {
    {"data", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericArgumentHolderFunc_data), METH_NOARGS, nullptr},
    {"metaType", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericArgumentHolderFunc_metaType), METH_NOARGS, nullptr},
    {"toGenericArgument", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericArgumentHolderFunc_toGenericArgument), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QtCoreHelper_QGenericArgumentHolder__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtCoreHelper_QGenericArgumentHolder_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtCoreHelper_QGenericArgumentHolder_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtCoreHelper_QGenericArgumentHolder_Type = nullptr;
static PyTypeObject *Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF(void)
{
    return _Sbk_QtCoreHelper_QGenericArgumentHolder_Type;
}

static PyType_Slot Sbk_QtCoreHelper_QGenericArgumentHolder_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericArgumentHolder_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericArgumentHolder_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericArgumentHolder_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QtCoreHelper_QGenericArgumentHolder_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtCoreHelper_QGenericArgumentHolder_spec = {
    "2:PySide6.QtCore.QGenericArgumentHolder",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtCoreHelper_QGenericArgumentHolder_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF()))
        return QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QGenericArgumentHolder_PTR_CppToPython_QGenericArgumentHolder(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QtCoreHelper::QGenericArgumentHolder *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QGenericArgumentHolder_COPY_CppToPython_QGenericArgumentHolder(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QtCoreHelper::QGenericArgumentHolder *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF(), new ::QtCoreHelper::QGenericArgumentHolder(*source), true, true);
}

// Python to C++ copy conversion.
static void QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QtCoreHelper::QGenericArgumentHolder *>(cppOut) = *reinterpret_cast< ::QtCoreHelper::QGenericArgumentHolder *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF()))
        return QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtCoreHelper_QGenericArgumentHolder_SignatureStrings[] = {
    "2:PySide6.QtCore.QGenericArgumentHolder(self)",
    "1:PySide6.QtCore.QGenericArgumentHolder(self,type:typing.Union[PySide6.QtCore.QMetaType, PySide6.QtCore.QMetaType.Type],aData:void)",
    "0:PySide6.QtCore.QGenericArgumentHolder(self,arg__1:PySide6.QtCore.QGenericArgumentHolder)",
    "PySide6.QtCore.QGenericArgumentHolder.data(self)->void",
    "PySide6.QtCore.QGenericArgumentHolder.metaType(self)->PySide6.QtCore.QMetaType",
    "PySide6.QtCore.QGenericArgumentHolder.toGenericArgument(self)->PySide6.QtCore.QGenericArgument",
    "PySide6.QtCore.QGenericArgumentHolder.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QtCoreHelper_QGenericArgumentHolder(PyObject *module)
{
    if (SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX].type != nullptr)
        return SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX].type;

    Shiboken::AutoDecRef Sbk_QtCoreHelper_QGenericArgumentHolder_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtCoreHelper_QGenericArgumentHolder_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QGenericArgumentHolder",
        "QtCoreHelper::QGenericArgumentHolder",
        &Sbk_QtCoreHelper_QGenericArgumentHolder_spec,
        &Shiboken::callCppDestructor< ::QtCoreHelper::QGenericArgumentHolder >,
        Sbk_QtCoreHelper_QGenericArgumentHolder_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QtCoreHelper_QGenericArgumentHolder_TypeF(); // references _Sbk_QtCoreHelper_QGenericArgumentHolder_Type
    InitSignatureStrings(pyType, QtCoreHelper_QGenericArgumentHolder_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtCoreHelper_QGenericArgumentHolder_PropertyStrings);
    SbkPySide6_QtCoreTypeStructs[SBK_QtCoreHelper_QGenericArgumentHolder_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_PTR,
        is_QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_PTR_Convertible,
        QGenericArgumentHolder_PTR_CppToPython_QGenericArgumentHolder,
        QGenericArgumentHolder_COPY_CppToPython_QGenericArgumentHolder);

    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericArgumentHolder");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericArgumentHolder*");
    Shiboken::Conversions::registerConverterName(converter, "QtCoreHelper::QGenericArgumentHolder&");
    Shiboken::Conversions::registerConverterName(converter, "QGenericArgumentHolder");
    Shiboken::Conversions::registerConverterName(converter, "QGenericArgumentHolder*");
    Shiboken::Conversions::registerConverterName(converter, "QGenericArgumentHolder&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QtCoreHelper::QGenericArgumentHolder).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_COPY,
        is_QGenericArgumentHolder_PythonToCpp_QGenericArgumentHolder_COPY_Convertible);

    qRegisterMetaType< ::QtCoreHelper::QGenericArgumentHolder >("QGenericArgumentHolder");
    qRegisterMetaType< ::QtCoreHelper::QGenericArgumentHolder >("QtCoreHelper::QGenericArgumentHolder");

    return pyType;
}
