// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTimeLineWrapper_H
#define SBK_QTimeLineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qtimeline.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTimeLineWrapper : public QTimeLine
{
public:
    QTimeLineWrapper(const QTimeLineWrapper &) = delete;
    QTimeLineWrapper& operator=(const QTimeLineWrapper &) = delete;
    QTimeLineWrapper(QTimeLineWrapper &&) = delete;
    QTimeLineWrapper& operator=(QTimeLineWrapper &&) = delete;

    QTimeLineWrapper(int duration = 1000, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    qreal valueForTime(int msec) const override;
    ~QTimeLineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QTimeLineWrapper_H

