// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdbus_python.h"

// main header
#include "qdbus_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QDBus_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDBus_EnumFlagInfo[] = {
    "CallMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDBus_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDBus_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDBus_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDBus_Type = nullptr;
static PyTypeObject *Sbk_QDBus_TypeF(void)
{
    return _Sbk_QDBus_Type;
}

static PyType_Slot Sbk_QDBus_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDBus_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDBus_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDBus_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDBus_spec = {
    "2:PySide6.QtDBus.QDBus",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDBus_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QDBus_CallMode_PythonToCpp_QDBus_CallMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDBus::CallMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDBus::CallMode *>(cppOut) = value;

}
static PythonToCppFunc is_QDBus_CallMode_PythonToCpp_QDBus_CallMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBus_CallMode_IDX])))
        return QDBus_CallMode_PythonToCpp_QDBus_CallMode;
    return {};
}
static PyObject *QDBus_CallMode_CppToPython_QDBus_CallMode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QDBus::CallMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtDBusTypeStructs[SBK_QDBus_CallMode_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtDBusQDBus_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtDBusQDBus(PyObject *module)
{
    if (SbkPySide6_QtDBusTypeStructs[SBK_QtDBusQDBus_IDX].type != nullptr)
        return SbkPySide6_QtDBusTypeStructs[SBK_QtDBusQDBus_IDX].type;

    Shiboken::AutoDecRef Sbk_QDBus_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDBus_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDBus",
        "QDBus",
        &Sbk_QDBus_spec,
        nullptr,
        Sbk_QDBus_Type_bases.object(),
        0);
    auto *pyType = Sbk_QDBus_TypeF(); // references _Sbk_QDBus_Type
    InitSignatureStrings(pyType, QtDBusQDBus_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDBus_PropertyStrings);
    SbkPySide6_QtDBusTypeStructs[SBK_QtDBusQDBus_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDBus_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'CallMode'.
    const char *CallMode_Initializer[] = {
        "NoBlock",
        "Block",
        "BlockWithGui",
        "AutoDetect",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t CallMode_InitializerValues[] = {
        uint8_t(QDBus::CallMode::NoBlock),      //  0x00  0
        uint8_t(QDBus::CallMode::Block),        //  0x01  1
        uint8_t(QDBus::CallMode::BlockWithGui), //  0x02  2
        uint8_t(QDBus::CallMode::AutoDetect)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDBus_TypeF(),
        "2:PySide6.QtDBus.QDBus.CallMode",
        CallMode_Initializer, CallMode_InitializerValues);
    SbkPySide6_QtDBusTypeStructs[SBK_QDBus_CallMode_IDX].type = EType;
    // Register converter for enum 'QDBus::CallMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDBus_CallMode_CppToPython_QDBus_CallMode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QDBus_CallMode_PythonToCpp_QDBus_CallMode,
            is_QDBus_CallMode_PythonToCpp_QDBus_CallMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QDBus::CallMode");
        Shiboken::Conversions::registerConverterName(converter, "CallMode");
    }
    // End of 'CallMode' enum.

    qRegisterMetaType< ::QDBus::CallMode >("QDBus::CallMode");

    return pyType;
}
