// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_Q3DObjectWrapper_H
#define SBK_Q3DObjectWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/q3dobject.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class Q3DObjectWrapper : public Q3DObject
{
public:
    Q3DObjectWrapper(const Q3DObjectWrapper &) = delete;
    Q3DObjectWrapper& operator=(const Q3DObjectWrapper &) = delete;
    Q3DObjectWrapper(Q3DObjectWrapper &&) = delete;
    Q3DObjectWrapper& operator=(Q3DObjectWrapper &&) = delete;

    Q3DObjectWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void copyValuesFrom(const ::Q3DObject & source) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~Q3DObjectWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_Q3DObjectWrapper_H

