// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDesignerContainerExtensionWrapper_H
#define SBK_QDesignerContainerExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/container.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QDesignerContainerExtensionWrapper : public QDesignerContainerExtension
{
public:
    QDesignerContainerExtensionWrapper(const QDesignerContainerExtensionWrapper &) = delete;
    QDesignerContainerExtensionWrapper& operator=(const QDesignerContainerExtensionWrapper &) = delete;
    QDesignerContainerExtensionWrapper(QDesignerContainerExtensionWrapper &&) = delete;
    QDesignerContainerExtensionWrapper& operator=(QDesignerContainerExtensionWrapper &&) = delete;

    QDesignerContainerExtensionWrapper() noexcept;
    void addWidget(::QWidget * widget) override;
    bool canAddWidget() const override;
    bool canRemove(int index) const override;
    int count() const override;
    int currentIndex() const override;
    void insertWidget(int index, ::QWidget * widget) override;
    void remove(int index) override;
    void setCurrentIndex(int index) override;
    ::QWidget * widget(int index) const override;
    ~QDesignerContainerExtensionWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QDesignerContainerExtensionWrapper_H

