// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtdesigner_python.h"

// main header
#include "qdesignerwidgetboxinterface_widget_wrapper.h"

// Argument includes
#include <QString>
#include <QtDesigner/abstractwidgetbox.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDesignerWidgetBoxInterface_Widget_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDesignerWidgetBoxInterface::Widget >()))
        return -1;

    ::QDesignerWidgetBoxInterface::Widget *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 4));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OOOO:Widget", &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: Widget::Widget(QDesignerWidgetBoxInterface::Widget)
    // 1: Widget::Widget(const QString&=,const QString&=,const QString&=,QDesignerWidgetBoxInterface::Widget::Type=)
    if (numArgs == 0) {
        overloadId = 1; // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 1; // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            if (numArgs == 2) {
                overloadId = 1; // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
            } else if (numArgs >= 3
                && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2])))) {
                if (numArgs == 3) {
                    overloadId = 1; // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
                } else if (numArgs >= 4
                    && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX])))->converter, (pyArgs[3])))) {
                    overloadId = 1; // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
                }
            }
        }
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), (pyArgs[0])))) {
        overloadId = 0; // Widget(QDesignerWidgetBoxInterface::Widget)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // Widget(const QDesignerWidgetBoxInterface::Widget & w)
        {
            if (kwds != nullptr && PyDict_Size(kwds) > 0) {
                errInfo.reset(kwds);
                Py_INCREF(errInfo.object());
                return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
            }
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDesignerWidgetBoxInterface::Widget cppArg0_local;
            ::QDesignerWidgetBoxInterface::Widget *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // Widget(QDesignerWidgetBoxInterface::Widget)
                cptr = new ::QDesignerWidgetBoxInterface::Widget(*cppArg0);
            }
            break;
        }
        case 1: // Widget(const QString & aname, const QString & xml, const QString & icon_name, QDesignerWidgetBoxInterface::Widget::Type atype)
        {
            if (kwds && PyDict_Size(kwds) > 0) {
                PyObject *value{};
                Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
                static PyObject *const key_aname = Shiboken::String::createStaticString("aname");
                if (PyDict_Contains(kwds, key_aname) != 0) {
                    value = PyDict_GetItem(kwds, key_aname);
                    if (value != nullptr && pyArgs[0] != nullptr ) {
                        errInfo.reset(key_aname);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[0] = value;
                        if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_aname);
                }
                static PyObject *const key_xml = Shiboken::String::createStaticString("xml");
                if (PyDict_Contains(kwds, key_xml) != 0) {
                    value = PyDict_GetItem(kwds, key_xml);
                    if (value != nullptr && pyArgs[1] != nullptr ) {
                        errInfo.reset(key_xml);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[1] = value;
                        if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_xml);
                }
                static PyObject *const key_icon_name = Shiboken::String::createStaticString("icon_name");
                if (PyDict_Contains(kwds, key_icon_name) != 0) {
                    value = PyDict_GetItem(kwds, key_icon_name);
                    if (value != nullptr && pyArgs[2] != nullptr ) {
                        errInfo.reset(key_icon_name);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[2] = value;
                        if (!(pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[2]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_icon_name);
                }
                static PyObject *const key_atype = Shiboken::String::createStaticString("atype");
                if (PyDict_Contains(kwds, key_atype) != 0) {
                    value = PyDict_GetItem(kwds, key_atype);
                    if (value != nullptr && pyArgs[3] != nullptr ) {
                        errInfo.reset(key_atype);
                        Py_INCREF(errInfo.object());
                        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    if (value != nullptr) {
                        pyArgs[3] = value;
                        if (!(pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX])))->converter, (pyArgs[3]))))
                            return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                    }
                    PyDict_DelItem(kwds_dup, key_atype);
                }
                if (PyDict_Size(kwds_dup) > 0) {
                    errInfo.reset(kwds_dup.release());
                    return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);
                }
            }
            ::QString cppArg0 = QString();
            if (pythonToCpp[0])
                pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QString cppArg1 = QString();
            if (pythonToCpp[1])
                pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QString cppArg2 = QString();
            if (pythonToCpp[2])
                pythonToCpp[2](pyArgs[2], &cppArg2);
            ::QDesignerWidgetBoxInterface::Widget::Type cppArg3(QDesignerWidgetBoxInterface::Widget::Type::Default);
            if (pythonToCpp[3])
                pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // Widget(QString,QString,QString,QDesignerWidgetBoxInterface::Widget::Type)
                cptr = new ::QDesignerWidgetBoxInterface::Widget(cppArg0, cppArg1, cppArg2, cppArg3);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDesignerWidgetBoxInterface::Widget >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_domXml(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.domXml";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // domXml()const
            QString cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppSelf)->domXml();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_iconName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.iconName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // iconName()const
            QString cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppSelf)->iconName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_isNull(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.isNull";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isNull()const
            bool cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppSelf)->isNull();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setDomXml(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setDomXml";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Widget::setDomXml(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setDomXml(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDomXml(QString)
            cppSelf->setDomXml(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setIconName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setIconName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Widget::setIconName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setIconName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setIconName(QString)
            cppSelf->setIconName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Widget::setName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setName(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setName(QString)
            cppSelf->setName(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: Widget::setType(QDesignerWidgetBoxInterface::Widget::Type)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setType(QDesignerWidgetBoxInterface::Widget::Type)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QDesignerWidgetBoxInterface::Widget::Type cppArg0{QDesignerWidgetBoxInterface::Widget::Default};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setType(QDesignerWidgetBoxInterface::Widget::Type)
            cppSelf->setType(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_WidgetFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QDesignerWidgetBoxInterface::Widget::Type cppResult = const_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDesignerWidgetBoxInterface_Widget__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDesignerWidgetBoxInterface_Widget_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QDesignerWidgetBoxInterface_Widget_EnumFlagInfo[] = {
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDesignerWidgetBoxInterface_Widget_methods[] = {
    {"domXml", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_domXml), METH_NOARGS, nullptr},
    {"iconName", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_iconName), METH_NOARGS, nullptr},
    {"isNull", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_isNull), METH_NOARGS, nullptr},
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_name), METH_NOARGS, nullptr},
    {"setDomXml", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setDomXml), METH_O, nullptr},
    {"setIconName", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setIconName), METH_O, nullptr},
    {"setName", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setName), METH_O, nullptr},
    {"setType", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_setType), METH_O, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_WidgetFunc_type), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDesignerWidgetBoxInterface_Widget__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static int Sbk_QDesignerWidgetBoxInterface_Widget___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    return !cppSelf->isNull() ? 1 : 0;
}

} // extern "C"

static int Sbk_QDesignerWidgetBoxInterface_Widget_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDesignerWidgetBoxInterface_Widget_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDesignerWidgetBoxInterface_Widget_Type = nullptr;
static PyTypeObject *Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(void)
{
    return _Sbk_QDesignerWidgetBoxInterface_Widget_Type;
}

static PyType_Slot Sbk_QDesignerWidgetBoxInterface_Widget_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Widget_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Widget_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Widget_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Widget_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QDesignerWidgetBoxInterface_Widget___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDesignerWidgetBoxInterface_Widget_spec = {
    "2:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDesignerWidgetBoxInterface_Widget_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QDesignerWidgetBoxInterface_Widget_Type_PythonToCpp_QDesignerWidgetBoxInterface_Widget_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QDesignerWidgetBoxInterface::Widget::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QDesignerWidgetBoxInterface::Widget::Type *>(cppOut) = value;

}
static PythonToCppFunc is_QDesignerWidgetBoxInterface_Widget_Type_PythonToCpp_QDesignerWidgetBoxInterface_Widget_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX])))
        return QDesignerWidgetBoxInterface_Widget_Type_PythonToCpp_QDesignerWidgetBoxInterface_Widget_Type;
    return {};
}
static PyObject *QDesignerWidgetBoxInterface_Widget_Type_CppToPython_QDesignerWidgetBoxInterface_Widget_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QDesignerWidgetBoxInterface::Widget::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Widget_PythonToCpp_Widget_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Widget_PythonToCpp_Widget_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDesignerWidgetBoxInterface_Widget_TypeF()))
        return Widget_PythonToCpp_Widget_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Widget_PTR_CppToPython_Widget(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *Widget_COPY_CppToPython_Widget(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDesignerWidgetBoxInterface::Widget *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(), new ::QDesignerWidgetBoxInterface::Widget(*source), true, true);
}

// Python to C++ copy conversion.
static void Widget_PythonToCpp_Widget_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDesignerWidgetBoxInterface::Widget *>(cppOut) = *reinterpret_cast< ::QDesignerWidgetBoxInterface::Widget *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_Widget_PythonToCpp_Widget_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDesignerWidgetBoxInterface_Widget_TypeF()))
        return Widget_PythonToCpp_Widget_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDesignerWidgetBoxInterface_Widget_SignatureStrings[] = {
    "1:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget(self,w:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget)",
    "0:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget(self,aname:QString=QString(),xml:QString=QString(),icon_name:QString=QString(),atype:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.Type=QDesignerWidgetBoxInterface.Widget.Type.Default)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.domXml(self)->QString",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.iconName(self)->QString",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.isNull(self)->bool",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.name(self)->QString",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setDomXml(self,xml:QString)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setIconName(self,icon_name:QString)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setName(self,aname:QString)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.setType(self,atype:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.Type)",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.type(self)->PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.Type",
    "PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDesignerWidgetBoxInterface_Widget(PyObject *enclosingClass)
{
    if (SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX].type != nullptr)
        return SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX].type;

    Shiboken::AutoDecRef Sbk_QDesignerWidgetBoxInterface_Widget_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDesignerWidgetBoxInterface_Widget_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "Widget",
        "QDesignerWidgetBoxInterface::Widget",
        &Sbk_QDesignerWidgetBoxInterface_Widget_spec,
        &Shiboken::callCppDestructor< ::QDesignerWidgetBoxInterface::Widget >,
        Sbk_QDesignerWidgetBoxInterface_Widget_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(); // references _Sbk_QDesignerWidgetBoxInterface_Widget_Type
    InitSignatureStrings(pyType, QDesignerWidgetBoxInterface_Widget_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDesignerWidgetBoxInterface_Widget_PropertyStrings);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        Widget_PythonToCpp_Widget_PTR,
        is_Widget_PythonToCpp_Widget_PTR_Convertible,
        Widget_PTR_CppToPython_Widget,
        Widget_COPY_CppToPython_Widget);

    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Widget");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Widget*");
    Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Widget&");
    Shiboken::Conversions::registerConverterName(converter, "Widget");
    Shiboken::Conversions::registerConverterName(converter, "Widget*");
    Shiboken::Conversions::registerConverterName(converter, "Widget&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDesignerWidgetBoxInterface::Widget).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        Widget_PythonToCpp_Widget_COPY,
        is_Widget_PythonToCpp_Widget_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QDesignerWidgetBoxInterface_Widget_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "Default",
        "Custom",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Type_InitializerValues[] = {
        uint8_t(QDesignerWidgetBoxInterface::Widget::Type::Default), //  0x00  0
        uint8_t(QDesignerWidgetBoxInterface::Widget::Type::Custom)   //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QDesignerWidgetBoxInterface_Widget_TypeF(),
        "2:PySide6.QtDesigner.QDesignerWidgetBoxInterface.Widget.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtDesignerTypeStructs[SBK_QDesignerWidgetBoxInterface_Widget_Type_IDX].type = EType;
    // Register converter for enum 'QDesignerWidgetBoxInterface::Widget::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QDesignerWidgetBoxInterface_Widget_Type_CppToPython_QDesignerWidgetBoxInterface_Widget_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QDesignerWidgetBoxInterface_Widget_Type_PythonToCpp_QDesignerWidgetBoxInterface_Widget_Type,
            is_QDesignerWidgetBoxInterface_Widget_Type_PythonToCpp_QDesignerWidgetBoxInterface_Widget_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QDesignerWidgetBoxInterface::Widget::Type");
        Shiboken::Conversions::registerConverterName(converter, "Widget::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Widget >("Widget");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Widget >("QDesignerWidgetBoxInterface::Widget");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Widget::Type >("Widget::Type");
    qRegisterMetaType< ::QDesignerWidgetBoxInterface::Widget::Type >("QDesignerWidgetBoxInterface::Widget::Type");

    return pyType;
}
