// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QExtensionManagerWrapper_H
#define SBK_QExtensionManagerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/qextensionmanager.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QExtensionManagerWrapper : public QExtensionManager
{
public:
    QExtensionManagerWrapper(const QExtensionManagerWrapper &) = delete;
    QExtensionManagerWrapper& operator=(const QExtensionManagerWrapper &) = delete;
    QExtensionManagerWrapper(QExtensionManagerWrapper &&) = delete;
    QExtensionManagerWrapper& operator=(QExtensionManagerWrapper &&) = delete;

    QExtensionManagerWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QObject * extension(::QObject * object, const ::QString & iid) const override;
    void registerExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid = QString()) override;
    void timerEvent(::QTimerEvent * event) override;
    void unregisterExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid = QString()) override;
    ~QExtensionManagerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QExtensionManagerWrapper_H

