// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPyDesignerPropertySheetExtensionWrapper_H
#define SBK_QPyDesignerPropertySheetExtensionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpydesignerextensions.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPyDesignerPropertySheetExtensionWrapper : public QPyDesignerPropertySheetExtension
{
public:
    QPyDesignerPropertySheetExtensionWrapper(const QPyDesignerPropertySheetExtensionWrapper &) = delete;
    QPyDesignerPropertySheetExtensionWrapper& operator=(const QPyDesignerPropertySheetExtensionWrapper &) = delete;
    QPyDesignerPropertySheetExtensionWrapper(QPyDesignerPropertySheetExtensionWrapper &&) = delete;
    QPyDesignerPropertySheetExtensionWrapper& operator=(QPyDesignerPropertySheetExtensionWrapper &&) = delete;

    QPyDesignerPropertySheetExtensionWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    int count() const override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasReset(int index) const override;
    int indexOf(const ::QString & name) const override;
    bool isAttribute(int index) const override;
    bool isChanged(int index) const override;
    bool isEnabled(int index) const override;
    bool isVisible(int index) const override;
    ::QVariant property(int index) const override;
    ::QString propertyGroup(int index) const override;
    ::QString propertyName(int index) const override;
    bool reset(int index) override;
    void setAttribute(int index, bool b) override;
    void setChanged(int index, bool changed) override;
    void setProperty(int index, const ::QVariant & value) override;
    void setPropertyGroup(int index, const ::QString & group) override;
    void setVisible(int index, bool b) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPyDesignerPropertySheetExtensionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    inline bool setProperty(const char * name, const ::QVariant & value) { return QObject::setProperty(name, value); }
    inline ::QVariant property(const char * name) const { return QObject::property(name); }
    inline bool setProperty(const char * name, ::QVariant && value) { return QObject::setProperty(name, value); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[23];
};

#endif // SBK_QPyDesignerPropertySheetExtensionWrapper_H

