// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAbstractFileIconProviderWrapper_H
#define SBK_QAbstractFileIconProviderWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qabstractfileiconprovider.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAbstractFileIconProviderWrapper : public QAbstractFileIconProvider
{
public:
    QAbstractFileIconProviderWrapper(const QAbstractFileIconProviderWrapper &) = delete;
    QAbstractFileIconProviderWrapper& operator=(const QAbstractFileIconProviderWrapper &) = delete;
    QAbstractFileIconProviderWrapper(QAbstractFileIconProviderWrapper &&) = delete;
    QAbstractFileIconProviderWrapper& operator=(QAbstractFileIconProviderWrapper &&) = delete;

    QAbstractFileIconProviderWrapper();
    ::QIcon icon(::QAbstractFileIconProvider::IconType arg__1) const override;
    ::QIcon icon(const ::QFileInfo & arg__1) const override;
    ::QFlags<QAbstractFileIconProvider::Option> options() const override;
    void setOptions(::QFlags<QAbstractFileIconProvider::Option> arg__1) override;
    ::QString type(const ::QFileInfo & arg__1) const override;
    ~QAbstractFileIconProviderWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5];
};

#endif // SBK_QAbstractFileIconProviderWrapper_H

