// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBitmapWrapper_H
#define SBK_QBitmapWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qbitmap.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QBitmapWrapper : public QBitmap
{
public:
    QBitmapWrapper(const QBitmapWrapper &) = delete;
    QBitmapWrapper& operator=(const QBitmapWrapper &) = delete;
    QBitmapWrapper(QBitmapWrapper &&) = delete;
    QBitmapWrapper& operator=(QBitmapWrapper &&) = delete;

    QBitmapWrapper();
    QBitmapWrapper(const QBitmap& self) : QBitmap(self)
    {
    }

    QBitmapWrapper(const ::QPixmap & arg__1);
    QBitmapWrapper(const ::QSize & arg__1);
    QBitmapWrapper(const ::QString & fileName, const char * format = nullptr);
    QBitmapWrapper(int w, int h);
    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    ::QPainter * sharedPainter() const override;
    ~QBitmapWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6];
};

#endif // SBK_QBitmapWrapper_H

