// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QChildWindowEventWrapper_H
#define SBK_QChildWindowEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QChildWindowEventWrapper : public QChildWindowEvent
{
public:
    QChildWindowEventWrapper(const QChildWindowEventWrapper &) = delete;
    QChildWindowEventWrapper& operator=(const QChildWindowEventWrapper &) = delete;
    QChildWindowEventWrapper(QChildWindowEventWrapper &&) = delete;
    QChildWindowEventWrapper& operator=(QChildWindowEventWrapper &&) = delete;

    QChildWindowEventWrapper(::QEvent::Type type, ::QWindow * childWindow);
    QChildWindowEventWrapper(const QChildWindowEvent& self) : QChildWindowEvent(self)
    {
    }

    ::QChildWindowEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QChildWindowEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QChildWindowEventWrapper_H

