// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qfontdatabase_wrapper.h"

// Extra includes
#include <QStringList>

// Argument includes
#include <QList>
#include <QString>
#include <QStringList>
#include <QtGui/qfont.h>
#include <QtGui/qfontdatabase.h>
#include <QtGui/qfontinfo.h>
#include <qbytearray.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QFontDatabase_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QFontDatabase >()))
        return -1;

    ::QFontDatabase *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QFontDatabase", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QFontDatabase::QFontDatabase()
    // 1: QFontDatabase::QFontDatabase(QFontDatabase)
    if (numArgs == 0) {
        overloadId = 0; // QFontDatabase()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QFontDatabase(QFontDatabase)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QFontDatabase()
        {
            Shiboken::Warnings::warnDeprecated("QFontDatabase", "QFontDatabase()");
            if (Shiboken::Errors::occurred() != nullptr)
                return -1;

            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontDatabase()
                cptr = new ::QFontDatabase();
            }
            break;
        }
        case 1: // QFontDatabase(const QFontDatabase & QFontDatabase)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFontDatabase cppArg0_local;
            ::QFontDatabase *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QFontDatabase(QFontDatabase)
                cptr = new ::QFontDatabase(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QFontDatabase >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QFontDatabaseFunc_addApplicationFont(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.addApplicationFont";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::addApplicationFont(QString)->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // addApplicationFont(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // addApplicationFont(QString)
            int cppResult = ::QFontDatabase::addApplicationFont(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_addApplicationFontFromData(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.addApplicationFontFromData";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::addApplicationFontFromData(QByteArray)->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArg)))) {
        overloadId = 0; // addApplicationFontFromData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // addApplicationFontFromData(QByteArray)
            int cppResult = ::QFontDatabase::addApplicationFontFromData(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_applicationFontFamilies(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.applicationFontFamilies";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::applicationFontFamilies(int)->QStringList
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // applicationFontFamilies(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // applicationFontFamilies(int)
            QStringList cppResult = ::QFontDatabase::applicationFontFamilies(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_bold(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.bold";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "bold", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::bold(QString,QString)->bool
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // bold(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // bold(QString,QString)
            bool cppResult = ::QFontDatabase::bold(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_families(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.families";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 0, 1));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|O:families", &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::families(QFontDatabase::WritingSystem=)->QStringList
    if (numArgs == 0) {
        overloadId = 0; // families(QFontDatabase::WritingSystem)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX])))->converter, (pyArgs[0])))) {
        overloadId = 0; // families(QFontDatabase::WritingSystem)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_writingSystem = Shiboken::String::createStaticString("writingSystem");
            if (PyDict_Contains(kwds, key_writingSystem) != 0) {
                value = PyDict_GetItem(kwds, key_writingSystem);
                if (value != nullptr && pyArgs[0] != nullptr ) {
                    errInfo.reset(key_writingSystem);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX])))->converter, (pyArgs[0]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_writingSystem);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QFontDatabase::WritingSystem cppArg0(QFontDatabase::WritingSystem::Any);
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // families(QFontDatabase::WritingSystem)
            QStringList cppResult = ::QFontDatabase::families(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_font(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.font";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "font", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::font(QString,QString,int)->QFont
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))) {
        overloadId = 0; // font(QString,QString,int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        int cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // font(QString,QString,int)
            QFont cppResult = ::QFontDatabase::font(cppArg0, cppArg1, cppArg2);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFont_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_hasFamily(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.hasFamily";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::hasFamily(QString)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // hasFamily(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // hasFamily(QString)
            bool cppResult = ::QFontDatabase::hasFamily(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_isBitmapScalable(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.isBitmapScalable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:isBitmapScalable", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::isBitmapScalable(QString,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // isBitmapScalable(QString,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // isBitmapScalable(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_style = Shiboken::String::createStaticString("style");
            if (PyDict_Contains(kwds, key_style) != 0) {
                value = PyDict_GetItem(kwds, key_style);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_style);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_style);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1 = QString();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isBitmapScalable(QString,QString)
            bool cppResult = ::QFontDatabase::isBitmapScalable(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_isFixedPitch(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.isFixedPitch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:isFixedPitch", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::isFixedPitch(QString,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // isFixedPitch(QString,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // isFixedPitch(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_style = Shiboken::String::createStaticString("style");
            if (PyDict_Contains(kwds, key_style) != 0) {
                value = PyDict_GetItem(kwds, key_style);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_style);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_style);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1 = QString();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isFixedPitch(QString,QString)
            bool cppResult = ::QFontDatabase::isFixedPitch(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_isPrivateFamily(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.isPrivateFamily";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::isPrivateFamily(QString)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // isPrivateFamily(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isPrivateFamily(QString)
            bool cppResult = ::QFontDatabase::isPrivateFamily(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_isScalable(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.isScalable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:isScalable", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::isScalable(QString,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // isScalable(QString,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // isScalable(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_style = Shiboken::String::createStaticString("style");
            if (PyDict_Contains(kwds, key_style) != 0) {
                value = PyDict_GetItem(kwds, key_style);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_style);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_style);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1 = QString();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isScalable(QString,QString)
            bool cppResult = ::QFontDatabase::isScalable(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_isSmoothlyScalable(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.isSmoothlyScalable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:isSmoothlyScalable", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::isSmoothlyScalable(QString,const QString&=)->bool
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // isSmoothlyScalable(QString,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // isSmoothlyScalable(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_style = Shiboken::String::createStaticString("style");
            if (PyDict_Contains(kwds, key_style) != 0) {
                value = PyDict_GetItem(kwds, key_style);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_style);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_style);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1 = QString();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // isSmoothlyScalable(QString,QString)
            bool cppResult = ::QFontDatabase::isSmoothlyScalable(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_italic(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.italic";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "italic", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::italic(QString,QString)->bool
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // italic(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // italic(QString,QString)
            bool cppResult = ::QFontDatabase::italic(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_pointSizes(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(self)
    SBK_UNUSED(kwds)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.pointSizes";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths
    errInfo.reset(Shiboken::checkInvalidArgumentCount(numArgs, 1, 2));
    if (!errInfo.isNull())
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    if (PyArg_ParseTuple(args, "|OO:pointSizes", &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::pointSizes(QString,const QString&=)->QList< int>
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        if (numArgs == 1) {
            overloadId = 0; // pointSizes(QString,QString)
        } else if (numArgs >= 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
            overloadId = 0; // pointSizes(QString,QString)
        }
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_style = Shiboken::String::createStaticString("style");
            if (PyDict_Contains(kwds, key_style) != 0) {
                value = PyDict_GetItem(kwds, key_style);
                if (value != nullptr && pyArgs[1] != nullptr ) {
                    errInfo.reset(key_style);
                    Py_INCREF(errInfo.object());
                    return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                if (value != nullptr) {
                    pyArgs[1] = value;
                    if (!(pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1]))))
                        return Shiboken::returnWrongArguments(args, fullName, errInfo);
                }
                PyDict_DelItem(kwds_dup, key_style);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                return Shiboken::returnWrongArguments(args, fullName, errInfo);
            }
        }
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1 = QString();
        if (pythonToCpp[1])
            pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // pointSizes(QString,QString)
            QList<int> cppResult = ::QFontDatabase::pointSizes(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_int_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_removeAllApplicationFonts(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.removeAllApplicationFonts";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeAllApplicationFonts()
            bool cppResult = ::QFontDatabase::removeAllApplicationFonts();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_removeApplicationFont(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.removeApplicationFont";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::removeApplicationFont(int)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // removeApplicationFont(int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // removeApplicationFont(int)
            bool cppResult = ::QFontDatabase::removeApplicationFont(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_smoothSizes(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.smoothSizes";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "smoothSizes", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::smoothSizes(QString,QString)->QList< int>
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // smoothSizes(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // smoothSizes(QString,QString)
            QList<int> cppResult = ::QFontDatabase::smoothSizes(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_int_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_standardSizes(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.standardSizes";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // standardSizes()
            QList<int> cppResult = ::QFontDatabase::standardSizes();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_int_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_styleString(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.styleString";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::styleString(QFont)->QString
    // 1: static QFontDatabase::styleString(QFontInfo)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFont_IDX]), (pyArg)))) {
        overloadId = 0; // styleString(QFont)
    } else if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontInfo_IDX]), (pyArg)))) {
        overloadId = 1; // styleString(QFontInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // styleString(const QFont & font)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QFont cppArg0_local;
            ::QFont *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // styleString(QFont)
                QString cppResult = ::QFontDatabase::styleString(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
        case 1: // styleString(const QFontInfo & fontInfo)
        {
            if (!Shiboken::Object::isValid(pyArg))
                return {};
            ::QFontInfo cppArg0_local = ::QFontInfo(::QFont());
            ::QFontInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp.isValue())
                pythonToCpp(pyArg, &cppArg0_local);
            else
                pythonToCpp(pyArg, &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // styleString(QFontInfo)
                QString cppResult = ::QFontDatabase::styleString(*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_styles(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.styles";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::styles(QString)->QStringList
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // styles(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // styles(QString)
            QStringList cppResult = ::QFontDatabase::styles(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QStringList_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_systemFont(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.systemFont";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::systemFont(QFontDatabase::SystemFont)->QFont
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_SystemFont_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // systemFont(QFontDatabase::SystemFont)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QFontDatabase::SystemFont cppArg0{QFontDatabase::GeneralFont};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // systemFont(QFontDatabase::SystemFont)
            QFont cppResult = ::QFontDatabase::systemFont(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFont_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_weight(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.weight";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "weight", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::weight(QString,QString)->int
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // weight(QString,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // weight(QString,QString)
            int cppResult = ::QFontDatabase::weight(cppArg0, cppArg1);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_writingSystemName(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.writingSystemName";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::writingSystemName(QFontDatabase::WritingSystem)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // writingSystemName(QFontDatabase::WritingSystem)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QFontDatabase::WritingSystem cppArg0{QFontDatabase::Any};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // writingSystemName(QFontDatabase::WritingSystem)
            QString cppResult = ::QFontDatabase::writingSystemName(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_writingSystemSample(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.writingSystemSample";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QFontDatabase::writingSystemSample(QFontDatabase::WritingSystem)->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // writingSystemSample(QFontDatabase::WritingSystem)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QFontDatabase::WritingSystem cppArg0{QFontDatabase::Any};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // writingSystemSample(QFontDatabase::WritingSystem)
            QString cppResult = ::QFontDatabase::writingSystemSample(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabaseFunc_writingSystems(PyObject *self, PyObject *args)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QFontDatabase.writingSystems";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "writingSystems", 0, 1, &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: static QFontDatabase::writingSystems()->QList< QFontDatabase::WritingSystem>
    // 1: static QFontDatabase::writingSystems(QString)->QList< QFontDatabase::WritingSystem>
    if (numArgs == 0) {
        overloadId = 0; // writingSystems()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[0])))) {
        overloadId = 1; // writingSystems(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // writingSystems()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // writingSystems()
                QList<QFontDatabase::WritingSystem> cppResult = ::QFontDatabase::writingSystems();
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QFontDatabase_WritingSystem_IDX], &cppResult);
            }
            break;
        }
        case 1: // writingSystems(const QString & family)
        {
            ::QString cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // writingSystems(QString)
                QList<QFontDatabase::WritingSystem> cppResult = ::QFontDatabase::writingSystems(cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QFontDatabase_WritingSystem_IDX], &cppResult);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QFontDatabase__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QFontDatabase *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QFontDatabase_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QFontDatabase_EnumFlagInfo[] = {
    "SystemFont:Enum",
    "WritingSystem:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QFontDatabase_methods[] = {
    {"addApplicationFont", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_addApplicationFont), METH_O|METH_STATIC, nullptr},
    {"addApplicationFontFromData", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_addApplicationFontFromData), METH_O|METH_STATIC, nullptr},
    {"applicationFontFamilies", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_applicationFontFamilies), METH_O|METH_STATIC, nullptr},
    {"bold", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_bold), METH_VARARGS|METH_STATIC, nullptr},
    {"families", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_families), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"font", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_font), METH_VARARGS|METH_STATIC, nullptr},
    {"hasFamily", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_hasFamily), METH_O|METH_STATIC, nullptr},
    {"isBitmapScalable", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_isBitmapScalable), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"isFixedPitch", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_isFixedPitch), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"isPrivateFamily", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_isPrivateFamily), METH_O|METH_STATIC, nullptr},
    {"isScalable", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_isScalable), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"isSmoothlyScalable", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_isSmoothlyScalable), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"italic", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_italic), METH_VARARGS|METH_STATIC, nullptr},
    {"pointSizes", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_pointSizes), METH_VARARGS|METH_KEYWORDS|METH_STATIC, nullptr},
    {"removeAllApplicationFonts", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_removeAllApplicationFonts), METH_NOARGS|METH_STATIC, nullptr},
    {"removeApplicationFont", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_removeApplicationFont), METH_O|METH_STATIC, nullptr},
    {"smoothSizes", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_smoothSizes), METH_VARARGS|METH_STATIC, nullptr},
    {"standardSizes", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_standardSizes), METH_NOARGS|METH_STATIC, nullptr},
    {"styleString", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_styleString), METH_O|METH_STATIC, nullptr},
    {"styles", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_styles), METH_O|METH_STATIC, nullptr},
    {"systemFont", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_systemFont), METH_O|METH_STATIC, nullptr},
    {"weight", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_weight), METH_VARARGS|METH_STATIC, nullptr},
    {"writingSystemName", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_writingSystemName), METH_O|METH_STATIC, nullptr},
    {"writingSystemSample", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_writingSystemSample), METH_O|METH_STATIC, nullptr},
    {"writingSystems", reinterpret_cast<PyCFunction>(Sbk_QFontDatabaseFunc_writingSystems), METH_VARARGS|METH_STATIC, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QFontDatabase__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QFontDatabase_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QFontDatabase_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QFontDatabase_Type = nullptr;
static PyTypeObject *Sbk_QFontDatabase_TypeF(void)
{
    return _Sbk_QFontDatabase_Type;
}

static PyType_Slot Sbk_QFontDatabase_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QFontDatabase_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QFontDatabase_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QFontDatabase_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QFontDatabase_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QFontDatabase_spec = {
    "2:PySide6.QtGui.QFontDatabase",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QFontDatabase_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QFontDatabase_WritingSystem_PythonToCpp_QFontDatabase_WritingSystem(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QFontDatabase::WritingSystem>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QFontDatabase::WritingSystem *>(cppOut) = value;

}
static PythonToCppFunc is_QFontDatabase_WritingSystem_PythonToCpp_QFontDatabase_WritingSystem_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX])))
        return QFontDatabase_WritingSystem_PythonToCpp_QFontDatabase_WritingSystem;
    return {};
}
static PyObject *QFontDatabase_WritingSystem_CppToPython_QFontDatabase_WritingSystem(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QFontDatabase::WritingSystem *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX]), castCppIn);

}

static void QFontDatabase_SystemFont_PythonToCpp_QFontDatabase_SystemFont(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QFontDatabase::SystemFont>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QFontDatabase::SystemFont *>(cppOut) = value;

}
static PythonToCppFunc is_QFontDatabase_SystemFont_PythonToCpp_QFontDatabase_SystemFont_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_SystemFont_IDX])))
        return QFontDatabase_SystemFont_PythonToCpp_QFontDatabase_SystemFont;
    return {};
}
static PyObject *QFontDatabase_SystemFont_CppToPython_QFontDatabase_SystemFont(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QFontDatabase::SystemFont *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_SystemFont_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QFontDatabase_PythonToCpp_QFontDatabase_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QFontDatabase_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QFontDatabase_PythonToCpp_QFontDatabase_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QFontDatabase_TypeF()))
        return QFontDatabase_PythonToCpp_QFontDatabase_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QFontDatabase_PTR_CppToPython_QFontDatabase(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QFontDatabase *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QFontDatabase_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QFontDatabase_COPY_CppToPython_QFontDatabase(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QFontDatabase *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QFontDatabase_TypeF(), new ::QFontDatabase(*source), true, true);
}

// Python to C++ copy conversion.
static void QFontDatabase_PythonToCpp_QFontDatabase_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFontDatabase *>(cppOut) = *reinterpret_cast< ::QFontDatabase *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QFontDatabase_PythonToCpp_QFontDatabase_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QFontDatabase_TypeF()))
        return QFontDatabase_PythonToCpp_QFontDatabase_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QFontDatabase_SignatureStrings[] = {
    "1:PySide6.QtGui.QFontDatabase(self)",
    "0:PySide6.QtGui.QFontDatabase(self,QFontDatabase:PySide6.QtGui.QFontDatabase)",
    "PySide6.QtGui.QFontDatabase.addApplicationFont(fileName:QString)->int",
    "PySide6.QtGui.QFontDatabase.addApplicationFontFromData(fontData:typing.Union[PySide6.QtCore.QByteArray, char*])->int",
    "PySide6.QtGui.QFontDatabase.applicationFontFamilies(id:int)->QStringList",
    "PySide6.QtGui.QFontDatabase.bold(family:QString,style:QString)->bool",
    "PySide6.QtGui.QFontDatabase.families(writingSystem:PySide6.QtGui.QFontDatabase.WritingSystem=QFontDatabase.WritingSystem.Any)->QStringList",
    "PySide6.QtGui.QFontDatabase.font(family:QString,style:QString,pointSize:int)->PySide6.QtGui.QFont",
    "PySide6.QtGui.QFontDatabase.hasFamily(family:QString)->bool",
    "PySide6.QtGui.QFontDatabase.isBitmapScalable(family:QString,style:QString=QString())->bool",
    "PySide6.QtGui.QFontDatabase.isFixedPitch(family:QString,style:QString=QString())->bool",
    "PySide6.QtGui.QFontDatabase.isPrivateFamily(family:QString)->bool",
    "PySide6.QtGui.QFontDatabase.isScalable(family:QString,style:QString=QString())->bool",
    "PySide6.QtGui.QFontDatabase.isSmoothlyScalable(family:QString,style:QString=QString())->bool",
    "PySide6.QtGui.QFontDatabase.italic(family:QString,style:QString)->bool",
    "PySide6.QtGui.QFontDatabase.pointSizes(family:QString,style:QString=QString())->QList[int]",
    "PySide6.QtGui.QFontDatabase.removeAllApplicationFonts()->bool",
    "PySide6.QtGui.QFontDatabase.removeApplicationFont(id:int)->bool",
    "PySide6.QtGui.QFontDatabase.smoothSizes(family:QString,style:QString)->QList[int]",
    "PySide6.QtGui.QFontDatabase.standardSizes()->QList[int]",
    "1:PySide6.QtGui.QFontDatabase.styleString(font:typing.Union[PySide6.QtGui.QFont, QString, QStringList])->QString",
    "0:PySide6.QtGui.QFontDatabase.styleString(fontInfo:typing.Union[PySide6.QtGui.QFontInfo, PySide6.QtGui.QFont])->QString",
    "PySide6.QtGui.QFontDatabase.styles(family:QString)->QStringList",
    "PySide6.QtGui.QFontDatabase.systemFont(type:PySide6.QtGui.QFontDatabase.SystemFont)->PySide6.QtGui.QFont",
    "PySide6.QtGui.QFontDatabase.weight(family:QString,style:QString)->int",
    "PySide6.QtGui.QFontDatabase.writingSystemName(writingSystem:PySide6.QtGui.QFontDatabase.WritingSystem)->QString",
    "PySide6.QtGui.QFontDatabase.writingSystemSample(writingSystem:PySide6.QtGui.QFontDatabase.WritingSystem)->QString",
    "1:PySide6.QtGui.QFontDatabase.writingSystems()->QList[PySide6.QtGui.QFontDatabase.WritingSystem]",
    "0:PySide6.QtGui.QFontDatabase.writingSystems(family:QString)->QList[PySide6.QtGui.QFontDatabase.WritingSystem]",
    "PySide6.QtGui.QFontDatabase.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QFontDatabase(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX].type;

    Shiboken::AutoDecRef Sbk_QFontDatabase_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QFontDatabase_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QFontDatabase",
        "QFontDatabase",
        &Sbk_QFontDatabase_spec,
        &Shiboken::callCppDestructor< ::QFontDatabase >,
        Sbk_QFontDatabase_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QFontDatabase_TypeF(); // references _Sbk_QFontDatabase_Type
    InitSignatureStrings(pyType, QFontDatabase_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QFontDatabase_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QFontDatabase_PythonToCpp_QFontDatabase_PTR,
        is_QFontDatabase_PythonToCpp_QFontDatabase_PTR_Convertible,
        QFontDatabase_PTR_CppToPython_QFontDatabase,
        QFontDatabase_COPY_CppToPython_QFontDatabase);

    Shiboken::Conversions::registerConverterName(converter, "QFontDatabase");
    Shiboken::Conversions::registerConverterName(converter, "QFontDatabase*");
    Shiboken::Conversions::registerConverterName(converter, "QFontDatabase&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QFontDatabase).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QFontDatabase_PythonToCpp_QFontDatabase_COPY,
        is_QFontDatabase_PythonToCpp_QFontDatabase_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QFontDatabase_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'WritingSystem'.
    const char *WritingSystem_Initializer[] = {
        "Any",
        "Latin",
        "Greek",
        "Cyrillic",
        "Armenian",
        "Hebrew",
        "Arabic",
        "Syriac",
        "Thaana",
        "Devanagari",
        "Bengali",
        "Gurmukhi",
        "Gujarati",
        "Oriya",
        "Tamil",
        "Telugu",
        "Kannada",
        "Malayalam",
        "Sinhala",
        "Thai",
        "Lao",
        "Tibetan",
        "Myanmar",
        "Georgian",
        "Khmer",
        "SimplifiedChinese",
        "TraditionalChinese",
        "Japanese",
        "Korean",
        "Vietnamese",
        "Symbol",
        "Other",
        "Ogham",
        "Runic",
        "Nko",
        "WritingSystemsCount",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t WritingSystem_InitializerValues[] = {
        uint8_t(QFontDatabase::WritingSystem::Any),                //  0x00  0
        uint8_t(QFontDatabase::WritingSystem::Latin),              //  0x01  1
        uint8_t(QFontDatabase::WritingSystem::Greek),              //  0x02  2
        uint8_t(QFontDatabase::WritingSystem::Cyrillic),           //  0x03  3
        uint8_t(QFontDatabase::WritingSystem::Armenian),           //  0x04  4
        uint8_t(QFontDatabase::WritingSystem::Hebrew),             //  0x05  5
        uint8_t(QFontDatabase::WritingSystem::Arabic),             //  0x06  6
        uint8_t(QFontDatabase::WritingSystem::Syriac),             //  0x07  7
        uint8_t(QFontDatabase::WritingSystem::Thaana),             //  0x08  8
        uint8_t(QFontDatabase::WritingSystem::Devanagari),         //  0x09  9
        uint8_t(QFontDatabase::WritingSystem::Bengali),            //  0x0a  10
        uint8_t(QFontDatabase::WritingSystem::Gurmukhi),           //  0x0b  11
        uint8_t(QFontDatabase::WritingSystem::Gujarati),           //  0x0c  12
        uint8_t(QFontDatabase::WritingSystem::Oriya),              //  0x0d  13
        uint8_t(QFontDatabase::WritingSystem::Tamil),              //  0x0e  14
        uint8_t(QFontDatabase::WritingSystem::Telugu),             //  0x0f  15
        uint8_t(QFontDatabase::WritingSystem::Kannada),            //  0x10  16
        uint8_t(QFontDatabase::WritingSystem::Malayalam),          //  0x11  17
        uint8_t(QFontDatabase::WritingSystem::Sinhala),            //  0x12  18
        uint8_t(QFontDatabase::WritingSystem::Thai),               //  0x13  19
        uint8_t(QFontDatabase::WritingSystem::Lao),                //  0x14  20
        uint8_t(QFontDatabase::WritingSystem::Tibetan),            //  0x15  21
        uint8_t(QFontDatabase::WritingSystem::Myanmar),            //  0x16  22
        uint8_t(QFontDatabase::WritingSystem::Georgian),           //  0x17  23
        uint8_t(QFontDatabase::WritingSystem::Khmer),              //  0x18  24
        uint8_t(QFontDatabase::WritingSystem::SimplifiedChinese),  //  0x19  25
        uint8_t(QFontDatabase::WritingSystem::TraditionalChinese), //  0x1a  26
        uint8_t(QFontDatabase::WritingSystem::Japanese),           //  0x1b  27
        uint8_t(QFontDatabase::WritingSystem::Korean),             //  0x1c  28
        uint8_t(QFontDatabase::WritingSystem::Vietnamese),         //  0x1d  29
        uint8_t(QFontDatabase::WritingSystem::Symbol),             //  0x1e  30
        uint8_t(QFontDatabase::WritingSystem::Other),              //  0x1e  30
        uint8_t(QFontDatabase::WritingSystem::Ogham),              //  0x1f  31
        uint8_t(QFontDatabase::WritingSystem::Runic),              //  0x20  32
        uint8_t(QFontDatabase::WritingSystem::Nko),                //  0x21  33
        uint8_t(QFontDatabase::WritingSystem::WritingSystemsCount) //  0x22  34
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QFontDatabase_TypeF(),
        "2:PySide6.QtGui.QFontDatabase.WritingSystem",
        WritingSystem_Initializer, WritingSystem_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_WritingSystem_IDX].type = EType;
    // Register converter for enum 'QFontDatabase::WritingSystem'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QFontDatabase_WritingSystem_CppToPython_QFontDatabase_WritingSystem);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QFontDatabase_WritingSystem_PythonToCpp_QFontDatabase_WritingSystem,
            is_QFontDatabase_WritingSystem_PythonToCpp_QFontDatabase_WritingSystem_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QFontDatabase::WritingSystem");
        Shiboken::Conversions::registerConverterName(converter, "WritingSystem");
    }
    // End of 'WritingSystem' enum.

    // Initialization of enum 'SystemFont'.
    const char *SystemFont_Initializer[] = {
        "GeneralFont",
        "FixedFont",
        "TitleFont",
        "SmallestReadableFont",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SystemFont_InitializerValues[] = {
        uint8_t(QFontDatabase::SystemFont::GeneralFont),         //  0x00  0
        uint8_t(QFontDatabase::SystemFont::FixedFont),           //  0x01  1
        uint8_t(QFontDatabase::SystemFont::TitleFont),           //  0x02  2
        uint8_t(QFontDatabase::SystemFont::SmallestReadableFont) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QFontDatabase_TypeF(),
        "2:PySide6.QtGui.QFontDatabase.SystemFont",
        SystemFont_Initializer, SystemFont_InitializerValues);
    SbkPySide6_QtGuiTypeStructs[SBK_QFontDatabase_SystemFont_IDX].type = EType;
    // Register converter for enum 'QFontDatabase::SystemFont'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QFontDatabase_SystemFont_CppToPython_QFontDatabase_SystemFont);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QFontDatabase_SystemFont_PythonToCpp_QFontDatabase_SystemFont,
            is_QFontDatabase_SystemFont_PythonToCpp_QFontDatabase_SystemFont_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QFontDatabase::SystemFont");
        Shiboken::Conversions::registerConverterName(converter, "SystemFont");
    }
    // End of 'SystemFont' enum.

    qRegisterMetaType< ::QFontDatabase >("QFontDatabase");
    qRegisterMetaType< ::QFontDatabase::WritingSystem >("QFontDatabase::WritingSystem");
    qRegisterMetaType< ::QFontDatabase::SystemFont >("QFontDatabase::SystemFont");

    return pyType;
}
