// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOffscreenSurfaceWrapper_H
#define SBK_QOffscreenSurfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qoffscreensurface.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QOffscreenSurfaceWrapper : public QOffscreenSurface
{
public:
    QOffscreenSurfaceWrapper(const QOffscreenSurfaceWrapper &) = delete;
    QOffscreenSurfaceWrapper& operator=(const QOffscreenSurfaceWrapper &) = delete;
    QOffscreenSurfaceWrapper(QOffscreenSurfaceWrapper &&) = delete;
    QOffscreenSurfaceWrapper& operator=(QOffscreenSurfaceWrapper &&) = delete;

    QOffscreenSurfaceWrapper(::QScreen * screen = nullptr, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QSurfaceFormat format() const override;
    ::QSize size() const override;
    ::QSurface::SurfaceType surfaceType() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QOffscreenSurfaceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QOffscreenSurfaceWrapper_H

