// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPaintDeviceWindowWrapper_H
#define SBK_QPaintDeviceWindowWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qpaintdevicewindow.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPaintDeviceWindowWrapper : public QPaintDeviceWindow
{
public:
    QPaintDeviceWindowWrapper(const QPaintDeviceWindowWrapper &) = delete;
    QPaintDeviceWindowWrapper& operator=(const QPaintDeviceWindowWrapper &) = delete;
    QPaintDeviceWindowWrapper(QPaintDeviceWindowWrapper &&) = delete;
    QPaintDeviceWindowWrapper& operator=(QPaintDeviceWindowWrapper &&) = delete;

    ::QAccessibleInterface * accessibleRoot() const override;
    void childEvent(::QChildEvent * event) override;
    void closeEvent(::QCloseEvent * arg__1) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    int devType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void exposeEvent(::QExposeEvent * arg__1) override;
    void focusInEvent(::QFocusEvent * arg__1) override;
    ::QObject * focusObject() const override;
    void focusOutEvent(::QFocusEvent * arg__1) override;
    ::QSurfaceFormat format() const override;
    void hideEvent(::QHideEvent * arg__1) override;
    void initPainter(::QPainter * painter) const override;
    void keyPressEvent(::QKeyEvent * arg__1) override;
    void keyReleaseEvent(::QKeyEvent * arg__1) override;
    int metric(::QPaintDevice::PaintDeviceMetric metric) const override;
    void mouseDoubleClickEvent(::QMouseEvent * arg__1) override;
    void mouseMoveEvent(::QMouseEvent * arg__1) override;
    void mousePressEvent(::QMouseEvent * arg__1) override;
    void mouseReleaseEvent(::QMouseEvent * arg__1) override;
    void moveEvent(::QMoveEvent * arg__1) override;
    bool nativeEvent(const ::QByteArray & eventType, void * message, ::qintptr * result) override;
    void paintEvent(::QPaintEvent * event) override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    void resizeEvent(::QResizeEvent * arg__1) override;
    ::QPainter * sharedPainter() const override;
    void showEvent(::QShowEvent * arg__1) override;
    ::QSize size() const override;
    ::QSurface::SurfaceType surfaceType() const override;
    void tabletEvent(::QTabletEvent * arg__1) override;
    void timerEvent(::QTimerEvent * event) override;
    void touchEvent(::QTouchEvent * arg__1) override;
    void wheelEvent(::QWheelEvent * arg__1) override;
    ~QPaintDeviceWindowWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[36];
};

#endif // SBK_QPaintDeviceWindowWrapper_H

