// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPyTextObjectWrapper_H
#define SBK_QPyTextObjectWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qpytextobject.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPyTextObjectWrapper : public QPyTextObject
{
public:
    QPyTextObjectWrapper(const QPyTextObjectWrapper &) = delete;
    QPyTextObjectWrapper& operator=(const QPyTextObjectWrapper &) = delete;
    QPyTextObjectWrapper(QPyTextObjectWrapper &&) = delete;
    QPyTextObjectWrapper& operator=(QPyTextObjectWrapper &&) = delete;

    QPyTextObjectWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void drawObject(::QPainter * painter, const ::QRectF & rect, ::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QSizeF intrinsicSize(::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QPyTextObjectWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QPyTextObjectWrapper_H

