// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QResizeEventWrapper_H
#define SBK_QResizeEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QResizeEventWrapper : public QResizeEvent
{
public:
    QResizeEventWrapper(const QResizeEventWrapper &) = delete;
    QResizeEventWrapper& operator=(const QResizeEventWrapper &) = delete;
    QResizeEventWrapper(QResizeEventWrapper &&) = delete;
    QResizeEventWrapper& operator=(QResizeEventWrapper &&) = delete;

    QResizeEventWrapper(const QResizeEvent& self) : QResizeEvent(self)
    {
    }

    QResizeEventWrapper(const ::QSize & size, const ::QSize & oldSize);
    ::QResizeEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QResizeEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QResizeEventWrapper_H

