// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhigraphicspipeline_stencilopstate_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiGraphicsPipeline_StencilOpState_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiGraphicsPipeline::StencilOpState >()))
        return -1;

    ::QRhiGraphicsPipeline::StencilOpState *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "StencilOpState", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: StencilOpState::StencilOpState()
    // 1: StencilOpState::StencilOpState(QRhiGraphicsPipeline::StencilOpState)
    if (numArgs == 0) {
        overloadId = 0; // StencilOpState()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), (pyArgs[0])))) {
        overloadId = 1; // StencilOpState(QRhiGraphicsPipeline::StencilOpState)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // StencilOpState()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // StencilOpState()
                cptr = new ::QRhiGraphicsPipeline::StencilOpState();
            }
            break;
        }
        case 1: // StencilOpState(const QRhiGraphicsPipeline::StencilOpState & StencilOpState)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiGraphicsPipeline::StencilOpState cppArg0_local;
            ::QRhiGraphicsPipeline::StencilOpState *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // StencilOpState(QRhiGraphicsPipeline::StencilOpState)
                cptr = new ::QRhiGraphicsPipeline::StencilOpState(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiGraphicsPipeline::StencilOpState >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiGraphicsPipeline_StencilOpState__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiGraphicsPipeline_StencilOpState_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiGraphicsPipeline_StencilOpState_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiGraphicsPipeline_StencilOpState__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QRhiGraphicsPipeline_StencilOpState_get_failOp(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::StencilOp cppOut_local = cppSelf->failOp;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_StencilOpState_set_failOp(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("failOp");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("failOp", "StencilOp");
        return -1;
    }

    auto cppOut_local = cppSelf->failOp;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->failOp = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_StencilOpState_get_depthFailOp(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::StencilOp cppOut_local = cppSelf->depthFailOp;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_StencilOpState_set_depthFailOp(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("depthFailOp");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("depthFailOp", "StencilOp");
        return -1;
    }

    auto cppOut_local = cppSelf->depthFailOp;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->depthFailOp = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_StencilOpState_get_passOp(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::StencilOp cppOut_local = cppSelf->passOp;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_StencilOpState_set_passOp(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("passOp");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("passOp", "StencilOp");
        return -1;
    }

    auto cppOut_local = cppSelf->passOp;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->passOp = cppOut_local;

    return 0;
}

static PyObject *Sbk_QRhiGraphicsPipeline_StencilOpState_get_compareOp(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QRhiGraphicsPipeline::CompareOp cppOut_local = cppSelf->compareOp;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_CompareOp_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QRhiGraphicsPipeline_StencilOpState_set_compareOp(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("compareOp");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_CompareOp_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("compareOp", "CompareOp");
        return -1;
    }

    auto cppOut_local = cppSelf->compareOp;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->compareOp = cppOut_local;

    return 0;
}

// Getters and Setters for StencilOpState
static PyGetSetDef Sbk_QRhiGraphicsPipeline_StencilOpState_getsetlist[] = {
    {const_cast<char *>("failOp"), Sbk_QRhiGraphicsPipeline_StencilOpState_get_failOp, Sbk_QRhiGraphicsPipeline_StencilOpState_set_failOp, nullptr, nullptr},
    {const_cast<char *>("depthFailOp"), Sbk_QRhiGraphicsPipeline_StencilOpState_get_depthFailOp, Sbk_QRhiGraphicsPipeline_StencilOpState_set_depthFailOp, nullptr, nullptr},
    {const_cast<char *>("passOp"), Sbk_QRhiGraphicsPipeline_StencilOpState_get_passOp, Sbk_QRhiGraphicsPipeline_StencilOpState_set_passOp, nullptr, nullptr},
    {const_cast<char *>("compareOp"), Sbk_QRhiGraphicsPipeline_StencilOpState_get_compareOp, Sbk_QRhiGraphicsPipeline_StencilOpState_set_compareOp, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiGraphicsPipeline_StencilOpState_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiGraphicsPipeline_StencilOpState_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiGraphicsPipeline_StencilOpState_Type = nullptr;
static PyTypeObject *Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF(void)
{
    return _Sbk_QRhiGraphicsPipeline_StencilOpState_Type;
}

static PyType_Slot Sbk_QRhiGraphicsPipeline_StencilOpState_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_StencilOpState_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_StencilOpState_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_StencilOpState_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_StencilOpState_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiGraphicsPipeline_StencilOpState_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiGraphicsPipeline_StencilOpState_spec = {
    "2:PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiGraphicsPipeline_StencilOpState_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void StencilOpState_PythonToCpp_StencilOpState_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_StencilOpState_PythonToCpp_StencilOpState_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF()))
        return StencilOpState_PythonToCpp_StencilOpState_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *StencilOpState_PTR_CppToPython_StencilOpState(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiGraphicsPipeline::StencilOpState *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *StencilOpState_COPY_CppToPython_StencilOpState(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiGraphicsPipeline::StencilOpState *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF(), new ::QRhiGraphicsPipeline::StencilOpState(*source), true, true);
}

// Python to C++ copy conversion.
static void StencilOpState_PythonToCpp_StencilOpState_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiGraphicsPipeline::StencilOpState *>(cppOut) = *reinterpret_cast< ::QRhiGraphicsPipeline::StencilOpState *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_StencilOpState_PythonToCpp_StencilOpState_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF()))
        return StencilOpState_PythonToCpp_StencilOpState_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiGraphicsPipeline_StencilOpState_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState(self)",
    "0:PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState(self,StencilOpState:PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState)",
    "PySide6.QtGui.QRhiGraphicsPipeline.StencilOpState.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiGraphicsPipeline_StencilOpState(PyObject *enclosingClass)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiGraphicsPipeline_StencilOpState_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiGraphicsPipeline_StencilOpState_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "StencilOpState",
        "QRhiGraphicsPipeline::StencilOpState",
        &Sbk_QRhiGraphicsPipeline_StencilOpState_spec,
        &Shiboken::callCppDestructor< ::QRhiGraphicsPipeline::StencilOpState >,
        Sbk_QRhiGraphicsPipeline_StencilOpState_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiGraphicsPipeline_StencilOpState_TypeF(); // references _Sbk_QRhiGraphicsPipeline_StencilOpState_Type
    InitSignatureStrings(pyType, QRhiGraphicsPipeline_StencilOpState_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiGraphicsPipeline_StencilOpState_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiGraphicsPipeline_StencilOpState_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        StencilOpState_PythonToCpp_StencilOpState_PTR,
        is_StencilOpState_PythonToCpp_StencilOpState_PTR_Convertible,
        StencilOpState_PTR_CppToPython_StencilOpState,
        StencilOpState_COPY_CppToPython_StencilOpState);

    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::StencilOpState");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::StencilOpState*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiGraphicsPipeline::StencilOpState&");
    Shiboken::Conversions::registerConverterName(converter, "StencilOpState");
    Shiboken::Conversions::registerConverterName(converter, "StencilOpState*");
    Shiboken::Conversions::registerConverterName(converter, "StencilOpState&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiGraphicsPipeline::StencilOpState).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        StencilOpState_PythonToCpp_StencilOpState_COPY,
        is_StencilOpState_PythonToCpp_StencilOpState_COPY_Convertible);

    qRegisterMetaType< ::QRhiGraphicsPipeline::StencilOpState >("StencilOpState");
    qRegisterMetaType< ::QRhiGraphicsPipeline::StencilOpState >("QRhiGraphicsPipeline::StencilOpState");

    return pyType;
}
