// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhinullinitparams_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiNullInitParams_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiNullInitParams >()))
        return -1;

    ::QRhiNullInitParams *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtGui.QRhiNullInitParams.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiNullInitParams", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiNullInitParams::QRhiNullInitParams()
    // 1: QRhiNullInitParams::QRhiNullInitParams(QRhiNullInitParams)
    if (numArgs == 0) {
        overloadId = 0; // QRhiNullInitParams()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiNullInitParams(QRhiNullInitParams)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiNullInitParams()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiNullInitParams()
                cptr = new ::QRhiNullInitParams();
            }
            break;
        }
        case 1: // QRhiNullInitParams(const QRhiNullInitParams & QRhiNullInitParams)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiNullInitParams cppArg0_local;
            ::QRhiNullInitParams *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiNullInitParams(QRhiNullInitParams)
                cptr = new ::QRhiNullInitParams(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiNullInitParams >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiNullInitParams__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiNullInitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiNullInitParams_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiNullInitParams_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiNullInitParams__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiNullInitParams_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiNullInitParams_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiNullInitParams_Type = nullptr;
static PyTypeObject *Sbk_QRhiNullInitParams_TypeF(void)
{
    return _Sbk_QRhiNullInitParams_Type;
}

static PyType_Slot Sbk_QRhiNullInitParams_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiNullInitParams_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiNullInitParams_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiNullInitParams_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiNullInitParams_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiNullInitParams_spec = {
    "2:PySide6.QtGui.QRhiNullInitParams",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiNullInitParams_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiNullInitParams_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiNullInitParams_TypeF()))
        return QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiNullInitParams_PTR_CppToPython_QRhiNullInitParams(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QRhiNullInitParams *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QRhiNullInitParams_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QRhiNullInitParams_COPY_CppToPython_QRhiNullInitParams(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiNullInitParams *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiNullInitParams_TypeF(), new ::QRhiNullInitParams(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiNullInitParams *>(cppOut) = *reinterpret_cast< ::QRhiNullInitParams *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiNullInitParams_TypeF()))
        return QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QRhiNullInitParams_SignatureStrings[] = {
    "1:PySide6.QtGui.QRhiNullInitParams(self)",
    "0:PySide6.QtGui.QRhiNullInitParams(self,QRhiNullInitParams:PySide6.QtGui.QRhiNullInitParams)",
    "PySide6.QtGui.QRhiNullInitParams.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QRhiNullInitParams(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiNullInitParams_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiInitParams_IDX]))));

    _Sbk_QRhiNullInitParams_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiNullInitParams",
        "QRhiNullInitParams",
        &Sbk_QRhiNullInitParams_spec,
        &Shiboken::callCppDestructor< ::QRhiNullInitParams >,
        Sbk_QRhiNullInitParams_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiNullInitParams_TypeF(); // references _Sbk_QRhiNullInitParams_Type
    InitSignatureStrings(pyType, QRhiNullInitParams_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiNullInitParams_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiNullInitParams_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_PTR,
        is_QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_PTR_Convertible,
        QRhiNullInitParams_PTR_CppToPython_QRhiNullInitParams,
        QRhiNullInitParams_COPY_CppToPython_QRhiNullInitParams);

    Shiboken::Conversions::registerConverterName(converter, "QRhiNullInitParams");
    Shiboken::Conversions::registerConverterName(converter, "QRhiNullInitParams*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiNullInitParams&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiNullInitParams).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_COPY,
        is_QRhiNullInitParams_PythonToCpp_QRhiNullInitParams_COPY_Convertible);

    qRegisterMetaType< ::QRhiNullInitParams >("QRhiNullInitParams");

    return pyType;
}
