// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiResourceWrapper_H
#define SBK_QRhiResourceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiResourceWrapper : public QRhiResource
{
public:
    QRhiResourceWrapper(const QRhiResourceWrapper &) = delete;
    QRhiResourceWrapper& operator=(const QRhiResourceWrapper &) = delete;
    QRhiResourceWrapper(QRhiResourceWrapper &&) = delete;
    QRhiResourceWrapper& operator=(QRhiResourceWrapper &&) = delete;

    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiResourceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QRhiResourceWrapper_H

