// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiSwapChainRenderTargetWrapper_H
#define SBK_QRhiSwapChainRenderTargetWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiSwapChainRenderTargetWrapper : public QRhiSwapChainRenderTarget
{
public:
    QRhiSwapChainRenderTargetWrapper(const QRhiSwapChainRenderTargetWrapper &) = delete;
    QRhiSwapChainRenderTargetWrapper& operator=(const QRhiSwapChainRenderTargetWrapper &) = delete;
    QRhiSwapChainRenderTargetWrapper(QRhiSwapChainRenderTargetWrapper &&) = delete;
    QRhiSwapChainRenderTargetWrapper& operator=(QRhiSwapChainRenderTargetWrapper &&) = delete;

    void destroy() override;
    float devicePixelRatio() const override;
    ::QSize pixelSize() const override;
    ::QRhiResource::Type resourceType() const override;
    int sampleCount() const override;
    ~QRhiSwapChainRenderTargetWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[5];
};

#endif // SBK_QRhiSwapChainRenderTargetWrapper_H

