// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRhiTextureRenderTargetWrapper_H
#define SBK_QRhiTextureRenderTargetWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiTextureRenderTargetWrapper : public QRhiTextureRenderTarget
{
public:
    QRhiTextureRenderTargetWrapper(const QRhiTextureRenderTargetWrapper &) = delete;
    QRhiTextureRenderTargetWrapper& operator=(const QRhiTextureRenderTargetWrapper &) = delete;
    QRhiTextureRenderTargetWrapper(QRhiTextureRenderTargetWrapper &&) = delete;
    QRhiTextureRenderTargetWrapper& operator=(QRhiTextureRenderTargetWrapper &&) = delete;

    bool create() override;
    void destroy() override;
    float devicePixelRatio() const override;
    ::QRhiRenderPassDescriptor * newCompatibleRenderPassDescriptor() override;
    ::QSize pixelSize() const override;
    ::QRhiResource::Type resourceType() const override;
    int sampleCount() const override;
    ~QRhiTextureRenderTargetWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QRhiTextureRenderTargetWrapper_H

