// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextDocumentWrapper_H
#define SBK_QTextDocumentWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qtextdocument.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTextDocumentWrapper : public QTextDocument
{
public:
    QTextDocumentWrapper(const QTextDocumentWrapper &) = delete;
    QTextDocumentWrapper& operator=(const QTextDocumentWrapper &) = delete;
    QTextDocumentWrapper(QTextDocumentWrapper &&) = delete;
    QTextDocumentWrapper& operator=(QTextDocumentWrapper &&) = delete;

    QTextDocumentWrapper(::QObject * parent = nullptr);
    QTextDocumentWrapper(const ::QString & text, ::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void clear() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QTextObject * createObject(const ::QTextFormat & f) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QVariant loadResource(int type, const ::QUrl & name) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QTextDocumentWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[10];
};

#endif // SBK_QTextDocumentWrapper_H

