// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTextObjectInterfaceWrapper_H
#define SBK_QTextObjectInterfaceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qabstracttextdocumentlayout.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTextObjectInterfaceWrapper : public QTextObjectInterface
{
public:
    QTextObjectInterfaceWrapper(const QTextObjectInterfaceWrapper &) = delete;
    QTextObjectInterfaceWrapper& operator=(const QTextObjectInterfaceWrapper &) = delete;
    QTextObjectInterfaceWrapper(QTextObjectInterfaceWrapper &&) = delete;
    QTextObjectInterfaceWrapper& operator=(QTextObjectInterfaceWrapper &&) = delete;

    QTextObjectInterfaceWrapper();
    void drawObject(::QPainter * painter, const ::QRectF & rect, ::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    ::QSizeF intrinsicSize(::QTextDocument * doc, int posInDocument, const ::QTextFormat & format) override;
    ~QTextObjectInterfaceWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QTextObjectInterfaceWrapper_H

