// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTouchEventWrapper_H
#define SBK_QTouchEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QTouchEventWrapper : public QTouchEvent
{
public:
    QTouchEventWrapper(const QTouchEventWrapper &) = delete;
    QTouchEventWrapper& operator=(const QTouchEventWrapper &) = delete;
    QTouchEventWrapper(QTouchEventWrapper &&) = delete;
    QTouchEventWrapper& operator=(QTouchEventWrapper &&) = delete;

    QTouchEventWrapper(::QEvent::Type eventType, const ::QPointingDevice * device = nullptr, ::QFlags<Qt::KeyboardModifier> modifiers = Qt::NoModifier, const ::QList<QEventPoint> & touchPoints = {});
    QTouchEventWrapper(const QTouchEvent& self) : QTouchEvent(self)
    {
    }

    ::QTouchEvent * clone() const override;
    bool isBeginEvent() const override;
    bool isEndEvent() const override;
    bool isUpdateEvent() const override;
    void setAccepted(bool accepted) override;
    void setTimestamp(quint64 timestamp) override;
    ~QTouchEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6];
};

#endif // SBK_QTouchEventWrapper_H

