// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoRoutingManagerEngineWrapper_H
#define SBK_QGeoRoutingManagerEngineWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qgeoroutingmanagerengine.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoRoutingManagerEngineWrapper : public QGeoRoutingManagerEngine
{
public:
    QGeoRoutingManagerEngineWrapper(const QGeoRoutingManagerEngineWrapper &) = delete;
    QGeoRoutingManagerEngineWrapper& operator=(const QGeoRoutingManagerEngineWrapper &) = delete;
    QGeoRoutingManagerEngineWrapper(QGeoRoutingManagerEngineWrapper &&) = delete;
    QGeoRoutingManagerEngineWrapper& operator=(QGeoRoutingManagerEngineWrapper &&) = delete;

    QGeoRoutingManagerEngineWrapper(const ::QMap<QString,QVariant> & parameters, ::QObject * parent = nullptr);
    ::QGeoRouteReply * calculateRoute(const ::QGeoRouteRequest & request) override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ::QGeoRouteReply * updateRoute(const ::QGeoRoute & route, const ::QGeoCoordinate & position) override;
    ~QGeoRoutingManagerEngineWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QGeoRoutingManagerEngineWrapper_H

