// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlaceResultWrapper_H
#define SBK_QPlaceResultWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplaceresult.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPlaceResultWrapper : public QPlaceResult
{
public:
    QPlaceResultWrapper(const QPlaceResultWrapper &) = delete;
    QPlaceResultWrapper& operator=(const QPlaceResultWrapper &) = delete;
    QPlaceResultWrapper(QPlaceResultWrapper &&) = delete;
    QPlaceResultWrapper& operator=(QPlaceResultWrapper &&) = delete;

    QPlaceResultWrapper();
    QPlaceResultWrapper(const ::QPlaceSearchResult & other);
    ~QPlaceResultWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QPlaceResultWrapper_H

