// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPlaceSearchResultWrapper_H
#define SBK_QPlaceSearchResultWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplacesearchresult.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QPlaceSearchResultWrapper : public QPlaceSearchResult
{
public:
    QPlaceSearchResultWrapper(const QPlaceSearchResultWrapper &) = delete;
    QPlaceSearchResultWrapper& operator=(const QPlaceSearchResultWrapper &) = delete;
    QPlaceSearchResultWrapper(QPlaceSearchResultWrapper &&) = delete;
    QPlaceSearchResultWrapper& operator=(QPlaceSearchResultWrapper &&) = delete;

    QPlaceSearchResultWrapper();
    QPlaceSearchResultWrapper(const QPlaceSearchResult& self) : QPlaceSearchResult(self)
    {
    }

    ~QPlaceSearchResultWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QPlaceSearchResultWrapper_H

