// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qcapturablewindow_wrapper.h"

// Argument includes
#include <QString>
#include <QtMultimedia/qcapturablewindow.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCapturableWindow_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCapturableWindow >()))
        return -1;

    ::QCapturableWindow *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QCapturableWindow.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCapturableWindow", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCapturableWindow::QCapturableWindow()
    // 1: QCapturableWindow::QCapturableWindow(QCapturableWindow)
    if (numArgs == 0) {
        overloadId = 0; // QCapturableWindow()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCapturableWindow(QCapturableWindow)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCapturableWindow()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCapturableWindow()
                cptr = new ::QCapturableWindow();
            }
            break;
        }
        case 1: // QCapturableWindow(const QCapturableWindow & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCapturableWindow cppArg0_local;
            ::QCapturableWindow *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCapturableWindow(QCapturableWindow)
                cptr = new ::QCapturableWindow(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCapturableWindow >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCapturableWindowFunc_description(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QCapturableWindow.description";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // description()const
            QString cppResult = const_cast<const ::QCapturableWindow *>(cppSelf)->description();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCapturableWindowFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtMultimedia.QCapturableWindow.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QCapturableWindow *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCapturableWindowFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QCapturableWindow.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCapturableWindow::swap(QCapturableWindow&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCapturableWindow&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCapturableWindow cppArg0_local;
        ::QCapturableWindow *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCapturableWindow&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCapturableWindow__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCapturableWindow_PropertyStrings[] = {
    "description:",
    "isValid:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCapturableWindow_methods[] = {
    {"description", reinterpret_cast<PyCFunction>(Sbk_QCapturableWindowFunc_description), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCapturableWindowFunc_isValid), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCapturableWindowFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCapturableWindow__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QCapturableWindow_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), (pyArg)))) {
                // operator!=(const QCapturableWindow & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QCapturableWindow cppArg0_local;
                ::QCapturableWindow *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QCapturableWindow_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCapturableWindow_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCapturableWindow_Type = nullptr;
static PyTypeObject *Sbk_QCapturableWindow_TypeF(void)
{
    return _Sbk_QCapturableWindow_Type;
}

static PyType_Slot Sbk_QCapturableWindow_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCapturableWindow_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCapturableWindow_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QCapturableWindow_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCapturableWindow_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCapturableWindow_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCapturableWindow_spec = {
    "2:PySide6.QtMultimedia.QCapturableWindow",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCapturableWindow_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCapturableWindow_PythonToCpp_QCapturableWindow_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCapturableWindow_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCapturableWindow_PythonToCpp_QCapturableWindow_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCapturableWindow_TypeF()))
        return QCapturableWindow_PythonToCpp_QCapturableWindow_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCapturableWindow_PTR_CppToPython_QCapturableWindow(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCapturableWindow *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCapturableWindow_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCapturableWindow_COPY_CppToPython_QCapturableWindow(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCapturableWindow *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCapturableWindow_TypeF(), new ::QCapturableWindow(*source), true, true);
}

// Python to C++ copy conversion.
static void QCapturableWindow_PythonToCpp_QCapturableWindow_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCapturableWindow *>(cppOut) = *reinterpret_cast< ::QCapturableWindow *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCapturableWindow_PythonToCpp_QCapturableWindow_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCapturableWindow_TypeF()))
        return QCapturableWindow_PythonToCpp_QCapturableWindow_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCapturableWindow_SignatureStrings[] = {
    "1:PySide6.QtMultimedia.QCapturableWindow(self)",
    "0:PySide6.QtMultimedia.QCapturableWindow(self,other:PySide6.QtMultimedia.QCapturableWindow)",
    "PySide6.QtMultimedia.QCapturableWindow.description(self)->QString",
    "PySide6.QtMultimedia.QCapturableWindow.isValid(self)->bool",
    "PySide6.QtMultimedia.QCapturableWindow.swap(self,other:PySide6.QtMultimedia.QCapturableWindow)",
    "PySide6.QtMultimedia.QCapturableWindow.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCapturableWindow(PyObject *module)
{
    if (SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX].type != nullptr)
        return SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX].type;

    Shiboken::AutoDecRef Sbk_QCapturableWindow_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCapturableWindow_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCapturableWindow",
        "QCapturableWindow",
        &Sbk_QCapturableWindow_spec,
        &Shiboken::callCppDestructor< ::QCapturableWindow >,
        Sbk_QCapturableWindow_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCapturableWindow_TypeF(); // references _Sbk_QCapturableWindow_Type
    InitSignatureStrings(pyType, QCapturableWindow_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCapturableWindow_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QCapturableWindow_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCapturableWindow_PythonToCpp_QCapturableWindow_PTR,
        is_QCapturableWindow_PythonToCpp_QCapturableWindow_PTR_Convertible,
        QCapturableWindow_PTR_CppToPython_QCapturableWindow,
        QCapturableWindow_COPY_CppToPython_QCapturableWindow);

    Shiboken::Conversions::registerConverterName(converter, "QCapturableWindow");
    Shiboken::Conversions::registerConverterName(converter, "QCapturableWindow*");
    Shiboken::Conversions::registerConverterName(converter, "QCapturableWindow&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCapturableWindow).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCapturableWindow_PythonToCpp_QCapturableWindow_COPY,
        is_QCapturableWindow_PythonToCpp_QCapturableWindow_COPY_Convertible);

    qRegisterMetaType< ::QCapturableWindow >("QCapturableWindow");

    return pyType;
}
