// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtmultimedia_python.h"

// main header
#include "qvideoframe_paintoptions_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QVideoFrame_PaintOptions_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QVideoFrame::PaintOptions >()))
        return -1;

    ::QVideoFrame::PaintOptions *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtMultimedia.QVideoFrame.PaintOptions.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "PaintOptions", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: PaintOptions::PaintOptions()
    // 1: PaintOptions::PaintOptions(QVideoFrame::PaintOptions)
    if (numArgs == 0) {
        overloadId = 0; // PaintOptions()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), (pyArgs[0])))) {
        overloadId = 1; // PaintOptions(QVideoFrame::PaintOptions)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // PaintOptions()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // PaintOptions()
                cptr = new ::QVideoFrame::PaintOptions();
            }
            break;
        }
        case 1: // PaintOptions(const QVideoFrame::PaintOptions & PaintOptions)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QVideoFrame::PaintOptions cppArg0_local;
            ::QVideoFrame::PaintOptions *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // PaintOptions(QVideoFrame::PaintOptions)
                cptr = new ::QVideoFrame::PaintOptions(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QVideoFrame::PaintOptions >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QVideoFrame_PaintOptions__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QVideoFrame_PaintOptions_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QVideoFrame_PaintOptions_EnumFlagInfo[] = {
    "PaintFlag:Flag:PaintFlags",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QVideoFrame_PaintOptions_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QVideoFrame_PaintOptions__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QVideoFrame_PaintOptions_get_backgroundColor(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->backgroundColor)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->backgroundColor))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->backgroundColor)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &(cppSelf->backgroundColor), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QVideoFrame_PaintOptions_set_backgroundColor(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("backgroundColor");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("backgroundColor", "QColor");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->backgroundColor;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QVideoFrame_PaintOptions_get_aspectRatioMode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::AspectRatioMode cppOut_local = cppSelf->aspectRatioMode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_AspectRatioMode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QVideoFrame_PaintOptions_set_aspectRatioMode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("aspectRatioMode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_AspectRatioMode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("aspectRatioMode", "AspectRatioMode");
        return -1;
    }

    auto cppOut_local = cppSelf->aspectRatioMode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->aspectRatioMode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QVideoFrame_PaintOptions_get_paintFlags(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QFlags_QVideoFrame_PaintOptions_PaintFlag_IDX])))->converter, &cppSelf->paintFlags);
    return pyOut;
}
static int Sbk_QVideoFrame_PaintOptions_set_paintFlags(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("paintFlags");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QFlags_QVideoFrame_PaintOptions_PaintFlag_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("paintFlags", "PaintFlags");
        return -1;
    }

    auto cppOut_local = cppSelf->paintFlags;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->paintFlags = cppOut_local;

    return 0;
}

// Getters and Setters for PaintOptions
static PyGetSetDef Sbk_QVideoFrame_PaintOptions_getsetlist[] = {
    {const_cast<char *>("backgroundColor"), Sbk_QVideoFrame_PaintOptions_get_backgroundColor, Sbk_QVideoFrame_PaintOptions_set_backgroundColor, nullptr, nullptr},
    {const_cast<char *>("aspectRatioMode"), Sbk_QVideoFrame_PaintOptions_get_aspectRatioMode, Sbk_QVideoFrame_PaintOptions_set_aspectRatioMode, nullptr, nullptr},
    {const_cast<char *>("paintFlags"), Sbk_QVideoFrame_PaintOptions_get_paintFlags, Sbk_QVideoFrame_PaintOptions_set_paintFlags, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QVideoFrame_PaintOptions_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QVideoFrame_PaintOptions_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QVideoFrame_PaintOptions_Type = nullptr;
static PyTypeObject *Sbk_QVideoFrame_PaintOptions_TypeF(void)
{
    return _Sbk_QVideoFrame_PaintOptions_Type;
}

static PyType_Slot Sbk_QVideoFrame_PaintOptions_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QVideoFrame_PaintOptions_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QVideoFrame_PaintOptions_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QVideoFrame_PaintOptions_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QVideoFrame_PaintOptions_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QVideoFrame_PaintOptions_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QVideoFrame_PaintOptions_spec = {
    "2:PySide6.QtMultimedia.QVideoFrame.PaintOptions",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QVideoFrame_PaintOptions_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QVideoFrame_PaintOptions_PaintFlag_PythonToCpp_QVideoFrame_PaintOptions_PaintFlag(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QVideoFrame::PaintOptions::PaintFlag>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QVideoFrame::PaintOptions::PaintFlag *>(cppOut) = value;

}
static PythonToCppFunc is_QVideoFrame_PaintOptions_PaintFlag_PythonToCpp_QVideoFrame_PaintOptions_PaintFlag_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_PaintFlag_IDX])))
        return QVideoFrame_PaintOptions_PaintFlag_PythonToCpp_QVideoFrame_PaintOptions_PaintFlag;
    return {};
}
static PyObject *QVideoFrame_PaintOptions_PaintFlag_CppToPython_QVideoFrame_PaintOptions_PaintFlag(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QVideoFrame::PaintOptions::PaintFlag *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_PaintFlag_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void PaintOptions_PythonToCpp_PaintOptions_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QVideoFrame_PaintOptions_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_PaintOptions_PythonToCpp_PaintOptions_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QVideoFrame_PaintOptions_TypeF()))
        return PaintOptions_PythonToCpp_PaintOptions_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *PaintOptions_PTR_CppToPython_PaintOptions(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QVideoFrame::PaintOptions *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QVideoFrame_PaintOptions_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *PaintOptions_COPY_CppToPython_PaintOptions(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QVideoFrame::PaintOptions *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QVideoFrame_PaintOptions_TypeF(), new ::QVideoFrame::PaintOptions(*source), true, true);
}

// Python to C++ copy conversion.
static void PaintOptions_PythonToCpp_PaintOptions_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QVideoFrame::PaintOptions *>(cppOut) = *reinterpret_cast< ::QVideoFrame::PaintOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_PaintOptions_PythonToCpp_PaintOptions_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QVideoFrame_PaintOptions_TypeF()))
        return PaintOptions_PythonToCpp_PaintOptions_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QVideoFrame_PaintOptions_SignatureStrings[] = {
    "1:PySide6.QtMultimedia.QVideoFrame.PaintOptions(self)",
    "0:PySide6.QtMultimedia.QVideoFrame.PaintOptions(self,PaintOptions:PySide6.QtMultimedia.QVideoFrame.PaintOptions)",
    "PySide6.QtMultimedia.QVideoFrame.PaintOptions.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QVideoFrame_PaintOptions(PyObject *enclosingClass)
{
    if (SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX].type != nullptr)
        return SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX].type;

    Shiboken::AutoDecRef Sbk_QVideoFrame_PaintOptions_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QVideoFrame_PaintOptions_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "PaintOptions",
        "QVideoFrame::PaintOptions",
        &Sbk_QVideoFrame_PaintOptions_spec,
        &Shiboken::callCppDestructor< ::QVideoFrame::PaintOptions >,
        Sbk_QVideoFrame_PaintOptions_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QVideoFrame_PaintOptions_TypeF(); // references _Sbk_QVideoFrame_PaintOptions_Type
    InitSignatureStrings(pyType, QVideoFrame_PaintOptions_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QVideoFrame_PaintOptions_PropertyStrings);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        PaintOptions_PythonToCpp_PaintOptions_PTR,
        is_PaintOptions_PythonToCpp_PaintOptions_PTR_Convertible,
        PaintOptions_PTR_CppToPython_PaintOptions,
        PaintOptions_COPY_CppToPython_PaintOptions);

    Shiboken::Conversions::registerConverterName(converter, "QVideoFrame::PaintOptions");
    Shiboken::Conversions::registerConverterName(converter, "QVideoFrame::PaintOptions*");
    Shiboken::Conversions::registerConverterName(converter, "QVideoFrame::PaintOptions&");
    Shiboken::Conversions::registerConverterName(converter, "PaintOptions");
    Shiboken::Conversions::registerConverterName(converter, "PaintOptions*");
    Shiboken::Conversions::registerConverterName(converter, "PaintOptions&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QVideoFrame::PaintOptions).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        PaintOptions_PythonToCpp_PaintOptions_COPY,
        is_PaintOptions_PythonToCpp_PaintOptions_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QVideoFrame_PaintOptions_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'PaintFlag'.
    const char *PaintFlag_Initializer[] = {
        "DontDrawSubtitles",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t PaintFlag_InitializerValues[] = {
        uint8_t(QVideoFrame::PaintOptions::PaintFlag::DontDrawSubtitles) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QVideoFrame_PaintOptions_TypeF(),
        "2:PySide6.QtMultimedia.QVideoFrame.PaintOptions.PaintFlag",
        PaintFlag_Initializer, PaintFlag_InitializerValues);
    SbkPySide6_QtMultimediaTypeStructs[SBK_QVideoFrame_PaintOptions_PaintFlag_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtMultimediaTypeStructs[SBK_QFlags_QVideoFrame_PaintOptions_PaintFlag_IDX].type =
        EType;
    // Register converter for enum 'QVideoFrame::PaintOptions::PaintFlag'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QVideoFrame_PaintOptions_PaintFlag_CppToPython_QVideoFrame_PaintOptions_PaintFlag);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QVideoFrame_PaintOptions_PaintFlag_PythonToCpp_QVideoFrame_PaintOptions_PaintFlag,
            is_QVideoFrame_PaintOptions_PaintFlag_PythonToCpp_QVideoFrame_PaintOptions_PaintFlag_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrame::PaintOptions::PaintFlag");
        Shiboken::Conversions::registerConverterName(converter, "PaintOptions::PaintFlag");
        Shiboken::Conversions::registerConverterName(converter, "PaintFlag");
        // Register converter for flag 'QFlags<QVideoFrame::PaintOptions::PaintFlag>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QVideoFrame::PaintOptions::PaintFlag>");
        Shiboken::Conversions::registerConverterName(converter, "QVideoFrame::PaintOptions::PaintFlags");
    }
    // End of 'PaintFlag' enum/flags.

    qRegisterMetaType< ::QVideoFrame::PaintOptions >("PaintOptions");
    qRegisterMetaType< ::QVideoFrame::PaintOptions >("QVideoFrame::PaintOptions");
    qRegisterMetaType< ::QVideoFrame::PaintOptions::PaintFlag >("PaintOptions::PaintFlag");
    qRegisterMetaType< ::QVideoFrame::PaintOptions::PaintFlag >("QVideoFrame::PaintOptions::PaintFlag");

    return pyType;
}
