// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qdnsdomainnamerecord_wrapper.h"

// Argument includes
#include <QString>
#include <QtNetwork/qdnslookup.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDnsDomainNameRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDnsDomainNameRecord >()))
        return -1;

    ::QDnsDomainNameRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsDomainNameRecord.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDnsDomainNameRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDnsDomainNameRecord::QDnsDomainNameRecord()
    // 1: QDnsDomainNameRecord::QDnsDomainNameRecord(QDnsDomainNameRecord)
    if (numArgs == 0) {
        overloadId = 0; // QDnsDomainNameRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDnsDomainNameRecord(QDnsDomainNameRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDnsDomainNameRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsDomainNameRecord()
                cptr = new ::QDnsDomainNameRecord();
            }
            break;
        }
        case 1: // QDnsDomainNameRecord(const QDnsDomainNameRecord & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDnsDomainNameRecord cppArg0_local;
            ::QDnsDomainNameRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsDomainNameRecord(QDnsDomainNameRecord)
                cptr = new ::QDnsDomainNameRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDnsDomainNameRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDnsDomainNameRecordFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsDomainNameRecord.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDnsDomainNameRecord *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsDomainNameRecordFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsDomainNameRecord.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDnsDomainNameRecord::swap(QDnsDomainNameRecord&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDnsDomainNameRecord&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDnsDomainNameRecord cppArg0_local;
        ::QDnsDomainNameRecord *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDnsDomainNameRecord&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDnsDomainNameRecordFunc_timeToLive(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsDomainNameRecord.timeToLive";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // timeToLive()const
            quint32 cppResult = const_cast<const ::QDnsDomainNameRecord *>(cppSelf)->timeToLive();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsDomainNameRecordFunc_value(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsDomainNameRecord.value";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // value()const
            QString cppResult = const_cast<const ::QDnsDomainNameRecord *>(cppSelf)->value();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsDomainNameRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDnsDomainNameRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDnsDomainNameRecord_methods[] = {
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDnsDomainNameRecordFunc_name), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDnsDomainNameRecordFunc_swap), METH_O, nullptr},
    {"timeToLive", reinterpret_cast<PyCFunction>(Sbk_QDnsDomainNameRecordFunc_timeToLive), METH_NOARGS, nullptr},
    {"value", reinterpret_cast<PyCFunction>(Sbk_QDnsDomainNameRecordFunc_value), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDnsDomainNameRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDnsDomainNameRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDnsDomainNameRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDnsDomainNameRecord_Type = nullptr;
static PyTypeObject *Sbk_QDnsDomainNameRecord_TypeF(void)
{
    return _Sbk_QDnsDomainNameRecord_Type;
}

static PyType_Slot Sbk_QDnsDomainNameRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDnsDomainNameRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDnsDomainNameRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDnsDomainNameRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDnsDomainNameRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDnsDomainNameRecord_spec = {
    "2:PySide6.QtNetwork.QDnsDomainNameRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDnsDomainNameRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDnsDomainNameRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsDomainNameRecord_TypeF()))
        return QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDnsDomainNameRecord_PTR_CppToPython_QDnsDomainNameRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDnsDomainNameRecord *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDnsDomainNameRecord_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QDnsDomainNameRecord_COPY_CppToPython_QDnsDomainNameRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDnsDomainNameRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDnsDomainNameRecord_TypeF(), new ::QDnsDomainNameRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDnsDomainNameRecord *>(cppOut) = *reinterpret_cast< ::QDnsDomainNameRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsDomainNameRecord_TypeF()))
        return QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDnsDomainNameRecord_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QDnsDomainNameRecord(self)",
    "0:PySide6.QtNetwork.QDnsDomainNameRecord(self,other:PySide6.QtNetwork.QDnsDomainNameRecord)",
    "PySide6.QtNetwork.QDnsDomainNameRecord.name(self)->QString",
    "PySide6.QtNetwork.QDnsDomainNameRecord.swap(self,other:PySide6.QtNetwork.QDnsDomainNameRecord)",
    "PySide6.QtNetwork.QDnsDomainNameRecord.timeToLive(self)->quint32",
    "PySide6.QtNetwork.QDnsDomainNameRecord.value(self)->QString",
    "PySide6.QtNetwork.QDnsDomainNameRecord.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDnsDomainNameRecord(PyObject *module)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX].type;

    Shiboken::AutoDecRef Sbk_QDnsDomainNameRecord_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDnsDomainNameRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDnsDomainNameRecord",
        "QDnsDomainNameRecord",
        &Sbk_QDnsDomainNameRecord_spec,
        &Shiboken::callCppDestructor< ::QDnsDomainNameRecord >,
        Sbk_QDnsDomainNameRecord_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDnsDomainNameRecord_TypeF(); // references _Sbk_QDnsDomainNameRecord_Type
    InitSignatureStrings(pyType, QDnsDomainNameRecord_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDnsDomainNameRecord_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsDomainNameRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_PTR,
        is_QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_PTR_Convertible,
        QDnsDomainNameRecord_PTR_CppToPython_QDnsDomainNameRecord,
        QDnsDomainNameRecord_COPY_CppToPython_QDnsDomainNameRecord);

    Shiboken::Conversions::registerConverterName(converter, "QDnsDomainNameRecord");
    Shiboken::Conversions::registerConverterName(converter, "QDnsDomainNameRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QDnsDomainNameRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDnsDomainNameRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_COPY,
        is_QDnsDomainNameRecord_PythonToCpp_QDnsDomainNameRecord_COPY_Convertible);

    qRegisterMetaType< ::QDnsDomainNameRecord >("QDnsDomainNameRecord");

    return pyType;
}
