// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qdnstextrecord_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtNetwork/qdnslookup.h>
#include <qbytearray.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDnsTextRecord_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDnsTextRecord >()))
        return -1;

    ::QDnsTextRecord *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsTextRecord.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QDnsTextRecord", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QDnsTextRecord::QDnsTextRecord()
    // 1: QDnsTextRecord::QDnsTextRecord(QDnsTextRecord)
    if (numArgs == 0) {
        overloadId = 0; // QDnsTextRecord()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QDnsTextRecord(QDnsTextRecord)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QDnsTextRecord()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsTextRecord()
                cptr = new ::QDnsTextRecord();
            }
            break;
        }
        case 1: // QDnsTextRecord(const QDnsTextRecord & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDnsTextRecord cppArg0_local;
            ::QDnsTextRecord *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QDnsTextRecord(QDnsTextRecord)
                cptr = new ::QDnsTextRecord(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDnsTextRecord >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDnsTextRecordFunc_name(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsTextRecord.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()const
            QString cppResult = const_cast<const ::QDnsTextRecord *>(cppSelf)->name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTextRecordFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsTextRecord.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QDnsTextRecord::swap(QDnsTextRecord&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QDnsTextRecord&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QDnsTextRecord cppArg0_local;
        ::QDnsTextRecord *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QDnsTextRecord&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QDnsTextRecordFunc_timeToLive(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsTextRecord.timeToLive";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // timeToLive()const
            quint32 cppResult = const_cast<const ::QDnsTextRecord *>(cppSelf)->timeToLive();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint32>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTextRecordFunc_values(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNetwork.QDnsTextRecord.values";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // values()const
            QList<QByteArray> cppResult = const_cast<const ::QDnsTextRecord *>(cppSelf)->values();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtNetworkTypeConverters[SBK_QtNetwork_QList_QByteArray_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QDnsTextRecord__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDnsTextRecord_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDnsTextRecord_methods[] = {
    {"name", reinterpret_cast<PyCFunction>(Sbk_QDnsTextRecordFunc_name), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QDnsTextRecordFunc_swap), METH_O, nullptr},
    {"timeToLive", reinterpret_cast<PyCFunction>(Sbk_QDnsTextRecordFunc_timeToLive), METH_NOARGS, nullptr},
    {"values", reinterpret_cast<PyCFunction>(Sbk_QDnsTextRecordFunc_values), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDnsTextRecord__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDnsTextRecord_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDnsTextRecord_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDnsTextRecord_Type = nullptr;
static PyTypeObject *Sbk_QDnsTextRecord_TypeF(void)
{
    return _Sbk_QDnsTextRecord_Type;
}

static PyType_Slot Sbk_QDnsTextRecord_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDnsTextRecord_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDnsTextRecord_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDnsTextRecord_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDnsTextRecord_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDnsTextRecord_spec = {
    "2:PySide6.QtNetwork.QDnsTextRecord",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDnsTextRecord_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QDnsTextRecord_PythonToCpp_QDnsTextRecord_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDnsTextRecord_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QDnsTextRecord_PythonToCpp_QDnsTextRecord_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsTextRecord_TypeF()))
        return QDnsTextRecord_PythonToCpp_QDnsTextRecord_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QDnsTextRecord_PTR_CppToPython_QDnsTextRecord(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDnsTextRecord *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDnsTextRecord_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QDnsTextRecord_COPY_CppToPython_QDnsTextRecord(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDnsTextRecord *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDnsTextRecord_TypeF(), new ::QDnsTextRecord(*source), true, true);
}

// Python to C++ copy conversion.
static void QDnsTextRecord_PythonToCpp_QDnsTextRecord_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDnsTextRecord *>(cppOut) = *reinterpret_cast< ::QDnsTextRecord *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QDnsTextRecord_PythonToCpp_QDnsTextRecord_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDnsTextRecord_TypeF()))
        return QDnsTextRecord_PythonToCpp_QDnsTextRecord_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDnsTextRecord_SignatureStrings[] = {
    "1:PySide6.QtNetwork.QDnsTextRecord(self)",
    "0:PySide6.QtNetwork.QDnsTextRecord(self,other:PySide6.QtNetwork.QDnsTextRecord)",
    "PySide6.QtNetwork.QDnsTextRecord.name(self)->QString",
    "PySide6.QtNetwork.QDnsTextRecord.swap(self,other:PySide6.QtNetwork.QDnsTextRecord)",
    "PySide6.QtNetwork.QDnsTextRecord.timeToLive(self)->quint32",
    "PySide6.QtNetwork.QDnsTextRecord.values(self)->QList[PySide6.QtCore.QByteArray]",
    "PySide6.QtNetwork.QDnsTextRecord.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDnsTextRecord(PyObject *module)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX].type;

    Shiboken::AutoDecRef Sbk_QDnsTextRecord_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDnsTextRecord_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QDnsTextRecord",
        "QDnsTextRecord",
        &Sbk_QDnsTextRecord_spec,
        &Shiboken::callCppDestructor< ::QDnsTextRecord >,
        Sbk_QDnsTextRecord_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDnsTextRecord_TypeF(); // references _Sbk_QDnsTextRecord_Type
    InitSignatureStrings(pyType, QDnsTextRecord_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDnsTextRecord_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDnsTextRecord_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QDnsTextRecord_PythonToCpp_QDnsTextRecord_PTR,
        is_QDnsTextRecord_PythonToCpp_QDnsTextRecord_PTR_Convertible,
        QDnsTextRecord_PTR_CppToPython_QDnsTextRecord,
        QDnsTextRecord_COPY_CppToPython_QDnsTextRecord);

    Shiboken::Conversions::registerConverterName(converter, "QDnsTextRecord");
    Shiboken::Conversions::registerConverterName(converter, "QDnsTextRecord*");
    Shiboken::Conversions::registerConverterName(converter, "QDnsTextRecord&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDnsTextRecord).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QDnsTextRecord_PythonToCpp_QDnsTextRecord_COPY,
        is_QDnsTextRecord_PythonToCpp_QDnsTextRecord_COPY_Convertible);

    qRegisterMetaType< ::QDnsTextRecord >("QDnsTextRecord");

    return pyType;
}
