// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnetwork_python.h"

// main header
#include "qdtlsclientverifier_generatorparameters_wrapper.h"

// Argument includes
#include <qbytearray.h>
#include <qcryptographichash.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDtlsClientVerifier_GeneratorParameters_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDtlsClientVerifier::GeneratorParameters >()))
        return -1;

    ::QDtlsClientVerifier::GeneratorParameters *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "GeneratorParameters", 0, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: GeneratorParameters::GeneratorParameters()
    // 1: GeneratorParameters::GeneratorParameters(QCryptographicHash::Algorithm,QByteArray)
    // 2: GeneratorParameters::GeneratorParameters(QDtlsClientVerifier::GeneratorParameters)
    if (numArgs == 0) {
        overloadId = 0; // GeneratorParameters()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), (pyArgs[0])))) {
        overloadId = 2; // GeneratorParameters(QDtlsClientVerifier::GeneratorParameters)
    } else if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCryptographicHash_Algorithm_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 1; // GeneratorParameters(QCryptographicHash::Algorithm,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // GeneratorParameters()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // GeneratorParameters()
                cptr = new ::QDtlsClientVerifier::GeneratorParameters();
            }
            break;
        }
        case 1: // GeneratorParameters(QCryptographicHash::Algorithm a, const QByteArray & s)
        {
            ::QCryptographicHash::Algorithm cppArg0{QCryptographicHash::Md4};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return -1;
            ::QByteArray cppArg1_local;
            ::QByteArray *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (Shiboken::Errors::occurred() == nullptr) {
                // GeneratorParameters(QCryptographicHash::Algorithm,QByteArray)
                cptr = new ::QDtlsClientVerifier::GeneratorParameters(cppArg0, *cppArg1);
            }
            break;
        }
        case 2: // GeneratorParameters(const QDtlsClientVerifier::GeneratorParameters & GeneratorParameters)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDtlsClientVerifier::GeneratorParameters cppArg0_local;
            ::QDtlsClientVerifier::GeneratorParameters *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // GeneratorParameters(QDtlsClientVerifier::GeneratorParameters)
                cptr = new ::QDtlsClientVerifier::GeneratorParameters(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDtlsClientVerifier::GeneratorParameters >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDtlsClientVerifier_GeneratorParameters__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDtlsClientVerifier_GeneratorParameters_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDtlsClientVerifier_GeneratorParameters_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDtlsClientVerifier_GeneratorParameters__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QDtlsClientVerifier_GeneratorParameters_get_hash(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QCryptographicHash::Algorithm cppOut_local = cppSelf->hash;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCryptographicHash_Algorithm_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QDtlsClientVerifier_GeneratorParameters_set_hash(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("hash");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QCryptographicHash_Algorithm_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("hash", "Algorithm");
        return -1;
    }

    auto cppOut_local = cppSelf->hash;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->hash = cppOut_local;

    return 0;
}

static PyObject *Sbk_QDtlsClientVerifier_GeneratorParameters_get_secret(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->secret)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->secret))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->secret)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &(cppSelf->secret), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QDtlsClientVerifier_GeneratorParameters_set_secret(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("secret");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("secret", "QByteArray");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->secret;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for GeneratorParameters
static PyGetSetDef Sbk_QDtlsClientVerifier_GeneratorParameters_getsetlist[] = {
    {const_cast<char *>("hash"), Sbk_QDtlsClientVerifier_GeneratorParameters_get_hash, Sbk_QDtlsClientVerifier_GeneratorParameters_set_hash, nullptr, nullptr},
    {const_cast<char *>("secret"), Sbk_QDtlsClientVerifier_GeneratorParameters_get_secret, Sbk_QDtlsClientVerifier_GeneratorParameters_set_secret, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDtlsClientVerifier_GeneratorParameters_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDtlsClientVerifier_GeneratorParameters_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDtlsClientVerifier_GeneratorParameters_Type = nullptr;
static PyTypeObject *Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF(void)
{
    return _Sbk_QDtlsClientVerifier_GeneratorParameters_Type;
}

static PyType_Slot Sbk_QDtlsClientVerifier_GeneratorParameters_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDtlsClientVerifier_GeneratorParameters_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDtlsClientVerifier_GeneratorParameters_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDtlsClientVerifier_GeneratorParameters_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QDtlsClientVerifier_GeneratorParameters_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDtlsClientVerifier_GeneratorParameters_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDtlsClientVerifier_GeneratorParameters_spec = {
    "2:PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDtlsClientVerifier_GeneratorParameters_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void GeneratorParameters_PythonToCpp_GeneratorParameters_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_GeneratorParameters_PythonToCpp_GeneratorParameters_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF()))
        return GeneratorParameters_PythonToCpp_GeneratorParameters_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *GeneratorParameters_PTR_CppToPython_GeneratorParameters(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDtlsClientVerifier::GeneratorParameters *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *GeneratorParameters_COPY_CppToPython_GeneratorParameters(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDtlsClientVerifier::GeneratorParameters *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF(), new ::QDtlsClientVerifier::GeneratorParameters(*source), true, true);
}

// Python to C++ copy conversion.
static void GeneratorParameters_PythonToCpp_GeneratorParameters_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDtlsClientVerifier::GeneratorParameters *>(cppOut) = *reinterpret_cast< ::QDtlsClientVerifier::GeneratorParameters *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_GeneratorParameters_PythonToCpp_GeneratorParameters_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF()))
        return GeneratorParameters_PythonToCpp_GeneratorParameters_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDtlsClientVerifier_GeneratorParameters_SignatureStrings[] = {
    "2:PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters(self)",
    "1:PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters(self,a:PySide6.QtCore.QCryptographicHash.Algorithm,s:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "0:PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters(self,GeneratorParameters:PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters)",
    "PySide6.QtNetwork.QDtlsClientVerifier.GeneratorParameters.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDtlsClientVerifier_GeneratorParameters(PyObject *enclosingClass)
{
    if (SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX].type != nullptr)
        return SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX].type;

    Shiboken::AutoDecRef Sbk_QDtlsClientVerifier_GeneratorParameters_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDtlsClientVerifier_GeneratorParameters_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "GeneratorParameters",
        "QDtlsClientVerifier::GeneratorParameters",
        &Sbk_QDtlsClientVerifier_GeneratorParameters_spec,
        &Shiboken::callCppDestructor< ::QDtlsClientVerifier::GeneratorParameters >,
        Sbk_QDtlsClientVerifier_GeneratorParameters_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDtlsClientVerifier_GeneratorParameters_TypeF(); // references _Sbk_QDtlsClientVerifier_GeneratorParameters_Type
    InitSignatureStrings(pyType, QDtlsClientVerifier_GeneratorParameters_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDtlsClientVerifier_GeneratorParameters_PropertyStrings);
    SbkPySide6_QtNetworkTypeStructs[SBK_QDtlsClientVerifier_GeneratorParameters_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        GeneratorParameters_PythonToCpp_GeneratorParameters_PTR,
        is_GeneratorParameters_PythonToCpp_GeneratorParameters_PTR_Convertible,
        GeneratorParameters_PTR_CppToPython_GeneratorParameters,
        GeneratorParameters_COPY_CppToPython_GeneratorParameters);

    Shiboken::Conversions::registerConverterName(converter, "QDtlsClientVerifier::GeneratorParameters");
    Shiboken::Conversions::registerConverterName(converter, "QDtlsClientVerifier::GeneratorParameters*");
    Shiboken::Conversions::registerConverterName(converter, "QDtlsClientVerifier::GeneratorParameters&");
    Shiboken::Conversions::registerConverterName(converter, "GeneratorParameters");
    Shiboken::Conversions::registerConverterName(converter, "GeneratorParameters*");
    Shiboken::Conversions::registerConverterName(converter, "GeneratorParameters&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDtlsClientVerifier::GeneratorParameters).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        GeneratorParameters_PythonToCpp_GeneratorParameters_COPY,
        is_GeneratorParameters_PythonToCpp_GeneratorParameters_COPY_Convertible);

    qRegisterMetaType< ::QDtlsClientVerifier::GeneratorParameters >("GeneratorParameters");
    qRegisterMetaType< ::QDtlsClientVerifier::GeneratorParameters >("QDtlsClientVerifier::GeneratorParameters");

    return pyType;
}
