// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QNetworkCookieJarWrapper_H
#define SBK_QNetworkCookieJarWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtNetwork/qnetworkcookiejar.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QNetworkCookieJarWrapper : public QNetworkCookieJar
{
public:
    QNetworkCookieJarWrapper(const QNetworkCookieJarWrapper &) = delete;
    QNetworkCookieJarWrapper& operator=(const QNetworkCookieJarWrapper &) = delete;
    QNetworkCookieJarWrapper(QNetworkCookieJarWrapper &&) = delete;
    QNetworkCookieJarWrapper& operator=(QNetworkCookieJarWrapper &&) = delete;

    QNetworkCookieJarWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QList<QNetworkCookie> cookiesForUrl(const ::QUrl & url) const override;
    void customEvent(::QEvent * event) override;
    bool deleteCookie(const ::QNetworkCookie & cookie) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool insertCookie(const ::QNetworkCookie & cookie) override;
    bool setCookiesFromUrl(const ::QList<QNetworkCookie> & cookieList, const ::QUrl & url) override;
    void timerEvent(::QTimerEvent * event) override;
    bool updateCookie(const ::QNetworkCookie & cookie) override;
    bool validateCookie(const ::QNetworkCookie & cookie, const ::QUrl & url) const override;
    ~QNetworkCookieJarWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QNetworkCookieJarWrapper_H

