// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnfc_python.h"

// main header
#include "qndeffilter_record_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNdefFilter_Record_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QNdefFilter::Record >()))
        return -1;

    ::QNdefFilter::Record *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNdefFilter.Record.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "Record", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: Record::Record()
    // 1: Record::Record(QNdefFilter::Record)
    if (numArgs == 0) {
        overloadId = 0; // Record()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), (pyArgs[0])))) {
        overloadId = 1; // Record(QNdefFilter::Record)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // Record()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // Record()
                cptr = new ::QNdefFilter::Record();
            }
            break;
        }
        case 1: // Record(const QNdefFilter::Record & Record)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNdefFilter::Record cppArg0_local;
            ::QNdefFilter::Record *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // Record(QNdefFilter::Record)
                cptr = new ::QNdefFilter::Record(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QNdefFilter::Record >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QNdefFilter_Record__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNdefFilter_Record_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNdefFilter_Record_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QNdefFilter_Record__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QNdefFilter_Record_get_typeNameFormat(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QNdefRecord::TypeNameFormat cppOut_local = cppSelf->typeNameFormat;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_TypeNameFormat_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QNdefFilter_Record_set_typeNameFormat(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("typeNameFormat");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefRecord_TypeNameFormat_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("typeNameFormat", "TypeNameFormat");
        return -1;
    }

    auto cppOut_local = cppSelf->typeNameFormat;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->typeNameFormat = cppOut_local;

    return 0;
}

static PyObject *Sbk_QNdefFilter_Record_get_type(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->type)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->type))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->type)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &(cppSelf->type), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QNdefFilter_Record_set_type(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("type");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("type", "QByteArray");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->type;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QNdefFilter_Record_get_minimum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned int cppOut_local = cppSelf->minimum;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QNdefFilter_Record_set_minimum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("minimum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("minimum", "unsigned int");
        return -1;
    }

    auto cppOut_local = cppSelf->minimum;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->minimum = cppOut_local;

    return 0;
}

static PyObject *Sbk_QNdefFilter_Record_get_maximum(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    unsigned int cppOut_local = cppSelf->maximum;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QNdefFilter_Record_set_maximum(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("maximum");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("maximum", "unsigned int");
        return -1;
    }

    auto cppOut_local = cppSelf->maximum;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->maximum = cppOut_local;

    return 0;
}

// Getters and Setters for Record
static PyGetSetDef Sbk_QNdefFilter_Record_getsetlist[] = {
    {const_cast<char *>("typeNameFormat"), Sbk_QNdefFilter_Record_get_typeNameFormat, Sbk_QNdefFilter_Record_set_typeNameFormat, nullptr, nullptr},
    {const_cast<char *>("type"), Sbk_QNdefFilter_Record_get_type, Sbk_QNdefFilter_Record_set_type, nullptr, nullptr},
    {const_cast<char *>("minimum"), Sbk_QNdefFilter_Record_get_minimum, Sbk_QNdefFilter_Record_set_minimum, nullptr, nullptr},
    {const_cast<char *>("maximum"), Sbk_QNdefFilter_Record_get_maximum, Sbk_QNdefFilter_Record_set_maximum, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QNdefFilter_Record_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNdefFilter_Record_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNdefFilter_Record_Type = nullptr;
static PyTypeObject *Sbk_QNdefFilter_Record_TypeF(void)
{
    return _Sbk_QNdefFilter_Record_Type;
}

static PyType_Slot Sbk_QNdefFilter_Record_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNdefFilter_Record_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNdefFilter_Record_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNdefFilter_Record_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QNdefFilter_Record_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNdefFilter_Record_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNdefFilter_Record_spec = {
    "2:PySide6.QtNfc.QNdefFilter.Record",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNdefFilter_Record_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void Record_PythonToCpp_Record_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNdefFilter_Record_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_Record_PythonToCpp_Record_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefFilter_Record_TypeF()))
        return Record_PythonToCpp_Record_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *Record_PTR_CppToPython_Record(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QNdefFilter::Record *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QNdefFilter_Record_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *Record_COPY_CppToPython_Record(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QNdefFilter::Record *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QNdefFilter_Record_TypeF(), new ::QNdefFilter::Record(*source), true, true);
}

// Python to C++ copy conversion.
static void Record_PythonToCpp_Record_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNdefFilter::Record *>(cppOut) = *reinterpret_cast< ::QNdefFilter::Record *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_Record_PythonToCpp_Record_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QNdefFilter_Record_TypeF()))
        return Record_PythonToCpp_Record_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QNdefFilter_Record_SignatureStrings[] = {
    "1:PySide6.QtNfc.QNdefFilter.Record(self)",
    "0:PySide6.QtNfc.QNdefFilter.Record(self,Record:PySide6.QtNfc.QNdefFilter.Record)",
    "PySide6.QtNfc.QNdefFilter.Record.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QNdefFilter_Record(PyObject *enclosingClass)
{
    if (SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX].type != nullptr)
        return SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX].type;

    Shiboken::AutoDecRef Sbk_QNdefFilter_Record_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QNdefFilter_Record_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "Record",
        "QNdefFilter::Record",
        &Sbk_QNdefFilter_Record_spec,
        &Shiboken::callCppDestructor< ::QNdefFilter::Record >,
        Sbk_QNdefFilter_Record_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QNdefFilter_Record_TypeF(); // references _Sbk_QNdefFilter_Record_Type
    InitSignatureStrings(pyType, QNdefFilter_Record_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNdefFilter_Record_PropertyStrings);
    SbkPySide6_QtNfcTypeStructs[SBK_QNdefFilter_Record_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        Record_PythonToCpp_Record_PTR,
        is_Record_PythonToCpp_Record_PTR_Convertible,
        Record_PTR_CppToPython_Record,
        Record_COPY_CppToPython_Record);

    Shiboken::Conversions::registerConverterName(converter, "QNdefFilter::Record");
    Shiboken::Conversions::registerConverterName(converter, "QNdefFilter::Record*");
    Shiboken::Conversions::registerConverterName(converter, "QNdefFilter::Record&");
    Shiboken::Conversions::registerConverterName(converter, "Record");
    Shiboken::Conversions::registerConverterName(converter, "Record*");
    Shiboken::Conversions::registerConverterName(converter, "Record&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNdefFilter::Record).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        Record_PythonToCpp_Record_COPY,
        is_Record_PythonToCpp_Record_COPY_Convertible);

    qRegisterMetaType< ::QNdefFilter::Record >("Record");
    qRegisterMetaType< ::QNdefFilter::Record >("QNdefFilter::Record");

    return pyType;
}
