// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtnfc_python.h"

// main header
#include "qnearfieldtarget_requestid_wrapper.h"

// Argument includes
#include <QtNfc/qnearfieldtarget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QNearFieldTarget_RequestId_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QNearFieldTarget::RequestId >()))
        return -1;

    ::QNearFieldTarget::RequestId *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtNfc.QNearFieldTarget.RequestId.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "RequestId", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: RequestId::RequestId()
    // 1: RequestId::RequestId(QNearFieldTarget::RequestId)
    if (numArgs == 0) {
        overloadId = 0; // RequestId()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), (pyArgs[0])))) {
        overloadId = 1; // RequestId(QNearFieldTarget::RequestId)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // RequestId()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // RequestId()
                cptr = new ::QNearFieldTarget::RequestId();
            }
            break;
        }
        case 1: // RequestId(const QNearFieldTarget::RequestId & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QNearFieldTarget::RequestId cppArg0_local;
            ::QNearFieldTarget::RequestId *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // RequestId(QNearFieldTarget::RequestId)
                cptr = new ::QNearFieldTarget::RequestId(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QNearFieldTarget::RequestId >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QNearFieldTarget_RequestIdFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNearFieldTarget::RequestId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNearFieldTarget.RequestId.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QNearFieldTarget::RequestId *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNearFieldTarget_RequestIdFunc_refCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QNearFieldTarget::RequestId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtNfc.QNearFieldTarget.RequestId.refCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // refCount()const
            int cppResult = const_cast<const ::QNearFieldTarget::RequestId *>(cppSelf)->refCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QNearFieldTarget_RequestId__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNearFieldTarget::RequestId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QNearFieldTarget_RequestId_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QNearFieldTarget_RequestId_methods[] = {
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QNearFieldTarget_RequestIdFunc_isValid), METH_NOARGS, nullptr},
    {"refCount", reinterpret_cast<PyCFunction>(Sbk_QNearFieldTarget_RequestIdFunc_refCount), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QNearFieldTarget_RequestId__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QNearFieldTarget_RequestId_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QNearFieldTarget::RequestId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), (pyArg)))) {
                // operator!=(const QNearFieldTarget::RequestId & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QNearFieldTarget::RequestId cppArg0_local;
                ::QNearFieldTarget::RequestId *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_LT:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), (pyArg)))) {
                // operator<(const QNearFieldTarget::RequestId & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QNearFieldTarget::RequestId cppArg0_local;
                ::QNearFieldTarget::RequestId *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf < (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                return Shiboken::returnFromRichCompare(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), (pyArg)))) {
                // operator==(const QNearFieldTarget::RequestId & other) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QNearFieldTarget::RequestId cppArg0_local;
                ::QNearFieldTarget::RequestId *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QNearFieldTarget_RequestId_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QNearFieldTarget_RequestId_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QNearFieldTarget_RequestId_Type = nullptr;
static PyTypeObject *Sbk_QNearFieldTarget_RequestId_TypeF(void)
{
    return _Sbk_QNearFieldTarget_RequestId_Type;
}

static PyType_Slot Sbk_QNearFieldTarget_RequestId_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QNearFieldTarget_RequestId_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QNearFieldTarget_RequestId_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QNearFieldTarget_RequestId_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QNearFieldTarget_RequestId_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QNearFieldTarget_RequestId_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QNearFieldTarget_RequestId_spec = {
    "2:PySide6.QtNfc.QNearFieldTarget.RequestId",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QNearFieldTarget_RequestId_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void RequestId_PythonToCpp_RequestId_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QNearFieldTarget_RequestId_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_RequestId_PythonToCpp_RequestId_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QNearFieldTarget_RequestId_TypeF()))
        return RequestId_PythonToCpp_RequestId_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *RequestId_PTR_CppToPython_RequestId(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QNearFieldTarget::RequestId *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QNearFieldTarget_RequestId_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *RequestId_COPY_CppToPython_RequestId(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QNearFieldTarget::RequestId *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QNearFieldTarget_RequestId_TypeF(), new ::QNearFieldTarget::RequestId(*source), true, true);
}

// Python to C++ copy conversion.
static void RequestId_PythonToCpp_RequestId_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QNearFieldTarget::RequestId *>(cppOut) = *reinterpret_cast< ::QNearFieldTarget::RequestId *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_RequestId_PythonToCpp_RequestId_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QNearFieldTarget_RequestId_TypeF()))
        return RequestId_PythonToCpp_RequestId_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QNearFieldTarget_RequestId_SignatureStrings[] = {
    "1:PySide6.QtNfc.QNearFieldTarget.RequestId(self)",
    "0:PySide6.QtNfc.QNearFieldTarget.RequestId(self,other:PySide6.QtNfc.QNearFieldTarget.RequestId)",
    "PySide6.QtNfc.QNearFieldTarget.RequestId.isValid(self)->bool",
    "PySide6.QtNfc.QNearFieldTarget.RequestId.refCount(self)->int",
    "PySide6.QtNfc.QNearFieldTarget.RequestId.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QNearFieldTarget_RequestId(PyObject *enclosingClass)
{
    if (SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX].type != nullptr)
        return SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX].type;

    Shiboken::AutoDecRef Sbk_QNearFieldTarget_RequestId_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QNearFieldTarget_RequestId_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "RequestId",
        "QNearFieldTarget::RequestId",
        &Sbk_QNearFieldTarget_RequestId_spec,
        &Shiboken::callCppDestructor< ::QNearFieldTarget::RequestId >,
        Sbk_QNearFieldTarget_RequestId_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QNearFieldTarget_RequestId_TypeF(); // references _Sbk_QNearFieldTarget_RequestId_Type
    InitSignatureStrings(pyType, QNearFieldTarget_RequestId_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QNearFieldTarget_RequestId_PropertyStrings);
    SbkPySide6_QtNfcTypeStructs[SBK_QNearFieldTarget_RequestId_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        RequestId_PythonToCpp_RequestId_PTR,
        is_RequestId_PythonToCpp_RequestId_PTR_Convertible,
        RequestId_PTR_CppToPython_RequestId,
        RequestId_COPY_CppToPython_RequestId);

    Shiboken::Conversions::registerConverterName(converter, "QNearFieldTarget::RequestId");
    Shiboken::Conversions::registerConverterName(converter, "QNearFieldTarget::RequestId*");
    Shiboken::Conversions::registerConverterName(converter, "QNearFieldTarget::RequestId&");
    Shiboken::Conversions::registerConverterName(converter, "RequestId");
    Shiboken::Conversions::registerConverterName(converter, "RequestId*");
    Shiboken::Conversions::registerConverterName(converter, "RequestId&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QNearFieldTarget::RequestId).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        RequestId_PythonToCpp_RequestId_COPY,
        is_RequestId_PythonToCpp_RequestId_COPY_Convertible);

    qRegisterMetaType< ::QNearFieldTarget::RequestId >("RequestId");
    qRegisterMetaType< ::QNearFieldTarget::RequestId >("QNearFieldTarget::RequestId");

    return pyType;
}
