// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtpdf_python.h"

// main header
#include "qpdfdocumentrenderoptions_wrapper.h"

// Argument includes
#include <QtPdf/qpdfdocumentrenderoptions.h>
#include <qrect.h>
#include <qsize.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QPdfDocumentRenderOptions_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QPdfDocumentRenderOptions >()))
        return -1;

    ::QPdfDocumentRenderOptions *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QPdfDocumentRenderOptions", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QPdfDocumentRenderOptions::QPdfDocumentRenderOptions()
    // 1: QPdfDocumentRenderOptions::QPdfDocumentRenderOptions(QPdfDocumentRenderOptions)
    if (numArgs == 0) {
        overloadId = 0; // QPdfDocumentRenderOptions()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QPdfDocumentRenderOptions(QPdfDocumentRenderOptions)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QPdfDocumentRenderOptions()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QPdfDocumentRenderOptions()
                cptr = new ::QPdfDocumentRenderOptions();
            }
            break;
        }
        case 1: // QPdfDocumentRenderOptions(const QPdfDocumentRenderOptions & QPdfDocumentRenderOptions)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QPdfDocumentRenderOptions cppArg0_local;
            ::QPdfDocumentRenderOptions *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QPdfDocumentRenderOptions(QPdfDocumentRenderOptions)
                cptr = new ::QPdfDocumentRenderOptions(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QPdfDocumentRenderOptions >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_renderFlags(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.renderFlags";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // renderFlags()const
            QFlags<QPdfDocumentRenderOptions::RenderFlag> cppResult = const_cast<const ::QPdfDocumentRenderOptions *>(cppSelf)->renderFlags();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QFlags_QPdfDocumentRenderOptions_RenderFlag_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_rotation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.rotation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rotation()const
            QPdfDocumentRenderOptions::Rotation cppResult = const_cast<const ::QPdfDocumentRenderOptions *>(cppSelf)->rotation();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_Rotation_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_scaledClipRect(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.scaledClipRect";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // scaledClipRect()const
            QRect cppResult = const_cast<const ::QPdfDocumentRenderOptions *>(cppSelf)->scaledClipRect();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_scaledSize(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.scaledSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // scaledSize()const
            QSize cppResult = const_cast<const ::QPdfDocumentRenderOptions *>(cppSelf)->scaledSize();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_setRenderFlags(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.setRenderFlags";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPdfDocumentRenderOptions::setRenderFlags(QFlags<QPdfDocumentRenderOptions::RenderFlag>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QFlags_QPdfDocumentRenderOptions_RenderFlag_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setRenderFlags(QFlags<QPdfDocumentRenderOptions::RenderFlag>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QFlags<QPdfDocumentRenderOptions::RenderFlag> cppArg0 = QFlags<QPdfDocumentRenderOptions::RenderFlag>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setRenderFlags(QFlags<QPdfDocumentRenderOptions::RenderFlag>)
            cppSelf->setRenderFlags(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_setRotation(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.setRotation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPdfDocumentRenderOptions::setRotation(QPdfDocumentRenderOptions::Rotation)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_Rotation_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setRotation(QPdfDocumentRenderOptions::Rotation)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QPdfDocumentRenderOptions::Rotation cppArg0{QPdfDocumentRenderOptions::Rotation::None};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setRotation(QPdfDocumentRenderOptions::Rotation)
            cppSelf->setRotation(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_setScaledClipRect(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.setScaledClipRect";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPdfDocumentRenderOptions::setScaledClipRect(QRect)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QRect_IDX]), (pyArg)))) {
        overloadId = 0; // setScaledClipRect(QRect)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QRect cppArg0_local;
        ::QRect *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setScaledClipRect(QRect)
            cppSelf->setScaledClipRect(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPdfDocumentRenderOptionsFunc_setScaledSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtPdf.QPdfDocumentRenderOptions.setScaledSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QPdfDocumentRenderOptions::setScaledSize(QSize)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyArg)))) {
        overloadId = 0; // setScaledSize(QSize)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSize cppArg0_local;
        ::QSize *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setScaledSize(QSize)
            cppSelf->setScaledSize(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QPdfDocumentRenderOptions__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QPdfDocumentRenderOptions_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QPdfDocumentRenderOptions_EnumFlagInfo[] = {
    "RenderFlag:Flag:RenderFlags",
    "Rotation:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QPdfDocumentRenderOptions_methods[] = {
    {"renderFlags", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_renderFlags), METH_NOARGS, nullptr},
    {"rotation", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_rotation), METH_NOARGS, nullptr},
    {"scaledClipRect", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_scaledClipRect), METH_NOARGS, nullptr},
    {"scaledSize", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_scaledSize), METH_NOARGS, nullptr},
    {"setRenderFlags", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_setRenderFlags), METH_O, nullptr},
    {"setRotation", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_setRotation), METH_O, nullptr},
    {"setScaledClipRect", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_setScaledClipRect), METH_O, nullptr},
    {"setScaledSize", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptionsFunc_setScaledSize), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QPdfDocumentRenderOptions__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QPdfDocumentRenderOptions_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), (pyArg)))) {
                // operator!=(const QPdfDocumentRenderOptions & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPdfDocumentRenderOptions cppArg0_local;
                ::QPdfDocumentRenderOptions *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), (pyArg)))) {
                // operator==(const QPdfDocumentRenderOptions & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QPdfDocumentRenderOptions cppArg0_local;
                ::QPdfDocumentRenderOptions *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QPdfDocumentRenderOptions_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QPdfDocumentRenderOptions_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QPdfDocumentRenderOptions_Type = nullptr;
static PyTypeObject *Sbk_QPdfDocumentRenderOptions_TypeF(void)
{
    return _Sbk_QPdfDocumentRenderOptions_Type;
}

static PyType_Slot Sbk_QPdfDocumentRenderOptions_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QPdfDocumentRenderOptions_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QPdfDocumentRenderOptions_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QPdfDocumentRenderOptions_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QPdfDocumentRenderOptions_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QPdfDocumentRenderOptions_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QPdfDocumentRenderOptions_spec = {
    "2:PySide6.QtPdf.QPdfDocumentRenderOptions",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QPdfDocumentRenderOptions_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QPdfDocumentRenderOptions_Rotation_PythonToCpp_QPdfDocumentRenderOptions_Rotation(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPdfDocumentRenderOptions::Rotation>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPdfDocumentRenderOptions::Rotation *>(cppOut) = value;

}
static PythonToCppFunc is_QPdfDocumentRenderOptions_Rotation_PythonToCpp_QPdfDocumentRenderOptions_Rotation_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_Rotation_IDX])))
        return QPdfDocumentRenderOptions_Rotation_PythonToCpp_QPdfDocumentRenderOptions_Rotation;
    return {};
}
static PyObject *QPdfDocumentRenderOptions_Rotation_CppToPython_QPdfDocumentRenderOptions_Rotation(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPdfDocumentRenderOptions::Rotation *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_Rotation_IDX]), castCppIn);

}

static void QPdfDocumentRenderOptions_RenderFlag_PythonToCpp_QPdfDocumentRenderOptions_RenderFlag(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QPdfDocumentRenderOptions::RenderFlag>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QPdfDocumentRenderOptions::RenderFlag *>(cppOut) = value;

}
static PythonToCppFunc is_QPdfDocumentRenderOptions_RenderFlag_PythonToCpp_QPdfDocumentRenderOptions_RenderFlag_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_RenderFlag_IDX])))
        return QPdfDocumentRenderOptions_RenderFlag_PythonToCpp_QPdfDocumentRenderOptions_RenderFlag;
    return {};
}
static PyObject *QPdfDocumentRenderOptions_RenderFlag_CppToPython_QPdfDocumentRenderOptions_RenderFlag(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QPdfDocumentRenderOptions::RenderFlag *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_RenderFlag_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QPdfDocumentRenderOptions_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QPdfDocumentRenderOptions_TypeF()))
        return QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QPdfDocumentRenderOptions_PTR_CppToPython_QPdfDocumentRenderOptions(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QPdfDocumentRenderOptions *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QPdfDocumentRenderOptions_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QPdfDocumentRenderOptions_COPY_CppToPython_QPdfDocumentRenderOptions(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QPdfDocumentRenderOptions *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QPdfDocumentRenderOptions_TypeF(), new ::QPdfDocumentRenderOptions(*source), true, true);
}

// Python to C++ copy conversion.
static void QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QPdfDocumentRenderOptions *>(cppOut) = *reinterpret_cast< ::QPdfDocumentRenderOptions *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QPdfDocumentRenderOptions_TypeF()))
        return QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QPdfDocumentRenderOptions_SignatureStrings[] = {
    "1:PySide6.QtPdf.QPdfDocumentRenderOptions(self)",
    "0:PySide6.QtPdf.QPdfDocumentRenderOptions(self,QPdfDocumentRenderOptions:PySide6.QtPdf.QPdfDocumentRenderOptions)",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.renderFlags(self)->PySide6.QtPdf.QPdfDocumentRenderOptions.RenderFlag",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.rotation(self)->PySide6.QtPdf.QPdfDocumentRenderOptions.Rotation",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.scaledClipRect(self)->PySide6.QtCore.QRect",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.scaledSize(self)->PySide6.QtCore.QSize",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.setRenderFlags(self,r:PySide6.QtPdf.QPdfDocumentRenderOptions.RenderFlag)",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.setRotation(self,r:PySide6.QtPdf.QPdfDocumentRenderOptions.Rotation)",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.setScaledClipRect(self,r:PySide6.QtCore.QRect)",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.setScaledSize(self,s:PySide6.QtCore.QSize)",
    "PySide6.QtPdf.QPdfDocumentRenderOptions.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QPdfDocumentRenderOptions(PyObject *module)
{
    if (SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX].type != nullptr)
        return SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX].type;

    Shiboken::AutoDecRef Sbk_QPdfDocumentRenderOptions_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QPdfDocumentRenderOptions_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QPdfDocumentRenderOptions",
        "QPdfDocumentRenderOptions",
        &Sbk_QPdfDocumentRenderOptions_spec,
        &Shiboken::callCppDestructor< ::QPdfDocumentRenderOptions >,
        Sbk_QPdfDocumentRenderOptions_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QPdfDocumentRenderOptions_TypeF(); // references _Sbk_QPdfDocumentRenderOptions_Type
    InitSignatureStrings(pyType, QPdfDocumentRenderOptions_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QPdfDocumentRenderOptions_PropertyStrings);
    SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_PTR,
        is_QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_PTR_Convertible,
        QPdfDocumentRenderOptions_PTR_CppToPython_QPdfDocumentRenderOptions,
        QPdfDocumentRenderOptions_COPY_CppToPython_QPdfDocumentRenderOptions);

    Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions");
    Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions*");
    Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QPdfDocumentRenderOptions).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_COPY,
        is_QPdfDocumentRenderOptions_PythonToCpp_QPdfDocumentRenderOptions_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QPdfDocumentRenderOptions_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Rotation'.
    const char *Rotation_Initializer[] = {
        "None_",
        "Clockwise90",
        "Clockwise180",
        "Clockwise270",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t Rotation_InitializerValues[] = {
        int8_t(QPdfDocumentRenderOptions::Rotation::None),         //  0x00  0
        int8_t(QPdfDocumentRenderOptions::Rotation::Clockwise90),  //  0x01  1
        int8_t(QPdfDocumentRenderOptions::Rotation::Clockwise180), //  0x02  2
        int8_t(QPdfDocumentRenderOptions::Rotation::Clockwise270)  //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPdfDocumentRenderOptions_TypeF(),
        "2:PySide6.QtPdf.QPdfDocumentRenderOptions.Rotation",
        Rotation_Initializer, Rotation_InitializerValues);
    SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_Rotation_IDX].type = EType;
    // Register converter for enum 'QPdfDocumentRenderOptions::Rotation'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPdfDocumentRenderOptions_Rotation_CppToPython_QPdfDocumentRenderOptions_Rotation);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QPdfDocumentRenderOptions_Rotation_PythonToCpp_QPdfDocumentRenderOptions_Rotation,
            is_QPdfDocumentRenderOptions_Rotation_PythonToCpp_QPdfDocumentRenderOptions_Rotation_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions::Rotation");
        Shiboken::Conversions::registerConverterName(converter, "Rotation");
    }
    // End of 'Rotation' enum.

    // Initialization of enum 'RenderFlag'.
    const char *RenderFlag_Initializer[] = {
        "None_",
        "Annotations",
        "OptimizedForLcd",
        "Grayscale",
        "ForceHalftone",
        "TextAliased",
        "ImageAliased",
        "PathAliased",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t RenderFlag_InitializerValues[] = {
        int8_t(QPdfDocumentRenderOptions::RenderFlag::None),            //  0x00  0
        int8_t(QPdfDocumentRenderOptions::RenderFlag::Annotations),     //  0x01  1
        int8_t(QPdfDocumentRenderOptions::RenderFlag::OptimizedForLcd), //  0x02  2
        int8_t(QPdfDocumentRenderOptions::RenderFlag::Grayscale),       //  0x04  4
        int8_t(QPdfDocumentRenderOptions::RenderFlag::ForceHalftone),   //  0x08  8
        int8_t(QPdfDocumentRenderOptions::RenderFlag::TextAliased),     //  0x10  16
        int8_t(QPdfDocumentRenderOptions::RenderFlag::ImageAliased),    //  0x20  32
        int8_t(QPdfDocumentRenderOptions::RenderFlag::PathAliased)      //  0x40  64
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QPdfDocumentRenderOptions_TypeF(),
        "2:PySide6.QtPdf.QPdfDocumentRenderOptions.RenderFlag",
        RenderFlag_Initializer, RenderFlag_InitializerValues);
    SbkPySide6_QtPdfTypeStructs[SBK_QPdfDocumentRenderOptions_RenderFlag_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtPdfTypeStructs[SBK_QFlags_QPdfDocumentRenderOptions_RenderFlag_IDX].type =
        EType;
    // Register converter for enum 'QPdfDocumentRenderOptions::RenderFlag'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QPdfDocumentRenderOptions_RenderFlag_CppToPython_QPdfDocumentRenderOptions_RenderFlag);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QPdfDocumentRenderOptions_RenderFlag_PythonToCpp_QPdfDocumentRenderOptions_RenderFlag,
            is_QPdfDocumentRenderOptions_RenderFlag_PythonToCpp_QPdfDocumentRenderOptions_RenderFlag_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions::RenderFlag");
        Shiboken::Conversions::registerConverterName(converter, "RenderFlag");
        // Register converter for flag 'QFlags<QPdfDocumentRenderOptions::RenderFlag>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QPdfDocumentRenderOptions::RenderFlag>");
        Shiboken::Conversions::registerConverterName(converter, "QPdfDocumentRenderOptions::RenderFlags");
    }
    // End of 'RenderFlag' enum/flags.

    qRegisterMetaType< ::QPdfDocumentRenderOptions >("QPdfDocumentRenderOptions");
    qRegisterMetaType< ::QPdfDocumentRenderOptions::Rotation >("QPdfDocumentRenderOptions::Rotation");
    qRegisterMetaType< ::QPdfDocumentRenderOptions::RenderFlag >("QPdfDocumentRenderOptions::RenderFlag");

    return pyType;
}
