// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGeoSatelliteInfoSourceWrapper_H
#define SBK_QGeoSatelliteInfoSourceWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeosatelliteinfosource.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGeoSatelliteInfoSourceWrapper : public QGeoSatelliteInfoSource
{
public:
    QGeoSatelliteInfoSourceWrapper(const QGeoSatelliteInfoSourceWrapper &) = delete;
    QGeoSatelliteInfoSourceWrapper& operator=(const QGeoSatelliteInfoSourceWrapper &) = delete;
    QGeoSatelliteInfoSourceWrapper(QGeoSatelliteInfoSourceWrapper &&) = delete;
    QGeoSatelliteInfoSourceWrapper& operator=(QGeoSatelliteInfoSourceWrapper &&) = delete;

    QGeoSatelliteInfoSourceWrapper(::QObject * parent);
    ::QVariant backendProperty(const ::QString & name) const override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QGeoSatelliteInfoSource::Error error() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    int minimumUpdateInterval() const override;
    void requestUpdate(int timeout = 0) override;
    bool setBackendProperty(const ::QString & name, const ::QVariant & value) override;
    void setUpdateInterval(int msec) override;
    void startUpdates() override;
    void stopUpdates() override;
    void timerEvent(::QTimerEvent * event) override;
    ~QGeoSatelliteInfoSourceWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[15];
};

#endif // SBK_QGeoSatelliteInfoSourceWrapper_H

