// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlExpressionWrapper_H
#define SBK_QQmlExpressionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlexpression.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQmlExpressionWrapper : public QQmlExpression
{
public:
    QQmlExpressionWrapper(const QQmlExpressionWrapper &) = delete;
    QQmlExpressionWrapper& operator=(const QQmlExpressionWrapper &) = delete;
    QQmlExpressionWrapper(QQmlExpressionWrapper &&) = delete;
    QQmlExpressionWrapper& operator=(QQmlExpressionWrapper &&) = delete;

    QQmlExpressionWrapper();
    QQmlExpressionWrapper(::QQmlContext * arg__1, ::QObject * arg__2, const ::QString & arg__3, ::QObject * arg__4 = nullptr);
    QQmlExpressionWrapper(const ::QQmlScriptString & arg__1, ::QQmlContext * arg__2 = nullptr, ::QObject * arg__3 = nullptr, ::QObject * arg__4 = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQmlExpressionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QQmlExpressionWrapper_H

