// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlIncubationControllerWrapper_H
#define SBK_QQmlIncubationControllerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlincubator.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQmlIncubationControllerWrapper : public QQmlIncubationController
{
public:
    QQmlIncubationControllerWrapper(const QQmlIncubationControllerWrapper &) = delete;
    QQmlIncubationControllerWrapper& operator=(const QQmlIncubationControllerWrapper &) = delete;
    QQmlIncubationControllerWrapper(QQmlIncubationControllerWrapper &&) = delete;
    QQmlIncubationControllerWrapper& operator=(QQmlIncubationControllerWrapper &&) = delete;

    QQmlIncubationControllerWrapper();
    void incubatingObjectCountChanged(int arg__1) override;
    ~QQmlIncubationControllerWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QQmlIncubationControllerWrapper_H

