// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQmlIncubatorWrapper_H
#define SBK_QQmlIncubatorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlincubator.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQmlIncubatorWrapper : public QQmlIncubator
{
public:
    QQmlIncubatorWrapper(const QQmlIncubatorWrapper &) = delete;
    QQmlIncubatorWrapper& operator=(const QQmlIncubatorWrapper &) = delete;
    QQmlIncubatorWrapper(QQmlIncubatorWrapper &&) = delete;
    QQmlIncubatorWrapper& operator=(QQmlIncubatorWrapper &&) = delete;

    QQmlIncubatorWrapper(::QQmlIncubator::IncubationMode arg__1 = QQmlIncubator::IncubationMode::Asynchronous);
    void setInitialState(::QObject * arg__1) override;
    void statusChanged(::QQmlIncubator::Status arg__1) override;
    ~QQmlIncubatorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QQmlIncubatorWrapper_H

