// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_RendererWrapper_H
#define SBK_RendererWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickframebufferobject.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class RendererWrapper : public QQuickFramebufferObject::Renderer
{
public:
    RendererWrapper(const RendererWrapper &) = delete;
    RendererWrapper& operator=(const RendererWrapper &) = delete;
    RendererWrapper(RendererWrapper &&) = delete;
    RendererWrapper& operator=(RendererWrapper &&) = delete;

    RendererWrapper();
    ::QOpenGLFramebufferObject * createFramebufferObject(const ::QSize & size) override;
    void render() override;
    void synchronize(::QQuickFramebufferObject * arg__1) override;
    ~RendererWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_RendererWrapper_H

