// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsggeometry_attributeset_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSGGeometry_AttributeSet_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSGGeometry::AttributeSet >()))
        return -1;

    ::QSGGeometry::AttributeSet *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSGGeometry.AttributeSet.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "AttributeSet", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: AttributeSet::AttributeSet()
    // 1: AttributeSet::AttributeSet(QSGGeometry::AttributeSet)
    if (numArgs == 0) {
        overloadId = 0; // AttributeSet()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), (pyArgs[0])))) {
        overloadId = 1; // AttributeSet(QSGGeometry::AttributeSet)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // AttributeSet()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // AttributeSet()
                cptr = new ::QSGGeometry::AttributeSet();
            }
            break;
        }
        case 1: // AttributeSet(const QSGGeometry::AttributeSet & AttributeSet)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QSGGeometry::AttributeSet cppArg0_local;
            ::QSGGeometry::AttributeSet *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // AttributeSet(QSGGeometry::AttributeSet)
                cptr = new ::QSGGeometry::AttributeSet(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSGGeometry::AttributeSet >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSGGeometry_AttributeSet__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QSGGeometry_AttributeSet_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QSGGeometry_AttributeSet_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSGGeometry_AttributeSet__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QSGGeometry_AttributeSet_get_count(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->count;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_AttributeSet_set_count(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("count");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("count", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->count;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->count = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGGeometry_AttributeSet_get_stride(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->stride;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QSGGeometry_AttributeSet_set_stride(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("stride");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("stride", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->stride;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->stride = cppOut_local;

    return 0;
}

static PyObject *Sbk_QSGGeometry_AttributeSet_get_attributes(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_Attribute_IDX]), cppSelf->attributes);
    return pyOut;
}
static int Sbk_QSGGeometry_AttributeSet_set_attributes(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("attributes");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_Attribute_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("attributes", "Attribute");
        return -1;
    }

    const auto *&cppOut_ptr = cppSelf->attributes;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "attributes", pyIn);
    return 0;
}

// Getters and Setters for AttributeSet
static PyGetSetDef Sbk_QSGGeometry_AttributeSet_getsetlist[] = {
    {const_cast<char *>("count"), Sbk_QSGGeometry_AttributeSet_get_count, Sbk_QSGGeometry_AttributeSet_set_count, nullptr, nullptr},
    {const_cast<char *>("stride"), Sbk_QSGGeometry_AttributeSet_get_stride, Sbk_QSGGeometry_AttributeSet_set_stride, nullptr, nullptr},
    {const_cast<char *>("attributes"), Sbk_QSGGeometry_AttributeSet_get_attributes, Sbk_QSGGeometry_AttributeSet_set_attributes, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QSGGeometry_AttributeSet_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSGGeometry_AttributeSet_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSGGeometry_AttributeSet_Type = nullptr;
static PyTypeObject *Sbk_QSGGeometry_AttributeSet_TypeF(void)
{
    return _Sbk_QSGGeometry_AttributeSet_Type;
}

static PyType_Slot Sbk_QSGGeometry_AttributeSet_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSGGeometry_AttributeSet_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSGGeometry_AttributeSet_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSGGeometry_AttributeSet_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QSGGeometry_AttributeSet_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSGGeometry_AttributeSet_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSGGeometry_AttributeSet_spec = {
    "2:PySide6.QtQuick.QSGGeometry.AttributeSet",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSGGeometry_AttributeSet_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void AttributeSet_PythonToCpp_AttributeSet_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSGGeometry_AttributeSet_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_AttributeSet_PythonToCpp_AttributeSet_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSGGeometry_AttributeSet_TypeF()))
        return AttributeSet_PythonToCpp_AttributeSet_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *AttributeSet_PTR_CppToPython_AttributeSet(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSGGeometry::AttributeSet *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSGGeometry_AttributeSet_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *AttributeSet_COPY_CppToPython_AttributeSet(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSGGeometry::AttributeSet *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSGGeometry_AttributeSet_TypeF(), new ::QSGGeometry::AttributeSet(*source), true, true);
}

// Python to C++ copy conversion.
static void AttributeSet_PythonToCpp_AttributeSet_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QSGGeometry::AttributeSet *>(cppOut) = *reinterpret_cast< ::QSGGeometry::AttributeSet *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_AttributeSet_PythonToCpp_AttributeSet_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QSGGeometry_AttributeSet_TypeF()))
        return AttributeSet_PythonToCpp_AttributeSet_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSGGeometry_AttributeSet_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSGGeometry.AttributeSet(self)",
    "0:PySide6.QtQuick.QSGGeometry.AttributeSet(self,AttributeSet:PySide6.QtQuick.QSGGeometry.AttributeSet)",
    "PySide6.QtQuick.QSGGeometry.AttributeSet.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSGGeometry_AttributeSet(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX].type;

    Shiboken::AutoDecRef Sbk_QSGGeometry_AttributeSet_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSGGeometry_AttributeSet_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "AttributeSet",
        "QSGGeometry::AttributeSet",
        &Sbk_QSGGeometry_AttributeSet_spec,
        &Shiboken::callCppDestructor< ::QSGGeometry::AttributeSet >,
        Sbk_QSGGeometry_AttributeSet_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QSGGeometry_AttributeSet_TypeF(); // references _Sbk_QSGGeometry_AttributeSet_Type
    InitSignatureStrings(pyType, QSGGeometry_AttributeSet_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QSGGeometry_AttributeSet_PropertyStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSGGeometry_AttributeSet_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        AttributeSet_PythonToCpp_AttributeSet_PTR,
        is_AttributeSet_PythonToCpp_AttributeSet_PTR_Convertible,
        AttributeSet_PTR_CppToPython_AttributeSet,
        AttributeSet_COPY_CppToPython_AttributeSet);

    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::AttributeSet");
    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::AttributeSet*");
    Shiboken::Conversions::registerConverterName(converter, "QSGGeometry::AttributeSet&");
    Shiboken::Conversions::registerConverterName(converter, "AttributeSet");
    Shiboken::Conversions::registerConverterName(converter, "AttributeSet*");
    Shiboken::Conversions::registerConverterName(converter, "AttributeSet&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSGGeometry::AttributeSet).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        AttributeSet_PythonToCpp_AttributeSet_COPY,
        is_AttributeSet_PythonToCpp_AttributeSet_COPY_Convertible);

    qRegisterMetaType< ::QSGGeometry::AttributeSet >("AttributeSet");
    qRegisterMetaType< ::QSGGeometry::AttributeSet >("QSGGeometry::AttributeSet");

    return pyType;
}
