// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGImageNodeWrapper_H
#define SBK_QSGImageNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgimagenode.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGImageNodeWrapper : public QSGImageNode
{
public:
    QSGImageNodeWrapper(const QSGImageNodeWrapper &) = delete;
    QSGImageNodeWrapper& operator=(const QSGImageNodeWrapper &) = delete;
    QSGImageNodeWrapper(QSGImageNodeWrapper &&) = delete;
    QSGImageNodeWrapper& operator=(QSGImageNodeWrapper &&) = delete;

    QSGImageNodeWrapper();
    ::QSGTexture::AnisotropyLevel anisotropyLevel() const override;
    ::QSGTexture::Filtering filtering() const override;
    bool isSubtreeBlocked() const override;
    ::QSGTexture::Filtering mipmapFiltering() const override;
    bool ownsTexture() const override;
    void preprocess() override;
    ::QRectF rect() const override;
    void setAnisotropyLevel(::QSGTexture::AnisotropyLevel level) override;
    void setFiltering(::QSGTexture::Filtering filtering) override;
    void setMipmapFiltering(::QSGTexture::Filtering filtering) override;
    void setOwnsTexture(bool owns) override;
    void setRect(const ::QRectF & rect) override;
    void setSourceRect(const ::QRectF & r) override;
    void setTexture(::QSGTexture * texture) override;
    void setTextureCoordinatesTransform(::QFlags<QSGImageNode::TextureCoordinatesTransformFlag> mode) override;
    ::QRectF sourceRect() const override;
    ::QSGTexture * texture() const override;
    ::QFlags<QSGImageNode::TextureCoordinatesTransformFlag> textureCoordinatesTransform() const override;
    ~QSGImageNodeWrapper() override;
    // Inherited overloads, because the using keyword sux
    inline void setSourceRect(qreal x, qreal y, qreal w, qreal h) { QSGImageNode::setSourceRect(x, y, w, h); }
    inline void setRect(qreal x, qreal y, qreal w, qreal h) { QSGImageNode::setRect(x, y, w, h); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[18];
};

#endif // SBK_QSGImageNodeWrapper_H

