// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNodeWrapper_H
#define SBK_QSGNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGNodeWrapper : public QSGNode
{
public:
    QSGNodeWrapper(const QSGNodeWrapper &) = delete;
    QSGNodeWrapper& operator=(const QSGNodeWrapper &) = delete;
    QSGNodeWrapper(QSGNodeWrapper &&) = delete;
    QSGNodeWrapper& operator=(QSGNodeWrapper &&) = delete;

    QSGNodeWrapper();
    QSGNodeWrapper(::QSGNode::NodeType type);
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QSGNodeWrapper_H

