// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGRenderNodeWrapper_H
#define SBK_QSGRenderNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgrendernode.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGRenderNodeWrapper : public QSGRenderNode
{
public:
    QSGRenderNodeWrapper(const QSGRenderNodeWrapper &) = delete;
    QSGRenderNodeWrapper& operator=(const QSGRenderNodeWrapper &) = delete;
    QSGRenderNodeWrapper(QSGRenderNodeWrapper &&) = delete;
    QSGRenderNodeWrapper& operator=(QSGRenderNodeWrapper &&) = delete;

    QSGRenderNodeWrapper();
    ::QFlags<QSGRenderNode::StateFlag> changedStates() const override;
    ::QFlags<QSGRenderNode::RenderingFlag> flags() const override;
    bool isSubtreeBlocked() const override;
    void prepare() override;
    void preprocess() override;
    ::QRectF rect() const override;
    void releaseResources() override;
    void render(const ::QSGRenderNode::RenderState * state) override;
    ~QSGRenderNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QSGRenderNodeWrapper_H

