// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGRootNodeWrapper_H
#define SBK_QSGRootNodeWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGRootNodeWrapper : public QSGRootNode
{
public:
    QSGRootNodeWrapper(const QSGRootNodeWrapper &) = delete;
    QSGRootNodeWrapper& operator=(const QSGRootNodeWrapper &) = delete;
    QSGRootNodeWrapper(QSGRootNodeWrapper &&) = delete;
    QSGRootNodeWrapper& operator=(QSGRootNodeWrapper &&) = delete;

    QSGRootNodeWrapper();
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ~QSGRootNodeWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QSGRootNodeWrapper_H

