// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGTextureMaterialWrapper_H
#define SBK_QSGTextureMaterialWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgtexturematerial.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSGTextureMaterialWrapper : public QSGTextureMaterial
{
public:
    QSGTextureMaterialWrapper(const QSGTextureMaterialWrapper &) = delete;
    QSGTextureMaterialWrapper& operator=(const QSGTextureMaterialWrapper &) = delete;
    QSGTextureMaterialWrapper(QSGTextureMaterialWrapper &&) = delete;
    QSGTextureMaterialWrapper& operator=(QSGTextureMaterialWrapper &&) = delete;

    QSGTextureMaterialWrapper();
    int compare(const ::QSGMaterial * other) const override;
    ::QSGMaterialShader * createShader(::QSGRendererInterface::RenderMode renderMode) const override;
    ::QSGMaterialType * type() const override;
    ~QSGTextureMaterialWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[3];
};

#endif // SBK_QSGTextureMaterialWrapper_H

