// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

// module include
#include "pyside6_qtquick_python.h"

// main header
#include "qsharedpointer_qquickitemgrabresult_wrapper.h"

// Extra includes
#include <QtQuick/qquickitemgrabresult.h>
#include <sbksmartpointer.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QSharedPointer_QQuickItemGrabResult_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QSharedPointer<QQuickItemGrabResult> >()))
        return -1;

    ::QSharedPointer<QQuickItemGrabResult> *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QSharedPointer_QQuickItemGrabResult", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QSharedPointer_QQuickItemGrabResult::QSharedPointer_QQuickItemGrabResult()
    // 1: QSharedPointer_QQuickItemGrabResult::QSharedPointer_QQuickItemGrabResult(QQuickItemGrabResult*)
    if (numArgs == 0) {
        overloadId = 0; // QSharedPointer_QQuickItemGrabResult()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItemGrabResult_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QSharedPointer_QQuickItemGrabResult(QQuickItemGrabResult*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QSharedPointer_QQuickItemGrabResult()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSharedPointer_QQuickItemGrabResult()
                cptr = new ::QSharedPointer<QQuickItemGrabResult>();
            }
            break;
        }
        case 1: // QSharedPointer_QQuickItemGrabResult(QQuickItemGrabResult * pointee)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQuickItemGrabResult *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QSharedPointer_QQuickItemGrabResult(QQuickItemGrabResult*)
                cptr = new ::QSharedPointer<QQuickItemGrabResult>(cppArg0);

                // Ownership transferences.
                Shiboken::Object::releaseOwnership(pyArgs[0]);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QSharedPointer<QQuickItemGrabResult> >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QSharedPointer_QQuickItemGrabResultFunc_reset(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.reset";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "reset", 0, 1, &(pyArgs[0])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QSharedPointer_QQuickItemGrabResult::reset()
    // 1: QSharedPointer_QQuickItemGrabResult::reset(QQuickItemGrabResult*)
    if (numArgs == 0) {
        overloadId = 0; // reset()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItemGrabResult_IDX]), (pyArgs[0])))) {
        overloadId = 1; // reset(QQuickItemGrabResult*)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    switch (overloadId) {
        case 0: // reset()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // reset()
                cppSelf->reset();
            }
            break;
        }
        case 1: // reset(QQuickItemGrabResult * t)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QQuickItemGrabResult *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // reset(QQuickItemGrabResult*)
                cppSelf->reset(cppArg0);

                // Ownership transferences.
                Shiboken::Object::releaseOwnership(pyArgs[0]);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QSharedPointer_QQuickItemGrabResultFunc_data(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.data";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // data()const
            QQuickItemGrabResult * cppResult = const_cast<const ::QSharedPointer<QQuickItemGrabResult> *>(cppSelf)->data();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QQuickItemGrabResult_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QSharedPointer_QQuickItemGrabResult__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

extern "C"
{
static PyObject *Sbk_QSharedPointer_QQuickItemGrabResult__dir__(PyObject *self)
{
    Shiboken::AutoDecRef pointee(PyObject_CallMethod(self, "data", 0));
    return Shiboken::SmartPointer::dir(self, pointee);
}
} // extern C

static PyMethodDef Sbk_QSharedPointer_QQuickItemGrabResult_methods[] = {
    {"reset", reinterpret_cast<PyCFunction>(Sbk_QSharedPointer_QQuickItemGrabResultFunc_reset), METH_VARARGS, nullptr},
    {"data", reinterpret_cast<PyCFunction>(Sbk_QSharedPointer_QQuickItemGrabResultFunc_data), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QSharedPointer_QQuickItemGrabResult__copy__), METH_NOARGS, nullptr},
    {"__dir__", reinterpret_cast<PyCFunction>(Sbk_QSharedPointer_QQuickItemGrabResult__dir__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QSharedPointer_QQuickItemGrabResult_getattro(PyObject *self, PyObject *name)
{
    PyObject *tmp = PyObject_GenericGetAttr(self, name);
    if (tmp)
        return tmp;
    if (PyErr_ExceptionMatches(PyExc_AttributeError) == 0)
        return nullptr;
    PyErr_Clear();
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    if (cppSelf->isNull()) {
        PyTypeObject *tp = Py_TYPE(self);
        PyErr_Format(PyExc_AttributeError, "Attempt to retrieve '%s' from null object '%s'.",
                     Shiboken::String::toCString(name), tp->tp_name);
        return nullptr;
    }
    // Try to find the 'name' attribute, by retrieving the PyObject for the corresponding C++ object held by the smart pointer.
    if (auto *rawObj = PyObject_CallMethod(self, "data", 0)) {
        if (auto *attribute = PyObject_GetAttr(rawObj, name))
            tmp = attribute;
        Py_DECREF(rawObj);
    }
    if (!tmp) {
        PyTypeObject *tp = Py_TYPE(self);
        PyErr_Format(PyExc_AttributeError,
                     "'%.50s' object has no attribute '%.400s'",
                     tp->tp_name, Shiboken::String::toCString(name));
    }
    return tmp;
}

static int Sbk_QSharedPointer_QQuickItemGrabResult_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    // Try to find the 'name' attribute, by retrieving the PyObject for the corresponding C++ object held by the smart pointer.
    if (auto *rawObj = PyObject_CallMethod(self, "data", 0)) {
        if (PyObject_HasAttr(rawObj, name) != 0)
            return PyObject_GenericSetAttr(rawObj, name, value);
        Py_DECREF(rawObj);
    }
    return PyObject_GenericSetAttr(self, name, value);
}

static int Sbk_QSharedPointer_QQuickItemGrabResult___nb_bool(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return -1;
    auto *cppSelf = reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    return !cppSelf->isNull() ? 1 : 0;
}

static PyObject * Sbk_QSharedPointer_QQuickItemGrabResult_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), (pyArg)))) {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSharedPointer<QQuickItemGrabResult> cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        const auto *cppSelfPointee = cppSelf.data();
        const auto *cppArg0Pointee = cppArg0.data();
        bool cppResult= false;
        switch (op) {
        case Py_EQ:
            cppResult = cppSelfPointee == cppArg0Pointee;
            break;
        case Py_NE:
            cppResult = cppSelfPointee != cppArg0Pointee;
            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
        }
        pyResult = cppResult ? Py_True : Py_False;
        Py_INCREF(pyResult);
    }
    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QSharedPointer_QQuickItemGrabResult_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QSharedPointer_QQuickItemGrabResult_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
extern "C"
{
static PyObject *Sbk_QSharedPointer_QQuickItemGrabResult__repr__(PyObject *self)
{
    Shiboken::AutoDecRef pointee(PyObject_CallMethod(self, "data", 0));
    return Shiboken::SmartPointer::repr(self, pointee);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QSharedPointer_QQuickItemGrabResult_Type = nullptr;
static PyTypeObject *Sbk_QSharedPointer_QQuickItemGrabResult_TypeF(void)
{
    return _Sbk_QSharedPointer_QQuickItemGrabResult_Type;
}

static PyType_Slot Sbk_QSharedPointer_QQuickItemGrabResult_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult__repr__)},
    {Py_tp_getattro,    reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_getattro)},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    // type supports number protocol
    {Py_nb_bool,        reinterpret_cast<void *>(Sbk_QSharedPointer_QQuickItemGrabResult___nb_bool)},
    {0, nullptr}
};
static PyType_Spec Sbk_QSharedPointer_QQuickItemGrabResult_spec = {
    "2:PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QSharedPointer_QQuickItemGrabResult_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QSharedPointer_QQuickItemGrabResult_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QSharedPointer_QQuickItemGrabResult_TypeF()))
        return QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QSharedPointer_QQuickItemGrabResult_PTR_CppToPython_QSharedPointer_QQuickItemGrabResult(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QSharedPointer<QQuickItemGrabResult> *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QSharedPointer_QQuickItemGrabResult_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QSharedPointer_QQuickItemGrabResult_COPY_CppToPython_QSharedPointer_QQuickItemGrabResult(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QSharedPointer<QQuickItemGrabResult> *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QSharedPointer_QQuickItemGrabResult_TypeF(), new ::QSharedPointer<QQuickItemGrabResult>(*source), true, true);
}

// Python to C++ copy conversion.
static void QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_COPY(PyObject *pyIn, void *cppOut)
{
    auto *ptr = reinterpret_cast<::QSharedPointer<QQuickItemGrabResult> *>(cppOut);
    if (pyIn == Py_None)
        ptr->reset();
    else
        *ptr = *reinterpret_cast< ::QSharedPointer<QQuickItemGrabResult> *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_COPY_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None || PyObject_TypeCheck(pyIn, Sbk_QSharedPointer_QQuickItemGrabResult_TypeF()))
        return QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QSharedPointer_QQuickItemGrabResult_SignatureStrings[] = {
    "1:PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult(self)",
    "0:PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult(self,pointee:PySide6.QtQuick.QQuickItemGrabResult)",
    "1:PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.reset(self)",
    "0:PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.reset(self,t:PySide6.QtQuick.QQuickItemGrabResult)",
    "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.data(self)->PySide6.QtQuick.QQuickItemGrabResult",
    "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.__copy__()",
    "PySide6.QtQuick.QSharedPointer_QQuickItemGrabResult.__dir__()",
    nullptr}; // Sentinel

PyTypeObject *init_QSharedPointer_QQuickItemGrabResult(PyObject *module)
{
    if (SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX].type != nullptr)
        return SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX].type;

    Shiboken::AutoDecRef Sbk_QSharedPointer_QQuickItemGrabResult_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QSharedPointer_QQuickItemGrabResult_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QSharedPointer_QQuickItemGrabResult",
        "QSharedPointer<QQuickItemGrabResult>",
        &Sbk_QSharedPointer_QQuickItemGrabResult_spec,
        &Shiboken::callCppDestructor< ::QSharedPointer<QQuickItemGrabResult> >,
        Sbk_QSharedPointer_QQuickItemGrabResult_Type_bases.object(),
        0);
    auto *pyType = Sbk_QSharedPointer_QQuickItemGrabResult_TypeF(); // references _Sbk_QSharedPointer_QQuickItemGrabResult_Type
    InitSignatureStrings(pyType, QSharedPointer_QQuickItemGrabResult_SignatureStrings);
    SbkPySide6_QtQuickTypeStructs[SBK_QSharedPointer_QQuickItemGrabResult_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_PTR,
        is_QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_PTR_Convertible,
        QSharedPointer_QQuickItemGrabResult_PTR_CppToPython_QSharedPointer_QQuickItemGrabResult,
        QSharedPointer_QQuickItemGrabResult_COPY_CppToPython_QSharedPointer_QQuickItemGrabResult);

    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QQuickItemGrabResult>");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QQuickItemGrabResult>*");
    Shiboken::Conversions::registerConverterName(converter, "QSharedPointer<QQuickItemGrabResult>&");
    Shiboken::Conversions::registerConverterName(converter, "QQuickItemGrabResult");
    Shiboken::Conversions::registerConverterName(converter, "QQuickItemGrabResult*");
    Shiboken::Conversions::registerConverterName(converter, "QQuickItemGrabResult&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QSharedPointer<QQuickItemGrabResult>).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_COPY,
        is_QSharedPointer_QQuickItemGrabResult_PythonToCpp_QSharedPointer_QQuickItemGrabResult_COPY_Convertible);

    qRegisterMetaType< ::QSharedPointer<QQuickItemGrabResult> >("QSharedPointer<QQuickItemGrabResult>");

    return pyType;
}
