// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquick3d_python.h"

// main header
#include "qquick3dinstancing_instancetableentry_wrapper.h"

// Argument includes
#include <QtGui/qcolor.h>
#include <QtGui/qquaternion.h>
#include <QtGui/qvectornd.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuick3DInstancing_InstanceTableEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuick3DInstancing::InstanceTableEntry >()))
        return -1;

    ::QQuick3DInstancing::InstanceTableEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "InstanceTableEntry", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: InstanceTableEntry::InstanceTableEntry()
    // 1: InstanceTableEntry::InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
    if (numArgs == 0) {
        overloadId = 0; // InstanceTableEntry()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), (pyArgs[0])))) {
        overloadId = 1; // InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // InstanceTableEntry()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // InstanceTableEntry()
                cptr = new ::QQuick3DInstancing::InstanceTableEntry();
            }
            break;
        }
        case 1: // InstanceTableEntry(const QQuick3DInstancing::InstanceTableEntry & InstanceTableEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQuick3DInstancing::InstanceTableEntry cppArg0_local;
            ::QQuick3DInstancing::InstanceTableEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
                cptr = new ::QQuick3DInstancing::InstanceTableEntry(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuick3DInstancing::InstanceTableEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getColor(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getColor";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getColor()const
            QColor cppResult = const_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppSelf)->getColor();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QColor_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getPosition(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getPosition";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getPosition()const
            QVector3D cppResult = const_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppSelf)->getPosition();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getRotation(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getRotation";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getRotation()const
            QQuaternion cppResult = const_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppSelf)->getRotation();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QQuaternion_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getScale(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getScale";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // getScale()const
            QVector3D cppResult = const_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppSelf)->getScale();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector3D_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQuick3DInstancing_InstanceTableEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuick3DInstancing_InstanceTableEntry_methods[] = {
    {"getColor", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getColor), METH_NOARGS, nullptr},
    {"getPosition", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getPosition), METH_NOARGS, nullptr},
    {"getRotation", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getRotation), METH_NOARGS, nullptr},
    {"getScale", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntryFunc_getScale), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntry__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row0(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row0)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row0))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row0)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), &(cppSelf->row0), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row0(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("row0");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("row0", "QVector4D");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row0;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row1(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row1)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row1))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row1)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), &(cppSelf->row1), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row1(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("row1");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("row1", "QVector4D");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row1;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row2(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row2)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row2))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row2)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), &(cppSelf->row2), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row2(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("row2");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("row2", "QVector4D");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row2;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_color(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->color)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->color))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->color)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), &(cppSelf->color), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_color(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("color");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("color", "QVector4D");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->color;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_instanceData(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->instanceData)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->instanceData))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->instanceData)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), &(cppSelf->instanceData), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_instanceData(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("instanceData");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QVector4D_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("instanceData", "QVector4D");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->instanceData;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for InstanceTableEntry
static PyGetSetDef Sbk_QQuick3DInstancing_InstanceTableEntry_getsetlist[] = {
    {const_cast<char *>("row0"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row0, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row0, nullptr, nullptr},
    {const_cast<char *>("row1"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row1, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row1, nullptr, nullptr},
    {const_cast<char *>("row2"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row2, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row2, nullptr, nullptr},
    {const_cast<char *>("color"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_color, Sbk_QQuick3DInstancing_InstanceTableEntry_set_color, nullptr, nullptr},
    {const_cast<char *>("instanceData"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_instanceData, Sbk_QQuick3DInstancing_InstanceTableEntry_set_instanceData, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuick3DInstancing_InstanceTableEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuick3DInstancing_InstanceTableEntry_Type = nullptr;
static PyTypeObject *Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(void)
{
    return _Sbk_QQuick3DInstancing_InstanceTableEntry_Type;
}

static PyType_Slot Sbk_QQuick3DInstancing_InstanceTableEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuick3DInstancing_InstanceTableEntry_spec = {
    "2:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuick3DInstancing_InstanceTableEntry_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF()))
        return InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *InstanceTableEntry_PTR_CppToPython_InstanceTableEntry(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *InstanceTableEntry_COPY_CppToPython_InstanceTableEntry(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), new ::QQuick3DInstancing::InstanceTableEntry(*source), true, true);
}

// Python to C++ copy conversion.
static void InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQuick3DInstancing::InstanceTableEntry *>(cppOut) = *reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF()))
        return InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQuick3DInstancing_InstanceTableEntry_SignatureStrings[] = {
    "1:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry(self)",
    "0:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry(self,InstanceTableEntry:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry)",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getColor(self)->PySide6.QtGui.QColor",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getPosition(self)->PySide6.QtGui.QVector3D",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getRotation(self)->PySide6.QtGui.QQuaternion",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.getScale(self)->PySide6.QtGui.QVector3D",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QQuick3DInstancing_InstanceTableEntry(PyObject *enclosingClass)
{
    if (SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX].type != nullptr)
        return SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX].type;

    Shiboken::AutoDecRef Sbk_QQuick3DInstancing_InstanceTableEntry_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQuick3DInstancing_InstanceTableEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "InstanceTableEntry",
        "QQuick3DInstancing::InstanceTableEntry",
        &Sbk_QQuick3DInstancing_InstanceTableEntry_spec,
        &Shiboken::callCppDestructor< ::QQuick3DInstancing::InstanceTableEntry >,
        Sbk_QQuick3DInstancing_InstanceTableEntry_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(); // references _Sbk_QQuick3DInstancing_InstanceTableEntry_Type
    InitSignatureStrings(pyType, QQuick3DInstancing_InstanceTableEntry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuick3DInstancing_InstanceTableEntry_PropertyStrings);
    SbkPySide6_QtQuick3DTypeStructs[SBK_QQuick3DInstancing_InstanceTableEntry_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR,
        is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR_Convertible,
        InstanceTableEntry_PTR_CppToPython_InstanceTableEntry,
        InstanceTableEntry_COPY_CppToPython_InstanceTableEntry);

    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry*");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry&");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry*");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuick3DInstancing::InstanceTableEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY,
        is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY_Convertible);

    qRegisterMetaType< ::QQuick3DInstancing::InstanceTableEntry >("InstanceTableEntry");
    qRegisterMetaType< ::QQuick3DInstancing::InstanceTableEntry >("QQuick3DInstancing::InstanceTableEntry");

    return pyType;
}
