// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQuickAttachedPropertyPropagatorWrapper_H
#define SBK_QQuickAttachedPropertyPropagatorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuickControls2/qquickattachedpropertypropagator.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QQuickAttachedPropertyPropagatorWrapper : public QQuickAttachedPropertyPropagator
{
public:
    QQuickAttachedPropertyPropagatorWrapper(const QQuickAttachedPropertyPropagatorWrapper &) = delete;
    QQuickAttachedPropertyPropagatorWrapper& operator=(const QQuickAttachedPropertyPropagatorWrapper &) = delete;
    QQuickAttachedPropertyPropagatorWrapper(QQuickAttachedPropertyPropagatorWrapper &&) = delete;
    QQuickAttachedPropertyPropagatorWrapper& operator=(QQuickAttachedPropertyPropagatorWrapper &&) = delete;

    QQuickAttachedPropertyPropagatorWrapper(::QObject * parent = nullptr);
    void attachedParentChange(::QQuickAttachedPropertyPropagator * newParent, ::QQuickAttachedPropertyPropagator * oldParent) override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QQuickAttachedPropertyPropagatorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QQuickAttachedPropertyPropagatorWrapper_H

