// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtquickcontrols2_python.h"

// main header
#include "qquickstyle_wrapper.h"

// Argument includes
#include <QString>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuickStyle_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuickStyle >()))
        return -1;

    ::QQuickStyle *cptr{};
    static const char fullName[] = "PySide6.QtQuickControls2.QQuickStyle.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QQuickStyle()
            cptr = new ::QQuickStyle();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuickStyle >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QQuickStyleFunc_name(PyObject *self)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtQuickControls2.QQuickStyle.name";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // name()
            QString cppResult = ::QQuickStyle::name();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuickStyleFunc_setFallbackStyle(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuickControls2.QQuickStyle.setFallbackStyle";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQuickStyle::setFallbackStyle(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setFallbackStyle(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFallbackStyle(QString)
            ::QQuickStyle::setFallbackStyle(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQuickStyleFunc_setStyle(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtQuickControls2.QQuickStyle.setStyle";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QQuickStyle::setStyle(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setStyle(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStyle(QString)
            ::QQuickStyle::setStyle(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QQuickStyle_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuickStyle_methods[] = {
    {"name", reinterpret_cast<PyCFunction>(Sbk_QQuickStyleFunc_name), METH_NOARGS|METH_STATIC, nullptr},
    {"setFallbackStyle", reinterpret_cast<PyCFunction>(Sbk_QQuickStyleFunc_setFallbackStyle), METH_O|METH_STATIC, nullptr},
    {"setStyle", reinterpret_cast<PyCFunction>(Sbk_QQuickStyleFunc_setStyle), METH_O|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuickStyle_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QQuickStyle_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuickStyle_Type = nullptr;
static PyTypeObject *Sbk_QQuickStyle_TypeF(void)
{
    return _Sbk_QQuickStyle_Type;
}

static PyType_Slot Sbk_QQuickStyle_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuickStyle_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuickStyle_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuickStyle_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuickStyle_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuickStyle_spec = {
    "2:PySide6.QtQuickControls2.QQuickStyle",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuickStyle_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQuickStyle_PythonToCpp_QQuickStyle_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuickStyle_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQuickStyle_PythonToCpp_QQuickStyle_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QQuickStyle_TypeF()))
        return QQuickStyle_PythonToCpp_QQuickStyle_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQuickStyle_PTR_CppToPython_QQuickStyle(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QQuickStyle *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QQuickStyle_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQuickStyle_SignatureStrings[] = {
    "PySide6.QtQuickControls2.QQuickStyle(self)",
    "PySide6.QtQuickControls2.QQuickStyle.name()->QString",
    "PySide6.QtQuickControls2.QQuickStyle.setFallbackStyle(style:QString)",
    "PySide6.QtQuickControls2.QQuickStyle.setStyle(style:QString)",
    nullptr}; // Sentinel

PyTypeObject *init_QQuickStyle(PyObject *module)
{
    if (SbkPySide6_QtQuickControls2TypeStructs[SBK_QQuickStyle_IDX].type != nullptr)
        return SbkPySide6_QtQuickControls2TypeStructs[SBK_QQuickStyle_IDX].type;

    Shiboken::AutoDecRef Sbk_QQuickStyle_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QQuickStyle_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQuickStyle",
        "QQuickStyle*",
        &Sbk_QQuickStyle_spec,
        &Shiboken::callCppDestructor< ::QQuickStyle >,
        Sbk_QQuickStyle_Type_bases.object(),
        0);
    auto *pyType = Sbk_QQuickStyle_TypeF(); // references _Sbk_QQuickStyle_Type
    InitSignatureStrings(pyType, QQuickStyle_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QQuickStyle_PropertyStrings);
    SbkPySide6_QtQuickControls2TypeStructs[SBK_QQuickStyle_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QQuickStyle_PythonToCpp_QQuickStyle_PTR,
        is_QQuickStyle_PythonToCpp_QQuickStyle_PTR_Convertible,
        QQuickStyle_PTR_CppToPython_QQuickStyle);

    Shiboken::Conversions::registerConverterName(converter, "QQuickStyle");
    Shiboken::Conversions::registerConverterName(converter, "QQuickStyle*");
    Shiboken::Conversions::registerConverterName(converter, "QQuickStyle&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuickStyle).name());

    qRegisterMetaType< ::QQuickStyle *>();

    return pyType;
}
