// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QConnectionAbstractServerWrapper_H
#define SBK_QConnectionAbstractServerWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qconnectionfactories.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QConnectionAbstractServerWrapper : public QConnectionAbstractServer
{
public:
    QConnectionAbstractServerWrapper(const QConnectionAbstractServerWrapper &) = delete;
    QConnectionAbstractServerWrapper& operator=(const QConnectionAbstractServerWrapper &) = delete;
    QConnectionAbstractServerWrapper(QConnectionAbstractServerWrapper &&) = delete;
    QConnectionAbstractServerWrapper& operator=(QConnectionAbstractServerWrapper &&) = delete;

    QConnectionAbstractServerWrapper(::QObject * parent = nullptr);
    ::QUrl address() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    ::QtROServerIoDevice * configureNewConnection() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasPendingConnections() const override;
    bool listen(const ::QUrl & address) override;
    ::QAbstractSocket::SocketError serverError() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QConnectionAbstractServerWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[13];
};

#endif // SBK_QConnectionAbstractServerWrapper_H

