// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRemoteObjectHostBaseWrapper_H
#define SBK_QRemoteObjectHostBaseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qremoteobjectnode.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRemoteObjectHostBaseWrapper : public QRemoteObjectHostBase
{
public:
    QRemoteObjectHostBaseWrapper(const QRemoteObjectHostBaseWrapper &) = delete;
    QRemoteObjectHostBaseWrapper& operator=(const QRemoteObjectHostBaseWrapper &) = delete;
    QRemoteObjectHostBaseWrapper(QRemoteObjectHostBaseWrapper &&) = delete;
    QRemoteObjectHostBaseWrapper& operator=(QRemoteObjectHostBaseWrapper &&) = delete;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QUrl hostUrl() const override;
    bool setHostUrl(const ::QUrl & hostAddress, ::QRemoteObjectHostBase::AllowedSchemas allowedSchemas = QRemoteObjectHostBase::AllowedSchemas::BuiltInSchemasOnly) override;
    void setName(const ::QString & name) override;
    bool setRegistryUrl(const ::QUrl & registryAddress) override;
    void timerEvent(::QTimerEvent * arg__1) override;
    ~QRemoteObjectHostBaseWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11];
};

#endif // SBK_QRemoteObjectHostBaseWrapper_H

