// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRemoteObjectSettingsStoreWrapper_H
#define SBK_QRemoteObjectSettingsStoreWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qremoteobjectsettingsstore.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRemoteObjectSettingsStoreWrapper : public QRemoteObjectSettingsStore
{
public:
    QRemoteObjectSettingsStoreWrapper(const QRemoteObjectSettingsStoreWrapper &) = delete;
    QRemoteObjectSettingsStoreWrapper& operator=(const QRemoteObjectSettingsStoreWrapper &) = delete;
    QRemoteObjectSettingsStoreWrapper(QRemoteObjectSettingsStoreWrapper &&) = delete;
    QRemoteObjectSettingsStoreWrapper& operator=(QRemoteObjectSettingsStoreWrapper &&) = delete;

    QRemoteObjectSettingsStoreWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QList<QVariant> restoreProperties(const ::QString & repName, const ::QByteArray & repSig) override;
    void saveProperties(const ::QString & repName, const ::QByteArray & repSig, const ::QList<QVariant> & values) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QRemoteObjectSettingsStoreWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QRemoteObjectSettingsStoreWrapper_H

