// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_foreachinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QScxmlExecutableContent;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QScxmlExecutableContent_ForeachInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QScxmlExecutableContent::ForeachInfo >()))
        return -1;

    ::QScxmlExecutableContent::ForeachInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "ForeachInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: ForeachInfo::ForeachInfo()
    // 1: ForeachInfo::ForeachInfo(QScxmlExecutableContent::ForeachInfo)
    if (numArgs == 0) {
        overloadId = 0; // ForeachInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // ForeachInfo(QScxmlExecutableContent::ForeachInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // ForeachInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // ForeachInfo()
                cptr = new ::QScxmlExecutableContent::ForeachInfo();
            }
            break;
        }
        case 1: // ForeachInfo(const QScxmlExecutableContent::ForeachInfo & ForeachInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QScxmlExecutableContent::ForeachInfo cppArg0_local;
            ::QScxmlExecutableContent::ForeachInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // ForeachInfo(QScxmlExecutableContent::ForeachInfo)
                cptr = new ::QScxmlExecutableContent::ForeachInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QScxmlExecutableContent::ForeachInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QScxmlExecutableContent_ForeachInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QScxmlExecutableContent_ForeachInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_ForeachInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QScxmlExecutableContent_ForeachInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QScxmlExecutableContent_ForeachInfo_get_array(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->array;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ForeachInfo_set_array(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("array");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("array", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->array;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->array = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_ForeachInfo_get_item(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->item;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ForeachInfo_set_item(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("item");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("item", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->item;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->item = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_ForeachInfo_get_index(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->index;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ForeachInfo_set_index(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("index");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("index", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->index;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->index = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_ForeachInfo_get_context(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->context;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_ForeachInfo_set_context(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("context");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("context", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->context;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->context = cppOut_local;

    return 0;
}

// Getters and Setters for ForeachInfo
static PyGetSetDef Sbk_QScxmlExecutableContent_ForeachInfo_getsetlist[] = {
    {const_cast<char *>("array"), Sbk_QScxmlExecutableContent_ForeachInfo_get_array, Sbk_QScxmlExecutableContent_ForeachInfo_set_array, nullptr, nullptr},
    {const_cast<char *>("item"), Sbk_QScxmlExecutableContent_ForeachInfo_get_item, Sbk_QScxmlExecutableContent_ForeachInfo_set_item, nullptr, nullptr},
    {const_cast<char *>("index"), Sbk_QScxmlExecutableContent_ForeachInfo_get_index, Sbk_QScxmlExecutableContent_ForeachInfo_set_index, nullptr, nullptr},
    {const_cast<char *>("context"), Sbk_QScxmlExecutableContent_ForeachInfo_get_context, Sbk_QScxmlExecutableContent_ForeachInfo_set_context, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_ForeachInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_ForeachInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_ForeachInfo_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_ForeachInfo_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_ForeachInfo_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_ForeachInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ForeachInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ForeachInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ForeachInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ForeachInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_ForeachInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_ForeachInfo_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_ForeachInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ForeachInfo_PythonToCpp_ForeachInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QScxmlExecutableContent_ForeachInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ForeachInfo_PythonToCpp_ForeachInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_ForeachInfo_TypeF()))
        return ForeachInfo_PythonToCpp_ForeachInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ForeachInfo_PTR_CppToPython_ForeachInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QScxmlExecutableContent::ForeachInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_ForeachInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *ForeachInfo_COPY_CppToPython_ForeachInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QScxmlExecutableContent::ForeachInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_ForeachInfo_TypeF(), new ::QScxmlExecutableContent::ForeachInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void ForeachInfo_PythonToCpp_ForeachInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QScxmlExecutableContent::ForeachInfo *>(cppOut) = *reinterpret_cast< ::QScxmlExecutableContent::ForeachInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_ForeachInfo_PythonToCpp_ForeachInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_ForeachInfo_TypeF()))
        return ForeachInfo_PythonToCpp_ForeachInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QScxmlExecutableContent_ForeachInfo_SignatureStrings[] = {
    "1:PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo(self)",
    "0:PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo(self,ForeachInfo:PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo)",
    "PySide6.QtScxml.QScxmlExecutableContent.ForeachInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QScxmlExecutableContent_ForeachInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX].type != nullptr)
        return SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QScxmlExecutableContent_ForeachInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QScxmlExecutableContent_ForeachInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ForeachInfo",
        "QScxmlExecutableContent::ForeachInfo",
        &Sbk_QScxmlExecutableContent_ForeachInfo_spec,
        &Shiboken::callCppDestructor< ::QScxmlExecutableContent::ForeachInfo >,
        Sbk_QScxmlExecutableContent_ForeachInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QScxmlExecutableContent_ForeachInfo_TypeF(); // references _Sbk_QScxmlExecutableContent_ForeachInfo_Type
    InitSignatureStrings(pyType, QScxmlExecutableContent_ForeachInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_ForeachInfo_PropertyStrings);
    SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_ForeachInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ForeachInfo_PythonToCpp_ForeachInfo_PTR,
        is_ForeachInfo_PythonToCpp_ForeachInfo_PTR_Convertible,
        ForeachInfo_PTR_CppToPython_ForeachInfo,
        ForeachInfo_COPY_CppToPython_ForeachInfo);

    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ForeachInfo");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ForeachInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::ForeachInfo&");
    Shiboken::Conversions::registerConverterName(converter, "ForeachInfo");
    Shiboken::Conversions::registerConverterName(converter, "ForeachInfo*");
    Shiboken::Conversions::registerConverterName(converter, "ForeachInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QScxmlExecutableContent::ForeachInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        ForeachInfo_PythonToCpp_ForeachInfo_COPY,
        is_ForeachInfo_PythonToCpp_ForeachInfo_COPY_Convertible);

    qRegisterMetaType< ::QScxmlExecutableContent::ForeachInfo >("ForeachInfo");
    qRegisterMetaType< ::QScxmlExecutableContent::ForeachInfo >("QScxmlExecutableContent::ForeachInfo");

    return pyType;
}
