// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_invokeinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>

using namespace QScxmlExecutableContent;


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QScxmlExecutableContent_InvokeInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QScxmlExecutableContent::InvokeInfo >()))
        return -1;

    ::QScxmlExecutableContent::InvokeInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "InvokeInfo", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: InvokeInfo::InvokeInfo()
    // 1: InvokeInfo::InvokeInfo(QScxmlExecutableContent::InvokeInfo)
    if (numArgs == 0) {
        overloadId = 0; // InvokeInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), (pyArgs[0])))) {
        overloadId = 1; // InvokeInfo(QScxmlExecutableContent::InvokeInfo)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // InvokeInfo()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // InvokeInfo()
                cptr = new ::QScxmlExecutableContent::InvokeInfo();
            }
            break;
        }
        case 1: // InvokeInfo(const QScxmlExecutableContent::InvokeInfo & InvokeInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QScxmlExecutableContent::InvokeInfo cppArg0_local;
            ::QScxmlExecutableContent::InvokeInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // InvokeInfo(QScxmlExecutableContent::InvokeInfo)
                cptr = new ::QScxmlExecutableContent::InvokeInfo(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QScxmlExecutableContent::InvokeInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QScxmlExecutableContent_InvokeInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_InvokeInfo_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QScxmlExecutableContent_InvokeInfo__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_id(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->id;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_id(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("id");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("id", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->id;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->id = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_prefix(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->prefix;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_prefix(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("prefix");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("prefix", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->prefix;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->prefix = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_location(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->location;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_location(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("location");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("location", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->location;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->location = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_context(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->context;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_context(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("context");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("context", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->context;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->context = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_expr(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->expr;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_expr(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("expr");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("expr", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->expr;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->expr = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_finalize(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->finalize;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_finalize(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("finalize");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("finalize", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->finalize;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->finalize = cppOut_local;

    return 0;
}

static PyObject *Sbk_QScxmlExecutableContent_InvokeInfo_get_autoforward(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->autoforward;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_set_autoforward(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("autoforward");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("autoforward", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->autoforward;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->autoforward = cppOut_local;

    return 0;
}

// Getters and Setters for InvokeInfo
static PyGetSetDef Sbk_QScxmlExecutableContent_InvokeInfo_getsetlist[] = {
    {const_cast<char *>("id"), Sbk_QScxmlExecutableContent_InvokeInfo_get_id, Sbk_QScxmlExecutableContent_InvokeInfo_set_id, nullptr, nullptr},
    {const_cast<char *>("prefix"), Sbk_QScxmlExecutableContent_InvokeInfo_get_prefix, Sbk_QScxmlExecutableContent_InvokeInfo_set_prefix, nullptr, nullptr},
    {const_cast<char *>("location"), Sbk_QScxmlExecutableContent_InvokeInfo_get_location, Sbk_QScxmlExecutableContent_InvokeInfo_set_location, nullptr, nullptr},
    {const_cast<char *>("context"), Sbk_QScxmlExecutableContent_InvokeInfo_get_context, Sbk_QScxmlExecutableContent_InvokeInfo_set_context, nullptr, nullptr},
    {const_cast<char *>("expr"), Sbk_QScxmlExecutableContent_InvokeInfo_get_expr, Sbk_QScxmlExecutableContent_InvokeInfo_set_expr, nullptr, nullptr},
    {const_cast<char *>("finalize"), Sbk_QScxmlExecutableContent_InvokeInfo_get_finalize, Sbk_QScxmlExecutableContent_InvokeInfo_set_finalize, nullptr, nullptr},
    {const_cast<char *>("autoforward"), Sbk_QScxmlExecutableContent_InvokeInfo_get_autoforward, Sbk_QScxmlExecutableContent_InvokeInfo_set_autoforward, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_InvokeInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_InvokeInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_InvokeInfo_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_InvokeInfo_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_InvokeInfo_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_InvokeInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_InvokeInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_InvokeInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_InvokeInfo_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_InvokeInfo_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_InvokeInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_InvokeInfo_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_InvokeInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void InvokeInfo_PythonToCpp_InvokeInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QScxmlExecutableContent_InvokeInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_InvokeInfo_PythonToCpp_InvokeInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_InvokeInfo_TypeF()))
        return InvokeInfo_PythonToCpp_InvokeInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *InvokeInfo_PTR_CppToPython_InvokeInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QScxmlExecutableContent::InvokeInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_InvokeInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *InvokeInfo_COPY_CppToPython_InvokeInfo(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QScxmlExecutableContent::InvokeInfo *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QScxmlExecutableContent_InvokeInfo_TypeF(), new ::QScxmlExecutableContent::InvokeInfo(*source), true, true);
}

// Python to C++ copy conversion.
static void InvokeInfo_PythonToCpp_InvokeInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QScxmlExecutableContent::InvokeInfo *>(cppOut) = *reinterpret_cast< ::QScxmlExecutableContent::InvokeInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_InvokeInfo_PythonToCpp_InvokeInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QScxmlExecutableContent_InvokeInfo_TypeF()))
        return InvokeInfo_PythonToCpp_InvokeInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QScxmlExecutableContent_InvokeInfo_SignatureStrings[] = {
    "1:PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo(self)",
    "0:PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo(self,InvokeInfo:PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo)",
    "PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QScxmlExecutableContent_InvokeInfo(PyObject *enclosingClass)
{
    if (SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX].type != nullptr)
        return SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QScxmlExecutableContent_InvokeInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QScxmlExecutableContent_InvokeInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "InvokeInfo",
        "QScxmlExecutableContent::InvokeInfo",
        &Sbk_QScxmlExecutableContent_InvokeInfo_spec,
        &Shiboken::callCppDestructor< ::QScxmlExecutableContent::InvokeInfo >,
        Sbk_QScxmlExecutableContent_InvokeInfo_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QScxmlExecutableContent_InvokeInfo_TypeF(); // references _Sbk_QScxmlExecutableContent_InvokeInfo_Type
    InitSignatureStrings(pyType, QScxmlExecutableContent_InvokeInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_InvokeInfo_PropertyStrings);
    SbkPySide6_QtScxmlTypeStructs[SBK_QScxmlExecutableContent_InvokeInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        InvokeInfo_PythonToCpp_InvokeInfo_PTR,
        is_InvokeInfo_PythonToCpp_InvokeInfo_PTR_Convertible,
        InvokeInfo_PTR_CppToPython_InvokeInfo,
        InvokeInfo_COPY_CppToPython_InvokeInfo);

    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::InvokeInfo");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::InvokeInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QScxmlExecutableContent::InvokeInfo&");
    Shiboken::Conversions::registerConverterName(converter, "InvokeInfo");
    Shiboken::Conversions::registerConverterName(converter, "InvokeInfo*");
    Shiboken::Conversions::registerConverterName(converter, "InvokeInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QScxmlExecutableContent::InvokeInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        InvokeInfo_PythonToCpp_InvokeInfo_COPY,
        is_InvokeInfo_PythonToCpp_InvokeInfo_COPY_Convertible);

    qRegisterMetaType< ::QScxmlExecutableContent::InvokeInfo >("InvokeInfo");
    qRegisterMetaType< ::QScxmlExecutableContent::InvokeInfo >("QScxmlExecutableContent::InvokeInfo");

    return pyType;
}
