// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAmbientTemperatureFilterWrapper_H
#define SBK_QAmbientTemperatureFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qambienttemperaturesensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QAmbientTemperatureFilterWrapper : public QAmbientTemperatureFilter
{
public:
    QAmbientTemperatureFilterWrapper(const QAmbientTemperatureFilterWrapper &) = delete;
    QAmbientTemperatureFilterWrapper& operator=(const QAmbientTemperatureFilterWrapper &) = delete;
    QAmbientTemperatureFilterWrapper(QAmbientTemperatureFilterWrapper &&) = delete;
    QAmbientTemperatureFilterWrapper& operator=(QAmbientTemperatureFilterWrapper &&) = delete;

    bool filter(::QAmbientTemperatureReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QAmbientTemperatureFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QAmbientTemperatureFilterWrapper_H

