// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOrientationFilterWrapper_H
#define SBK_QOrientationFilterWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qorientationsensor.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QOrientationFilterWrapper : public QOrientationFilter
{
public:
    QOrientationFilterWrapper(const QOrientationFilterWrapper &) = delete;
    QOrientationFilterWrapper& operator=(const QOrientationFilterWrapper &) = delete;
    QOrientationFilterWrapper(QOrientationFilterWrapper &&) = delete;
    QOrientationFilterWrapper& operator=(QOrientationFilterWrapper &&) = delete;

    bool filter(::QOrientationReading * reading) override;
    void setSensor(::QSensor * sensor) override;
    ~QOrientationFilterWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QOrientationFilterWrapper_H

