// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qcanuniqueiddescription_wrapper.h"

// Argument includes
#include <QtSerialBus/qcancommondefinitions.h>
#include <QtSerialBus/qcanuniqueiddescription.h>
#include <qsysinfo.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QCanUniqueIdDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QCanUniqueIdDescription >()))
        return -1;

    ::QCanUniqueIdDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QCanUniqueIdDescription", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::QCanUniqueIdDescription()
    // 1: QCanUniqueIdDescription::QCanUniqueIdDescription(QCanUniqueIdDescription)
    if (numArgs == 0) {
        overloadId = 0; // QCanUniqueIdDescription()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QCanUniqueIdDescription(QCanUniqueIdDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QCanUniqueIdDescription()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanUniqueIdDescription()
                cptr = new ::QCanUniqueIdDescription();
            }
            break;
        }
        case 1: // QCanUniqueIdDescription(const QCanUniqueIdDescription & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QCanUniqueIdDescription cppArg0_local;
            ::QCanUniqueIdDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QCanUniqueIdDescription(QCanUniqueIdDescription)
                cptr = new ::QCanUniqueIdDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QCanUniqueIdDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_bitLength(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.bitLength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // bitLength()const
            quint8 cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->bitLength();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_endian(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.endian";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // endian()const
            QSysInfo::Endian cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->endian();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSysInfo_Endian_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.isValid";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isValid()const
            bool cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setBitLength(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.setBitLength";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setBitLength(quint8)
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), (pyArg)))) {
        overloadId = 0; // setBitLength(quint8)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint8 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setBitLength(quint8)
            cppSelf->setBitLength(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setEndian(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.setEndian";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setEndian(QSysInfo::Endian)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSysInfo_Endian_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setEndian(QSysInfo::Endian)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QSysInfo::Endian cppArg0{QSysInfo::BigEndian};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setEndian(QSysInfo::Endian)
            cppSelf->setEndian(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setSource(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.setSource";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setSource(QtCanBus::DataSource)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setSource(QtCanBus::DataSource)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QtCanBus::DataSource cppArg0{QtCanBus::DataSource::Payload};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setSource(QtCanBus::DataSource)
            cppSelf->setSource(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_setStartBit(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.setStartBit";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::setStartBit(quint16)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // setStartBit(quint16)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setStartBit(quint16)
            cppSelf->setStartBit(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_source(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.source";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // source()const
            QtCanBus::DataSource cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->source();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_startBit(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.startBit";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // startBit()const
            quint16 cppResult = const_cast<const ::QCanUniqueIdDescription *>(cppSelf)->startBit();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QCanUniqueIdDescriptionFunc_swap(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QCanUniqueIdDescription.swap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QCanUniqueIdDescription::swap(QCanUniqueIdDescription&)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), (pyArg)))) {
        overloadId = 0; // swap(QCanUniqueIdDescription&)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QCanUniqueIdDescription cppArg0_local;
        ::QCanUniqueIdDescription *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // swap(QCanUniqueIdDescription&)
            cppSelf->swap(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QCanUniqueIdDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QCanUniqueIdDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QCanUniqueIdDescription_methods[] = {
    {"bitLength", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_bitLength), METH_NOARGS, nullptr},
    {"endian", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_endian), METH_NOARGS, nullptr},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_isValid), METH_NOARGS, nullptr},
    {"setBitLength", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setBitLength), METH_O, nullptr},
    {"setEndian", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setEndian), METH_O, nullptr},
    {"setSource", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setSource), METH_O, nullptr},
    {"setStartBit", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_setStartBit), METH_O, nullptr},
    {"source", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_source), METH_NOARGS, nullptr},
    {"startBit", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_startBit), METH_NOARGS, nullptr},
    {"swap", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescriptionFunc_swap), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QCanUniqueIdDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QCanUniqueIdDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QCanUniqueIdDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QCanUniqueIdDescription_Type = nullptr;
static PyTypeObject *Sbk_QCanUniqueIdDescription_TypeF(void)
{
    return _Sbk_QCanUniqueIdDescription_Type;
}

static PyType_Slot Sbk_QCanUniqueIdDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QCanUniqueIdDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QCanUniqueIdDescription_spec = {
    "2:PySide6.QtSerialBus.QCanUniqueIdDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QCanUniqueIdDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QCanUniqueIdDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QCanUniqueIdDescription_TypeF()))
        return QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QCanUniqueIdDescription_PTR_CppToPython_QCanUniqueIdDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QCanUniqueIdDescription *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QCanUniqueIdDescription_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QCanUniqueIdDescription_COPY_CppToPython_QCanUniqueIdDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QCanUniqueIdDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QCanUniqueIdDescription_TypeF(), new ::QCanUniqueIdDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QCanUniqueIdDescription *>(cppOut) = *reinterpret_cast< ::QCanUniqueIdDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QCanUniqueIdDescription_TypeF()))
        return QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QCanUniqueIdDescription_SignatureStrings[] = {
    "1:PySide6.QtSerialBus.QCanUniqueIdDescription(self)",
    "0:PySide6.QtSerialBus.QCanUniqueIdDescription(self,other:PySide6.QtSerialBus.QCanUniqueIdDescription)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.bitLength(self)->quint8",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.endian(self)->PySide6.QtCore.QSysInfo.Endian",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.isValid(self)->bool",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setBitLength(self,length:quint8)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setEndian(self,endian:PySide6.QtCore.QSysInfo.Endian)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setSource(self,source:PySide6.QtSerialBus.QtCanBus.DataSource)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.setStartBit(self,bit:quint16)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.source(self)->PySide6.QtSerialBus.QtCanBus.DataSource",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.startBit(self)->quint16",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.swap(self,other:PySide6.QtSerialBus.QCanUniqueIdDescription)",
    "PySide6.QtSerialBus.QCanUniqueIdDescription.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QCanUniqueIdDescription(PyObject *module)
{
    if (SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type != nullptr)
        return SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QCanUniqueIdDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QCanUniqueIdDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QCanUniqueIdDescription",
        "QCanUniqueIdDescription",
        &Sbk_QCanUniqueIdDescription_spec,
        &Shiboken::callCppDestructor< ::QCanUniqueIdDescription >,
        Sbk_QCanUniqueIdDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QCanUniqueIdDescription_TypeF(); // references _Sbk_QCanUniqueIdDescription_Type
    InitSignatureStrings(pyType, QCanUniqueIdDescription_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QCanUniqueIdDescription_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QCanUniqueIdDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR,
        is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_PTR_Convertible,
        QCanUniqueIdDescription_PTR_CppToPython_QCanUniqueIdDescription,
        QCanUniqueIdDescription_COPY_CppToPython_QCanUniqueIdDescription);

    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription");
    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QCanUniqueIdDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QCanUniqueIdDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY,
        is_QCanUniqueIdDescription_PythonToCpp_QCanUniqueIdDescription_COPY_Convertible);

    qRegisterMetaType< ::QCanUniqueIdDescription >("QCanUniqueIdDescription");

    return pyType;
}
