// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QModbusExceptionResponseWrapper_H
#define SBK_QModbusExceptionResponseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QModbusExceptionResponseWrapper : public QModbusExceptionResponse
{
public:
    QModbusExceptionResponseWrapper(const QModbusExceptionResponseWrapper &) = delete;
    QModbusExceptionResponseWrapper& operator=(const QModbusExceptionResponseWrapper &) = delete;
    QModbusExceptionResponseWrapper(QModbusExceptionResponseWrapper &&) = delete;
    QModbusExceptionResponseWrapper& operator=(QModbusExceptionResponseWrapper &&) = delete;

    QModbusExceptionResponseWrapper();
    QModbusExceptionResponseWrapper(::QModbusPdu::FunctionCode fc, ::QModbusPdu::ExceptionCode ec);
    QModbusExceptionResponseWrapper(const ::QModbusPdu & pdu);
    void setFunctionCode(::QModbusPdu::FunctionCode c) override;
    ~QModbusExceptionResponseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[1];
};

#endif // SBK_QModbusExceptionResponseWrapper_H

