// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtserialbus_python.h"

// main header
#include "qtcanbus_wrapper.h"

// Argument includes
#include <QtSerialBus/qcancommondefinitions.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QtCanBusFunc_qbswap(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtSerialBus.QtCanBus.qbswap";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QtCanBus::qbswap(QtCanBus::UniqueId)->QtCanBus::UniqueId
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_UniqueId_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // qbswap(QtCanBus::UniqueId)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QtCanBus::UniqueId cppArg0 = static_cast< ::QtCanBus::UniqueId>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // qbswap(QtCanBus::UniqueId)
            QtCanBus::UniqueId cppResult = ::QtCanBus::qbswap(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_UniqueId_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QtCanBus_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QtCanBus_EnumFlagInfo[] = {
    "DataFormat:Enum",
    "DataSource:Enum",
    "MultiplexState:Enum",
    "UniqueId:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtCanBus_methods[] = {
    {"qbswap", reinterpret_cast<PyCFunction>(Sbk_QtCanBusFunc_qbswap), METH_O|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtCanBus_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtCanBus_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtCanBus_Type = nullptr;
static PyTypeObject *Sbk_QtCanBus_TypeF(void)
{
    return _Sbk_QtCanBus_Type;
}

static PyType_Slot Sbk_QtCanBus_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtCanBus_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtCanBus_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtCanBus_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtCanBus_spec = {
    "2:PySide6.QtSerialBus.QtCanBus",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtCanBus_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QtCanBus_DataSource_PythonToCpp_QtCanBus_DataSource(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtCanBus::DataSource>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtCanBus::DataSource *>(cppOut) = value;

}
static PythonToCppFunc is_QtCanBus_DataSource_PythonToCpp_QtCanBus_DataSource_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX])))
        return QtCanBus_DataSource_PythonToCpp_QtCanBus_DataSource;
    return {};
}
static PyObject *QtCanBus_DataSource_CppToPython_QtCanBus_DataSource(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtCanBus::DataSource *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX]), castCppIn);

}

static void QtCanBus_DataFormat_PythonToCpp_QtCanBus_DataFormat(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtCanBus::DataFormat>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtCanBus::DataFormat *>(cppOut) = value;

}
static PythonToCppFunc is_QtCanBus_DataFormat_PythonToCpp_QtCanBus_DataFormat_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataFormat_IDX])))
        return QtCanBus_DataFormat_PythonToCpp_QtCanBus_DataFormat;
    return {};
}
static PyObject *QtCanBus_DataFormat_CppToPython_QtCanBus_DataFormat(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtCanBus::DataFormat *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataFormat_IDX]), castCppIn);

}

static void QtCanBus_MultiplexState_PythonToCpp_QtCanBus_MultiplexState(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtCanBus::MultiplexState>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtCanBus::MultiplexState *>(cppOut) = value;

}
static PythonToCppFunc is_QtCanBus_MultiplexState_PythonToCpp_QtCanBus_MultiplexState_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_MultiplexState_IDX])))
        return QtCanBus_MultiplexState_PythonToCpp_QtCanBus_MultiplexState;
    return {};
}
static PyObject *QtCanBus_MultiplexState_CppToPython_QtCanBus_MultiplexState(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtCanBus::MultiplexState *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_MultiplexState_IDX]), castCppIn);

}

static void QtCanBus_UniqueId_PythonToCpp_QtCanBus_UniqueId(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtCanBus::UniqueId>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtCanBus::UniqueId *>(cppOut) = value;

}
static PythonToCppFunc is_QtCanBus_UniqueId_PythonToCpp_QtCanBus_UniqueId_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_UniqueId_IDX])))
        return QtCanBus_UniqueId_PythonToCpp_QtCanBus_UniqueId;
    return {};
}
static PyObject *QtCanBus_UniqueId_CppToPython_QtCanBus_UniqueId(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtCanBus::UniqueId *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_UniqueId_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtSerialBusQtCanBus_SignatureStrings[] = {
    "PySide6.QtSerialBus.QtCanBus.qbswap(src:PySide6.QtSerialBus.QtCanBus.UniqueId)->PySide6.QtSerialBus.QtCanBus.UniqueId",
    nullptr}; // Sentinel

PyTypeObject *init_QtSerialBusQtCanBus(PyObject *module)
{
    if (SbkPySide6_QtSerialBusTypeStructs[SBK_QtSerialBusQtCanBus_IDX].type != nullptr)
        return SbkPySide6_QtSerialBusTypeStructs[SBK_QtSerialBusQtCanBus_IDX].type;

    Shiboken::AutoDecRef Sbk_QtCanBus_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtCanBus_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtCanBus",
        "QtCanBus",
        &Sbk_QtCanBus_spec,
        nullptr,
        Sbk_QtCanBus_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtCanBus_TypeF(); // references _Sbk_QtCanBus_Type
    InitSignatureStrings(pyType, QtSerialBusQtCanBus_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtCanBus_PropertyStrings);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QtSerialBusQtCanBus_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QtCanBus_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'DataSource'.
    const char *DataSource_Initializer[] = {
        "Payload",
        "FrameId",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t DataSource_InitializerValues[] = {
        uint8_t(QtCanBus::DataSource::Payload), //  0x00  0
        uint8_t(QtCanBus::DataSource::FrameId)  //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtCanBus_TypeF(),
        "2:PySide6.QtSerialBus.QtCanBus.DataSource",
        DataSource_Initializer, DataSource_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataSource_IDX].type = EType;
    // Register converter for enum 'QtCanBus::DataSource'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtCanBus_DataSource_CppToPython_QtCanBus_DataSource);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtCanBus_DataSource_PythonToCpp_QtCanBus_DataSource,
            is_QtCanBus_DataSource_PythonToCpp_QtCanBus_DataSource_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtCanBus::DataSource");
        Shiboken::Conversions::registerConverterName(converter, "DataSource");
    }
    // End of 'DataSource' enum.

    // Initialization of enum 'DataFormat'.
    const char *DataFormat_Initializer[] = {
        "SignedInteger",
        "UnsignedInteger",
        "Float",
        "Double",
        "AsciiString",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t DataFormat_InitializerValues[] = {
        uint8_t(QtCanBus::DataFormat::SignedInteger),   //  0x00  0
        uint8_t(QtCanBus::DataFormat::UnsignedInteger), //  0x01  1
        uint8_t(QtCanBus::DataFormat::Float),           //  0x02  2
        uint8_t(QtCanBus::DataFormat::Double),          //  0x03  3
        uint8_t(QtCanBus::DataFormat::AsciiString)      //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtCanBus_TypeF(),
        "2:PySide6.QtSerialBus.QtCanBus.DataFormat",
        DataFormat_Initializer, DataFormat_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_DataFormat_IDX].type = EType;
    // Register converter for enum 'QtCanBus::DataFormat'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtCanBus_DataFormat_CppToPython_QtCanBus_DataFormat);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtCanBus_DataFormat_PythonToCpp_QtCanBus_DataFormat,
            is_QtCanBus_DataFormat_PythonToCpp_QtCanBus_DataFormat_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtCanBus::DataFormat");
        Shiboken::Conversions::registerConverterName(converter, "DataFormat");
    }
    // End of 'DataFormat' enum.

    // Initialization of enum 'MultiplexState'.
    const char *MultiplexState_Initializer[] = {
        "None_",
        "MultiplexorSwitch",
        "MultiplexedSignal",
        "SwitchAndSignal",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t MultiplexState_InitializerValues[] = {
        uint8_t(QtCanBus::MultiplexState::None),              //  0x00  0
        uint8_t(QtCanBus::MultiplexState::MultiplexorSwitch), //  0x01  1
        uint8_t(QtCanBus::MultiplexState::MultiplexedSignal), //  0x02  2
        uint8_t(QtCanBus::MultiplexState::SwitchAndSignal)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtCanBus_TypeF(),
        "2:PySide6.QtSerialBus.QtCanBus.MultiplexState",
        MultiplexState_Initializer, MultiplexState_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_MultiplexState_IDX].type = EType;
    // Register converter for enum 'QtCanBus::MultiplexState'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtCanBus_MultiplexState_CppToPython_QtCanBus_MultiplexState);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtCanBus_MultiplexState_PythonToCpp_QtCanBus_MultiplexState,
            is_QtCanBus_MultiplexState_PythonToCpp_QtCanBus_MultiplexState_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtCanBus::MultiplexState");
        Shiboken::Conversions::registerConverterName(converter, "MultiplexState");
    }
    // End of 'MultiplexState' enum.

    // Initialization of enum 'UniqueId'.
    const char *UniqueId_Initializer[] = {
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    const uint8_t *UniqueId_InitializerValues{};
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtCanBus_TypeF(),
        "2:PySide6.QtSerialBus.QtCanBus.UniqueId",
        UniqueId_Initializer, UniqueId_InitializerValues);
    SbkPySide6_QtSerialBusTypeStructs[SBK_QtCanBus_UniqueId_IDX].type = EType;
    // Register converter for enum 'QtCanBus::UniqueId'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtCanBus_UniqueId_CppToPython_QtCanBus_UniqueId);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtCanBus_UniqueId_PythonToCpp_QtCanBus_UniqueId,
            is_QtCanBus_UniqueId_PythonToCpp_QtCanBus_UniqueId_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtCanBus::UniqueId");
        Shiboken::Conversions::registerConverterName(converter, "UniqueId");
    }
    // End of 'UniqueId' enum.

    qRegisterMetaType< ::QtCanBus::DataSource >("QtCanBus::DataSource");
    qRegisterMetaType< ::QtCanBus::DataFormat >("QtCanBus::DataFormat");
    qRegisterMetaType< ::QtCanBus::MultiplexState >("QtCanBus::MultiplexState");
    qRegisterMetaType< ::QtCanBus::UniqueId >("QtCanBus::UniqueId");

    return pyType;
}
