// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QEventTransitionWrapper_H
#define SBK_QEventTransitionWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qeventtransition.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QEventTransitionWrapper : public QEventTransition
{
public:
    QEventTransitionWrapper(const QEventTransitionWrapper &) = delete;
    QEventTransitionWrapper& operator=(const QEventTransitionWrapper &) = delete;
    QEventTransitionWrapper(QEventTransitionWrapper &&) = delete;
    QEventTransitionWrapper& operator=(QEventTransitionWrapper &&) = delete;

    QEventTransitionWrapper(::QObject * object, ::QEvent::Type type, ::QState * sourceState = nullptr);
    QEventTransitionWrapper(::QState * sourceState = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * e) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool eventTest(::QEvent * event) override;
    void onTransition(::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QEventTransitionWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#endif // SBK_QEventTransitionWrapper_H

