// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSvgGeneratorWrapper_H
#define SBK_QSvgGeneratorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSvg/qsvggenerator.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QSvgGeneratorWrapper : public QSvgGenerator
{
public:
    QSvgGeneratorWrapper(const QSvgGeneratorWrapper &) = delete;
    QSvgGeneratorWrapper& operator=(const QSvgGeneratorWrapper &) = delete;
    QSvgGeneratorWrapper(QSvgGeneratorWrapper &&) = delete;
    QSvgGeneratorWrapper& operator=(QSvgGeneratorWrapper &&) = delete;

    QSvgGeneratorWrapper();
    QSvgGeneratorWrapper(::QSvgGenerator::SvgVersion version);
    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric metric) const override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    ::QPainter * sharedPainter() const override;
    ~QSvgGeneratorWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[6];
};

#endif // SBK_QSvgGeneratorWrapper_H

