// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtsvg_python.h"

// main header
#include "qtsvg_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QtSvg_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QtSvg_EnumFlagInfo[] = {
    "Option:Flag:Options",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtSvg_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtSvg_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtSvg_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtSvg_Type = nullptr;
static PyTypeObject *Sbk_QtSvg_TypeF(void)
{
    return _Sbk_QtSvg_Type;
}

static PyType_Slot Sbk_QtSvg_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtSvg_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtSvg_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtSvg_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtSvg_spec = {
    "2:PySide6.QtSvg.QtSvg",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtSvg_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QtSvg_Option_PythonToCpp_QtSvg_Option(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QtSvg::Option>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QtSvg::Option *>(cppOut) = value;

}
static PythonToCppFunc is_QtSvg_Option_PythonToCpp_QtSvg_Option_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtSvgTypeStructs[SBK_QtSvg_Option_IDX])))
        return QtSvg_Option_PythonToCpp_QtSvg_Option;
    return {};
}
static PyObject *QtSvg_Option_CppToPython_QtSvg_Option(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QtSvg::Option *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtSvgTypeStructs[SBK_QtSvg_Option_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtSvgQtSvg_SignatureStrings[] = {
    nullptr}; // Sentinel

PyTypeObject *init_QtSvgQtSvg(PyObject *module)
{
    if (SbkPySide6_QtSvgTypeStructs[SBK_QtSvgQtSvg_IDX].type != nullptr)
        return SbkPySide6_QtSvgTypeStructs[SBK_QtSvgQtSvg_IDX].type;

    Shiboken::AutoDecRef Sbk_QtSvg_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtSvg_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtSvg",
        "QtSvg",
        &Sbk_QtSvg_spec,
        nullptr,
        Sbk_QtSvg_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtSvg_TypeF(); // references _Sbk_QtSvg_Type
    InitSignatureStrings(pyType, QtSvgQtSvg_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtSvg_PropertyStrings);
    SbkPySide6_QtSvgTypeStructs[SBK_QtSvgQtSvg_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QtSvg_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Option'.
    const char *Option_Initializer[] = {
        "NoOption",
        "Tiny12FeaturesOnly",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t Option_InitializerValues[] = {
        uint8_t(QtSvg::Option::NoOption),          //  0x00  0
        uint8_t(QtSvg::Option::Tiny12FeaturesOnly) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QtSvg_TypeF(),
        "2:PySide6.QtSvg.QtSvg.Option",
        Option_Initializer, Option_InitializerValues);
    SbkPySide6_QtSvgTypeStructs[SBK_QtSvg_Option_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtSvgTypeStructs[SBK_QFlags_QtSvg_Option_IDX].type =
        EType;
    // Register converter for enum 'QtSvg::Option'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QtSvg_Option_CppToPython_QtSvg_Option);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QtSvg_Option_PythonToCpp_QtSvg_Option,
            is_QtSvg_Option_PythonToCpp_QtSvg_Option_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QtSvg::Option");
        Shiboken::Conversions::registerConverterName(converter, "Option");
        // Register converter for flag 'QFlags<QtSvg::Option>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QtSvg::Option>");
        Shiboken::Conversions::registerConverterName(converter, "QtSvg::Options");
    }
    // End of 'Option' enum/flags.

    qRegisterMetaType< ::QtSvg::Option >("QtSvg::Option");

    return pyType;
}
