// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginecertificateerror_wrapper.h"

// Argument includes
#include <QList>
#include <QString>
#include <QtNetwork/qsslcertificate.h>
#include <QtWebEngineCore/qwebenginecertificateerror.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineCertificateError_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineCertificateError >()))
        return -1;

    ::QWebEngineCertificateError *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineCertificateError", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineCertificateError::QWebEngineCertificateError(QWebEngineCertificateError)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), (pyArgs[0]))))) {
        overloadId = 0; // QWebEngineCertificateError(QWebEngineCertificateError)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QWebEngineCertificateError *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWebEngineCertificateError(QWebEngineCertificateError)
            cptr = new ::QWebEngineCertificateError(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineCertificateError >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_acceptCertificate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.acceptCertificate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // acceptCertificate()
            cppSelf->acceptCertificate();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_certificateChain(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.certificateChain";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // certificateChain()const
            QList<QSslCertificate> cppResult = const_cast<const ::QWebEngineCertificateError *>(cppSelf)->certificateChain();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QList_QSslCertificate_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_defer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.defer";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // defer()
            cppSelf->defer();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_description(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.description";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // description()const
            QString cppResult = const_cast<const ::QWebEngineCertificateError *>(cppSelf)->description();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_isOverridable(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.isOverridable";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // isOverridable()const
            bool cppResult = const_cast<const ::QWebEngineCertificateError *>(cppSelf)->isOverridable();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_rejectCertificate(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.rejectCertificate";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rejectCertificate()
            cppSelf->rejectCertificate();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_type(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.type";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // type()const
            QWebEngineCertificateError::Type cppResult = const_cast<const ::QWebEngineCertificateError *>(cppSelf)->type();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_Type_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineCertificateErrorFunc_url(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCertificateError.url";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // url()const
            QUrl cppResult = const_cast<const ::QWebEngineCertificateError *>(cppSelf)->url();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineCertificateError__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineCertificateError_PropertyStrings[] = {
    "description:",
    "overridable:isOverridable",
    "type:",
    "url:",
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineCertificateError_EnumFlagInfo[] = {
    "Type:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineCertificateError_methods[] = {
    {"acceptCertificate", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_acceptCertificate), METH_NOARGS, nullptr},
    {"certificateChain", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_certificateChain), METH_NOARGS, nullptr},
    {"defer", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_defer), METH_NOARGS, nullptr},
    {"description", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_description), METH_NOARGS, nullptr},
    {"isOverridable", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_isOverridable), METH_NOARGS, nullptr},
    {"rejectCertificate", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_rejectCertificate), METH_NOARGS, nullptr},
    {"type", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_type), METH_NOARGS, nullptr},
    {"url", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateErrorFunc_url), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCertificateError__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineCertificateError_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineCertificateError_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineCertificateError_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineCertificateError_TypeF(void)
{
    return _Sbk_QWebEngineCertificateError_Type;
}

static PyType_Slot Sbk_QWebEngineCertificateError_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineCertificateError_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineCertificateError_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineCertificateError_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineCertificateError_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineCertificateError_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineCertificateError",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineCertificateError_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebEngineCertificateError_Type_PythonToCpp_QWebEngineCertificateError_Type(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineCertificateError::Type>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineCertificateError::Type *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineCertificateError_Type_PythonToCpp_QWebEngineCertificateError_Type_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_Type_IDX])))
        return QWebEngineCertificateError_Type_PythonToCpp_QWebEngineCertificateError_Type;
    return {};
}
static PyObject *QWebEngineCertificateError_Type_CppToPython_QWebEngineCertificateError_Type(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineCertificateError::Type *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_Type_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineCertificateError_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineCertificateError_TypeF()))
        return QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineCertificateError_PTR_CppToPython_QWebEngineCertificateError(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineCertificateError *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineCertificateError_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebEngineCertificateError_COPY_CppToPython_QWebEngineCertificateError(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineCertificateError *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineCertificateError_TypeF(), new ::QWebEngineCertificateError(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineCertificateError *>(cppOut) = *reinterpret_cast< ::QWebEngineCertificateError *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineCertificateError_TypeF()))
        return QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineCertificateError_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineCertificateError(self,other:PySide6.QtWebEngineCore.QWebEngineCertificateError)",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.acceptCertificate(self)",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.certificateChain(self)->QList[PySide6.QtNetwork.QSslCertificate]",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.defer(self)",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.description(self)->QString",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.isOverridable(self)->bool",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.rejectCertificate(self)",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.type(self)->PySide6.QtWebEngineCore.QWebEngineCertificateError.Type",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.url(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineCertificateError.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineCertificateError(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineCertificateError_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineCertificateError_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineCertificateError",
        "QWebEngineCertificateError",
        &Sbk_QWebEngineCertificateError_spec,
        &Shiboken::callCppDestructor< ::QWebEngineCertificateError >,
        Sbk_QWebEngineCertificateError_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineCertificateError_TypeF(); // references _Sbk_QWebEngineCertificateError_Type
    InitSignatureStrings(pyType, QWebEngineCertificateError_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineCertificateError_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_PTR,
        is_QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_PTR_Convertible,
        QWebEngineCertificateError_PTR_CppToPython_QWebEngineCertificateError,
        QWebEngineCertificateError_COPY_CppToPython_QWebEngineCertificateError);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCertificateError");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCertificateError*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCertificateError&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineCertificateError).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_COPY,
        is_QWebEngineCertificateError_PythonToCpp_QWebEngineCertificateError_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineCertificateError_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Type'.
    const char *Type_Initializer[] = {
        "SslPinnedKeyNotInCertificateChain",
        "CertificateCommonNameInvalid",
        "CertificateDateInvalid",
        "CertificateAuthorityInvalid",
        "CertificateContainsErrors",
        "CertificateNoRevocationMechanism",
        "CertificateUnableToCheckRevocation",
        "CertificateRevoked",
        "CertificateInvalid",
        "CertificateWeakSignatureAlgorithm",
        "CertificateNonUniqueName",
        "CertificateWeakKey",
        "CertificateNameConstraintViolation",
        "CertificateValidityTooLong",
        "CertificateTransparencyRequired",
        "CertificateSymantecLegacy",
        "CertificateKnownInterceptionBlocked",
        "SslObsoleteVersion",
        nullptr};
    // "int16_t" used instead of "int"
    constexpr int16_t Type_InitializerValues[] = {
        int16_t(QWebEngineCertificateError::Type::SslPinnedKeyNotInCertificateChain),   // -0x0096 -150
        int16_t(QWebEngineCertificateError::Type::CertificateCommonNameInvalid),        // -0x00c8 -200
        int16_t(QWebEngineCertificateError::Type::CertificateDateInvalid),              // -0x00c9 -201
        int16_t(QWebEngineCertificateError::Type::CertificateAuthorityInvalid),         // -0x00ca -202
        int16_t(QWebEngineCertificateError::Type::CertificateContainsErrors),           // -0x00cb -203
        int16_t(QWebEngineCertificateError::Type::CertificateNoRevocationMechanism),    // -0x00cc -204
        int16_t(QWebEngineCertificateError::Type::CertificateUnableToCheckRevocation),  // -0x00cd -205
        int16_t(QWebEngineCertificateError::Type::CertificateRevoked),                  // -0x00ce -206
        int16_t(QWebEngineCertificateError::Type::CertificateInvalid),                  // -0x00cf -207
        int16_t(QWebEngineCertificateError::Type::CertificateWeakSignatureAlgorithm),   // -0x00d0 -208
        int16_t(QWebEngineCertificateError::Type::CertificateNonUniqueName),            // -0x00d2 -210
        int16_t(QWebEngineCertificateError::Type::CertificateWeakKey),                  // -0x00d3 -211
        int16_t(QWebEngineCertificateError::Type::CertificateNameConstraintViolation),  // -0x00d4 -212
        int16_t(QWebEngineCertificateError::Type::CertificateValidityTooLong),          // -0x00d5 -213
        int16_t(QWebEngineCertificateError::Type::CertificateTransparencyRequired),     // -0x00d6 -214
        int16_t(QWebEngineCertificateError::Type::CertificateSymantecLegacy),           // -0x00d7 -215
        int16_t(QWebEngineCertificateError::Type::CertificateKnownInterceptionBlocked), // -0x00d9 -217
        int16_t(QWebEngineCertificateError::Type::SslObsoleteVersion)                   // -0x00da -218
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineCertificateError_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineCertificateError.Type",
        Type_Initializer, Type_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCertificateError_Type_IDX].type = EType;
    // Register converter for enum 'QWebEngineCertificateError::Type'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineCertificateError_Type_CppToPython_QWebEngineCertificateError_Type);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineCertificateError_Type_PythonToCpp_QWebEngineCertificateError_Type,
            is_QWebEngineCertificateError_Type_PythonToCpp_QWebEngineCertificateError_Type_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineCertificateError::Type");
        Shiboken::Conversions::registerConverterName(converter, "Type");
    }
    // End of 'Type' enum.

    qRegisterMetaType< ::QWebEngineCertificateError >("QWebEngineCertificateError");
    qRegisterMetaType< ::QWebEngineCertificateError::Type >("QWebEngineCertificateError::Type");

    return pyType;
}
