// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineclientcertificateselection_wrapper.h"

// Argument includes
#include <QList>
#include <QtNetwork/qsslcertificate.h>
#include <QtWebEngineCore/qwebengineclientcertificateselection.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineClientCertificateSelection_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineClientCertificateSelection >()))
        return -1;

    ::QWebEngineClientCertificateSelection *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineClientCertificateSelection", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineClientCertificateSelection::QWebEngineClientCertificateSelection(QWebEngineClientCertificateSelection)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), (pyArgs[0]))))) {
        overloadId = 0; // QWebEngineClientCertificateSelection(QWebEngineClientCertificateSelection)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QWebEngineClientCertificateSelection *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWebEngineClientCertificateSelection(QWebEngineClientCertificateSelection)
            cptr = new ::QWebEngineClientCertificateSelection(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineClientCertificateSelection >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineClientCertificateSelectionFunc_certificates(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.certificates";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // certificates()const
            QList<QSslCertificate> cppResult = const_cast<const ::QWebEngineClientCertificateSelection *>(cppSelf)->certificates();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QList_QSslCertificate_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineClientCertificateSelectionFunc_host(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.host";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // host()const
            QUrl cppResult = const_cast<const ::QWebEngineClientCertificateSelection *>(cppSelf)->host();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineClientCertificateSelectionFunc_select(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.select";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineClientCertificateSelection::select(QSslCertificate)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtNetworkTypeStructs[SBK_QSslCertificate_IDX]), (pyArg)))) {
        overloadId = 0; // select(QSslCertificate)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QSslCertificate cppArg0_local;
        ::QSslCertificate *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // select(QSslCertificate)
            cppSelf->select(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineClientCertificateSelectionFunc_selectNone(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.selectNone";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // selectNone()
            cppSelf->selectNone();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineClientCertificateSelection__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineClientCertificateSelection_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineClientCertificateSelection_methods[] = {
    {"certificates", reinterpret_cast<PyCFunction>(Sbk_QWebEngineClientCertificateSelectionFunc_certificates), METH_NOARGS, nullptr},
    {"host", reinterpret_cast<PyCFunction>(Sbk_QWebEngineClientCertificateSelectionFunc_host), METH_NOARGS, nullptr},
    {"select", reinterpret_cast<PyCFunction>(Sbk_QWebEngineClientCertificateSelectionFunc_select), METH_O, nullptr},
    {"selectNone", reinterpret_cast<PyCFunction>(Sbk_QWebEngineClientCertificateSelectionFunc_selectNone), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineClientCertificateSelection__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineClientCertificateSelection_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineClientCertificateSelection_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineClientCertificateSelection_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineClientCertificateSelection_TypeF(void)
{
    return _Sbk_QWebEngineClientCertificateSelection_Type;
}

static PyType_Slot Sbk_QWebEngineClientCertificateSelection_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineClientCertificateSelection_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineClientCertificateSelection_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineClientCertificateSelection_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineClientCertificateSelection_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineClientCertificateSelection_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineClientCertificateSelection_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineClientCertificateSelection_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineClientCertificateSelection_TypeF()))
        return QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineClientCertificateSelection_PTR_CppToPython_QWebEngineClientCertificateSelection(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineClientCertificateSelection *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineClientCertificateSelection_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebEngineClientCertificateSelection_COPY_CppToPython_QWebEngineClientCertificateSelection(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineClientCertificateSelection *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineClientCertificateSelection_TypeF(), new ::QWebEngineClientCertificateSelection(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineClientCertificateSelection *>(cppOut) = *reinterpret_cast< ::QWebEngineClientCertificateSelection *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineClientCertificateSelection_TypeF()))
        return QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineClientCertificateSelection_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection(self,arg__1:PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection)",
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.certificates(self)->QList[PySide6.QtNetwork.QSslCertificate]",
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.host(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.select(self,certificate:typing.Union[PySide6.QtNetwork.QSslCertificate, PySide6.QtCore.QIODevice])",
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.selectNone(self)",
    "PySide6.QtWebEngineCore.QWebEngineClientCertificateSelection.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineClientCertificateSelection(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineClientCertificateSelection_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineClientCertificateSelection_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineClientCertificateSelection",
        "QWebEngineClientCertificateSelection",
        &Sbk_QWebEngineClientCertificateSelection_spec,
        &Shiboken::callCppDestructor< ::QWebEngineClientCertificateSelection >,
        Sbk_QWebEngineClientCertificateSelection_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineClientCertificateSelection_TypeF(); // references _Sbk_QWebEngineClientCertificateSelection_Type
    InitSignatureStrings(pyType, QWebEngineClientCertificateSelection_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineClientCertificateSelection_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineClientCertificateSelection_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_PTR,
        is_QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_PTR_Convertible,
        QWebEngineClientCertificateSelection_PTR_CppToPython_QWebEngineClientCertificateSelection,
        QWebEngineClientCertificateSelection_COPY_CppToPython_QWebEngineClientCertificateSelection);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineClientCertificateSelection");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineClientCertificateSelection*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineClientCertificateSelection&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineClientCertificateSelection).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_COPY,
        is_QWebEngineClientCertificateSelection_PythonToCpp_QWebEngineClientCertificateSelection_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineClientCertificateSelection >("QWebEngineClientCertificateSelection");

    return pyType;
}
