// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginecookiestore_filterrequest_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineCookieStore_FilterRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineCookieStore::FilterRequest >()))
        return -1;

    ::QWebEngineCookieStore::FilterRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "FilterRequest", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: FilterRequest::FilterRequest()
    // 1: FilterRequest::FilterRequest(QWebEngineCookieStore::FilterRequest)
    if (numArgs == 0) {
        overloadId = 0; // FilterRequest()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), (pyArgs[0])))) {
        overloadId = 1; // FilterRequest(QWebEngineCookieStore::FilterRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // FilterRequest()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // FilterRequest()
                cptr = new ::QWebEngineCookieStore::FilterRequest();
            }
            break;
        }
        case 1: // FilterRequest(const QWebEngineCookieStore::FilterRequest & FilterRequest)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebEngineCookieStore::FilterRequest cppArg0_local;
            ::QWebEngineCookieStore::FilterRequest *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // FilterRequest(QWebEngineCookieStore::FilterRequest)
                cptr = new ::QWebEngineCookieStore::FilterRequest(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineCookieStore::FilterRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineCookieStore_FilterRequest_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineCookieStore_FilterRequest_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineCookieStore_FilterRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest_get_firstPartyUrl(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->firstPartyUrl)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->firstPartyUrl))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->firstPartyUrl)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &(cppSelf->firstPartyUrl), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QWebEngineCookieStore_FilterRequest_set_firstPartyUrl(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("firstPartyUrl");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("firstPartyUrl", "QUrl");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->firstPartyUrl;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest_get_origin(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->origin)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->origin))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->origin)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &(cppSelf->origin), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QWebEngineCookieStore_FilterRequest_set_origin(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("origin");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("origin", "QUrl");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->origin;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest_get_thirdParty(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->thirdParty;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineCookieStore_FilterRequest_set_thirdParty(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("thirdParty");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("thirdParty", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->thirdParty;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->thirdParty = cppOut_local;

    return 0;
}

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest_get__reservedFlag(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->_reservedFlag;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineCookieStore_FilterRequest_set__reservedFlag(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("_reservedFlag");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("_reservedFlag", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->_reservedFlag;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->_reservedFlag = cppOut_local;

    return 0;
}

static PyObject *Sbk_QWebEngineCookieStore_FilterRequest_get__reservedType(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ushort cppOut_local = cppSelf->_reservedType;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<ushort>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QWebEngineCookieStore_FilterRequest_set__reservedType(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("_reservedType");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<ushort>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("_reservedType", "ushort");
        return -1;
    }

    auto cppOut_local = cppSelf->_reservedType;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->_reservedType = cppOut_local;

    return 0;
}

// Getters and Setters for FilterRequest
static PyGetSetDef Sbk_QWebEngineCookieStore_FilterRequest_getsetlist[] = {
    {const_cast<char *>("firstPartyUrl"), Sbk_QWebEngineCookieStore_FilterRequest_get_firstPartyUrl, Sbk_QWebEngineCookieStore_FilterRequest_set_firstPartyUrl, nullptr, nullptr},
    {const_cast<char *>("origin"), Sbk_QWebEngineCookieStore_FilterRequest_get_origin, Sbk_QWebEngineCookieStore_FilterRequest_set_origin, nullptr, nullptr},
    {const_cast<char *>("thirdParty"), Sbk_QWebEngineCookieStore_FilterRequest_get_thirdParty, Sbk_QWebEngineCookieStore_FilterRequest_set_thirdParty, nullptr, nullptr},
    {const_cast<char *>("_reservedFlag"), Sbk_QWebEngineCookieStore_FilterRequest_get__reservedFlag, Sbk_QWebEngineCookieStore_FilterRequest_set__reservedFlag, nullptr, nullptr},
    {const_cast<char *>("_reservedType"), Sbk_QWebEngineCookieStore_FilterRequest_get__reservedType, Sbk_QWebEngineCookieStore_FilterRequest_set__reservedType, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineCookieStore_FilterRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineCookieStore_FilterRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineCookieStore_FilterRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineCookieStore_FilterRequest_TypeF(void)
{
    return _Sbk_QWebEngineCookieStore_FilterRequest_Type;
}

static PyType_Slot Sbk_QWebEngineCookieStore_FilterRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineCookieStore_FilterRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineCookieStore_FilterRequest_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineCookieStore_FilterRequest_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QWebEngineCookieStore_FilterRequest_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineCookieStore_FilterRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineCookieStore_FilterRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineCookieStore_FilterRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void FilterRequest_PythonToCpp_FilterRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineCookieStore_FilterRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_FilterRequest_PythonToCpp_FilterRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineCookieStore_FilterRequest_TypeF()))
        return FilterRequest_PythonToCpp_FilterRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *FilterRequest_PTR_CppToPython_FilterRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineCookieStore::FilterRequest *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineCookieStore_FilterRequest_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *FilterRequest_COPY_CppToPython_FilterRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineCookieStore::FilterRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineCookieStore_FilterRequest_TypeF(), new ::QWebEngineCookieStore::FilterRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void FilterRequest_PythonToCpp_FilterRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineCookieStore::FilterRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineCookieStore::FilterRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_FilterRequest_PythonToCpp_FilterRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineCookieStore_FilterRequest_TypeF()))
        return FilterRequest_PythonToCpp_FilterRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineCookieStore_FilterRequest_SignatureStrings[] = {
    "1:PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest(self)",
    "0:PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest(self,FilterRequest:PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest)",
    "PySide6.QtWebEngineCore.QWebEngineCookieStore.FilterRequest.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineCookieStore_FilterRequest(PyObject *enclosingClass)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineCookieStore_FilterRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineCookieStore_FilterRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "FilterRequest",
        "QWebEngineCookieStore::FilterRequest",
        &Sbk_QWebEngineCookieStore_FilterRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineCookieStore::FilterRequest >,
        Sbk_QWebEngineCookieStore_FilterRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineCookieStore_FilterRequest_TypeF(); // references _Sbk_QWebEngineCookieStore_FilterRequest_Type
    InitSignatureStrings(pyType, QWebEngineCookieStore_FilterRequest_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineCookieStore_FilterRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineCookieStore_FilterRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        FilterRequest_PythonToCpp_FilterRequest_PTR,
        is_FilterRequest_PythonToCpp_FilterRequest_PTR_Convertible,
        FilterRequest_PTR_CppToPython_FilterRequest,
        FilterRequest_COPY_CppToPython_FilterRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCookieStore::FilterRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCookieStore::FilterRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineCookieStore::FilterRequest&");
    Shiboken::Conversions::registerConverterName(converter, "FilterRequest");
    Shiboken::Conversions::registerConverterName(converter, "FilterRequest*");
    Shiboken::Conversions::registerConverterName(converter, "FilterRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineCookieStore::FilterRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        FilterRequest_PythonToCpp_FilterRequest_COPY,
        is_FilterRequest_PythonToCpp_FilterRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineCookieStore::FilterRequest >("FilterRequest");
    qRegisterMetaType< ::QWebEngineCookieStore::FilterRequest >("QWebEngineCookieStore::FilterRequest");

    return pyType;
}
