// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginefindtextresult_wrapper.h"

// Argument includes
#include <QtWebEngineCore/qwebenginefindtextresult.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineFindTextResult_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineFindTextResult >()))
        return -1;

    ::QWebEngineFindTextResult *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFindTextResult.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineFindTextResult", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineFindTextResult::QWebEngineFindTextResult()
    // 1: QWebEngineFindTextResult::QWebEngineFindTextResult(QWebEngineFindTextResult)
    if (numArgs == 0) {
        overloadId = 0; // QWebEngineFindTextResult()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QWebEngineFindTextResult(QWebEngineFindTextResult)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QWebEngineFindTextResult()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebEngineFindTextResult()
                cptr = new ::QWebEngineFindTextResult();
            }
            break;
        }
        case 1: // QWebEngineFindTextResult(const QWebEngineFindTextResult & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QWebEngineFindTextResult cppArg0_local;
            ::QWebEngineFindTextResult *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QWebEngineFindTextResult(QWebEngineFindTextResult)
                cptr = new ::QWebEngineFindTextResult(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineFindTextResult >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineFindTextResultFunc_activeMatch(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFindTextResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFindTextResult.activeMatch";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // activeMatch()const
            int cppResult = const_cast<const ::QWebEngineFindTextResult *>(cppSelf)->activeMatch();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFindTextResultFunc_numberOfMatches(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFindTextResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFindTextResult.numberOfMatches";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // numberOfMatches()const
            int cppResult = const_cast<const ::QWebEngineFindTextResult *>(cppSelf)->numberOfMatches();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFindTextResult__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineFindTextResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineFindTextResult_PropertyStrings[] = {
    "activeMatch:",
    "numberOfMatches:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineFindTextResult_methods[] = {
    {"activeMatch", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFindTextResultFunc_activeMatch), METH_NOARGS, nullptr},
    {"numberOfMatches", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFindTextResultFunc_numberOfMatches), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFindTextResult__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineFindTextResult_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineFindTextResult_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineFindTextResult_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineFindTextResult_TypeF(void)
{
    return _Sbk_QWebEngineFindTextResult_Type;
}

static PyType_Slot Sbk_QWebEngineFindTextResult_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineFindTextResult_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineFindTextResult_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineFindTextResult_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineFindTextResult_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineFindTextResult_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineFindTextResult",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineFindTextResult_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineFindTextResult_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineFindTextResult_TypeF()))
        return QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineFindTextResult_PTR_CppToPython_QWebEngineFindTextResult(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineFindTextResult *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineFindTextResult_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebEngineFindTextResult_COPY_CppToPython_QWebEngineFindTextResult(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineFindTextResult *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineFindTextResult_TypeF(), new ::QWebEngineFindTextResult(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineFindTextResult *>(cppOut) = *reinterpret_cast< ::QWebEngineFindTextResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineFindTextResult_TypeF()))
        return QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineFindTextResult_SignatureStrings[] = {
    "1:PySide6.QtWebEngineCore.QWebEngineFindTextResult(self)",
    "0:PySide6.QtWebEngineCore.QWebEngineFindTextResult(self,other:PySide6.QtWebEngineCore.QWebEngineFindTextResult)",
    "PySide6.QtWebEngineCore.QWebEngineFindTextResult.activeMatch(self)->int",
    "PySide6.QtWebEngineCore.QWebEngineFindTextResult.numberOfMatches(self)->int",
    "PySide6.QtWebEngineCore.QWebEngineFindTextResult.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineFindTextResult(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineFindTextResult_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineFindTextResult_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineFindTextResult",
        "QWebEngineFindTextResult",
        &Sbk_QWebEngineFindTextResult_spec,
        &Shiboken::callCppDestructor< ::QWebEngineFindTextResult >,
        Sbk_QWebEngineFindTextResult_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineFindTextResult_TypeF(); // references _Sbk_QWebEngineFindTextResult_Type
    InitSignatureStrings(pyType, QWebEngineFindTextResult_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineFindTextResult_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineFindTextResult_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_PTR,
        is_QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_PTR_Convertible,
        QWebEngineFindTextResult_PTR_CppToPython_QWebEngineFindTextResult,
        QWebEngineFindTextResult_COPY_CppToPython_QWebEngineFindTextResult);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFindTextResult");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFindTextResult*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFindTextResult&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineFindTextResult).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_COPY,
        is_QWebEngineFindTextResult_PythonToCpp_QWebEngineFindTextResult_COPY_Convertible);


    return pyType;
}
