// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineglobalsettings_wrapper.h"

// inner classes
#include "qwebengineglobalsettings_dnsmode_wrapper.h"

// Argument includes
#include <QtWebEngineCore/qwebengineglobalsettings.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QWebEngineGlobalSettingsFunc_setDnsMode(PyObject *self, PyObject *pyArg)
{
    SBK_UNUSED(self)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineGlobalSettings.setDnsMode";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: static QWebEngineGlobalSettings::setDnsMode(QWebEngineGlobalSettings::DnsMode)->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineGlobalSettings_DnsMode_IDX]), (pyArg)))) {
        overloadId = 0; // setDnsMode(QWebEngineGlobalSettings::DnsMode)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QWebEngineGlobalSettings::DnsMode cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDnsMode(QWebEngineGlobalSettings::DnsMode)
            bool cppResult = ::QWebEngineGlobalSettings::setDnsMode(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineGlobalSettings_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineGlobalSettings_EnumFlagInfo[] = {
    "SecureDnsMode:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineGlobalSettings_methods[] = {
    {"setDnsMode", reinterpret_cast<PyCFunction>(Sbk_QWebEngineGlobalSettingsFunc_setDnsMode), METH_O|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineGlobalSettings_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineGlobalSettings_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineGlobalSettings_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineGlobalSettings_TypeF(void)
{
    return _Sbk_QWebEngineGlobalSettings_Type;
}

static PyType_Slot Sbk_QWebEngineGlobalSettings_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineGlobalSettings_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineGlobalSettings_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineGlobalSettings_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineGlobalSettings_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineGlobalSettings",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineGlobalSettings_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebEngineGlobalSettings_SecureDnsMode_PythonToCpp_QWebEngineGlobalSettings_SecureDnsMode(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineGlobalSettings::SecureDnsMode>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineGlobalSettings::SecureDnsMode *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineGlobalSettings_SecureDnsMode_PythonToCpp_QWebEngineGlobalSettings_SecureDnsMode_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineGlobalSettings_SecureDnsMode_IDX])))
        return QWebEngineGlobalSettings_SecureDnsMode_PythonToCpp_QWebEngineGlobalSettings_SecureDnsMode;
    return {};
}
static PyObject *QWebEngineGlobalSettings_SecureDnsMode_CppToPython_QWebEngineGlobalSettings_SecureDnsMode(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineGlobalSettings::SecureDnsMode *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineGlobalSettings_SecureDnsMode_IDX]), castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtWebEngineCoreQWebEngineGlobalSettings_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineGlobalSettings.setDnsMode(dnsMode:PySide6.QtWebEngineCore.QWebEngineGlobalSettings.DnsMode)->bool",
    nullptr}; // Sentinel

PyTypeObject *init_QtWebEngineCoreQWebEngineGlobalSettings(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QtWebEngineCoreQWebEngineGlobalSettings_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QtWebEngineCoreQWebEngineGlobalSettings_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineGlobalSettings_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineGlobalSettings_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineGlobalSettings",
        "QWebEngineGlobalSettings",
        &Sbk_QWebEngineGlobalSettings_spec,
        nullptr,
        Sbk_QWebEngineGlobalSettings_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWebEngineGlobalSettings_TypeF(); // references _Sbk_QWebEngineGlobalSettings_Type
    InitSignatureStrings(pyType, QtWebEngineCoreQWebEngineGlobalSettings_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineGlobalSettings_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QtWebEngineCoreQWebEngineGlobalSettings_IDX].type = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineGlobalSettings_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'SecureDnsMode'.
    const char *SecureDnsMode_Initializer[] = {
        "SystemOnly",
        "SecureWithFallback",
        "SecureOnly",
        nullptr};
    // "uint8_t" used instead of "unsigned char"
    constexpr uint8_t SecureDnsMode_InitializerValues[] = {
        uint8_t(QWebEngineGlobalSettings::SecureDnsMode::SystemOnly),         //  0x00  0
        uint8_t(QWebEngineGlobalSettings::SecureDnsMode::SecureWithFallback), //  0x01  1
        uint8_t(QWebEngineGlobalSettings::SecureDnsMode::SecureOnly)          //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineGlobalSettings_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineGlobalSettings.SecureDnsMode",
        SecureDnsMode_Initializer, SecureDnsMode_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineGlobalSettings_SecureDnsMode_IDX].type = EType;
    // Register converter for enum 'QWebEngineGlobalSettings::SecureDnsMode'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineGlobalSettings_SecureDnsMode_CppToPython_QWebEngineGlobalSettings_SecureDnsMode);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineGlobalSettings_SecureDnsMode_PythonToCpp_QWebEngineGlobalSettings_SecureDnsMode,
            is_QWebEngineGlobalSettings_SecureDnsMode_PythonToCpp_QWebEngineGlobalSettings_SecureDnsMode_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineGlobalSettings::SecureDnsMode");
        Shiboken::Conversions::registerConverterName(converter, "SecureDnsMode");
    }
    // End of 'SecureDnsMode' enum.

    qRegisterMetaType< ::QWebEngineGlobalSettings::SecureDnsMode >("QWebEngineGlobalSettings::SecureDnsMode");

    return pyType;
}
