// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineregisterprotocolhandlerrequest_wrapper.h"

// Argument includes
#include <QString>
#include <QtWebEngineCore/qwebengineregisterprotocolhandlerrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineRegisterProtocolHandlerRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >()))
        return -1;

    ::QWebEngineRegisterProtocolHandlerRequest *cptr{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWebEngineRegisterProtocolHandlerRequest()
            cptr = new ::QWebEngineRegisterProtocolHandlerRequest();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineRegisterProtocolHandlerRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.accept";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // accept()
            cppSelf->accept();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.origin";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // origin()const
            QUrl cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->origin();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.reject";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // reject()
            cppSelf->reject();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.scheme";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // scheme()const
            QString cppResult = const_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppSelf)->scheme();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings[] = {
    "origin:",
    "scheme:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineRegisterProtocolHandlerRequest_methods[] = {
    {"accept", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_accept), METH_NOARGS, nullptr},
    {"origin", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_origin), METH_NOARGS, nullptr},
    {"reject", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_reject), METH_NOARGS, nullptr},
    {"scheme", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequestFunc_scheme), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineRegisterProtocolHandlerRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator!=(const QWebEngineRegisterProtocolHandlerRequest & that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), (pyArg)))) {
                // operator==(const QWebEngineRegisterProtocolHandlerRequest & that) const
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineRegisterProtocolHandlerRequest cppArg0_local;
                ::QWebEngineRegisterProtocolHandlerRequest *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineRegisterProtocolHandlerRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(void)
{
    return _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type;
}

static PyType_Slot Sbk_QWebEngineRegisterProtocolHandlerRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineRegisterProtocolHandlerRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineRegisterProtocolHandlerRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineRegisterProtocolHandlerRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineRegisterProtocolHandlerRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(), new ::QWebEngineRegisterProtocolHandlerRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineRegisterProtocolHandlerRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineRegisterProtocolHandlerRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF()))
        return QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineRegisterProtocolHandlerRequest_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.accept(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.origin(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.reject(self)",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.scheme(self)->QString",
    "PySide6.QtWebEngineCore.QWebEngineRegisterProtocolHandlerRequest.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineRegisterProtocolHandlerRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineRegisterProtocolHandlerRequest",
        "QWebEngineRegisterProtocolHandlerRequest",
        &Sbk_QWebEngineRegisterProtocolHandlerRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineRegisterProtocolHandlerRequest >,
        Sbk_QWebEngineRegisterProtocolHandlerRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineRegisterProtocolHandlerRequest_TypeF(); // references _Sbk_QWebEngineRegisterProtocolHandlerRequest_Type
    InitSignatureStrings(pyType, QWebEngineRegisterProtocolHandlerRequest_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineRegisterProtocolHandlerRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineRegisterProtocolHandlerRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_PTR_Convertible,
        QWebEngineRegisterProtocolHandlerRequest_PTR_CppToPython_QWebEngineRegisterProtocolHandlerRequest,
        QWebEngineRegisterProtocolHandlerRequest_COPY_CppToPython_QWebEngineRegisterProtocolHandlerRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineRegisterProtocolHandlerRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineRegisterProtocolHandlerRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY,
        is_QWebEngineRegisterProtocolHandlerRequest_PythonToCpp_QWebEngineRegisterProtocolHandlerRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineRegisterProtocolHandlerRequest >("QWebEngineRegisterProtocolHandlerRequest");

    return pyType;
}
