// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginesettings_wrapper.h"

// Argument includes
#include <QString>
#include <QtWebEngineCore/qwebenginesettings.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QWebEngineSettingsFunc_defaultTextEncoding(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.defaultTextEncoding";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // defaultTextEncoding()const
            QString cppResult = const_cast<const ::QWebEngineSettings *>(cppSelf)->defaultTextEncoding();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineSettingsFunc_fontFamily(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.fontFamily";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::fontFamily(QWebEngineSettings::FontFamily)const->QString
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // fontFamily(QWebEngineSettings::FontFamily)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontFamily cppArg0{QWebEngineSettings::StandardFont};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fontFamily(QWebEngineSettings::FontFamily)const
            QString cppResult = const_cast<const ::QWebEngineSettings *>(cppSelf)->fontFamily(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineSettingsFunc_fontSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.fontSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::fontSize(QWebEngineSettings::FontSize)const->int
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // fontSize(QWebEngineSettings::FontSize)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontSize cppArg0{QWebEngineSettings::MinimumFontSize};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // fontSize(QWebEngineSettings::FontSize)const
            int cppResult = const_cast<const ::QWebEngineSettings *>(cppSelf)->fontSize(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineSettingsFunc_resetAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.resetAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::resetAttribute(QWebEngineSettings::WebAttribute)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // resetAttribute(QWebEngineSettings::WebAttribute)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // resetAttribute(QWebEngineSettings::WebAttribute)
            cppSelf->resetAttribute(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_resetFontFamily(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.resetFontFamily";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::resetFontFamily(QWebEngineSettings::FontFamily)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // resetFontFamily(QWebEngineSettings::FontFamily)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontFamily cppArg0{QWebEngineSettings::StandardFont};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // resetFontFamily(QWebEngineSettings::FontFamily)
            cppSelf->resetFontFamily(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_resetFontSize(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.resetFontSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::resetFontSize(QWebEngineSettings::FontSize)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // resetFontSize(QWebEngineSettings::FontSize)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontSize cppArg0{QWebEngineSettings::MinimumFontSize};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // resetFontSize(QWebEngineSettings::FontSize)
            cppSelf->resetFontSize(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_resetUnknownUrlSchemePolicy(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.resetUnknownUrlSchemePolicy";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // resetUnknownUrlSchemePolicy()
            cppSelf->resetUnknownUrlSchemePolicy();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_setAttribute(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.setAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setAttribute", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QWebEngineSettings::setAttribute(QWebEngineSettings::WebAttribute,bool)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArgs[1])))) {
        overloadId = 0; // setAttribute(QWebEngineSettings::WebAttribute,bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        bool cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setAttribute(QWebEngineSettings::WebAttribute,bool)
            cppSelf->setAttribute(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_setDefaultTextEncoding(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.setDefaultTextEncoding";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::setDefaultTextEncoding(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArg)))) {
        overloadId = 0; // setDefaultTextEncoding(QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setDefaultTextEncoding(QString)
            cppSelf->setDefaultTextEncoding(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_setFontFamily(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.setFontFamily";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setFontFamily", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QWebEngineSettings::setFontFamily(QWebEngineSettings::FontFamily,QString)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyArgs[1])))) {
        overloadId = 0; // setFontFamily(QWebEngineSettings::FontFamily,QString)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontFamily cppArg0{QWebEngineSettings::StandardFont};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        ::QString cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFontFamily(QWebEngineSettings::FontFamily,QString)
            cppSelf->setFontFamily(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_setFontSize(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.setFontSize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setFontSize", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QWebEngineSettings::setFontSize(QWebEngineSettings::FontSize,int)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX])))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))) {
        overloadId = 0; // setFontSize(QWebEngineSettings::FontSize,int)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::FontSize cppArg0{QWebEngineSettings::MinimumFontSize};
        pythonToCpp[0](pyArgs[0], &cppArg0);
        int cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setFontSize(QWebEngineSettings::FontSize,int)
            cppSelf->setFontSize(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_setUnknownUrlSchemePolicy(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.setUnknownUrlSchemePolicy";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::setUnknownUrlSchemePolicy(QWebEngineSettings::UnknownUrlSchemePolicy)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_UnknownUrlSchemePolicy_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // setUnknownUrlSchemePolicy(QWebEngineSettings::UnknownUrlSchemePolicy)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::UnknownUrlSchemePolicy cppArg0{QWebEngineSettings::InheritedUnknownUrlSchemePolicy};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // setUnknownUrlSchemePolicy(QWebEngineSettings::UnknownUrlSchemePolicy)
            cppSelf->setUnknownUrlSchemePolicy(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineSettingsFunc_testAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.testAttribute";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineSettings::testAttribute(QWebEngineSettings::WebAttribute)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))->converter, (pyArg)))) {
        overloadId = 0; // testAttribute(QWebEngineSettings::WebAttribute)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        ::QWebEngineSettings::WebAttribute cppArg0{QWebEngineSettings::AutoLoadImages};
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // testAttribute(QWebEngineSettings::WebAttribute)const
            bool cppResult = const_cast<const ::QWebEngineSettings *>(cppSelf)->testAttribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineSettingsFunc_unknownUrlSchemePolicy(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineSettings *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineSettings.unknownUrlSchemePolicy";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // unknownUrlSchemePolicy()const
            QWebEngineSettings::UnknownUrlSchemePolicy cppResult = const_cast<const ::QWebEngineSettings *>(cppSelf)->unknownUrlSchemePolicy();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_UnknownUrlSchemePolicy_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineSettings_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineSettings_EnumFlagInfo[] = {
    "FontFamily:Enum",
    "FontSize:Enum",
    "UnknownUrlSchemePolicy:Enum",
    "WebAttribute:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineSettings_methods[] = {
    {"defaultTextEncoding", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_defaultTextEncoding), METH_NOARGS, nullptr},
    {"fontFamily", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_fontFamily), METH_O, nullptr},
    {"fontSize", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_fontSize), METH_O, nullptr},
    {"resetAttribute", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_resetAttribute), METH_O, nullptr},
    {"resetFontFamily", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_resetFontFamily), METH_O, nullptr},
    {"resetFontSize", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_resetFontSize), METH_O, nullptr},
    {"resetUnknownUrlSchemePolicy", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_resetUnknownUrlSchemePolicy), METH_NOARGS, nullptr},
    {"setAttribute", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_setAttribute), METH_VARARGS, nullptr},
    {"setDefaultTextEncoding", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_setDefaultTextEncoding), METH_O, nullptr},
    {"setFontFamily", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_setFontFamily), METH_VARARGS, nullptr},
    {"setFontSize", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_setFontSize), METH_VARARGS, nullptr},
    {"setUnknownUrlSchemePolicy", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_setUnknownUrlSchemePolicy), METH_O, nullptr},
    {"testAttribute", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_testAttribute), METH_O, nullptr},
    {"unknownUrlSchemePolicy", reinterpret_cast<PyCFunction>(Sbk_QWebEngineSettingsFunc_unknownUrlSchemePolicy), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineSettings_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineSettings_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineSettings_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineSettings_TypeF(void)
{
    return _Sbk_QWebEngineSettings_Type;
}

static PyType_Slot Sbk_QWebEngineSettings_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineSettings_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineSettings_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineSettings_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineSettings_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineSettings",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineSettings_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebEngineSettings_FontFamily_PythonToCpp_QWebEngineSettings_FontFamily(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineSettings::FontFamily>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineSettings::FontFamily *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineSettings_FontFamily_PythonToCpp_QWebEngineSettings_FontFamily_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX])))
        return QWebEngineSettings_FontFamily_PythonToCpp_QWebEngineSettings_FontFamily;
    return {};
}
static PyObject *QWebEngineSettings_FontFamily_CppToPython_QWebEngineSettings_FontFamily(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineSettings::FontFamily *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX]), castCppIn);

}

static void QWebEngineSettings_WebAttribute_PythonToCpp_QWebEngineSettings_WebAttribute(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineSettings::WebAttribute>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineSettings::WebAttribute *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineSettings_WebAttribute_PythonToCpp_QWebEngineSettings_WebAttribute_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX])))
        return QWebEngineSettings_WebAttribute_PythonToCpp_QWebEngineSettings_WebAttribute;
    return {};
}
static PyObject *QWebEngineSettings_WebAttribute_CppToPython_QWebEngineSettings_WebAttribute(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineSettings::WebAttribute *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX]), castCppIn);

}

static void QWebEngineSettings_FontSize_PythonToCpp_QWebEngineSettings_FontSize(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineSettings::FontSize>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineSettings::FontSize *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineSettings_FontSize_PythonToCpp_QWebEngineSettings_FontSize_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX])))
        return QWebEngineSettings_FontSize_PythonToCpp_QWebEngineSettings_FontSize;
    return {};
}
static PyObject *QWebEngineSettings_FontSize_CppToPython_QWebEngineSettings_FontSize(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineSettings::FontSize *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX]), castCppIn);

}

static void QWebEngineSettings_UnknownUrlSchemePolicy_PythonToCpp_QWebEngineSettings_UnknownUrlSchemePolicy(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineSettings::UnknownUrlSchemePolicy>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineSettings::UnknownUrlSchemePolicy *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineSettings_UnknownUrlSchemePolicy_PythonToCpp_QWebEngineSettings_UnknownUrlSchemePolicy_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_UnknownUrlSchemePolicy_IDX])))
        return QWebEngineSettings_UnknownUrlSchemePolicy_PythonToCpp_QWebEngineSettings_UnknownUrlSchemePolicy;
    return {};
}
static PyObject *QWebEngineSettings_UnknownUrlSchemePolicy_CppToPython_QWebEngineSettings_UnknownUrlSchemePolicy(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineSettings::UnknownUrlSchemePolicy *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_UnknownUrlSchemePolicy_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineSettings_PythonToCpp_QWebEngineSettings_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineSettings_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineSettings_PythonToCpp_QWebEngineSettings_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineSettings_TypeF()))
        return QWebEngineSettings_PythonToCpp_QWebEngineSettings_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineSettings_PTR_CppToPython_QWebEngineSettings(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineSettings *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineSettings_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineSettings_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineSettings.defaultTextEncoding(self)->QString",
    "PySide6.QtWebEngineCore.QWebEngineSettings.fontFamily(self,which:PySide6.QtWebEngineCore.QWebEngineSettings.FontFamily)->QString",
    "PySide6.QtWebEngineCore.QWebEngineSettings.fontSize(self,type:PySide6.QtWebEngineCore.QWebEngineSettings.FontSize)->int",
    "PySide6.QtWebEngineCore.QWebEngineSettings.resetAttribute(self,attr:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.resetFontFamily(self,which:PySide6.QtWebEngineCore.QWebEngineSettings.FontFamily)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.resetFontSize(self,type:PySide6.QtWebEngineCore.QWebEngineSettings.FontSize)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.resetUnknownUrlSchemePolicy(self)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.setAttribute(self,attr:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute,on:bool)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.setDefaultTextEncoding(self,encoding:QString)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.setFontFamily(self,which:PySide6.QtWebEngineCore.QWebEngineSettings.FontFamily,family:QString)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.setFontSize(self,type:PySide6.QtWebEngineCore.QWebEngineSettings.FontSize,size:int)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.setUnknownUrlSchemePolicy(self,policy:PySide6.QtWebEngineCore.QWebEngineSettings.UnknownUrlSchemePolicy)",
    "PySide6.QtWebEngineCore.QWebEngineSettings.testAttribute(self,attr:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute)->bool",
    "PySide6.QtWebEngineCore.QWebEngineSettings.unknownUrlSchemePolicy(self)->PySide6.QtWebEngineCore.QWebEngineSettings.UnknownUrlSchemePolicy",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineSettings(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineSettings_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineSettings_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineSettings",
        "QWebEngineSettings*",
        &Sbk_QWebEngineSettings_spec,
        &Shiboken::callCppDestructor< ::QWebEngineSettings >,
        Sbk_QWebEngineSettings_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWebEngineSettings_TypeF(); // references _Sbk_QWebEngineSettings_Type
    InitSignatureStrings(pyType, QWebEngineSettings_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineSettings_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineSettings_PythonToCpp_QWebEngineSettings_PTR,
        is_QWebEngineSettings_PythonToCpp_QWebEngineSettings_PTR_Convertible,
        QWebEngineSettings_PTR_CppToPython_QWebEngineSettings);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineSettings).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineSettings_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'FontFamily'.
    const char *FontFamily_Initializer[] = {
        "StandardFont",
        "FixedFont",
        "SerifFont",
        "SansSerifFont",
        "CursiveFont",
        "FantasyFont",
        "PictographFont",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FontFamily_InitializerValues[] = {
        uint8_t(QWebEngineSettings::FontFamily::StandardFont),  //  0x00  0
        uint8_t(QWebEngineSettings::FontFamily::FixedFont),     //  0x01  1
        uint8_t(QWebEngineSettings::FontFamily::SerifFont),     //  0x02  2
        uint8_t(QWebEngineSettings::FontFamily::SansSerifFont), //  0x03  3
        uint8_t(QWebEngineSettings::FontFamily::CursiveFont),   //  0x04  4
        uint8_t(QWebEngineSettings::FontFamily::FantasyFont),   //  0x05  5
        uint8_t(QWebEngineSettings::FontFamily::PictographFont) //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineSettings_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineSettings.FontFamily",
        FontFamily_Initializer, FontFamily_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontFamily_IDX].type = EType;
    // Register converter for enum 'QWebEngineSettings::FontFamily'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineSettings_FontFamily_CppToPython_QWebEngineSettings_FontFamily);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineSettings_FontFamily_PythonToCpp_QWebEngineSettings_FontFamily,
            is_QWebEngineSettings_FontFamily_PythonToCpp_QWebEngineSettings_FontFamily_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings::FontFamily");
        Shiboken::Conversions::registerConverterName(converter, "FontFamily");
    }
    // End of 'FontFamily' enum.

    // Initialization of enum 'WebAttribute'.
    const char *WebAttribute_Initializer[] = {
        "AutoLoadImages",
        "JavascriptEnabled",
        "JavascriptCanOpenWindows",
        "JavascriptCanAccessClipboard",
        "LinksIncludedInFocusChain",
        "LocalStorageEnabled",
        "LocalContentCanAccessRemoteUrls",
        "XSSAuditingEnabled",
        "SpatialNavigationEnabled",
        "LocalContentCanAccessFileUrls",
        "HyperlinkAuditingEnabled",
        "ScrollAnimatorEnabled",
        "ErrorPageEnabled",
        "PluginsEnabled",
        "FullScreenSupportEnabled",
        "ScreenCaptureEnabled",
        "WebGLEnabled",
        "Accelerated2dCanvasEnabled",
        "AutoLoadIconsForPage",
        "TouchIconsEnabled",
        "FocusOnNavigationEnabled",
        "PrintElementBackgrounds",
        "AllowRunningInsecureContent",
        "AllowGeolocationOnInsecureOrigins",
        "AllowWindowActivationFromJavaScript",
        "ShowScrollBars",
        "PlaybackRequiresUserGesture",
        "WebRTCPublicInterfacesOnly",
        "JavascriptCanPaste",
        "DnsPrefetchEnabled",
        "PdfViewerEnabled",
        "NavigateOnDropEnabled",
        "ReadingFromCanvasEnabled",
        "ForceDarkMode",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t WebAttribute_InitializerValues[] = {
        uint8_t(QWebEngineSettings::WebAttribute::AutoLoadImages),                      //  0x00  0
        uint8_t(QWebEngineSettings::WebAttribute::JavascriptEnabled),                   //  0x01  1
        uint8_t(QWebEngineSettings::WebAttribute::JavascriptCanOpenWindows),            //  0x02  2
        uint8_t(QWebEngineSettings::WebAttribute::JavascriptCanAccessClipboard),        //  0x03  3
        uint8_t(QWebEngineSettings::WebAttribute::LinksIncludedInFocusChain),           //  0x04  4
        uint8_t(QWebEngineSettings::WebAttribute::LocalStorageEnabled),                 //  0x05  5
        uint8_t(QWebEngineSettings::WebAttribute::LocalContentCanAccessRemoteUrls),     //  0x06  6
        uint8_t(QWebEngineSettings::WebAttribute::XSSAuditingEnabled),                  //  0x07  7
        uint8_t(QWebEngineSettings::WebAttribute::SpatialNavigationEnabled),            //  0x08  8
        uint8_t(QWebEngineSettings::WebAttribute::LocalContentCanAccessFileUrls),       //  0x09  9
        uint8_t(QWebEngineSettings::WebAttribute::HyperlinkAuditingEnabled),            //  0x0a  10
        uint8_t(QWebEngineSettings::WebAttribute::ScrollAnimatorEnabled),               //  0x0b  11
        uint8_t(QWebEngineSettings::WebAttribute::ErrorPageEnabled),                    //  0x0c  12
        uint8_t(QWebEngineSettings::WebAttribute::PluginsEnabled),                      //  0x0d  13
        uint8_t(QWebEngineSettings::WebAttribute::FullScreenSupportEnabled),            //  0x0e  14
        uint8_t(QWebEngineSettings::WebAttribute::ScreenCaptureEnabled),                //  0x0f  15
        uint8_t(QWebEngineSettings::WebAttribute::WebGLEnabled),                        //  0x10  16
        uint8_t(QWebEngineSettings::WebAttribute::Accelerated2dCanvasEnabled),          //  0x11  17
        uint8_t(QWebEngineSettings::WebAttribute::AutoLoadIconsForPage),                //  0x12  18
        uint8_t(QWebEngineSettings::WebAttribute::TouchIconsEnabled),                   //  0x13  19
        uint8_t(QWebEngineSettings::WebAttribute::FocusOnNavigationEnabled),            //  0x14  20
        uint8_t(QWebEngineSettings::WebAttribute::PrintElementBackgrounds),             //  0x15  21
        uint8_t(QWebEngineSettings::WebAttribute::AllowRunningInsecureContent),         //  0x16  22
        uint8_t(QWebEngineSettings::WebAttribute::AllowGeolocationOnInsecureOrigins),   //  0x17  23
        uint8_t(QWebEngineSettings::WebAttribute::AllowWindowActivationFromJavaScript), //  0x18  24
        uint8_t(QWebEngineSettings::WebAttribute::ShowScrollBars),                      //  0x19  25
        uint8_t(QWebEngineSettings::WebAttribute::PlaybackRequiresUserGesture),         //  0x1a  26
        uint8_t(QWebEngineSettings::WebAttribute::WebRTCPublicInterfacesOnly),          //  0x1b  27
        uint8_t(QWebEngineSettings::WebAttribute::JavascriptCanPaste),                  //  0x1c  28
        uint8_t(QWebEngineSettings::WebAttribute::DnsPrefetchEnabled),                  //  0x1d  29
        uint8_t(QWebEngineSettings::WebAttribute::PdfViewerEnabled),                    //  0x1e  30
        uint8_t(QWebEngineSettings::WebAttribute::NavigateOnDropEnabled),               //  0x1f  31
        uint8_t(QWebEngineSettings::WebAttribute::ReadingFromCanvasEnabled),            //  0x20  32
        uint8_t(QWebEngineSettings::WebAttribute::ForceDarkMode)                        //  0x21  33
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineSettings_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineSettings.WebAttribute",
        WebAttribute_Initializer, WebAttribute_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_WebAttribute_IDX].type = EType;
    // Register converter for enum 'QWebEngineSettings::WebAttribute'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineSettings_WebAttribute_CppToPython_QWebEngineSettings_WebAttribute);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineSettings_WebAttribute_PythonToCpp_QWebEngineSettings_WebAttribute,
            is_QWebEngineSettings_WebAttribute_PythonToCpp_QWebEngineSettings_WebAttribute_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings::WebAttribute");
        Shiboken::Conversions::registerConverterName(converter, "WebAttribute");
    }
    // End of 'WebAttribute' enum.

    // Initialization of enum 'FontSize'.
    const char *FontSize_Initializer[] = {
        "MinimumFontSize",
        "MinimumLogicalFontSize",
        "DefaultFontSize",
        "DefaultFixedFontSize",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FontSize_InitializerValues[] = {
        uint8_t(QWebEngineSettings::FontSize::MinimumFontSize),        //  0x00  0
        uint8_t(QWebEngineSettings::FontSize::MinimumLogicalFontSize), //  0x01  1
        uint8_t(QWebEngineSettings::FontSize::DefaultFontSize),        //  0x02  2
        uint8_t(QWebEngineSettings::FontSize::DefaultFixedFontSize)    //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineSettings_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineSettings.FontSize",
        FontSize_Initializer, FontSize_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_FontSize_IDX].type = EType;
    // Register converter for enum 'QWebEngineSettings::FontSize'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineSettings_FontSize_CppToPython_QWebEngineSettings_FontSize);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineSettings_FontSize_PythonToCpp_QWebEngineSettings_FontSize,
            is_QWebEngineSettings_FontSize_PythonToCpp_QWebEngineSettings_FontSize_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings::FontSize");
        Shiboken::Conversions::registerConverterName(converter, "FontSize");
    }
    // End of 'FontSize' enum.

    // Initialization of enum 'UnknownUrlSchemePolicy'.
    const char *UnknownUrlSchemePolicy_Initializer[] = {
        "InheritedUnknownUrlSchemePolicy",
        "DisallowUnknownUrlSchemes",
        "AllowUnknownUrlSchemesFromUserInteraction",
        "AllowAllUnknownUrlSchemes",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t UnknownUrlSchemePolicy_InitializerValues[] = {
        uint8_t(QWebEngineSettings::UnknownUrlSchemePolicy::InheritedUnknownUrlSchemePolicy),           //  0x00  0
        uint8_t(QWebEngineSettings::UnknownUrlSchemePolicy::DisallowUnknownUrlSchemes),                 //  0x01  1
        uint8_t(QWebEngineSettings::UnknownUrlSchemePolicy::AllowUnknownUrlSchemesFromUserInteraction), //  0x02  2
        uint8_t(QWebEngineSettings::UnknownUrlSchemePolicy::AllowAllUnknownUrlSchemes)                  //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineSettings_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineSettings.UnknownUrlSchemePolicy",
        UnknownUrlSchemePolicy_Initializer, UnknownUrlSchemePolicy_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineSettings_UnknownUrlSchemePolicy_IDX].type = EType;
    // Register converter for enum 'QWebEngineSettings::UnknownUrlSchemePolicy'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineSettings_UnknownUrlSchemePolicy_CppToPython_QWebEngineSettings_UnknownUrlSchemePolicy);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineSettings_UnknownUrlSchemePolicy_PythonToCpp_QWebEngineSettings_UnknownUrlSchemePolicy,
            is_QWebEngineSettings_UnknownUrlSchemePolicy_PythonToCpp_QWebEngineSettings_UnknownUrlSchemePolicy_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineSettings::UnknownUrlSchemePolicy");
        Shiboken::Conversions::registerConverterName(converter, "UnknownUrlSchemePolicy");
    }
    // End of 'UnknownUrlSchemePolicy' enum.

    qRegisterMetaType< ::QWebEngineSettings *>();
    qRegisterMetaType< ::QWebEngineSettings::FontFamily >("QWebEngineSettings::FontFamily");
    qRegisterMetaType< ::QWebEngineSettings::WebAttribute >("QWebEngineSettings::WebAttribute");
    qRegisterMetaType< ::QWebEngineSettings::FontSize >("QWebEngineSettings::FontSize");
    qRegisterMetaType< ::QWebEngineSettings::UnknownUrlSchemePolicy >("QWebEngineSettings::UnknownUrlSchemePolicy");

    return pyType;
}
