// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebengineurlrequestinfo_wrapper.h"

// Argument includes
#include <QHash>
#include <QtWebEngineCore/qwebengineurlrequestinfo.h>
#include <qbytearray.h>
#include <qiodevice.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_block(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.block";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineUrlRequestInfo::block(bool)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyArg)))) {
        overloadId = 0; // block(bool)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        bool cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // block(bool)
            cppSelf->block(cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_changed(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.changed";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // changed()const
            bool cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->changed();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_firstPartyUrl(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.firstPartyUrl";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // firstPartyUrl()const
            QUrl cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->firstPartyUrl();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_httpHeaders(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.httpHeaders";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // httpHeaders()const
            QHash<QByteArray,QByteArray> cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->httpHeaders();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypeConverters[SBK_QtWebEngineCore_QHash_QByteArray_QByteArray_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_initiator(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.initiator";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // initiator()const
            QUrl cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->initiator();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_navigationType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.navigationType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // navigationType()const
            QWebEngineUrlRequestInfo::NavigationType cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->navigationType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_NavigationType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_redirect(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.redirect";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineUrlRequestInfo::redirect(QUrl)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), (pyArg)))) {
        overloadId = 0; // redirect(QUrl)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QUrl cppArg0_local;
        ::QUrl *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // redirect(QUrl)
            cppSelf->redirect(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_requestBody(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestBody";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // requestBody()const
            QIODevice * cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->requestBody();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QIODevice_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_requestMethod(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestMethod";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // requestMethod()const
            QByteArray cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->requestMethod();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_requestUrl(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestUrl";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // requestUrl()const
            QUrl cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->requestUrl();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QUrl_IDX]), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_resourceType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.resourceType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // resourceType()const
            QWebEngineUrlRequestInfo::ResourceType cppResult = const_cast<const ::QWebEngineUrlRequestInfo *>(cppSelf)->resourceType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_ResourceType_IDX])))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineUrlRequestInfoFunc_setHttpHeader(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineUrlRequestInfo *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.setHttpHeader";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "setHttpHeader", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: QWebEngineUrlRequestInfo::setHttpHeader(QByteArray,QByteArray)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QByteArray_IDX]), (pyArgs[1])))) {
        overloadId = 0; // setHttpHeader(QByteArray,QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QByteArray cppArg0_local;
        ::QByteArray *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0].isValue())
            pythonToCpp[0](pyArgs[0], &cppArg0_local);
        else
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QByteArray cppArg1_local;
        ::QByteArray *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (Shiboken::Errors::occurred() == nullptr) {
            // setHttpHeader(QByteArray,QByteArray)
            cppSelf->setHttpHeader(*cppArg0, *cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QWebEngineUrlRequestInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineUrlRequestInfo_EnumFlagInfo[] = {
    "NavigationType:Enum",
    "ResourceType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineUrlRequestInfo_methods[] = {
    {"block", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_block), METH_O, nullptr},
    {"changed", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_changed), METH_NOARGS, nullptr},
    {"firstPartyUrl", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_firstPartyUrl), METH_NOARGS, nullptr},
    {"httpHeaders", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_httpHeaders), METH_NOARGS, nullptr},
    {"initiator", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_initiator), METH_NOARGS, nullptr},
    {"navigationType", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_navigationType), METH_NOARGS, nullptr},
    {"redirect", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_redirect), METH_O, nullptr},
    {"requestBody", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_requestBody), METH_NOARGS, nullptr},
    {"requestMethod", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_requestMethod), METH_NOARGS, nullptr},
    {"requestUrl", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_requestUrl), METH_NOARGS, nullptr},
    {"resourceType", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_resourceType), METH_NOARGS, nullptr},
    {"setHttpHeader", reinterpret_cast<PyCFunction>(Sbk_QWebEngineUrlRequestInfoFunc_setHttpHeader), METH_VARARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineUrlRequestInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineUrlRequestInfo_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineUrlRequestInfo_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineUrlRequestInfo_TypeF(void)
{
    return _Sbk_QWebEngineUrlRequestInfo_Type;
}

static PyType_Slot Sbk_QWebEngineUrlRequestInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(SbkDeallocWrapperWithPrivateDtor)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineUrlRequestInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineUrlRequestInfo_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineUrlRequestInfo_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineUrlRequestInfo_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineUrlRequestInfo_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebEngineUrlRequestInfo_ResourceType_PythonToCpp_QWebEngineUrlRequestInfo_ResourceType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineUrlRequestInfo::ResourceType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineUrlRequestInfo::ResourceType *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineUrlRequestInfo_ResourceType_PythonToCpp_QWebEngineUrlRequestInfo_ResourceType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_ResourceType_IDX])))
        return QWebEngineUrlRequestInfo_ResourceType_PythonToCpp_QWebEngineUrlRequestInfo_ResourceType;
    return {};
}
static PyObject *QWebEngineUrlRequestInfo_ResourceType_CppToPython_QWebEngineUrlRequestInfo_ResourceType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineUrlRequestInfo::ResourceType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_ResourceType_IDX]), castCppIn);

}

static void QWebEngineUrlRequestInfo_NavigationType_PythonToCpp_QWebEngineUrlRequestInfo_NavigationType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineUrlRequestInfo::NavigationType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineUrlRequestInfo::NavigationType *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineUrlRequestInfo_NavigationType_PythonToCpp_QWebEngineUrlRequestInfo_NavigationType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_NavigationType_IDX])))
        return QWebEngineUrlRequestInfo_NavigationType_PythonToCpp_QWebEngineUrlRequestInfo_NavigationType;
    return {};
}
static PyObject *QWebEngineUrlRequestInfo_NavigationType_CppToPython_QWebEngineUrlRequestInfo_NavigationType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineUrlRequestInfo::NavigationType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_NavigationType_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineUrlRequestInfo_PythonToCpp_QWebEngineUrlRequestInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineUrlRequestInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineUrlRequestInfo_PythonToCpp_QWebEngineUrlRequestInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineUrlRequestInfo_TypeF()))
        return QWebEngineUrlRequestInfo_PythonToCpp_QWebEngineUrlRequestInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineUrlRequestInfo_PTR_CppToPython_QWebEngineUrlRequestInfo(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineUrlRequestInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineUrlRequestInfo_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineUrlRequestInfo_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.block(self,shouldBlock:bool)",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.changed(self)->bool",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.firstPartyUrl(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.httpHeaders(self)->QHash[PySide6.QtCore.QByteArray, PySide6.QtCore.QByteArray]",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.initiator(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.navigationType(self)->PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.NavigationType",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.redirect(self,url:typing.Union[PySide6.QtCore.QUrl, QString])",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestBody(self)->PySide6.QtCore.QIODevice",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestMethod(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.requestUrl(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.resourceType(self)->PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.ResourceType",
    "PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.setHttpHeader(self,name:typing.Union[PySide6.QtCore.QByteArray, char*],value:typing.Union[PySide6.QtCore.QByteArray, char*])",
    nullptr}; // Sentinel

PyTypeObject *init_QWebEngineUrlRequestInfo(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineUrlRequestInfo_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineUrlRequestInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineUrlRequestInfo",
        "QWebEngineUrlRequestInfo*",
        &Sbk_QWebEngineUrlRequestInfo_spec,
        nullptr,
        Sbk_QWebEngineUrlRequestInfo_Type_bases.object(),
        0);
    auto *pyType = Sbk_QWebEngineUrlRequestInfo_TypeF(); // references _Sbk_QWebEngineUrlRequestInfo_Type
    InitSignatureStrings(pyType, QWebEngineUrlRequestInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineUrlRequestInfo_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineUrlRequestInfo_PythonToCpp_QWebEngineUrlRequestInfo_PTR,
        is_QWebEngineUrlRequestInfo_PythonToCpp_QWebEngineUrlRequestInfo_PTR_Convertible,
        QWebEngineUrlRequestInfo_PTR_CppToPython_QWebEngineUrlRequestInfo);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineUrlRequestInfo");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineUrlRequestInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineUrlRequestInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineUrlRequestInfo).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineUrlRequestInfo_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'ResourceType'.
    const char *ResourceType_Initializer[] = {
        "ResourceTypeMainFrame",
        "ResourceTypeSubFrame",
        "ResourceTypeStylesheet",
        "ResourceTypeScript",
        "ResourceTypeImage",
        "ResourceTypeFontResource",
        "ResourceTypeSubResource",
        "ResourceTypeObject",
        "ResourceTypeMedia",
        "ResourceTypeWorker",
        "ResourceTypeSharedWorker",
        "ResourceTypePrefetch",
        "ResourceTypeFavicon",
        "ResourceTypeXhr",
        "ResourceTypePing",
        "ResourceTypeServiceWorker",
        "ResourceTypeCspReport",
        "ResourceTypePluginResource",
        "ResourceTypeNavigationPreloadMainFrame",
        "ResourceTypeNavigationPreloadSubFrame",
        "ResourceTypeLast",
        "ResourceTypeWebSocket",
        "ResourceTypeUnknown",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t ResourceType_InitializerValues[] = {
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeMainFrame),                  //  0x00  0
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeSubFrame),                   //  0x01  1
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeStylesheet),                 //  0x02  2
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeScript),                     //  0x03  3
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeImage),                      //  0x04  4
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeFontResource),               //  0x05  5
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeSubResource),                //  0x06  6
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeObject),                     //  0x07  7
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeMedia),                      //  0x08  8
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeWorker),                     //  0x09  9
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeSharedWorker),               //  0x0a  10
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypePrefetch),                   //  0x0b  11
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeFavicon),                    //  0x0c  12
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeXhr),                        //  0x0d  13
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypePing),                       //  0x0e  14
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeServiceWorker),              //  0x0f  15
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeCspReport),                  //  0x10  16
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypePluginResource),             //  0x11  17
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeNavigationPreloadMainFrame), //  0x13  19
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeNavigationPreloadSubFrame),  //  0x14  20
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeLast),                       //  0x14  20
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeWebSocket),                  //  0xfe  254
        uint8_t(QWebEngineUrlRequestInfo::ResourceType::ResourceTypeUnknown)                     //  0xff  255
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineUrlRequestInfo_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.ResourceType",
        ResourceType_Initializer, ResourceType_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_ResourceType_IDX].type = EType;
    // Register converter for enum 'QWebEngineUrlRequestInfo::ResourceType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineUrlRequestInfo_ResourceType_CppToPython_QWebEngineUrlRequestInfo_ResourceType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineUrlRequestInfo_ResourceType_PythonToCpp_QWebEngineUrlRequestInfo_ResourceType,
            is_QWebEngineUrlRequestInfo_ResourceType_PythonToCpp_QWebEngineUrlRequestInfo_ResourceType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineUrlRequestInfo::ResourceType");
        Shiboken::Conversions::registerConverterName(converter, "ResourceType");
    }
    // End of 'ResourceType' enum.

    // Initialization of enum 'NavigationType'.
    const char *NavigationType_Initializer[] = {
        "NavigationTypeLink",
        "NavigationTypeTyped",
        "NavigationTypeFormSubmitted",
        "NavigationTypeBackForward",
        "NavigationTypeReload",
        "NavigationTypeOther",
        "NavigationTypeRedirect",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t NavigationType_InitializerValues[] = {
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeLink),          //  0x00  0
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeTyped),         //  0x01  1
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeFormSubmitted), //  0x02  2
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeBackForward),   //  0x03  3
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeReload),        //  0x04  4
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeOther),         //  0x05  5
        uint8_t(QWebEngineUrlRequestInfo::NavigationType::NavigationTypeRedirect)       //  0x06  6
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineUrlRequestInfo_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineUrlRequestInfo.NavigationType",
        NavigationType_Initializer, NavigationType_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineUrlRequestInfo_NavigationType_IDX].type = EType;
    // Register converter for enum 'QWebEngineUrlRequestInfo::NavigationType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineUrlRequestInfo_NavigationType_CppToPython_QWebEngineUrlRequestInfo_NavigationType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineUrlRequestInfo_NavigationType_PythonToCpp_QWebEngineUrlRequestInfo_NavigationType,
            is_QWebEngineUrlRequestInfo_NavigationType_PythonToCpp_QWebEngineUrlRequestInfo_NavigationType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineUrlRequestInfo::NavigationType");
        Shiboken::Conversions::registerConverterName(converter, "NavigationType");
    }
    // End of 'NavigationType' enum.

    qRegisterMetaType< ::QWebEngineUrlRequestInfo *>();
    qRegisterMetaType< ::QWebEngineUrlRequestInfo::ResourceType >("QWebEngineUrlRequestInfo::ResourceType");
    qRegisterMetaType< ::QWebEngineUrlRequestInfo::NavigationType >("QWebEngineUrlRequestInfo::NavigationType");

    return pyType;
}
