// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWebEngineUrlRequestInterceptorWrapper_H
#define SBK_QWebEngineUrlRequestInterceptorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebEngineCore/qwebengineurlrequestinterceptor.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QWebEngineUrlRequestInterceptorWrapper : public QWebEngineUrlRequestInterceptor
{
public:
    QWebEngineUrlRequestInterceptorWrapper(const QWebEngineUrlRequestInterceptorWrapper &) = delete;
    QWebEngineUrlRequestInterceptorWrapper& operator=(const QWebEngineUrlRequestInterceptorWrapper &) = delete;
    QWebEngineUrlRequestInterceptorWrapper(QWebEngineUrlRequestInterceptorWrapper &&) = delete;
    QWebEngineUrlRequestInterceptorWrapper& operator=(QWebEngineUrlRequestInterceptorWrapper &&) = delete;

    QWebEngineUrlRequestInterceptorWrapper(::QObject * p = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void interceptRequest(::QWebEngineUrlRequestInfo & info) override;
    void timerEvent(::QTimerEvent * event) override;
    ~QWebEngineUrlRequestInterceptorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_QWebEngineUrlRequestInterceptorWrapper_H

