// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginequick_python.h"

// main header
#include "qtwebenginequick_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static PyObject *Sbk_QtWebEngineQuickFunc_initialize(PyObject *self)
{
    SBK_UNUSED(self)
    static const char fullName[] = "PySide6.QtWebEngineQuick.QtWebEngineQuick.initialize";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // initialize()
            ::QtWebEngineQuick::initialize();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_QtWebEngineQuick_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QtWebEngineQuick_methods[] = {
    {"initialize", reinterpret_cast<PyCFunction>(Sbk_QtWebEngineQuickFunc_initialize), METH_NOARGS|METH_STATIC, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QtWebEngineQuick_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QtWebEngineQuick_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QtWebEngineQuick_Type = nullptr;
static PyTypeObject *Sbk_QtWebEngineQuick_TypeF(void)
{
    return _Sbk_QtWebEngineQuick_Type;
}

static PyType_Slot Sbk_QtWebEngineQuick_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QtWebEngineQuick_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QtWebEngineQuick_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QtWebEngineQuick_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QtWebEngineQuick_spec = {
    "2:PySide6.QtWebEngineQuick.QtWebEngineQuick",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QtWebEngineQuick_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtWebEngineQuickQtWebEngineQuick_SignatureStrings[] = {
    "PySide6.QtWebEngineQuick.QtWebEngineQuick.initialize()",
    nullptr}; // Sentinel

PyTypeObject *init_QtWebEngineQuickQtWebEngineQuick(PyObject *module)
{
    if (SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type;

    Shiboken::AutoDecRef Sbk_QtWebEngineQuick_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QtWebEngineQuick_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QtWebEngineQuick",
        "QtWebEngineQuick",
        &Sbk_QtWebEngineQuick_spec,
        nullptr,
        Sbk_QtWebEngineQuick_Type_bases.object(),
        0);
    auto *pyType = Sbk_QtWebEngineQuick_TypeF(); // references _Sbk_QtWebEngineQuick_Type
    InitSignatureStrings(pyType, QtWebEngineQuickQtWebEngineQuick_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QtWebEngineQuick_PropertyStrings);
    SbkPySide6_QtWebEngineQuickTypeStructs[SBK_QtWebEngineQuickQtWebEngineQuick_IDX].type = pyType;



    return pyType;
}
