// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qformlayout_takerowresult_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QFormLayout_TakeRowResult_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QFormLayout::TakeRowResult >()))
        return -1;

    ::QFormLayout::TakeRowResult *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QFormLayout.TakeRowResult.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "TakeRowResult", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: TakeRowResult::TakeRowResult()
    // 1: TakeRowResult::TakeRowResult(QFormLayout::TakeRowResult)
    if (numArgs == 0) {
        overloadId = 0; // TakeRowResult()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), (pyArgs[0])))) {
        overloadId = 1; // TakeRowResult(QFormLayout::TakeRowResult)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // TakeRowResult()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // TakeRowResult()
                cptr = new ::QFormLayout::TakeRowResult();
            }
            break;
        }
        case 1: // TakeRowResult(const QFormLayout::TakeRowResult & TakeRowResult)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QFormLayout::TakeRowResult cppArg0_local;
            ::QFormLayout::TakeRowResult *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // TakeRowResult(QFormLayout::TakeRowResult)
                cptr = new ::QFormLayout::TakeRowResult(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QFormLayout::TakeRowResult >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QFormLayout_TakeRowResult__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QFormLayout_TakeRowResult_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QFormLayout_TakeRowResult_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QFormLayout_TakeRowResult__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QFormLayout_TakeRowResult_get_labelItem(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QLayoutItem_IDX]), cppSelf->labelItem);
    return pyOut;
}
static int Sbk_QFormLayout_TakeRowResult_set_labelItem(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("labelItem");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QLayoutItem_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("labelItem", "QLayoutItem");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->labelItem;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "labelItem", pyIn);
    return 0;
}

static PyObject *Sbk_QFormLayout_TakeRowResult_get_fieldItem(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QLayoutItem_IDX]), cppSelf->fieldItem);
    return pyOut;
}
static int Sbk_QFormLayout_TakeRowResult_set_fieldItem(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("fieldItem");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QLayoutItem_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("fieldItem", "QLayoutItem");
        return -1;
    }

    auto *&cppOut_ptr = cppSelf->fieldItem;
    pythonToCpp(pyIn, &cppOut_ptr);

    Shiboken::Object::keepReference(reinterpret_cast<SbkObject *>(self), "fieldItem", pyIn);
    return 0;
}

// Getters and Setters for TakeRowResult
static PyGetSetDef Sbk_QFormLayout_TakeRowResult_getsetlist[] = {
    {const_cast<char *>("labelItem"), Sbk_QFormLayout_TakeRowResult_get_labelItem, Sbk_QFormLayout_TakeRowResult_set_labelItem, nullptr, nullptr},
    {const_cast<char *>("fieldItem"), Sbk_QFormLayout_TakeRowResult_get_fieldItem, Sbk_QFormLayout_TakeRowResult_set_fieldItem, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QFormLayout_TakeRowResult_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QFormLayout_TakeRowResult_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QFormLayout_TakeRowResult_Type = nullptr;
static PyTypeObject *Sbk_QFormLayout_TakeRowResult_TypeF(void)
{
    return _Sbk_QFormLayout_TakeRowResult_Type;
}

static PyType_Slot Sbk_QFormLayout_TakeRowResult_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QFormLayout_TakeRowResult_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QFormLayout_TakeRowResult_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QFormLayout_TakeRowResult_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QFormLayout_TakeRowResult_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QFormLayout_TakeRowResult_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QFormLayout_TakeRowResult_spec = {
    "2:PySide6.QtWidgets.QFormLayout.TakeRowResult",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QFormLayout_TakeRowResult_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void TakeRowResult_PythonToCpp_TakeRowResult_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QFormLayout_TakeRowResult_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_TakeRowResult_PythonToCpp_TakeRowResult_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QFormLayout_TakeRowResult_TypeF()))
        return TakeRowResult_PythonToCpp_TakeRowResult_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *TakeRowResult_PTR_CppToPython_TakeRowResult(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QFormLayout::TakeRowResult *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QFormLayout_TakeRowResult_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *TakeRowResult_COPY_CppToPython_TakeRowResult(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QFormLayout::TakeRowResult *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QFormLayout_TakeRowResult_TypeF(), new ::QFormLayout::TakeRowResult(*source), true, true);
}

// Python to C++ copy conversion.
static void TakeRowResult_PythonToCpp_TakeRowResult_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QFormLayout::TakeRowResult *>(cppOut) = *reinterpret_cast< ::QFormLayout::TakeRowResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_TakeRowResult_PythonToCpp_TakeRowResult_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QFormLayout_TakeRowResult_TypeF()))
        return TakeRowResult_PythonToCpp_TakeRowResult_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QFormLayout_TakeRowResult_SignatureStrings[] = {
    "1:PySide6.QtWidgets.QFormLayout.TakeRowResult(self)",
    "0:PySide6.QtWidgets.QFormLayout.TakeRowResult(self,TakeRowResult:PySide6.QtWidgets.QFormLayout.TakeRowResult)",
    "PySide6.QtWidgets.QFormLayout.TakeRowResult.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QFormLayout_TakeRowResult(PyObject *enclosingClass)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX].type;

    Shiboken::AutoDecRef Sbk_QFormLayout_TakeRowResult_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QFormLayout_TakeRowResult_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "TakeRowResult",
        "QFormLayout::TakeRowResult",
        &Sbk_QFormLayout_TakeRowResult_spec,
        &Shiboken::callCppDestructor< ::QFormLayout::TakeRowResult >,
        Sbk_QFormLayout_TakeRowResult_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QFormLayout_TakeRowResult_TypeF(); // references _Sbk_QFormLayout_TakeRowResult_Type
    InitSignatureStrings(pyType, QFormLayout_TakeRowResult_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QFormLayout_TakeRowResult_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QFormLayout_TakeRowResult_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        TakeRowResult_PythonToCpp_TakeRowResult_PTR,
        is_TakeRowResult_PythonToCpp_TakeRowResult_PTR_Convertible,
        TakeRowResult_PTR_CppToPython_TakeRowResult,
        TakeRowResult_COPY_CppToPython_TakeRowResult);

    Shiboken::Conversions::registerConverterName(converter, "QFormLayout::TakeRowResult");
    Shiboken::Conversions::registerConverterName(converter, "QFormLayout::TakeRowResult*");
    Shiboken::Conversions::registerConverterName(converter, "QFormLayout::TakeRowResult&");
    Shiboken::Conversions::registerConverterName(converter, "TakeRowResult");
    Shiboken::Conversions::registerConverterName(converter, "TakeRowResult*");
    Shiboken::Conversions::registerConverterName(converter, "TakeRowResult&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QFormLayout::TakeRowResult).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        TakeRowResult_PythonToCpp_TakeRowResult_COPY,
        is_TakeRowResult_PythonToCpp_TakeRowResult_COPY_Convertible);

    qRegisterMetaType< ::QFormLayout::TakeRowResult >("TakeRowResult");
    qRegisterMetaType< ::QFormLayout::TakeRowResult >("QFormLayout::TakeRowResult");

    return pyType;
}
