// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsEllipseItemWrapper_H
#define SBK_QGraphicsEllipseItemWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicsitem.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsEllipseItemWrapper : public QGraphicsEllipseItem
{
public:
    QGraphicsEllipseItemWrapper(const QGraphicsEllipseItemWrapper &) = delete;
    QGraphicsEllipseItemWrapper& operator=(const QGraphicsEllipseItemWrapper &) = delete;
    QGraphicsEllipseItemWrapper(QGraphicsEllipseItemWrapper &&) = delete;
    QGraphicsEllipseItemWrapper& operator=(QGraphicsEllipseItemWrapper &&) = delete;

    QGraphicsEllipseItemWrapper(::QGraphicsItem * parent = nullptr);
    QGraphicsEllipseItemWrapper(const ::QRectF & rect, ::QGraphicsItem * parent = nullptr);
    QGraphicsEllipseItemWrapper(qreal x, qreal y, qreal w, qreal h, ::QGraphicsItem * parent = nullptr);
    void advance(int phase) override;
    ::QRectF boundingRect() const override;
    bool collidesWithItem(const ::QGraphicsItem * other, ::Qt::ItemSelectionMode mode = Qt::IntersectsItemShape) const override;
    bool collidesWithPath(const ::QPainterPath & path, ::Qt::ItemSelectionMode mode = Qt::IntersectsItemShape) const override;
    bool contains(const ::QPointF & point) const override;
    void contextMenuEvent(::QGraphicsSceneContextMenuEvent * event) override;
    void dragEnterEvent(::QGraphicsSceneDragDropEvent * event) override;
    void dragLeaveEvent(::QGraphicsSceneDragDropEvent * event) override;
    void dragMoveEvent(::QGraphicsSceneDragDropEvent * event) override;
    void dropEvent(::QGraphicsSceneDragDropEvent * event) override;
    ::QVariant extension(const ::QVariant & variant) const override;
    void focusInEvent(::QFocusEvent * event) override;
    void focusOutEvent(::QFocusEvent * event) override;
    void hoverEnterEvent(::QGraphicsSceneHoverEvent * event) override;
    void hoverLeaveEvent(::QGraphicsSceneHoverEvent * event) override;
    void hoverMoveEvent(::QGraphicsSceneHoverEvent * event) override;
    void inputMethodEvent(::QInputMethodEvent * event) override;
    ::QVariant inputMethodQuery(::Qt::InputMethodQuery query) const override;
    bool isObscuredBy(const ::QGraphicsItem * item) const override;
    ::QVariant itemChange(::QGraphicsItem::GraphicsItemChange change, const ::QVariant & value) override;
    void keyPressEvent(::QKeyEvent * event) override;
    void keyReleaseEvent(::QKeyEvent * event) override;
    void mouseDoubleClickEvent(::QGraphicsSceneMouseEvent * event) override;
    void mouseMoveEvent(::QGraphicsSceneMouseEvent * event) override;
    void mousePressEvent(::QGraphicsSceneMouseEvent * event) override;
    void mouseReleaseEvent(::QGraphicsSceneMouseEvent * event) override;
    ::QPainterPath opaqueArea() const override;
    void paint(::QPainter * painter, const ::QStyleOptionGraphicsItem * option, ::QWidget * widget = nullptr) override;
    bool sceneEvent(::QEvent * event) override;
    bool sceneEventFilter(::QGraphicsItem * watched, ::QEvent * event) override;
    ::QPainterPath shape() const override;
    int type() const override;
    void wheelEvent(::QGraphicsSceneWheelEvent * event) override;
    ~QGraphicsEllipseItemWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[33];
};

#endif // SBK_QGraphicsEllipseItemWrapper_H

