// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGraphicsSceneHelpEventWrapper_H
#define SBK_QGraphicsSceneHelpEventWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QGraphicsSceneHelpEventWrapper : public QGraphicsSceneHelpEvent
{
public:
    QGraphicsSceneHelpEventWrapper(const QGraphicsSceneHelpEventWrapper &) = delete;
    QGraphicsSceneHelpEventWrapper& operator=(const QGraphicsSceneHelpEventWrapper &) = delete;
    QGraphicsSceneHelpEventWrapper(QGraphicsSceneHelpEventWrapper &&) = delete;
    QGraphicsSceneHelpEventWrapper& operator=(QGraphicsSceneHelpEventWrapper &&) = delete;

    QGraphicsSceneHelpEventWrapper(::QEvent::Type type = QEvent::Type::None);
    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QGraphicsSceneHelpEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QGraphicsSceneHelpEventWrapper_H

