// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QItemEditorCreatorBaseWrapper_H
#define SBK_QItemEditorCreatorBaseWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qitemeditorfactory.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QItemEditorCreatorBaseWrapper : public QItemEditorCreatorBase
{
public:
    QItemEditorCreatorBaseWrapper(const QItemEditorCreatorBaseWrapper &) = delete;
    QItemEditorCreatorBaseWrapper& operator=(const QItemEditorCreatorBaseWrapper &) = delete;
    QItemEditorCreatorBaseWrapper(QItemEditorCreatorBaseWrapper &&) = delete;
    QItemEditorCreatorBaseWrapper& operator=(QItemEditorCreatorBaseWrapper &&) = delete;

    QItemEditorCreatorBaseWrapper();
    ::QWidget * createWidget(::QWidget * parent) const override;
    ::QByteArray valuePropertyName() const override;
    ~QItemEditorCreatorBaseWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QItemEditorCreatorBaseWrapper_H

