// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptionframe_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>
#include <QtWidgets/qwidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionFrame_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionFrame >()))
        return -1;

    ::QStyleOptionFrame *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionFrame.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionFrame", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionFrame::QStyleOptionFrame()
    // 1: QStyleOptionFrame::QStyleOptionFrame(QStyleOptionFrame)
    // 2: QStyleOptionFrame::QStyleOptionFrame(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionFrame()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionFrame(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionFrame(QStyleOptionFrame)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionFrame()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionFrame()
                cptr = new ::QStyleOptionFrame();
            }
            break;
        }
        case 1: // QStyleOptionFrame(const QStyleOptionFrame & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionFrame *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionFrame(QStyleOptionFrame)
                cptr = new ::QStyleOptionFrame(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionFrame(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionFrame(int)
                cptr = new ::QStyleOptionFrame(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionFrame >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionFrame_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionFrame_EnumFlagInfo[] = {
    "FrameFeature:Flag:FrameFeatures",
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionFrame_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionFrame_get_lineWidth(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->lineWidth;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionFrame_set_lineWidth(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("lineWidth");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("lineWidth", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->lineWidth;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->lineWidth = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionFrame_get_midLineWidth(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->midLineWidth;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionFrame_set_midLineWidth(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("midLineWidth");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("midLineWidth", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->midLineWidth;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->midLineWidth = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionFrame_get_features(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionFrame_FrameFeature_IDX])))->converter, &cppSelf->features);
    return pyOut;
}
static int Sbk_QStyleOptionFrame_set_features(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("features");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionFrame_FrameFeature_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("features", "FrameFeatures");
        return -1;
    }

    auto cppOut_local = cppSelf->features;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->features = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionFrame_get_frameShape(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QFrame::Shape cppOut_local = cppSelf->frameShape;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFrame_Shape_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionFrame_set_frameShape(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionFrame *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("frameShape");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFrame_Shape_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("frameShape", "Shape");
        return -1;
    }

    auto cppOut_local = cppSelf->frameShape;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->frameShape = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionFrame
static PyGetSetDef Sbk_QStyleOptionFrame_getsetlist[] = {
    {const_cast<char *>("lineWidth"), Sbk_QStyleOptionFrame_get_lineWidth, Sbk_QStyleOptionFrame_set_lineWidth, nullptr, nullptr},
    {const_cast<char *>("midLineWidth"), Sbk_QStyleOptionFrame_get_midLineWidth, Sbk_QStyleOptionFrame_set_midLineWidth, nullptr, nullptr},
    {const_cast<char *>("features"), Sbk_QStyleOptionFrame_get_features, Sbk_QStyleOptionFrame_set_features, nullptr, nullptr},
    {const_cast<char *>("frameShape"), Sbk_QStyleOptionFrame_get_frameShape, Sbk_QStyleOptionFrame_set_frameShape, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionFrame_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionFrame_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionFrame_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionFrame_TypeF(void)
{
    return _Sbk_QStyleOptionFrame_Type;
}

static PyType_Slot Sbk_QStyleOptionFrame_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionFrame_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionFrame_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionFrame_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionFrame_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionFrame_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionFrame_spec = {
    "2:PySide6.QtWidgets.QStyleOptionFrame",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionFrame_slots
};

} //extern "C"

static void *Sbk_QStyleOptionFrame_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionFrame *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleOptionFrame_StyleOptionType_PythonToCpp_QStyleOptionFrame_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionFrame::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionFrame::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionFrame_StyleOptionType_PythonToCpp_QStyleOptionFrame_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionType_IDX])))
        return QStyleOptionFrame_StyleOptionType_PythonToCpp_QStyleOptionFrame_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionFrame_StyleOptionType_CppToPython_QStyleOptionFrame_StyleOptionType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionFrame::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionType_IDX]), castCppIn);

}

static void QStyleOptionFrame_StyleOptionVersion_PythonToCpp_QStyleOptionFrame_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionFrame::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionFrame::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionFrame_StyleOptionVersion_PythonToCpp_QStyleOptionFrame_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionVersion_IDX])))
        return QStyleOptionFrame_StyleOptionVersion_PythonToCpp_QStyleOptionFrame_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionFrame_StyleOptionVersion_CppToPython_QStyleOptionFrame_StyleOptionVersion(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionFrame::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionVersion_IDX]), castCppIn);

}

static void QStyleOptionFrame_FrameFeature_PythonToCpp_QStyleOptionFrame_FrameFeature(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionFrame::FrameFeature>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionFrame::FrameFeature *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionFrame_FrameFeature_PythonToCpp_QStyleOptionFrame_FrameFeature_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_FrameFeature_IDX])))
        return QStyleOptionFrame_FrameFeature_PythonToCpp_QStyleOptionFrame_FrameFeature;
    return {};
}
static PyObject *QStyleOptionFrame_FrameFeature_CppToPython_QStyleOptionFrame_FrameFeature(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionFrame::FrameFeature *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_FrameFeature_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionFrame_PythonToCpp_QStyleOptionFrame_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionFrame_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionFrame_PythonToCpp_QStyleOptionFrame_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionFrame_TypeF()))
        return QStyleOptionFrame_PythonToCpp_QStyleOptionFrame_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionFrame_PTR_CppToPython_QStyleOptionFrame(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionFrame *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionFrame_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionFrame_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionFrame(self)",
    "1:PySide6.QtWidgets.QStyleOptionFrame(self,other:PySide6.QtWidgets.QStyleOptionFrame)",
    "0:PySide6.QtWidgets.QStyleOptionFrame(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionFrame(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionFrame_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOption_IDX]))));

    _Sbk_QStyleOptionFrame_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionFrame",
        "QStyleOptionFrame*",
        &Sbk_QStyleOptionFrame_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionFrame >,
        Sbk_QStyleOptionFrame_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionFrame_TypeF(); // references _Sbk_QStyleOptionFrame_Type
    InitSignatureStrings(pyType, QStyleOptionFrame_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionFrame_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionFrame_PythonToCpp_QStyleOptionFrame_PTR,
        is_QStyleOptionFrame_PythonToCpp_QStyleOptionFrame_PTR_Convertible,
        QStyleOptionFrame_PTR_CppToPython_QStyleOptionFrame);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionFrame).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionFrame_TypeF(), &Sbk_QStyleOptionFrame_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionFrame_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionFrame::StyleOptionType::Type) //  0x05  5
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionFrame_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionFrame.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionFrame::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionFrame_StyleOptionType_CppToPython_QStyleOptionFrame_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionFrame_StyleOptionType_PythonToCpp_QStyleOptionFrame_StyleOptionType,
            is_QStyleOptionFrame_StyleOptionType_PythonToCpp_QStyleOptionFrame_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionFrame::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionFrame_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionFrame.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionFrame::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionFrame_StyleOptionVersion_CppToPython_QStyleOptionFrame_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionFrame_StyleOptionVersion_PythonToCpp_QStyleOptionFrame_StyleOptionVersion,
            is_QStyleOptionFrame_StyleOptionVersion_PythonToCpp_QStyleOptionFrame_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'FrameFeature'.
    const char *FrameFeature_Initializer[] = {
        "None_",
        "Flat",
        "Rounded",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t FrameFeature_InitializerValues[] = {
        uint8_t(QStyleOptionFrame::FrameFeature::None),   //  0x00  0
        uint8_t(QStyleOptionFrame::FrameFeature::Flat),   //  0x01  1
        uint8_t(QStyleOptionFrame::FrameFeature::Rounded) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionFrame_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionFrame.FrameFeature",
        FrameFeature_Initializer, FrameFeature_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionFrame_FrameFeature_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionFrame_FrameFeature_IDX].type =
        EType;
    // Register converter for enum 'QStyleOptionFrame::FrameFeature'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionFrame_FrameFeature_CppToPython_QStyleOptionFrame_FrameFeature);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionFrame_FrameFeature_PythonToCpp_QStyleOptionFrame_FrameFeature,
            is_QStyleOptionFrame_FrameFeature_PythonToCpp_QStyleOptionFrame_FrameFeature_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame::FrameFeature");
        Shiboken::Conversions::registerConverterName(converter, "FrameFeature");
        // Register converter for flag 'QFlags<QStyleOptionFrame::FrameFeature>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QStyleOptionFrame::FrameFeature>");
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFrame::FrameFeatures");
    }
    // End of 'FrameFeature' enum/flags.

    qRegisterMetaType< ::QStyleOptionFrame *>();
    qRegisterMetaType< ::QStyleOptionFrame::StyleOptionType >("QStyleOptionFrame::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionFrame::StyleOptionVersion >("QStyleOptionFrame::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionFrame::FrameFeature >("QStyleOptionFrame::FrameFeature");

    return pyType;
}
