// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptionheaderv2_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionHeaderV2_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionHeaderV2 >()))
        return -1;

    ::QStyleOptionHeaderV2 *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionHeaderV2.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionHeaderV2", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionHeaderV2::QStyleOptionHeaderV2()
    // 1: QStyleOptionHeaderV2::QStyleOptionHeaderV2(QStyleOptionHeaderV2)
    // 2: QStyleOptionHeaderV2::QStyleOptionHeaderV2(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionHeaderV2()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionHeaderV2(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionHeaderV2(QStyleOptionHeaderV2)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionHeaderV2()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeaderV2()
                cptr = new ::QStyleOptionHeaderV2();
            }
            break;
        }
        case 1: // QStyleOptionHeaderV2(const QStyleOptionHeaderV2 & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionHeaderV2 *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeaderV2(QStyleOptionHeaderV2)
                cptr = new ::QStyleOptionHeaderV2(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionHeaderV2(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionHeaderV2(int)
                cptr = new ::QStyleOptionHeaderV2(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionHeaderV2 >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionHeaderV2_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionHeaderV2_EnumFlagInfo[] = {
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionHeaderV2_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionHeaderV2_get_textElideMode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::Qt::TextElideMode cppOut_local = cppSelf->textElideMode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TextElideMode_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeaderV2_set_textElideMode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("textElideMode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_Qt_TextElideMode_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("textElideMode", "TextElideMode");
        return -1;
    }

    auto cppOut_local = cppSelf->textElideMode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->textElideMode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeaderV2_get_isSectionDragTarget(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->isSectionDragTarget;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeaderV2_set_isSectionDragTarget(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("isSectionDragTarget");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("isSectionDragTarget", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->isSectionDragTarget;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->isSectionDragTarget = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionHeaderV2_get_unused(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->unused;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionHeaderV2_set_unused(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionHeaderV2 *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("unused");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("unused", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->unused;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->unused = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionHeaderV2
static PyGetSetDef Sbk_QStyleOptionHeaderV2_getsetlist[] = {
    {const_cast<char *>("textElideMode"), Sbk_QStyleOptionHeaderV2_get_textElideMode, Sbk_QStyleOptionHeaderV2_set_textElideMode, nullptr, nullptr},
    {const_cast<char *>("isSectionDragTarget"), Sbk_QStyleOptionHeaderV2_get_isSectionDragTarget, Sbk_QStyleOptionHeaderV2_set_isSectionDragTarget, nullptr, nullptr},
    {const_cast<char *>("unused"), Sbk_QStyleOptionHeaderV2_get_unused, Sbk_QStyleOptionHeaderV2_set_unused, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionHeaderV2_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionHeaderV2_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionHeaderV2_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionHeaderV2_TypeF(void)
{
    return _Sbk_QStyleOptionHeaderV2_Type;
}

static PyType_Slot Sbk_QStyleOptionHeaderV2_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionHeaderV2_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionHeaderV2_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionHeaderV2_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionHeaderV2_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionHeaderV2_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionHeaderV2_spec = {
    "2:PySide6.QtWidgets.QStyleOptionHeaderV2",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionHeaderV2_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleOptionHeaderV2_StyleOptionType_PythonToCpp_QStyleOptionHeaderV2_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeaderV2::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeaderV2::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionHeaderV2_StyleOptionType_PythonToCpp_QStyleOptionHeaderV2_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionType_IDX])))
        return QStyleOptionHeaderV2_StyleOptionType_PythonToCpp_QStyleOptionHeaderV2_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionHeaderV2_StyleOptionType_CppToPython_QStyleOptionHeaderV2_StyleOptionType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeaderV2::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionType_IDX]), castCppIn);

}

static void QStyleOptionHeaderV2_StyleOptionVersion_PythonToCpp_QStyleOptionHeaderV2_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionHeaderV2::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionHeaderV2::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionHeaderV2_StyleOptionVersion_PythonToCpp_QStyleOptionHeaderV2_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionVersion_IDX])))
        return QStyleOptionHeaderV2_StyleOptionVersion_PythonToCpp_QStyleOptionHeaderV2_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionHeaderV2_StyleOptionVersion_CppToPython_QStyleOptionHeaderV2_StyleOptionVersion(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionHeaderV2::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionVersion_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionHeaderV2_PythonToCpp_QStyleOptionHeaderV2_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionHeaderV2_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionHeaderV2_PythonToCpp_QStyleOptionHeaderV2_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionHeaderV2_TypeF()))
        return QStyleOptionHeaderV2_PythonToCpp_QStyleOptionHeaderV2_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionHeaderV2_PTR_CppToPython_QStyleOptionHeaderV2(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionHeaderV2 *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionHeaderV2_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionHeaderV2_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionHeaderV2(self)",
    "1:PySide6.QtWidgets.QStyleOptionHeaderV2(self,other:PySide6.QtWidgets.QStyleOptionHeaderV2)",
    "0:PySide6.QtWidgets.QStyleOptionHeaderV2(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionHeaderV2(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionHeaderV2_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeader_IDX]))));

    _Sbk_QStyleOptionHeaderV2_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionHeaderV2",
        "QStyleOptionHeaderV2*",
        &Sbk_QStyleOptionHeaderV2_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionHeaderV2 >,
        Sbk_QStyleOptionHeaderV2_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionHeaderV2_TypeF(); // references _Sbk_QStyleOptionHeaderV2_Type
    InitSignatureStrings(pyType, QStyleOptionHeaderV2_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionHeaderV2_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionHeaderV2_PythonToCpp_QStyleOptionHeaderV2_PTR,
        is_QStyleOptionHeaderV2_PythonToCpp_QStyleOptionHeaderV2_PTR_Convertible,
        QStyleOptionHeaderV2_PTR_CppToPython_QStyleOptionHeaderV2);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeaderV2");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeaderV2*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeaderV2&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionHeaderV2).name());

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionHeaderV2_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionHeaderV2::StyleOptionType::Type) //  0x08  8
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeaderV2_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeaderV2.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeaderV2::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeaderV2_StyleOptionType_CppToPython_QStyleOptionHeaderV2_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionHeaderV2_StyleOptionType_PythonToCpp_QStyleOptionHeaderV2_StyleOptionType,
            is_QStyleOptionHeaderV2_StyleOptionType_PythonToCpp_QStyleOptionHeaderV2_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeaderV2::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionHeaderV2::StyleOptionVersion::Version) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionHeaderV2_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionHeaderV2.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionHeaderV2_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionHeaderV2::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionHeaderV2_StyleOptionVersion_CppToPython_QStyleOptionHeaderV2_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionHeaderV2_StyleOptionVersion_PythonToCpp_QStyleOptionHeaderV2_StyleOptionVersion,
            is_QStyleOptionHeaderV2_StyleOptionVersion_PythonToCpp_QStyleOptionHeaderV2_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionHeaderV2::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    qRegisterMetaType< ::QStyleOptionHeaderV2 *>();
    qRegisterMetaType< ::QStyleOptionHeaderV2::StyleOptionType >("QStyleOptionHeaderV2::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionHeaderV2::StyleOptionVersion >("QStyleOptionHeaderV2::StyleOptionVersion");

    return pyType;
}
