// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptiontab_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>
#include <QtWidgets/qwidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionTab_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionTab >()))
        return -1;

    ::QStyleOptionTab *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionTab.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionTab", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionTab::QStyleOptionTab()
    // 1: QStyleOptionTab::QStyleOptionTab(QStyleOptionTab)
    // 2: QStyleOptionTab::QStyleOptionTab(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionTab()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionTab(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionTab(QStyleOptionTab)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionTab()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionTab()
                cptr = new ::QStyleOptionTab();
            }
            break;
        }
        case 1: // QStyleOptionTab(const QStyleOptionTab & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionTab *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionTab(QStyleOptionTab)
                cptr = new ::QStyleOptionTab(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionTab(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionTab(int)
                cptr = new ::QStyleOptionTab(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionTab >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionTab_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionTab_EnumFlagInfo[] = {
    "CornerWidget:Flag:CornerWidgets",
    "SelectedPosition:Enum",
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    "TabFeature:Flag:TabFeatures",
    "TabPosition:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionTab_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionTab_get_shape(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QTabBar::Shape cppOut_local = cppSelf->shape;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTabBar_Shape_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_shape(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("shape");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTabBar_Shape_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("shape", "Shape");
        return -1;
    }

    auto cppOut_local = cppSelf->shape;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->shape = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_text(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->text);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_text(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("text");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("text", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->text;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_icon(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->icon)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->icon))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->icon)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), &(cppSelf->icon), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_icon(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("icon");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("icon", "QIcon");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->icon;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_row(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->row;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_row(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("row");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("row", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->row;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->row = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_position(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionTab::TabPosition cppOut_local = cppSelf->position;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_position(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("position");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("position", "TabPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->position;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->position = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_selectedPosition(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionTab::SelectedPosition cppOut_local = cppSelf->selectedPosition;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_SelectedPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_selectedPosition(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selectedPosition");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_SelectedPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selectedPosition", "SelectedPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->selectedPosition;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->selectedPosition = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_cornerWidgets(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_CornerWidget_IDX])))->converter, &cppSelf->cornerWidgets);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_cornerWidgets(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("cornerWidgets");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_CornerWidget_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("cornerWidgets", "CornerWidgets");
        return -1;
    }

    auto cppOut_local = cppSelf->cornerWidgets;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->cornerWidgets = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_iconSize(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->iconSize)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->iconSize))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->iconSize)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &(cppSelf->iconSize), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_iconSize(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("iconSize");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("iconSize", "QSize");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->iconSize;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_documentMode(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    bool cppOut_local = cppSelf->documentMode;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_documentMode(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("documentMode");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("documentMode", "bool");
        return -1;
    }

    auto cppOut_local = cppSelf->documentMode;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->documentMode = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_leftButtonSize(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->leftButtonSize)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->leftButtonSize))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->leftButtonSize)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &(cppSelf->leftButtonSize), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_leftButtonSize(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("leftButtonSize");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("leftButtonSize", "QSize");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->leftButtonSize;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_rightButtonSize(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->rightButtonSize)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->rightButtonSize))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->rightButtonSize)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), &(cppSelf->rightButtonSize), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_rightButtonSize(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("rightButtonSize");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QSize_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("rightButtonSize", "QSize");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->rightButtonSize;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_features(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_TabFeature_IDX])))->converter, &cppSelf->features);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_features(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("features");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_TabFeature_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("features", "TabFeatures");
        return -1;
    }

    auto cppOut_local = cppSelf->features;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->features = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionTab_get_tabIndex(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    int cppOut_local = cppSelf->tabIndex;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionTab_set_tabIndex(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionTab *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("tabIndex");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("tabIndex", "int");
        return -1;
    }

    auto cppOut_local = cppSelf->tabIndex;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->tabIndex = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionTab
static PyGetSetDef Sbk_QStyleOptionTab_getsetlist[] = {
    {const_cast<char *>("shape"), Sbk_QStyleOptionTab_get_shape, Sbk_QStyleOptionTab_set_shape, nullptr, nullptr},
    {const_cast<char *>("text"), Sbk_QStyleOptionTab_get_text, Sbk_QStyleOptionTab_set_text, nullptr, nullptr},
    {const_cast<char *>("icon"), Sbk_QStyleOptionTab_get_icon, Sbk_QStyleOptionTab_set_icon, nullptr, nullptr},
    {const_cast<char *>("row"), Sbk_QStyleOptionTab_get_row, Sbk_QStyleOptionTab_set_row, nullptr, nullptr},
    {const_cast<char *>("position"), Sbk_QStyleOptionTab_get_position, Sbk_QStyleOptionTab_set_position, nullptr, nullptr},
    {const_cast<char *>("selectedPosition"), Sbk_QStyleOptionTab_get_selectedPosition, Sbk_QStyleOptionTab_set_selectedPosition, nullptr, nullptr},
    {const_cast<char *>("cornerWidgets"), Sbk_QStyleOptionTab_get_cornerWidgets, Sbk_QStyleOptionTab_set_cornerWidgets, nullptr, nullptr},
    {const_cast<char *>("iconSize"), Sbk_QStyleOptionTab_get_iconSize, Sbk_QStyleOptionTab_set_iconSize, nullptr, nullptr},
    {const_cast<char *>("documentMode"), Sbk_QStyleOptionTab_get_documentMode, Sbk_QStyleOptionTab_set_documentMode, nullptr, nullptr},
    {const_cast<char *>("leftButtonSize"), Sbk_QStyleOptionTab_get_leftButtonSize, Sbk_QStyleOptionTab_set_leftButtonSize, nullptr, nullptr},
    {const_cast<char *>("rightButtonSize"), Sbk_QStyleOptionTab_get_rightButtonSize, Sbk_QStyleOptionTab_set_rightButtonSize, nullptr, nullptr},
    {const_cast<char *>("features"), Sbk_QStyleOptionTab_get_features, Sbk_QStyleOptionTab_set_features, nullptr, nullptr},
    {const_cast<char *>("tabIndex"), Sbk_QStyleOptionTab_get_tabIndex, Sbk_QStyleOptionTab_set_tabIndex, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionTab_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionTab_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionTab_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionTab_TypeF(void)
{
    return _Sbk_QStyleOptionTab_Type;
}

static PyType_Slot Sbk_QStyleOptionTab_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionTab_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionTab_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionTab_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionTab_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionTab_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionTab_spec = {
    "2:PySide6.QtWidgets.QStyleOptionTab",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionTab_slots
};

} //extern "C"

static void *Sbk_QStyleOptionTab_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionTab *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleOptionTab_StyleOptionType_PythonToCpp_QStyleOptionTab_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_StyleOptionType_PythonToCpp_QStyleOptionTab_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionType_IDX])))
        return QStyleOptionTab_StyleOptionType_PythonToCpp_QStyleOptionTab_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionTab_StyleOptionType_CppToPython_QStyleOptionTab_StyleOptionType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionType_IDX]), castCppIn);

}

static void QStyleOptionTab_StyleOptionVersion_PythonToCpp_QStyleOptionTab_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_StyleOptionVersion_PythonToCpp_QStyleOptionTab_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionVersion_IDX])))
        return QStyleOptionTab_StyleOptionVersion_PythonToCpp_QStyleOptionTab_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionTab_StyleOptionVersion_CppToPython_QStyleOptionTab_StyleOptionVersion(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionVersion_IDX]), castCppIn);

}

static void QStyleOptionTab_TabPosition_PythonToCpp_QStyleOptionTab_TabPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::TabPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::TabPosition *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_TabPosition_PythonToCpp_QStyleOptionTab_TabPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabPosition_IDX])))
        return QStyleOptionTab_TabPosition_PythonToCpp_QStyleOptionTab_TabPosition;
    return {};
}
static PyObject *QStyleOptionTab_TabPosition_CppToPython_QStyleOptionTab_TabPosition(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::TabPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabPosition_IDX]), castCppIn);

}

static void QStyleOptionTab_SelectedPosition_PythonToCpp_QStyleOptionTab_SelectedPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::SelectedPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::SelectedPosition *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_SelectedPosition_PythonToCpp_QStyleOptionTab_SelectedPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_SelectedPosition_IDX])))
        return QStyleOptionTab_SelectedPosition_PythonToCpp_QStyleOptionTab_SelectedPosition;
    return {};
}
static PyObject *QStyleOptionTab_SelectedPosition_CppToPython_QStyleOptionTab_SelectedPosition(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::SelectedPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_SelectedPosition_IDX]), castCppIn);

}

static void QStyleOptionTab_CornerWidget_PythonToCpp_QStyleOptionTab_CornerWidget(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::CornerWidget>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::CornerWidget *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_CornerWidget_PythonToCpp_QStyleOptionTab_CornerWidget_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_CornerWidget_IDX])))
        return QStyleOptionTab_CornerWidget_PythonToCpp_QStyleOptionTab_CornerWidget;
    return {};
}
static PyObject *QStyleOptionTab_CornerWidget_CppToPython_QStyleOptionTab_CornerWidget(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::CornerWidget *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_CornerWidget_IDX]), castCppIn);

}

static void QStyleOptionTab_TabFeature_PythonToCpp_QStyleOptionTab_TabFeature(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionTab::TabFeature>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionTab::TabFeature *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionTab_TabFeature_PythonToCpp_QStyleOptionTab_TabFeature_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabFeature_IDX])))
        return QStyleOptionTab_TabFeature_PythonToCpp_QStyleOptionTab_TabFeature;
    return {};
}
static PyObject *QStyleOptionTab_TabFeature_CppToPython_QStyleOptionTab_TabFeature(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionTab::TabFeature *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabFeature_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionTab_PythonToCpp_QStyleOptionTab_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionTab_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionTab_PythonToCpp_QStyleOptionTab_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionTab_TypeF()))
        return QStyleOptionTab_PythonToCpp_QStyleOptionTab_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionTab_PTR_CppToPython_QStyleOptionTab(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionTab *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionTab_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionTab_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionTab(self)",
    "1:PySide6.QtWidgets.QStyleOptionTab(self,other:PySide6.QtWidgets.QStyleOptionTab)",
    "0:PySide6.QtWidgets.QStyleOptionTab(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionTab(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionTab_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOption_IDX]))));

    _Sbk_QStyleOptionTab_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionTab",
        "QStyleOptionTab*",
        &Sbk_QStyleOptionTab_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionTab >,
        Sbk_QStyleOptionTab_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionTab_TypeF(); // references _Sbk_QStyleOptionTab_Type
    InitSignatureStrings(pyType, QStyleOptionTab_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionTab_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionTab_PythonToCpp_QStyleOptionTab_PTR,
        is_QStyleOptionTab_PythonToCpp_QStyleOptionTab_PTR_Convertible,
        QStyleOptionTab_PTR_CppToPython_QStyleOptionTab);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionTab).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionTab_TypeF(), &Sbk_QStyleOptionTab_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionTab_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionTab::StyleOptionType::Type) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionTab::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_StyleOptionType_CppToPython_QStyleOptionTab_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_StyleOptionType_PythonToCpp_QStyleOptionTab_StyleOptionType,
            is_QStyleOptionTab_StyleOptionType_PythonToCpp_QStyleOptionTab_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionTab::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionTab::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_StyleOptionVersion_CppToPython_QStyleOptionTab_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_StyleOptionVersion_PythonToCpp_QStyleOptionTab_StyleOptionVersion,
            is_QStyleOptionTab_StyleOptionVersion_PythonToCpp_QStyleOptionTab_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'TabPosition'.
    const char *TabPosition_Initializer[] = {
        "Beginning",
        "Middle",
        "End",
        "OnlyOneTab",
        "Moving",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t TabPosition_InitializerValues[] = {
        uint8_t(QStyleOptionTab::TabPosition::Beginning),  //  0x00  0
        uint8_t(QStyleOptionTab::TabPosition::Middle),     //  0x01  1
        uint8_t(QStyleOptionTab::TabPosition::End),        //  0x02  2
        uint8_t(QStyleOptionTab::TabPosition::OnlyOneTab), //  0x03  3
        uint8_t(QStyleOptionTab::TabPosition::Moving)      //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.TabPosition",
        TabPosition_Initializer, TabPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionTab::TabPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_TabPosition_CppToPython_QStyleOptionTab_TabPosition);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_TabPosition_PythonToCpp_QStyleOptionTab_TabPosition,
            is_QStyleOptionTab_TabPosition_PythonToCpp_QStyleOptionTab_TabPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::TabPosition");
        Shiboken::Conversions::registerConverterName(converter, "TabPosition");
    }
    // End of 'TabPosition' enum.

    // Initialization of enum 'SelectedPosition'.
    const char *SelectedPosition_Initializer[] = {
        "NotAdjacent",
        "NextIsSelected",
        "PreviousIsSelected",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SelectedPosition_InitializerValues[] = {
        uint8_t(QStyleOptionTab::SelectedPosition::NotAdjacent),       //  0x00  0
        uint8_t(QStyleOptionTab::SelectedPosition::NextIsSelected),    //  0x01  1
        uint8_t(QStyleOptionTab::SelectedPosition::PreviousIsSelected) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.SelectedPosition",
        SelectedPosition_Initializer, SelectedPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_SelectedPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionTab::SelectedPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_SelectedPosition_CppToPython_QStyleOptionTab_SelectedPosition);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_SelectedPosition_PythonToCpp_QStyleOptionTab_SelectedPosition,
            is_QStyleOptionTab_SelectedPosition_PythonToCpp_QStyleOptionTab_SelectedPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::SelectedPosition");
        Shiboken::Conversions::registerConverterName(converter, "SelectedPosition");
    }
    // End of 'SelectedPosition' enum.

    // Initialization of enum 'CornerWidget'.
    const char *CornerWidget_Initializer[] = {
        "NoCornerWidgets",
        "LeftCornerWidget",
        "RightCornerWidget",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t CornerWidget_InitializerValues[] = {
        uint8_t(QStyleOptionTab::CornerWidget::NoCornerWidgets),  //  0x00  0
        uint8_t(QStyleOptionTab::CornerWidget::LeftCornerWidget), //  0x01  1
        uint8_t(QStyleOptionTab::CornerWidget::RightCornerWidget) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.CornerWidget",
        CornerWidget_Initializer, CornerWidget_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_CornerWidget_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_CornerWidget_IDX].type =
        EType;
    // Register converter for enum 'QStyleOptionTab::CornerWidget'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_CornerWidget_CppToPython_QStyleOptionTab_CornerWidget);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_CornerWidget_PythonToCpp_QStyleOptionTab_CornerWidget,
            is_QStyleOptionTab_CornerWidget_PythonToCpp_QStyleOptionTab_CornerWidget_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::CornerWidget");
        Shiboken::Conversions::registerConverterName(converter, "CornerWidget");
        // Register converter for flag 'QFlags<QStyleOptionTab::CornerWidget>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QStyleOptionTab::CornerWidget>");
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::CornerWidgets");
    }
    // End of 'CornerWidget' enum/flags.

    // Initialization of enum 'TabFeature'.
    const char *TabFeature_Initializer[] = {
        "None_",
        "HasFrame",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t TabFeature_InitializerValues[] = {
        uint8_t(QStyleOptionTab::TabFeature::None),    //  0x00  0
        uint8_t(QStyleOptionTab::TabFeature::HasFrame) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionTab_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionTab.TabFeature",
        TabFeature_Initializer, TabFeature_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionTab_TabFeature_IDX].type = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtWidgetsTypeStructs[SBK_QFlags_QStyleOptionTab_TabFeature_IDX].type =
        EType;
    // Register converter for enum 'QStyleOptionTab::TabFeature'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionTab_TabFeature_CppToPython_QStyleOptionTab_TabFeature);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionTab_TabFeature_PythonToCpp_QStyleOptionTab_TabFeature,
            is_QStyleOptionTab_TabFeature_PythonToCpp_QStyleOptionTab_TabFeature_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::TabFeature");
        Shiboken::Conversions::registerConverterName(converter, "TabFeature");
        // Register converter for flag 'QFlags<QStyleOptionTab::TabFeature>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QStyleOptionTab::TabFeature>");
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionTab::TabFeatures");
    }
    // End of 'TabFeature' enum/flags.

    qRegisterMetaType< ::QStyleOptionTab *>();
    qRegisterMetaType< ::QStyleOptionTab::StyleOptionType >("QStyleOptionTab::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionTab::StyleOptionVersion >("QStyleOptionTab::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionTab::TabPosition >("QStyleOptionTab::TabPosition");
    qRegisterMetaType< ::QStyleOptionTab::SelectedPosition >("QStyleOptionTab::SelectedPosition");
    qRegisterMetaType< ::QStyleOptionTab::CornerWidget >("QStyleOptionTab::CornerWidget");
    qRegisterMetaType< ::QStyleOptionTab::TabFeature >("QStyleOptionTab::TabFeature");

    return pyType;
}
