// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qstyleoptiontoolbox_wrapper.h"

// Argument includes
#include <QtWidgets/qstyleoption.h>
#include <QtWidgets/qwidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionToolBox_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionToolBox >()))
        return -1;

    ::QStyleOptionToolBox *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QStyleOptionToolBox.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QStyleOptionToolBox", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionToolBox::QStyleOptionToolBox()
    // 1: QStyleOptionToolBox::QStyleOptionToolBox(QStyleOptionToolBox)
    // 2: QStyleOptionToolBox::QStyleOptionToolBox(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionToolBox()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionToolBox(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionToolBox(QStyleOptionToolBox)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionToolBox()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBox()
                cptr = new ::QStyleOptionToolBox();
            }
            break;
        }
        case 1: // QStyleOptionToolBox(const QStyleOptionToolBox & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionToolBox *cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBox(QStyleOptionToolBox)
                cptr = new ::QStyleOptionToolBox(*cppArg0);
            }
            break;
        }
        case 2: // QStyleOptionToolBox(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QStyleOptionToolBox(int)
                cptr = new ::QStyleOptionToolBox(cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionToolBox >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}


static const char *Sbk_QStyleOptionToolBox_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QStyleOptionToolBox_EnumFlagInfo[] = {
    "SelectedPosition:Enum",
    "StyleOptionType:Enum",
    "StyleOptionVersion:Enum",
    "TabPosition:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QStyleOptionToolBox_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QStyleOptionToolBox_get_text(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->text);
    return pyOut;
}
static int Sbk_QStyleOptionToolBox_set_text(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("text");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("text", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->text;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBox_get_icon(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->icon)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX])));
        if (pyOut != nullptr) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->icon))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->icon)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), &(cppSelf->icon), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionToolBox_set_icon(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("icon");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QIcon_IDX]), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("icon", "QIcon");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->icon;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBox_get_position(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionToolBox::TabPosition cppOut_local = cppSelf->position;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_TabPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBox_set_position(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("position");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_TabPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("position", "TabPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->position;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->position = cppOut_local;

    return 0;
}

static PyObject *Sbk_QStyleOptionToolBox_get_selectedPosition(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    ::QStyleOptionToolBox::SelectedPosition cppOut_local = cppSelf->selectedPosition;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_SelectedPosition_IDX])))->converter, &cppOut_local);
    return pyOut;
}
static int Sbk_QStyleOptionToolBox_set_selectedPosition(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QStyleOptionToolBox *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("selectedPosition");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_SelectedPosition_IDX])))->converter, (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("selectedPosition", "SelectedPosition");
        return -1;
    }

    auto cppOut_local = cppSelf->selectedPosition;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->selectedPosition = cppOut_local;

    return 0;
}

// Getters and Setters for QStyleOptionToolBox
static PyGetSetDef Sbk_QStyleOptionToolBox_getsetlist[] = {
    {const_cast<char *>("text"), Sbk_QStyleOptionToolBox_get_text, Sbk_QStyleOptionToolBox_set_text, nullptr, nullptr},
    {const_cast<char *>("icon"), Sbk_QStyleOptionToolBox_get_icon, Sbk_QStyleOptionToolBox_set_icon, nullptr, nullptr},
    {const_cast<char *>("position"), Sbk_QStyleOptionToolBox_get_position, Sbk_QStyleOptionToolBox_set_position, nullptr, nullptr},
    {const_cast<char *>("selectedPosition"), Sbk_QStyleOptionToolBox_get_selectedPosition, Sbk_QStyleOptionToolBox_set_selectedPosition, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionToolBox_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QStyleOptionToolBox_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QStyleOptionToolBox_Type = nullptr;
static PyTypeObject *Sbk_QStyleOptionToolBox_TypeF(void)
{
    return _Sbk_QStyleOptionToolBox_Type;
}

static PyType_Slot Sbk_QStyleOptionToolBox_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QStyleOptionToolBox_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QStyleOptionToolBox_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QStyleOptionToolBox_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QStyleOptionToolBox_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QStyleOptionToolBox_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QStyleOptionToolBox_spec = {
    "2:PySide6.QtWidgets.QStyleOptionToolBox",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QStyleOptionToolBox_slots
};

} //extern "C"

static void *Sbk_QStyleOptionToolBox_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    SBK_UNUSED(cptr)
    SBK_UNUSED(instanceType)
    if (qstyleoption_cast<const QStyleOptionToolBox *>( reinterpret_cast< ::QStyleOption *>(cptr)) != nullptr)
        return cptr;
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleOptionToolBox_StyleOptionType_PythonToCpp_QStyleOptionToolBox_StyleOptionType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBox::StyleOptionType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBox::StyleOptionType *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionToolBox_StyleOptionType_PythonToCpp_QStyleOptionToolBox_StyleOptionType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionType_IDX])))
        return QStyleOptionToolBox_StyleOptionType_PythonToCpp_QStyleOptionToolBox_StyleOptionType;
    return {};
}
static PyObject *QStyleOptionToolBox_StyleOptionType_CppToPython_QStyleOptionToolBox_StyleOptionType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBox::StyleOptionType *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionType_IDX]), castCppIn);

}

static void QStyleOptionToolBox_StyleOptionVersion_PythonToCpp_QStyleOptionToolBox_StyleOptionVersion(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBox::StyleOptionVersion>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBox::StyleOptionVersion *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionToolBox_StyleOptionVersion_PythonToCpp_QStyleOptionToolBox_StyleOptionVersion_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionVersion_IDX])))
        return QStyleOptionToolBox_StyleOptionVersion_PythonToCpp_QStyleOptionToolBox_StyleOptionVersion;
    return {};
}
static PyObject *QStyleOptionToolBox_StyleOptionVersion_CppToPython_QStyleOptionToolBox_StyleOptionVersion(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBox::StyleOptionVersion *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionVersion_IDX]), castCppIn);

}

static void QStyleOptionToolBox_TabPosition_PythonToCpp_QStyleOptionToolBox_TabPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBox::TabPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBox::TabPosition *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionToolBox_TabPosition_PythonToCpp_QStyleOptionToolBox_TabPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_TabPosition_IDX])))
        return QStyleOptionToolBox_TabPosition_PythonToCpp_QStyleOptionToolBox_TabPosition;
    return {};
}
static PyObject *QStyleOptionToolBox_TabPosition_CppToPython_QStyleOptionToolBox_TabPosition(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBox::TabPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_TabPosition_IDX]), castCppIn);

}

static void QStyleOptionToolBox_SelectedPosition_PythonToCpp_QStyleOptionToolBox_SelectedPosition(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QStyleOptionToolBox::SelectedPosition>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QStyleOptionToolBox::SelectedPosition *>(cppOut) = value;

}
static PythonToCppFunc is_QStyleOptionToolBox_SelectedPosition_PythonToCpp_QStyleOptionToolBox_SelectedPosition_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_SelectedPosition_IDX])))
        return QStyleOptionToolBox_SelectedPosition_PythonToCpp_QStyleOptionToolBox_SelectedPosition;
    return {};
}
static PyObject *QStyleOptionToolBox_SelectedPosition_CppToPython_QStyleOptionToolBox_SelectedPosition(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QStyleOptionToolBox::SelectedPosition *>(cppIn));
    return Shiboken::Enum::newItem(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_SelectedPosition_IDX]), castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionToolBox_PythonToCpp_QStyleOptionToolBox_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QStyleOptionToolBox_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionToolBox_PythonToCpp_QStyleOptionToolBox_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QStyleOptionToolBox_TypeF()))
        return QStyleOptionToolBox_PythonToCpp_QStyleOptionToolBox_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QStyleOptionToolBox_PTR_CppToPython_QStyleOptionToolBox(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QStyleOptionToolBox *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QStyleOptionToolBox_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QStyleOptionToolBox_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QStyleOptionToolBox(self)",
    "1:PySide6.QtWidgets.QStyleOptionToolBox(self,other:PySide6.QtWidgets.QStyleOptionToolBox)",
    "0:PySide6.QtWidgets.QStyleOptionToolBox(self,version:int)",
    nullptr}; // Sentinel

PyTypeObject *init_QStyleOptionToolBox(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX].type;

    Shiboken::AutoDecRef Sbk_QStyleOptionToolBox_Type_bases(PyTuple_Pack(1,
        reinterpret_cast<PyObject *>(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOption_IDX]))));

    _Sbk_QStyleOptionToolBox_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QStyleOptionToolBox",
        "QStyleOptionToolBox*",
        &Sbk_QStyleOptionToolBox_spec,
        &Shiboken::callCppDestructor< ::QStyleOptionToolBox >,
        Sbk_QStyleOptionToolBox_Type_bases.object(),
        0);
    auto *pyType = Sbk_QStyleOptionToolBox_TypeF(); // references _Sbk_QStyleOptionToolBox_Type
    InitSignatureStrings(pyType, QStyleOptionToolBox_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QStyleOptionToolBox_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QStyleOptionToolBox_PythonToCpp_QStyleOptionToolBox_PTR,
        is_QStyleOptionToolBox_PythonToCpp_QStyleOptionToolBox_PTR_Convertible,
        QStyleOptionToolBox_PTR_CppToPython_QStyleOptionToolBox);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionToolBox).name());

    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(
        Sbk_QStyleOptionToolBox_TypeF(), &Sbk_QStyleOptionToolBox_typeDiscovery);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QStyleOptionToolBox_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'StyleOptionType'.
    const char *StyleOptionType_Initializer[] = {
        "Type",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionType_InitializerValues[] = {
        uint8_t(QStyleOptionToolBox::StyleOptionType::Type) //  0x07  7
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBox_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBox.StyleOptionType",
        StyleOptionType_Initializer, StyleOptionType_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionType_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBox::StyleOptionType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBox_StyleOptionType_CppToPython_QStyleOptionToolBox_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionToolBox_StyleOptionType_PythonToCpp_QStyleOptionToolBox_StyleOptionType,
            is_QStyleOptionToolBox_StyleOptionType_PythonToCpp_QStyleOptionToolBox_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    const char *StyleOptionVersion_Initializer[] = {
        "Version",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t StyleOptionVersion_InitializerValues[] = {
        uint8_t(QStyleOptionToolBox::StyleOptionVersion::Version) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBox_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBox.StyleOptionVersion",
        StyleOptionVersion_Initializer, StyleOptionVersion_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_StyleOptionVersion_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBox::StyleOptionVersion'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBox_StyleOptionVersion_CppToPython_QStyleOptionToolBox_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionToolBox_StyleOptionVersion_PythonToCpp_QStyleOptionToolBox_StyleOptionVersion,
            is_QStyleOptionToolBox_StyleOptionVersion_PythonToCpp_QStyleOptionToolBox_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.

    // Initialization of enum 'TabPosition'.
    const char *TabPosition_Initializer[] = {
        "Beginning",
        "Middle",
        "End",
        "OnlyOneTab",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t TabPosition_InitializerValues[] = {
        uint8_t(QStyleOptionToolBox::TabPosition::Beginning), //  0x00  0
        uint8_t(QStyleOptionToolBox::TabPosition::Middle),    //  0x01  1
        uint8_t(QStyleOptionToolBox::TabPosition::End),       //  0x02  2
        uint8_t(QStyleOptionToolBox::TabPosition::OnlyOneTab) //  0x03  3
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBox_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBox.TabPosition",
        TabPosition_Initializer, TabPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_TabPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBox::TabPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBox_TabPosition_CppToPython_QStyleOptionToolBox_TabPosition);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionToolBox_TabPosition_PythonToCpp_QStyleOptionToolBox_TabPosition,
            is_QStyleOptionToolBox_TabPosition_PythonToCpp_QStyleOptionToolBox_TabPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox::TabPosition");
        Shiboken::Conversions::registerConverterName(converter, "TabPosition");
    }
    // End of 'TabPosition' enum.

    // Initialization of enum 'SelectedPosition'.
    const char *SelectedPosition_Initializer[] = {
        "NotAdjacent",
        "NextIsSelected",
        "PreviousIsSelected",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t SelectedPosition_InitializerValues[] = {
        uint8_t(QStyleOptionToolBox::SelectedPosition::NotAdjacent),       //  0x00  0
        uint8_t(QStyleOptionToolBox::SelectedPosition::NextIsSelected),    //  0x01  1
        uint8_t(QStyleOptionToolBox::SelectedPosition::PreviousIsSelected) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QStyleOptionToolBox_TypeF(),
        "2:PySide6.QtWidgets.QStyleOptionToolBox.SelectedPosition",
        SelectedPosition_Initializer, SelectedPosition_InitializerValues);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QStyleOptionToolBox_SelectedPosition_IDX].type = EType;
    // Register converter for enum 'QStyleOptionToolBox::SelectedPosition'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QStyleOptionToolBox_SelectedPosition_CppToPython_QStyleOptionToolBox_SelectedPosition);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionToolBox_SelectedPosition_PythonToCpp_QStyleOptionToolBox_SelectedPosition,
            is_QStyleOptionToolBox_SelectedPosition_PythonToCpp_QStyleOptionToolBox_SelectedPosition_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionToolBox::SelectedPosition");
        Shiboken::Conversions::registerConverterName(converter, "SelectedPosition");
    }
    // End of 'SelectedPosition' enum.

    qRegisterMetaType< ::QStyleOptionToolBox *>();
    qRegisterMetaType< ::QStyleOptionToolBox::StyleOptionType >("QStyleOptionToolBox::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionToolBox::StyleOptionVersion >("QStyleOptionToolBox::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionToolBox::TabPosition >("QStyleOptionToolBox::TabPosition");
    qRegisterMetaType< ::QStyleOptionToolBox::SelectedPosition >("QStyleOptionToolBox::SelectedPosition");

    return pyType;
}
