// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwidgets_python.h"

// main header
#include "qtablewidgetselectionrange_wrapper.h"

// Argument includes
#include <QtWidgets/qtablewidget.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QTableWidgetSelectionRange_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QTableWidgetSelectionRange >()))
        return -1;

    ::QTableWidgetSelectionRange *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[4];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr, nullptr};

    // invalid argument lengths
    if (numArgs == 2 || numArgs == 3)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    if (PyArg_UnpackTuple(args, "QTableWidgetSelectionRange", 0, 4, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2]), &(pyArgs[3])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QTableWidgetSelectionRange::QTableWidgetSelectionRange()
    // 1: QTableWidgetSelectionRange::QTableWidgetSelectionRange(QTableWidgetSelectionRange)
    // 2: QTableWidgetSelectionRange::QTableWidgetSelectionRange(int,int,int,int)
    if (numArgs == 0) {
        overloadId = 0; // QTableWidgetSelectionRange()
    } else if (numArgs == 4
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[2])))
        && (pythonToCpp[3] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[3])))) {
        overloadId = 2; // QTableWidgetSelectionRange(int,int,int,int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QTableWidgetSelectionRange(QTableWidgetSelectionRange)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QTableWidgetSelectionRange()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // QTableWidgetSelectionRange()
                cptr = new ::QTableWidgetSelectionRange();
            }
            break;
        }
        case 1: // QTableWidgetSelectionRange(const QTableWidgetSelectionRange & QTableWidgetSelectionRange)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QTableWidgetSelectionRange cppArg0_local;
            ::QTableWidgetSelectionRange *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QTableWidgetSelectionRange(QTableWidgetSelectionRange)
                cptr = new ::QTableWidgetSelectionRange(*cppArg0);
            }
            break;
        }
        case 2: // QTableWidgetSelectionRange(int top, int left, int bottom, int right)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            int cppArg2;
            pythonToCpp[2](pyArgs[2], &cppArg2);
            int cppArg3;
            pythonToCpp[3](pyArgs[3], &cppArg3);

            if (Shiboken::Errors::occurred() == nullptr) {
                // QTableWidgetSelectionRange(int,int,int,int)
                cptr = new ::QTableWidgetSelectionRange(cppArg0, cppArg1, cppArg2, cppArg3);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QTableWidgetSelectionRange >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_bottomRow(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.bottomRow";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // bottomRow()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->bottomRow();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_columnCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.columnCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // columnCount()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->columnCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_leftColumn(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.leftColumn";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // leftColumn()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->leftColumn();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_rightColumn(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.rightColumn";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rightColumn()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->rightColumn();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_rowCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.rowCount";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // rowCount()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->rowCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRangeFunc_topRow(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWidgets.QTableWidgetSelectionRange.topRow";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // topRow()const
            int cppResult = const_cast<const ::QTableWidgetSelectionRange *>(cppSelf)->topRow();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QTableWidgetSelectionRange__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QTableWidgetSelectionRange_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QTableWidgetSelectionRange_methods[] = {
    {"bottomRow", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_bottomRow), METH_NOARGS, nullptr},
    {"columnCount", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_columnCount), METH_NOARGS, nullptr},
    {"leftColumn", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_leftColumn), METH_NOARGS, nullptr},
    {"rightColumn", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_rightColumn), METH_NOARGS, nullptr},
    {"rowCount", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_rowCount), METH_NOARGS, nullptr},
    {"topRow", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRangeFunc_topRow), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QTableWidgetSelectionRange__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QTableWidgetSelectionRange_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), (pyArg)))) {
                // operator!=(const QTableWidgetSelectionRange & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTableWidgetSelectionRange cppArg0_local;
                ::QTableWidgetSelectionRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), (pyArg)))) {
                // operator==(const QTableWidgetSelectionRange & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QTableWidgetSelectionRange cppArg0_local;
                ::QTableWidgetSelectionRange *cppArg0 = &cppArg0_local;
                if (pythonToCpp.isValue())
                    pythonToCpp(pyArg, &cppArg0_local);
                else
                    pythonToCpp(pyArg, &cppArg0);

                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QTableWidgetSelectionRange_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QTableWidgetSelectionRange_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QTableWidgetSelectionRange_Type = nullptr;
static PyTypeObject *Sbk_QTableWidgetSelectionRange_TypeF(void)
{
    return _Sbk_QTableWidgetSelectionRange_Type;
}

static PyType_Slot Sbk_QTableWidgetSelectionRange_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QTableWidgetSelectionRange_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QTableWidgetSelectionRange_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QTableWidgetSelectionRange_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QTableWidgetSelectionRange_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QTableWidgetSelectionRange_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QTableWidgetSelectionRange_spec = {
    "2:PySide6.QtWidgets.QTableWidgetSelectionRange",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QTableWidgetSelectionRange_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QTableWidgetSelectionRange_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QTableWidgetSelectionRange_TypeF()))
        return QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QTableWidgetSelectionRange_PTR_CppToPython_QTableWidgetSelectionRange(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QTableWidgetSelectionRange *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QTableWidgetSelectionRange_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *QTableWidgetSelectionRange_COPY_CppToPython_QTableWidgetSelectionRange(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QTableWidgetSelectionRange *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QTableWidgetSelectionRange_TypeF(), new ::QTableWidgetSelectionRange(*source), true, true);
}

// Python to C++ copy conversion.
static void QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QTableWidgetSelectionRange *>(cppOut) = *reinterpret_cast< ::QTableWidgetSelectionRange *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QTableWidgetSelectionRange_TypeF()))
        return QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QTableWidgetSelectionRange_SignatureStrings[] = {
    "2:PySide6.QtWidgets.QTableWidgetSelectionRange(self)",
    "1:PySide6.QtWidgets.QTableWidgetSelectionRange(self,QTableWidgetSelectionRange:PySide6.QtWidgets.QTableWidgetSelectionRange)",
    "0:PySide6.QtWidgets.QTableWidgetSelectionRange(self,top:int,left:int,bottom:int,right:int)",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.bottomRow(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.columnCount(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.leftColumn(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.rightColumn(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.rowCount(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.topRow(self)->int",
    "PySide6.QtWidgets.QTableWidgetSelectionRange.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QTableWidgetSelectionRange(PyObject *module)
{
    if (SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX].type != nullptr)
        return SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX].type;

    Shiboken::AutoDecRef Sbk_QTableWidgetSelectionRange_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QTableWidgetSelectionRange_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QTableWidgetSelectionRange",
        "QTableWidgetSelectionRange",
        &Sbk_QTableWidgetSelectionRange_spec,
        &Shiboken::callCppDestructor< ::QTableWidgetSelectionRange >,
        Sbk_QTableWidgetSelectionRange_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QTableWidgetSelectionRange_TypeF(); // references _Sbk_QTableWidgetSelectionRange_Type
    InitSignatureStrings(pyType, QTableWidgetSelectionRange_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QTableWidgetSelectionRange_PropertyStrings);
    SbkPySide6_QtWidgetsTypeStructs[SBK_QTableWidgetSelectionRange_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_PTR,
        is_QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_PTR_Convertible,
        QTableWidgetSelectionRange_PTR_CppToPython_QTableWidgetSelectionRange,
        QTableWidgetSelectionRange_COPY_CppToPython_QTableWidgetSelectionRange);

    Shiboken::Conversions::registerConverterName(converter, "QTableWidgetSelectionRange");
    Shiboken::Conversions::registerConverterName(converter, "QTableWidgetSelectionRange*");
    Shiboken::Conversions::registerConverterName(converter, "QTableWidgetSelectionRange&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QTableWidgetSelectionRange).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_COPY,
        is_QTableWidgetSelectionRange_PythonToCpp_QTableWidgetSelectionRange_COPY_Convertible);

    qRegisterMetaType< ::QTableWidgetSelectionRange >("QTableWidgetSelectionRange");

    return pyType;
}
