// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtxml_python.h"

// main header
#include "qdomdocument_parseresult_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QDomDocument_ParseResult_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QDomDocument::ParseResult >()))
        return -1;

    ::QDomDocument::ParseResult *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtXml.QDomDocument.ParseResult.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "ParseResult", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: ParseResult::ParseResult()
    // 1: ParseResult::ParseResult(QDomDocument::ParseResult)
    if (numArgs == 0) {
        overloadId = 0; // ParseResult()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), (pyArgs[0])))) {
        overloadId = 1; // ParseResult(QDomDocument::ParseResult)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // ParseResult()
        {

            if (Shiboken::Errors::occurred() == nullptr) {
                // ParseResult()
                cptr = new ::QDomDocument::ParseResult();
            }
            break;
        }
        case 1: // ParseResult(const QDomDocument::ParseResult & ParseResult)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QDomDocument::ParseResult cppArg0_local;
            ::QDomDocument::ParseResult *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // ParseResult(QDomDocument::ParseResult)
                cptr = new ::QDomDocument::ParseResult(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QDomDocument::ParseResult >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QDomDocument_ParseResult__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QDomDocument_ParseResult_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QDomDocument_ParseResult_methods[] = {
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QDomDocument_ParseResult__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

static PyObject *Sbk_QDomDocument_ParseResult_get_errorMessage(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], &cppSelf->errorMessage);
    return pyOut;
}
static int Sbk_QDomDocument_ParseResult_set_errorMessage(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("errorMessage");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QString_IDX], (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("errorMessage", "QString");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->errorMessage;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QDomDocument_ParseResult_get_errorLine(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    qsizetype cppOut_local = cppSelf->errorLine;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QDomDocument_ParseResult_set_errorLine(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("errorLine");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("errorLine", "qsizetype");
        return -1;
    }

    auto cppOut_local = cppSelf->errorLine;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->errorLine = cppOut_local;

    return 0;
}

static PyObject *Sbk_QDomDocument_ParseResult_get_errorColumn(PyObject *self, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    qsizetype cppOut_local = cppSelf->errorColumn;
    PyObject *pyOut = {};
    pyOut = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppOut_local);
    return pyOut;
}
static int Sbk_QDomDocument_ParseResult_set_errorColumn(PyObject *self, PyObject *pyIn, void * /* closure */)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto *cppSelf = reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        Shiboken::Errors::setInvalidTypeDeletion("errorColumn");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyIn)))) {
        Shiboken::Errors::setSetterTypeError("errorColumn", "qsizetype");
        return -1;
    }

    auto cppOut_local = cppSelf->errorColumn;
    pythonToCpp(pyIn, &cppOut_local);
    cppSelf->errorColumn = cppOut_local;

    return 0;
}

// Getters and Setters for ParseResult
static PyGetSetDef Sbk_QDomDocument_ParseResult_getsetlist[] = {
    {const_cast<char *>("errorMessage"), Sbk_QDomDocument_ParseResult_get_errorMessage, Sbk_QDomDocument_ParseResult_set_errorMessage, nullptr, nullptr},
    {const_cast<char *>("errorLine"), Sbk_QDomDocument_ParseResult_get_errorLine, Sbk_QDomDocument_ParseResult_set_errorLine, nullptr, nullptr},
    {const_cast<char *>("errorColumn"), Sbk_QDomDocument_ParseResult_get_errorColumn, Sbk_QDomDocument_ParseResult_set_errorColumn, nullptr, nullptr},
    {nullptr, nullptr, nullptr, nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QDomDocument_ParseResult_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QDomDocument_ParseResult_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QDomDocument_ParseResult_Type = nullptr;
static PyTypeObject *Sbk_QDomDocument_ParseResult_TypeF(void)
{
    return _Sbk_QDomDocument_ParseResult_Type;
}

static PyType_Slot Sbk_QDomDocument_ParseResult_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QDomDocument_ParseResult_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QDomDocument_ParseResult_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QDomDocument_ParseResult_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QDomDocument_ParseResult_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QDomDocument_ParseResult_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QDomDocument_ParseResult_spec = {
    "2:PySide6.QtXml.QDomDocument.ParseResult",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QDomDocument_ParseResult_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void ParseResult_PythonToCpp_ParseResult_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QDomDocument_ParseResult_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_ParseResult_PythonToCpp_ParseResult_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QDomDocument_ParseResult_TypeF()))
        return ParseResult_PythonToCpp_ParseResult_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *ParseResult_PTR_CppToPython_ParseResult(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool exactType = false;
    auto *tCppIn = reinterpret_cast<const ::QDomDocument::ParseResult *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType))
        exactType = true;
    PyObject *result = Shiboken::Object::newObject(Sbk_QDomDocument_ParseResult_TypeF(), const_cast<void *>(cppIn), false, exactType, typeName);
    return result;
}

// C++ to Python copy conversion.
static PyObject *ParseResult_COPY_CppToPython_ParseResult(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QDomDocument::ParseResult *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QDomDocument_ParseResult_TypeF(), new ::QDomDocument::ParseResult(*source), true, true);
}

// Python to C++ copy conversion.
static void ParseResult_PythonToCpp_ParseResult_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QDomDocument::ParseResult *>(cppOut) = *reinterpret_cast< ::QDomDocument::ParseResult *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_ParseResult_PythonToCpp_ParseResult_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QDomDocument_ParseResult_TypeF()))
        return ParseResult_PythonToCpp_ParseResult_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QDomDocument_ParseResult_SignatureStrings[] = {
    "1:PySide6.QtXml.QDomDocument.ParseResult(self)",
    "0:PySide6.QtXml.QDomDocument.ParseResult(self,ParseResult:PySide6.QtXml.QDomDocument.ParseResult)",
    "PySide6.QtXml.QDomDocument.ParseResult.__copy__()",
    nullptr}; // Sentinel

PyTypeObject *init_QDomDocument_ParseResult(PyObject *enclosingClass)
{
    if (SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX].type != nullptr)
        return SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX].type;

    Shiboken::AutoDecRef Sbk_QDomDocument_ParseResult_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QDomDocument_ParseResult_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "ParseResult",
        "QDomDocument::ParseResult",
        &Sbk_QDomDocument_ParseResult_spec,
        &Shiboken::callCppDestructor< ::QDomDocument::ParseResult >,
        Sbk_QDomDocument_ParseResult_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::InnerClass | Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QDomDocument_ParseResult_TypeF(); // references _Sbk_QDomDocument_ParseResult_Type
    InitSignatureStrings(pyType, QDomDocument_ParseResult_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QDomDocument_ParseResult_PropertyStrings);
    SbkPySide6_QtXmlTypeStructs[SBK_QDomDocument_ParseResult_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        ParseResult_PythonToCpp_ParseResult_PTR,
        is_ParseResult_PythonToCpp_ParseResult_PTR_Convertible,
        ParseResult_PTR_CppToPython_ParseResult,
        ParseResult_COPY_CppToPython_ParseResult);

    Shiboken::Conversions::registerConverterName(converter, "QDomDocument::ParseResult");
    Shiboken::Conversions::registerConverterName(converter, "QDomDocument::ParseResult*");
    Shiboken::Conversions::registerConverterName(converter, "QDomDocument::ParseResult&");
    Shiboken::Conversions::registerConverterName(converter, "ParseResult");
    Shiboken::Conversions::registerConverterName(converter, "ParseResult*");
    Shiboken::Conversions::registerConverterName(converter, "ParseResult&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QDomDocument::ParseResult).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        ParseResult_PythonToCpp_ParseResult_COPY,
        is_ParseResult_PythonToCpp_ParseResult_COPY_Convertible);

    qRegisterMetaType< ::QDomDocument::ParseResult >("ParseResult");
    qRegisterMetaType< ::QDomDocument::ParseResult >("QDomDocument::ParseResult");

    return pyType;
}
